#$Id: //depot/prod/test/Rsierranevada/storage/hdd/NADQ_SEA/FS/Common_Lib.pm#39 $
#
#  Library of utility functions for HDD qualification tests
#
#
## @summary Library of routines to help simply HDD qualfication test development
## @description Library of routines to help in simplify the verfication required for various test cases oh hdd test plan.
##
## @synopsis
## use Storage::Common_Lib;
##
##
## @author
##         arunak@netapp.com
##         vpankaj@netapp.com
##   	   arjunl@netapp.com
##		   himangin@netapp.com
##		   aditis@netapp.com
####################################################################
## Subroutines used from 7_Mode Common_lib.pm
##
## 
##
##
##
##
##
##
##
####################################################################
## 
## Design guidelines to be followed
##
## Each subroutine must use validate options
## Each subroutine must contain author and usage of subroutines
## Every optional value must contain default value assigned
## 
##
###################################################################

package Storage::Common_Lib;
use TCD;
use CR::Setup::TCD qw(nlog);
use strict;
use Tharn;
use NACL::C::StorageAggregate;
use NACL::APISet;
use Data::Dumper;
use NACL::C::Disk;
use NACL::C::Volume;
use NACL::C::Aggregate;
use NACL::C::Vserver;
use NACL::C::VolumeMember;
use NACL::CS::StorageAggregateMember;
use NACL::MTask::EventLogDetector;
use Utils;
use HTML::Mail;
use NACL::MTask::SCP;
use NACL::C::Client;
use NACL::STask::SecurityLogin;
use NACL::STask::Node;
use NACL::MTask::SystemLogDetector;
use boot;
use San;
use Utils qw(make_conn);
use Storage::SASUtils qw(filer_cmd);
use Storage::Misc qw(filer_cmd);
use install;
use misc qw(cli_localhost);
use Storage::Storage qw(storage_show_adapter);
use POSIX;
use NACL::Transit;
use Storage::SASUtils qw(disable_dbg_msgs);
use HTML::Mail;
use NACL::C::Node;
use Tharn qw(sleep);
use Tharn qw(param);
use Hostrec;
use Server;
use Options;
use SayRetry;
use mount;
use NACL::MTask::EventLogDetector;
use NACL::STask::StorageFailover;
use NACL::CS::Cluster;

my $params = NATE::ParamSet->new(global => 1);
my $Kernel = $params->get('KERNEL', default => 'SN');
my $MAIL_TO              = $params->get( 'MAIL_TO',			default => 'Email to' );
my $MAIL_FROM            = $params->get( 'MAIL_FROM',		default => 'Email from' );
my $RUNID            	 = $params->get( 'RUNID',			default => 'undef' );
my $STEST_FILE 			 = $params->get('STEST_FILE', 		default => '');
my $BOOT_MODE 			 = $params->get('BOOT_MODE',		default => undef);
my $Filer_mode			 = $params->get('Filer_mode',       default => 'F');
my $TEST_WAIT_TIME 		 = $params->get( 'TEST_WAIT_TIME',  default => '3' );
my $PRE_DETAILS;
my $POST_DETAILS;
logcomment("Kernel $Kernel");
logcomment("Id $RUNID");
my @run_id = split('/',$RUNID);
my $parse_id = $run_id[-1];
if($Kernel=~/FS/i){
	require  NACL::C::StorageDiskPartition;
	require  NACL::CS::StorageDiskPartition;
}
my $AGGR_CNT={};
our $SAS_ADMIN_DEV_PRE;
our $GET_PHY_STATE;
our $PHYDUMP;
our $SHELFLOG_DETECTOR={};
our $EMS_DETECTOR={};
our $STO_DISK_SHOW={};
our $AGGR_CREATE_CNTR;
my $SCSI_DISK_ERRORS={};
# Import exceptions
#
use NACL::APISet::Exceptions::ResponseException qw(:try);
use NACL::APISet::Exceptions::CommandFailedException qw (:try);
use NACL::APISet::Exceptions::MissingRequiredParamException qw(:try);
use NACL::APISet::Exceptions::InvalidParamValueException qw(:try);
use NACL::APISet::Exceptions::MethodNotFoundException qw(:try);
use NACL::Exceptions::NoElementsFound qw(:try);
use NATE::BaseException qw(:try);
use NACL::Transit::Exceptions::Timeout qw(:try);
use NACL::Transit::Exceptions::RetriesExceeded qw(:try);
use NACL::Transit::Exceptions::TransitException qw(:try);
use NACL::APISet::Exceptions::TimeoutException qw(:try);
use NACL::Exceptions::EventCheckFailure qw(:try);
#use NATE::Result::Fatal qw(:try);
#
use Params::Validate qw(validate OBJECT SCALAR HASHREF ARRAYREF);
use Tharn qw( host logcomment );

BEGIN {
    Params::Validate::validation_options(
        on_fail => sub {
            my @msgs = @_;
            chomp(@msgs);
            Carp::confess( Tharn::script_result(@msgs) );
        }
    );
}

require Exporter;
use vars ( '@ISA', '@EXPORT' );
@ISA = ('Exporter');

@EXPORT = qw(
	disk_list_data
	run_disk_qual_t12
	disk_show_drive_maint
	copy_files_to_client_from_filer
	spare_count_cmode
	sysconfig_v_data
	sysconfig_r_data
	storage_show_data
	hammer_start
	hammer_status
	boot_filer_in_req_state
	remove_partition
	enable_ssh
	aggregate_volume_delete
	disk_qual_abort
	get_disk_information
	get_max_timeout
	remv_assign_ownership_maint
	remv_assign_ownership_cli
	storage_show_disk_a_data
	disk_remv_assign_ownership
	disk_show_n
	zero_spares
	check_mode_nodes
	disk_ddr_label_print
	boot_it_good_Maint
	compare_disk_qual_t12
	delete_mini_disk
	create_mini_disk
	compact_flash
	list_of_disk
	vserver_delete
	check_non_root_volumes
	setup_cmode_filers
	wipe_config_filers
	disk_qual_stop_file_system
	create_join_cluster
    cm_disk_firmware
	copy_files_to_filer_from_client
	compare_disk_lists
	compare_fcadmin_link_stats
	compare_fcadmin_fcal_stats
	compare_sasadmin_dev_stats
	check_ert_config
	compare_sasadmin_expander_map
	compare_storage_show
	trim
	node_new_obj
	twenty_four_bar_seven
	clean_config
	get_max_disk_size
	comp_disk_qual_t12	
	pnate_versions_display
	destroy_root_volume
	check_multiple_filer_names
	version_test
	display_version
	get_disks_list
	delete_aggregates_with_no_volumes
	intersection
	max_drives_count
	eye_catcher
	check_for_drive_ownership
	change_diag_more_than_6
	filer_disk_create
	check_disk_owner
	array_diff
	diag_password_change_cmode
	commom_drives
	boot_in_twenty_four_seven_cmode
	time_taken_for_frm_dwnld
	convert_to_date
	convertTime
	HA_config
	create_flex_vol
	create_aggr_volume
	status_return
	send_message
	disk_show_v
	compare_scsi_disk
	copy_FW_files_to_filer_directory
	copy_files_to_filer
	unique
	compare_sysconfig
	compare_fcadmins
	scrub_stop
	scsi_disk_errors
	execute_pre_test
	execute_post_test
	sasadmin_expander_map_cmode
	sasadmin_dev_stats_cmode	
	handle_run_local_error
	enable_firmware_console_message
	sasadmin_inject_sub
	display_node_details
	fcadmin_inject_sub
	fcadmin_link_stats
	fcadmin_device_map
	fcadmin_fcal_stats	
	disable_debug_msg
	create_spares
	check_aggr_vol_offline
	unfail_disk_zero_spares
	disable_fg_bg_firmware_hammer
	get_config_status
	WaitReconstruct
	WaitSickDiskcopy
	check_recons_sickdisk
	check_path_ha
	get_filer_check
	get_phy_state
	handle_prompts
	report_failed_drives
	print_test_variables
	scsi_inquiry_cmode	
	giveback_takeover
	sasadmin_expander_cli_phydump
	sasadmin_expander_cli
	compare_sasadmin_expander_cli_phydump
	compare_phy_state
	read_shelflog
	read_ems_logs
	start_shelflog_detector
	end_shelflog_detector
	start_ems_detector
	end_ems_detector
	drive_names_minus_adapter
	compare_WWN
	set_filer_time
	get_valid_drives_for_firm
	compare_scsi_disk_errors
	fail_if_diff_drive_foramt
	get_system_logs
	del_system_logs
	);
	
	
#######################################################
##	Author : arjun.lavu@netapp.com
######################################################

sub version_test {
     my (%opts) = validate(
        @_,
        {
			node_present => { type => ARRAYREF },
			tc_name => { type => SCALAR },
		}
    );
    my @Nodes = @{ $opts{node_present} };
    my $TC_name = $opts{tc_name};
    my $node_version;
	pnate_versions_display();
	print_test_variables();
    foreach my $Node(@Nodes) {
		my $Mode = $Node->mode();
        my $FILER_C = $Node->name();
        my $Host = host($FILER_C);
		display_node_details(Node=>$Node);
        my $Transit_obj = NACL::Transit->new( name => $FILER_C );
        my $filer_state = $Transit_obj->get_state('timeout' => 600);
        logcomment("Node $FILER_C is in the Filer state $filer_state");
		if($filer_state=~/PASS|USER/i){
			$Transit_obj->change_state( to => "CLI");
		}
		if ($filer_state =~/UP|CLI/i) {
			diag_password_change_cmode(Node_ref=>[$Node]);
			my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
			$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
			try{
				set_filer_time(Node =>$Node);
				my $prompts_answers = [ ".*Do you want to continue.*" => 'y' ];
			        $Api_Set_Obj->execute_raw_command( 'command' => "set test", 'connectrec-match_table' => $prompts_answers );
				$node_version = $Api_Set_Obj->execute_command('command' => 'version');
			
				$Api_Set_Obj->execute_raw_command('command' => 'event config modify -suppression off -console on');
				$Api_Set_Obj->execute_raw_command('command' => 'event config modify -suppression off -consoleloglevel DEBUG');
				
			}catch NATE::BaseException with {	
				logcomment("WARNING :: $FILER_C : filer is in CMode, SSH connection is not proper");
			};	
		} elsif ($filer_state =~/MAINT/i) {
			my $API_Object = NACL::APISet->new(
					hostobj   => $Host,
					category  => "Node",
					interface => "CLI",
					set       => "Maintenance"
					);
				$API_Object->set_timeout( "connectrec-timeout" => 1200 );
			$node_version = $API_Object->execute_raw_command( command => "version" );
		}
		logcomment("Node Version : $node_version");
    }
	
	##Set the filer time if filer is in CLI mode
	# set_filer_time(Node =>$Nodes[0]);
	filer_disk_create();
	
	# my @subtests;
	# foreach my $Node(@Nodes){
        # my $FILER_C = $Node->name();
		# push(@subtests,	subtest(\&check_recons_sickdisk, -runid, "check_recons_sickdisk_$FILER_C", -bg,"--", Node =>$Node));
	# }
	# Subtest::wait_finish(subtest => [@subtests]);
	# status_return(subtest_ref  =>[@subtests]);
	
	
}

sub display_node_details{
my (%opts) = validate(
	@_,
        {
            Node    => { type => OBJECT },
		}
	);
	my $Node = $opts{Node};
	my $FILER_C = $Node->name();
	my $Host = host($FILER_C);
	logcomment("Printing the details of the filer $FILER_C");
	my ($N_M_P,$N_M_I,$N_M_M,$N_M_G,$C_P,$C_I,$C_M,$C_G,$C_M_P,$C_M_I,$C_M_G,$C_M_M,$Cluster_Name)=($Host->{MGMT_PORT},$Host->{MGMT_IP},$Host->{MGMT_MASK},$Host->{MGMT_GATEWAY},$Host->{CLUSTER_PORT1},
											$Host->{CLUSTER_IP1},$Host->{CLUSTER_MASK1},$Host->{CLUSTER_GATEWAY1},$Host->{CLUSTER_MGMT_PORT},$Host->{CLUSTER_MGMT_IP},$Host->{CLUSTER_MGMT_GATEWAY},
											$Host->{CLUSTER_MGMT_MASK},$Host->{CLUSTER_NAME});
	logcomment("Node Management Port = $N_M_P \nNode Management Ip = $N_M_I \nNode Management mask = $N_M_M \nNode Management Gateway = $N_M_G \n\nCluster Port = $C_P \nCluster IP = $C_I \nCluster Mask = $C_M \nCluster Gateway = $C_G \n\nCluster Mangement Port = $C_M_P \nCluster Mangement Ip = $C_M_I \nCluster Mangement Gateway = $C_M_G \nCluster Mangement Mask = $C_M_M \n
Cluster Name = $Cluster_Name");							

}

sub hammer_start {
	my (%opts) = validate(
	@_,
        {
            Node    => { type => OBJECT },
            file_name      => { type => SCALAR},
            file_size  => { type => SCALAR },
			root_vol => { type => SCALAR, optional =>1, default => 'no'},
			Test 	=> {type => OBJECT},
		}
	);
    my $Node = $opts{Node};
    my $file_name = $opts{file_name};
    my $file_size = $opts{file_size};
    my $root_vol = $opts{root_vol};
    my $Test = $opts{Test};
    my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset(connid => "console");
    try {
        my $response = $Api_Set_Obj->hammer(
            'force'      => "1",
            'num-runs'   => "-1",
            'file-name'   => $file_name,
            'num-blocks' => $file_size
        );
		my $ret = $Api_Set_Obj->hammer_status();
		if(!$ret->get_raw_output()){
			$Test->nlog("Hammer is not running checking again");
			my $ret1 = $Api_Set_Obj->hammer_status();
			if(!$ret1->get_raw_output()){
				$Test->nlog("Hammer is not running");	
				return 1;
			}
	     } else {
		 	$Test->nlog("Status of HAMMER is ".$ret->get_raw_output());
	        return 0;
		 }
	 }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception_object = shift;
        my $resp             = $exception_object->get_response_object();
        $Test->nlog( "Caught a " . ref($exception_object) . "!" );
        $Test->nlog( "Error is: " . $exception_object->text() );
        $Test->nlog( "Raw output was:\n" . $resp->get_raw_output() );
        $Test->nlog("Hammer with $file_size and file $file_name didnt start properly");
        return 1;
    };
}

#######################################################################################################
##@name :: enable_ssh
##  @auther - arunak@netapp.com
##  @This subrotine enable ssh and rsh based on modes of the filers.
##  @The following named arguments are accepted,
##(Required) : Filer Node Object to use.
##(Required) : Test Object.
##(Required) : Mode of the Filer/Node.
#######################################################################################################

sub enable_ssh {
	my (%opts) = validate(
			    @_,{    Node  => { type => OBJECT }, 
					Test => {type => OBJECT},
					Mode	=> {type => SCALAR},
				}
    			);
	my $Node = $opts{Node};
    my $Test = $opts{Test};
	my $Mode = $opts{Mode};
    my $flag = 0;
	my $Vserver;
	my $FILER_C = $Node->name();
	my $Home = $ENV{HOME};
	#Get ssh values
	logcomment("$FILER_C : Checking Host key");
	`sudo rm -rf $Home/.ssh/known_hosts`;
	$Test->nlog ("$FILER_C : Getting ssh parameters from host file");
	my $ssh_user = $Node->{hostrec}->{conn}->{ssh}->{username};
	my $ssh_pass = $Node->{hostrec}->{conn}->{ssh}->{password};
	my $ssh_conn = $Node->{hostrec}->{conn}->{ssh}->{connhost};
    my $ssh_con_ty = $Node->{hostrec}->{conn}->{ssh}->{conntype};
	$Test->nlog (" Captured ssh options for host file");
	$Test->nlog ("------------------ ssh params ---------------------");
	$Test->nlog (" Connection-user	 : $ssh_user");
	$Test->nlog (" Connection-type     : $ssh_con_ty");
	$Test->nlog (" Connection-host-IP  : $ssh_conn");
	$Test->nlog (" Connection-password : $ssh_pass");
	$Test->nlog ("---------------------------------------------------");
	#Enable ssh if Mode is CMode
	if ($Mode eq 'CMode'){
		logcomment("$FILER_C : Get vserver present on Node");
		# Call vserver subroutine 
		my $vserver_obj = NACL::STask::Vserver->find(
          						  command_interface => $Node,
					            filter            => { type => "node", },
				         );
		$Vserver = $vserver_obj->get_one_state_attribute('vserver');
		logcomment("Vserever name - $Vserver");
		logcomment("$FILER_C : Checking network interface fo e0M for ssh connection");
		my $Home = $ENV{HOME};
		my $Address;
		my $interface;
		my $Netmask;
	    $Home = trim($Home);
	    my $host_file    = "$Home/NDATE/FILER_INFO/$FILER_C";
	    my $filer_config = `cat $host_file`;
	    foreach my $line ( split /\n/, $filer_config ) {
    	    if ( $line =~ /^\#/ ) {
	            next;    # skip overall result report starting with a '#'.
    	    }
	        elsif ( $line =~ /^MGMT_IP\=(.*)/ ) {
	            $Address = $1;
	        }
    	    elsif ( $line =~ /^MGMT_MASK=(.*)/ ) {
	            $Netmask = $1;
	        }
	        elsif ( $line =~ /^MGMT_PORT=(.*)/ ) {
	            $interface = $1;
    	    }
	    }
		my $Lif = "mgmt1";
#		my $Address = $Node->{hostrec}->{net}->[2]->{address};
#		my $interface = $Node->{hostrec}->{conn}->{MGMT_PORT};
		$Test->nlog("Lif - $Lif");
		$Test->nlog("Add - $Address");
		$Test->nlog("Netmask - $Netmask");
		$Test->nlog("Interface - $interface");
		try{
			NACL::STask::NetworkInterface->create(
				command_interface => $Node,
				lif               => $Lif,
				vserver           => $Vserver,
				role              => 'node-mgmt',
				'home-node'       => $FILER_C,
				'home-port'       => $interface,
				address           => $Address,
				netmask           => $Netmask,
				nacltask_if_exists => 'reuse',
			);
		} catch  NACL::APISet::Exceptions::NoMatchingEntriesException with {
            $Test->nlog("LIF is already configured");
        } catch NACL::APISet::Exceptions::CommandFailedException with {
            $Test->nlog("LIF is already configured");
        };
		logcomment("$FILER_C : Checking for ssh options");
		logcomment("$FILER_C : Enabling security login, if exists re-using same ");
		try {
		my $obj = NACL::STask::SecurityLogin->create(
	        command_interface  => $Node,
	        'vserver'          => $Vserver,
	        'username'         => $ssh_user,
	        'authmethod'       => "password",
	        'application'      => "ssh",
	        'password'         => $ssh_pass,
	        'role'             => "admin",
	        nacltask_if_exists => "reuse",
	    );
		} catch  NACL::APISet::Exceptions::NoMatchingEntriesException with {
			logcomment("$FILER_C : Element not found, Configure ssh manually");
		};
	}
}

#######################################################################################################
##@name ::hammer_status
##  @auther - arjun.lavu@netapp.com
##  @my $hash = hammer_status(node=>$node,Test=>$Test);
##  @This routine returns a either 1(Fail) or 0(Pass).
##  @The following named arguments are accepted,
##(Required) : Filer Node Object to use.
##(Required) : Test Object.
#######################################################################################################


sub hammer_status{
	my (%opts) = validate(
    @_,
		{
			Node  => { type => OBJECT }, 
			Test => {type => OBJECT, optional =>1, default => ''}
		}
    );

    my $Node = $opts{Node};
    my $Test = $opts{Test};
    my $flag=0;
	my $return =0;

    my $API_obj= $Node->get_7m_or_nodescope_apiset();
	try {
		my $ret=$API_obj->hammer_status();
		my @arr_hammer=@{$ret->{'parsed_output'}};
		if(!@arr_hammer){
		    logcomment("Hammer is not running");
		    $return=1;
		}
		for my $ref(@arr_hammer){
			for my $reff(sort keys %$ref) { 
				my $file_name;
				if(($reff =='file_name')&&($ref->{$reff})){
					$file_name=$ref->{$reff};
				}
				if(($reff =='status')&&($ref->{$reff}=='Writing')){
					logcomment("Hammer is running for the file $file_name");
					last;
				}
			}
		}
	}catch NACL::APISet::Exceptions::ResponseException with {
		my $exception_object = shift;
	    my $resp             = $exception_object->get_response_object();
	    logcomment( "Caught a " . ref($exception_object) . "!" );
		logcomment( "Error is: " . $exception_object->text() );
	    logcomment( "Raw output was:\n" . $resp->get_raw_output() );
	    logcomment("Hammer status couldn't start properly");
	    $return =1;
	};
	return $return;
}
	

#####################################################################################################
##@name :: boot_filer_in_req_state
##auther :: arunak@netapp.com
##Description : Boots the filer in required mode, used in pre_n_post_test_process in subtest
##Return : NULL
##Mandatory param : Filer name, Test object and State to change
##Supported Mode : CMODE
#####################################################################################################

sub boot_filer_in_req_state {
	my (%opts) = validate(
        @_,
        {
		 filer_name => { type => SCALAR },
		 Test 		=>	{type => OBJECT, optional =>1, default => ''},
		 change_state_to => { type => SCALAR },
    	}
    );
	my $filer_name = $opts{filer_name};
	my $Test =  $opts{Test};
	my $change_state_to = $opts{change_state_to};
	logcomment("Checking State of $filer_name");
	my $Transit_obj = NACL::Transit->new( name => $filer_name );
    my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if ($filer_state ne $change_state_to){
		$Transit_obj->change_state( to => "$change_state_to");
		logcomment("Filer state changed to $change_state_to : $filer_name");
	}else{
		logcomment("Filer state is already in required state ($change_state_to) : $filer_name");
	}
}

#####################################################################################################	
##@name ::copy_files_to_client_from_filer
##auther ::skaran
##DEscripton : Copies files from filer to client using scp
##Return : NULL
##Mandatory : Nodes Present, Filer Path , Start toend, log path
##Supported Mode : CMODE
#####################################################################################################
sub copy_files_to_client_from_filer {
	 my (%opts) = validate(
        @_,
		{
	 node_present => { type => OBJECT},
	 filer_path => { type => SCALAR },
	start_or_end => { type => SCALAR },
	log_path => { type => SCALAR },
	}
	);
	my $node=$opts{node_present};
	my $filer_path=$opts{filer_path};
	my $when=$opts{start_or_end};
	my $LOGDIR=$opts{log_path};

	my $Filer_apiset                = $node->apiset(
        category  => 'Node',
        interface => 'CLI',
        set       => "Systemshell"
    );
	my  $Username;
	my  $Password;
	my  $Client = NACL::C::Client->find();
	 my $conn = $Client->hostrec()->conn();
    my $Client_apiset = $Client->apiset();
 
	 while ( my ( $user, $pass) = each(%$conn) ) {
        if ( defined( $pass->{username} ) && defined( $pass->{password} ) ) {
            $Username = $pass->{username};
            $Password = $pass->{password};
            last;
        }
    } ## end while 
	 my $scp = NACL::MTask::SCP->new(
        target_command_interface => $node,
        source_command_interface => $Client,
    );
	my $File_on_filer=$Filer_apiset->execute_raw_command(command =>"ls $filer_path");
	chomp($File_on_filer);
	logcomment("FILE ON FILER >$File_on_filer<");

#	$Client_apiset->execute_raw_command( command => "sudo mkdir -m 777 $LOGDIR/Acorn_logs_$when/" );
	my $files = [$File_on_filer];
	my @temp_array = @$files;
	@temp_array = split("\t+|\n", $temp_array[0]);
	foreach my $file (@temp_array){
		chomp($file);
		my @temp_file = $file;
		 $scp->copy_from_target_to_source(
					'files_to_copy'         => \@temp_file,
				    set_directory_on_source => "$LOGDIR",
		);
		shift(@temp_file);
	}
}



#####################################################################################################
##@name :: check_non_root_volumes
##auther ::Arjun Lavu
##DEscripton : Returns the non-root volumes of the node which is passed
##Return : array, which contains all the non-root volumes or null if no non-root volumes found
##Mandatory : Node
##Supported Mode : CMODE
#####################################################################################################
sub check_non_root_volumes {
	my (%opts) = validate(
        @_,
        {	
			Node => { type => OBJECT },
		}
	);
	my $Node = $opts{Node};
	my $Mode = $Node->mode();
	my @aggregates;
	
	my $FILER_C  = $Node->name();
	my @non_root;
	my $filter='vsroot';
	try {
		##Checking for Non Rooot Volumes
		my @tot_vol = NACL::C::Volume->find(
						command_interface => $Node,
						filter            => {node => $FILER_C, $filter => 'false'}
					);
		foreach my $vol (@tot_vol) {
			push( @aggregates, $vol->get_one_state_attribute('aggregate') );
			push( @non_root, $vol->volume() );
		}											
		logcomment("$FILER_C : Non Root volumes available are - @non_root");
    }catch NACL::Exceptions::NoElementsFound with {
        logcomment("$FILER_C : Non Root volumes are not found");
    };
	return @non_root;
}

##Author Arjun Lavu
# Description - 
# Support -  Returns Spare drives
##########################################################################################################
sub spare_count_cmode {
	my (%opts) = validate(
        @_,
        {
            Node   => { type => OBJECT },
			run_local => {type =>SCALAR, optional => 1, default => 'NO'},
			waiting => {type =>SCALAR,optional => 1, default => undef},
        }
    );
    my $node    =	$opts{Node};
    my $filer	=	$node->name();
	my $runlocal = $opts{run_local};
	my $params = NATE::ParamSet->new(global => 1);
    my $Kernel = $params->get('KERNEL', default => 'FS');
    my @spare_disk_list;
	my $view_msg =1;
	while(1){
		my $API_obj = $node->get_7m_or_nodescope_apiset();
		my $out = $API_obj->execute_command( 'command' => "aggr status -s");
		# my $zero_cnt;\
		my (@zeroing,@clear_spares);
		if($out =~/zeroing|not zeroed/i){
			# $zero_cnt=$out=~/zeroing|not zeroed/ig;
			my $n      = 0;
            my @lines  = split( /\n/, $out );
            while ( $n <= $#lines ) {
                last if ( $lines[$n] =~ /^-----/ );
                $n++;
            }
            $n++;
            foreach my $var ( @lines[ $n .. $#lines ] ) {
				$var=~s/^\s+|\s+$//gi;
				if($var=~/spare\s*(\S+).*(not zeroed|zeroing)/){
					push(@zeroing,$1);
				}
				if($var!~/zeroing|not zeroed/){
					if($var=~/spare\s*(\S+)/){
						push(@clear_spares,$1);
					}	
				}
			}
			
			if($out =~/not zeroed/i){
				$API_obj->execute_command( 'command' => "disk zero spares");
				sleep 300;
			}
			logcomment("$filer : Zeroing spare count is :: ". scalar @zeroing." and the spares are @zeroing");
			logcomment("$filer : Total non zeroing spare count : ". scalar @clear_spares." and the spare are @clear_spares")if(@clear_spares);
			logcomment("$filer : No non zeroing spares found in the filer ")if(!scalar @clear_spares);
			my $clear_spares =scalar @clear_spares;
			if($opts{waiting}=~/yes/i){
				logcomment("Filer : $filer : Spare drives are zeroing, Please wait ..");
				sleep 600;
			}elsif($opts{waiting}=~/No/i){
				logcomment("**WARNING** : $filer : Spare drives are zeroing \(@zeroing\), Test execution will continue without waiting for disk zeroing completion");
				my $mail_subject = "INFO : $parse_id : zeroing spares found ";
				my $mail_body = "#################################################################################################
##
## Spare disk(s) on FILER : $filer are zeroing, Test execution will continue without waiting for disk zeroing completion.
##
## Zeroing Drives : @zeroing
##
#################################################################################################";
				my %mail_params = (HTML    => $mail_body,
				Text    => $mail_body,
				From    => $MAIL_FROM,
				To      => $MAIL_TO,
				Subject => $mail_subject,);
				$mail_params{HTML} = "<HTML><pre>$mail_params{Text}<\\HTML>";
				my $mail = HTML::Mail->new(%mail_params);
				$mail->send()or logcomment("CONFIG : trouble sending mail");
				last;
			}else{
				my @non_root_volumes = check_non_root_volumes(Node =>$node);
				if(!(scalar @non_root_volumes)){
					logcomment("$filer : Non-root volumes are not found in the filer $filer");
					logcomment("$filer : Zeroing spare count is : ". scalar @zeroing);
					##check for partition
					
					if(scalar @clear_spares > 3){
						# logcomment("Difference is : $diff_spares");
						if($view_msg){
							logcomment("INFO : $filer : Normal spare count\($clear_spares\) are sufficient to proceed with test execution");
							my $mail_subject = "INFO : $parse_id : zeroing spares found ";
							my $mail_body = "#################################################################################################
##
## FILER : $filer :: drives are zeroing, Normal spare count \($clear_spares\) are sufficient to proceed with test execution.
##
##
## Zeroing Drives : @zeroing
##
##
#################################################################################################";
							my %mail_params = (HTML    => $mail_body,
							Text    => $mail_body,
							From    => $MAIL_FROM,
							To      => $MAIL_TO,
							Subject => $mail_subject,);
		
							$mail_params{HTML} = "<HTML><pre>$mail_params{Text}<\\HTML>";
							my $mail = HTML::Mail->new(%mail_params);
							$mail->send()or logcomment("CONFIG : trouble sending mail");
							$view_msg =0;
						}
						last;
					}elsif((scalar @zeroing)>=3){
						logcomment("$filer : Not enough spare are present to create aggregate, NDATE will wait till disk zeroing completes");
						if($view_msg){
							# logcomment("INFO : $filer : Normal spare\($diff_spares\) are sufficient to proceed with test execution");
							my $mail_subject = "INFO : $parse_id : zeroing spares found ";
							my $mail_body = "#################################################################################################
##
## FILER : $filer :: drives are zeroing, NDATE will wait till the completion.
##
## User can stop execution of test by killing <process_id> to stop execution.
##
## sudo kill -9 $$
##
##
#################################################################################################";
							my %mail_params = (HTML    => $mail_body,
							Text    => $mail_body,
							From    => $MAIL_FROM,
							To      => $MAIL_TO,
							Subject => $mail_subject,);
		
							$mail_params{HTML} = "<HTML><pre>$mail_params{Text}<\\HTML>";
							my $mail = HTML::Mail->new(%mail_params);
							$mail->send()or logcomment("CONFIG : trouble sending mail");
							$view_msg =0;
						}
						sleep 600;
					}else{
						logcomment("Spare drives are zeroing");
						last;
					}
				}else{
					logcomment("$filer : Non-root volumes are : @non_root_volumes, So continiuing test");
					last;
				}
			}
		}else{
			logcomment("No zeroing spare drives found");
			last;
		}
	}
	if($runlocal =~/YES/i){
		try{	
			my $Api_Set_Obj = $node->get_7m_or_nodescope_apiset();
            my $output=$Api_Set_Obj->execute_command( 'command' => "aggr status -s");
            my $n      = 0;
            my @lines  = split( /\n/, $output );
            while ( $n <= $#lines ) {
                last if ( $lines[$n] =~ /^-----/ );
                $n++;
            }
            $n++;
            foreach my $line ( @lines[ $n .. $#lines ] ) {
                if ($line =~/spare\s+(\S+)/){
                    # logcomment("spare present $1");
                    push( @spare_disk_list,$1);
                }
            }
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("No spare disks found for the filer $filer");
		};	
		logcomment("$filer : The number of spare disks present are ".scalar @spare_disk_list." and the disks are @spare_disk_list") if (@spare_disk_list);
		return @spare_disk_list;
	}else{
		try{	
			my %hash =(filter => { "owner" => $filer,"state" => "spare"});
			my @disk_obj = NACL::C::Disk->find(
							command_interface => $node,
							%hash,
						);
			foreach my $state_obj (@disk_obj){
				my $free_disk = $state_obj->disk();
				if ($free_disk =~ /(\S+)\:(\S+)/){
					$free_disk = $2;
				}
				push( @spare_disk_list,$free_disk);
			}
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("No container spare disks found for the filer $filer,");
            
		};	
		try{
			logcomment("Checking for partitioned spare drives if present");
			my @disk_obj = NACL::CS::StorageDiskPartition->fetch(
					command_interface => $node,
					filter => { "owner-node-name" => $filer, 'container-type'=>"spare" },
					requested_fields  => [qw(partition)]
				);
				foreach my $state_obj (@disk_obj){
					my $free_disk = $state_obj->partition();
					push( @spare_disk_list,$free_disk);
				}
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("No partitioned spare drives found in the filer $filer");
		};
		logcomment("$filer : The number of spare disks present are ".scalar @spare_disk_list." and the disks are @spare_disk_list") if (@spare_disk_list);
		return @spare_disk_list;
	}
}

##########################################################################################################
# Auther - skaran
# Description - This routine returns spare disk, failed disk and by passed disk , normal disk
# Usage -
# Support - 
##########################################################################################################

sub sysconfig_v_data{
 my (%opts) = validate(
        @_,
        {
            node => { type => OBJECT},
			API_Obj => { type => OBJECT, default => undef, optional => 1 },
        }
    );
 
   my $Node=$opts{node};
   my $API_Obj = $opts{API_Obj} if(defined $opts{API_Obj});
   my $filer_name = $Node->name();
   my $sysconfig_out;
   logcomment("Get filer configruation for filer $filer_name");
   my $Transit_obj = NACL::Transit->new( name => $filer_name );
   my $filer_state = $Transit_obj->get_state('timeout' => 600);
   logcomment("Filer $filer_name is in state : $filer_state");
   if($filer_state =~ /CLI|UP/i ) {
		my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		$sysconfig_out = $Api_Set_Obj->execute_command('command' => 'sysconfig -v' , 'timeout' => 600);
   }elsif($filer_state =~/MAINT/){
		if($API_Obj){
			$API_Obj->set_timeout( "connectrec-timeout" => 1200 );
			$sysconfig_out = $API_Obj->execute_raw_command('command' => 'sysconfig -v');
		}else{
			my $Host = host($filer_name);
			$API_Obj = NACL::APISet->new(
				hostobj   => $Host,
				category  => "Node",
				interface => "CLI",
				set       => "Maintenance",
			);
			$API_Obj->set_timeout( "connectrec-timeout" => 1200 );
			$sysconfig_out = $API_Obj->execute_raw_command('command' => 'sysconfig -v');
		}
   }
   chomp( my @sysconf_lines = split( /\r?\n/, $sysconfig_out ) );
    my @normaldisks;
    my @faileddisks;
    my @upchannels;
    my @bypassdisks;
	my $path;
	my $system_id;
	my $model;
	my $disk_blocks={};
    my $config_struct = {};
    foreach my $line (@sysconf_lines) {
        if ( $line =~ /<UP>/ ) {
            $line =~ /\S+\s+\d+:.*Adapter\s+(.*)\s+\(\D.*\)/;
            push( @upchannels, $1 );
        }
		if( $line =~ /System(\S+|\s+)Storage(\S+|\s+)Configuration:(\S+path|\s+.+path)/ig) {
			$path = $3;
		}
		if($line =~ /System ID:\s+(\S+)/ig){
			$system_id = $1;
		}
		if($line =~ /Model Name:\s+(\S+)/ig){
			$model = $1;
		}
		if($line =~/(\S+)\s*:\s*\S+\s*\S+\s+\S+\s+\S+GB\s+\((\S+)\s+/){
			$disk_blocks->{$1} = $2;
		}
        if ( $line =~ /^\s+(\d*\.?\d+):/ ) {
            my $disk = $1;
            if ( $line =~ /Failed/ ) {
                push( @faileddisks, $disk );
            }
            else {
                push( @normaldisks, $disk );
            }
        }
        if ( $line =~ /^\s+Disk\s+(.+)\s+in.+bypassed/ ) {
            push( @bypassdisks, $1 );
        }
    }
 logcomment("\nupchannels : @upchannels \nfaileddisks : @faileddisks \nnormaldisks : @normaldisks \nbypassdisks : @bypassdisks");
 
    $config_struct = {
        upchannels  => [@upchannels],
        normaldisks => [@normaldisks],
        faileddisks => [@faileddisks],
        bypassdisks => [@bypassdisks],
		path		=> $path,
		model		=> $model,
		disk_blocks => $disk_blocks,
		system_id	=> $system_id
    };
    return $config_struct;
}

##########################################################################################################
# Auther - skaran
# Description - 
# Usage -
# Supported - Cmode (CLI)
##########################################################################################################

sub sysconfig_r_data {
	 my (%opts) = validate(
        @_,
        {
            node => { type => OBJECT},

        }
    );

   my $Node=$opts{node};
   my $filer_name = $Node->name();
   logcomment("- Get filer configruation for filer $filer_name");
	 my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
    my $raw_output = $Api_Set_Obj->execute_command('command' => 'sysconfig -r' , 'timeout' => 600);
	 chomp( my @sysconf_lines = split( /\r?\n/, $raw_output ) );
    my $spare_count   = 0;
    my $fail_count    = 0;
    my $offline_count = 0;
    foreach my $line (@sysconf_lines) {
        $spare_count++   if ( $line =~ /spare/ );
        $fail_count++    if ( $line =~ /failed|FAILED|not responding/ );
        $offline_count++ if ( $line =~ /\(offline\)/ );
    }

    my $sys_result = {
        spare_count   => $spare_count,
        fail_count    => $fail_count,
        offline_count => $offline_count
    };
    return $sys_result;
} ## end sub sysconfig__r

##Arjun.Lavu
sub disk_ddr_label_print{
my (%opts) = validate(
 	@_,
		{ 	
			Node => { type => OBJECT},
		}
	);
	my $Node=$opts{Node};
	my $Mode = $Node->mode();
	my $FILER_C = $Node->name();
	my $Host    = host($FILER_C);
		#**************************************************
	#Checking the filer state
	#**************************************************
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	
	my($API_obj,$output);
	##############################################
	##Based on mode(UP/MAINT) API object is created
	##############################################
	if($filer_state =~/(CLI|UP)/){
		$API_obj = $Node->get_7m_or_nodescope_apiset();
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		logcomment("Filer : $FILER_C - Executing disk ddr_label print -d all");
		$output = $API_obj->execute_command( 'command' => "disk ddr_label print -d all");
	}elsif($filer_state =~/MAINT/){
		$API_obj = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance"
		);
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		logcomment("$FILER_C : Executing disk ddr_label print -d all");
		$output = $API_obj->execute_raw_command('command' => "disk ddr_label print -d all");
	}
	my $disk_data={};
	my $key_val={};
	my @data_total=split(/\n/,$output);	
	foreach(@data_total){
		my $disk;
		###########################################################
		##Total lines are splitted with the delimeter ":" 
		##and first part is taken as key and second part is taken as value
		###########################################################
		foreach my $var(@data_total){
			if($var=~/Disk:\s(\S+)/){
				$disk=$1;
			}
			my @data=split(/\n/,$var);
			foreach my $line(@data){
				if($line=~/(.+):\s+(.+)/){
					my($key,$value)=$line=~/(.+):\s+(.+)/;
					$key_val->{$key}=$value;
				}
			}
			for my $dat(keys %$key_val){
				$disk_data->{$disk}->{$dat} =$key_val->{$dat};
			}
			$key_val={};
		}
	}
	return $disk_data;
}
#######################################################################################################
##storage_show_data
##auther - arjun.lavu@netapp.com
##my $hash = storage_show_data(node=>$node);
##This routine returns a pointer to hash table of storage show information in the filer
##It dies on failure.
##The following named arguments are accepted,
##(Required) : Filer Node to use.
########################################################################################################

sub storage_show_data{
	my (%opts) = validate(
 	 @_,
		{ 	node => { type => OBJECT},
			API_Obj => { type => OBJECT,default => undef, optional => 1 },
		}
	 );
 
	my $Node=$opts{node};
	my $API_Obj = $opts{API_Obj} if(defined $opts{API_Obj}) ;
	my $filer_name = $Node->name();
    my $storage_struct = {};
    my @shelf_id;
    my (
        @adapter_list, $cmd,          $output,    $line,
        @adap,         $adapter_name, @shelflist, $shelflist,
        @shelfline,    $shelfname,    $channel,   $shelfid,
        $shelfstate,   $phy,          $linenum,   $disk,
        $shelf,        $bay,          $serial,    $ven,
        $model,        $rev,          $crc, $Transit_obj,$filer_state
    );
	$Transit_obj = NACL::Transit->new( name => $filer_name );
    $filer_state = $Transit_obj->get_state('timeout' => 600);
	logcomment("Filer $filer_name are in state : $filer_state");
	if($filer_state !~ /^(MAINT)/ ) {
		my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();	
		$output = $Api_Set_Obj->execute_command(command => "storage show" );
	}else{
		if($API_Obj){
			$API_Obj->set_timeout( "connectrec-timeout" => 1200 );
			$output = $API_Obj->execute_raw_command(command => "storage show");
		}else{
			my $console = Tharn::connect("$filer_name#console");
			# Set the properties for the Connectrec used for creating the APIset
			$console->{prompts} = [qr/\*>/];
			$console->{max_idle} = 600;
			$console->{on_idle} = sub { $console->execute(""); };
			$API_Obj = NACL::APISet->new(connection => $console,
										category => "Node",
										interface => "CLI",
										set => "Maintenance");
			$API_Obj->set_timeout( "connectrec-timeout" => 1200 );
			$output = $API_Obj->execute_raw_command(command => "storage show");
		}
	}
   
    @adapter_list = split( /\r*\n/, $output );
    @adapter_list = grep /\S+/, @adapter_list;
    foreach $line (@adapter_list) {
        @adap = split( /:\s+|\r\n/, $line );
        if ( !defined( $adap[1] ) ) {
            $adap[1] = "undef";
        }
        if ( $line =~ /^Slot:/ ) {
            $adapter_name = $adap[1];
            $adapter_name =~ s/\s+//g;
            goto LABEL;
        }
        if ( $adap[0] =~ /Description/ ) {
            $storage_struct->{$adapter_name}->{Description} = $adap[1];
        }
        elsif ( $adap[0] =~ /^State/ ) {
            $storage_struct->{$adapter_name}->{State} = $adap[1];
        }
      LABEL:;
    } ## end foreach $line (@adapter_list)
    @shelflist = split( /\r*\n/, $output );
    foreach $shelflist (@shelflist) {
        @shelfline = split( /\s+/, $shelflist );
        if ( $shelflist =~ /^Shelf name:/ ) {
            $shelfname = $shelfline[2];
        }
        elsif ( $shelflist =~ /^Channel:/ ) {
            $channel = $shelfline[1];
        }
        elsif ( $shelflist =~ /^Shelf id:/ ) {
            $shelfid = $shelfline[2];
        }
        elsif ( $shelflist =~ /^Shelf state:/ ) {
            $shelfstate = $shelfline[2];
            $storage_struct->{$channel}->{Shelfname} = $shelfname;
            $storage_struct->{$channel}->{Shelfid} =
              "$channel" . "." . "$shelfid";
            $storage_struct->{$channel}->{Shelfstate} = $shelfstate;
            push( @shelf_id, "$channel" . "." . "$shelfid" );
            # Consists of array of shelfids remove the duplicates later
            $storage_struct->{$channel}->{Shelfids} = \@shelf_id;
        }
        elsif ( $shelflist =~ /up\s+CRC\s+Word\s+Delta/ ) {
            $crc = 4;
        }
        elsif ( $shelflist =~ /Rate\s+DWord\s+Disparity/ ) {
            $crc = 8;
        }
        elsif ( $shelflist =~ /^\[(IN|OUT)/ ) {
            $phy = $shelfline[0];
            $phy =~ s/\[//g;
            if ( $phy =~ /\]/ ) {
                $phy =~ s/\]//g;
            }
            $phy =~ s/^\s+//;
            $phy =~ s/\s+$//;
            if ( ( $crc == 8 ) && ( $shelflist =~ /^\[(OUT)\S*\s*\]*\s+\S+\s+\S+\s+\S+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s*\d*/ ) ) {
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{InvalidWordCount} = $shelfline[4];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{RunningDisparityCount} = $shelfline[5];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{LossDwordCount} = $shelfline[6];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{PhyResetProblem} = $shelfline[7];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{CRCErrorCount} = $shelfline[8];
                #Added for SAS disks
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{PhyChangeCount} = $shelfline[9];
            }
            elsif ( ( $crc == 8 ) && ( $shelflist =~ /^\[(IN)\S*\s*\]*\s+\S+\s+\S+\s+\S+\s+\S+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s*\d*/ ) ) {
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{InvalidWordCount} = $shelfline[5];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{RunningDisparityCount} = $shelfline[6];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{LossDwordCount} = $shelfline[7];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{PhyResetProblem} = $shelfline[8];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{CRCErrorCount} = $shelfline[9];
                #Added for SAS disks
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{PhyChangeCount} = $shelfline[10];
            }
            elsif ( ( $crc == 4 ) && ( $shelflist =~ /^\[(IN|OUT)\S*\s*\]*\s+\S+\s+\S+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+/ ) ) {
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{LoopupCount} =
                  $shelfline[3];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{CRCErrorCount} = $shelfline[4];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{InvalidWordCount} = $shelfline[5];
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{ClockDelta} =
                  $shelfline[6];
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{InsertCount} =
                  $shelfline[7];
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{LIPCount} =
                  $shelfline[8];
            }
        }
        elsif ( $shelflist =~ /^\[(AUX|SQR|CIR|SIL)/ ) {
            $phy = $shelfline[0];
            $phy =~ s/\[//g;
            if ( $phy =~ /\]/ ) {
                $phy =~ s/\]//g;
            }
            $phy =~ s/^\s+//;
            $phy =~ s/\s+$//;
            if ( ( $crc == 8 ) && ( $shelflist =~ /^\[(AUX|SQR|CIR|SIL)\S*\s*\]*\s+\S+\s+\S+\s+\S+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s*\d*/ ) ) {
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{InvalidWordCount} = $shelfline[4];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{RunningDisparityCount} = $shelfline[5];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{LossDwordCount} = $shelfline[6];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{PhyResetProblem} = $shelfline[7];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{CRCErrorCount} = $shelfline[8];
                #Added for SAS
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{PhyChangeCount} = $shelfline[9];
            }
            elsif ( ( $crc == 4 ) && ( $shelflist =~ /^\[(AUX|SQR|CIR|SIL)\S*\s*\]*\s+\S+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s+\S+\s+\d+/  ) ) {
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{LoopupCount} =
                  $shelfline[2];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{CRCErrorCount} = $shelfline[3];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{InvalidWordCount} = $shelfline[4];
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{ClockDelta} =
                  $shelfline[5];
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{InsertCount} =
                  $shelfline[6];
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{LIPCount} =
                  $shelfline[8];
            }
        }
        elsif ( $shelflist =~ /^\[\s+\d+/ ) {
            $phy = $shelfline[1];
            if ( $phy =~ /\]/ ) {
                $phy =~ s/\]//g;
            }
            $phy =~ s/^\s+//;
            $phy =~ s/\s+$//;
            if ( ( $crc == 8 ) && ( $shelflist =~ /^\[\s+\d+\S*\s*\]*\s+\S+\s+\S+\s+\S+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s*\d*/  ) ) {
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{InvalidWordCount} = $shelfline[6];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{RunningDisparityCount} = $shelfline[7];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{LossDwordCount} = $shelfline[8];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{PhyResetProblem} = $shelfline[9];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{CRCErrorCount} = $shelfline[10];
                #Added for SAS
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{PhyChangeCount} = $shelfline[11];
            }
            elsif ( ( $crc == 4 ) && ( $shelflist =~ /^\[\s+\d+\S*\s*\]*\s+\S+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+/  ) ) {
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{LoopupCount} =
                  $shelfline[4];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{CRCErrorCount} = $shelfline[5];
                $storage_struct->{$channel}->{$shelfid}->{$phy}
                  ->{InvalidWordCount} = $shelfline[6];
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{ClockDelta} =
                  $shelfline[7];
                $storage_struct->{$channel}->{$shelfid}->{$phy}->{InsertCount} =
                  $shelfline[8];
            }
        } ## end elsif ($shelflist =~ /^\[\s+\d+/)
    } ## end foreach $shelflist (@shelflist)
    $linenum = 0;
    foreach $line (@shelflist) {
        $linenum++;
        if ( $line =~ /^DISK\s+SHELF/ ) {
            $linenum = $linenum + 2;
            foreach my $line ( @shelflist[ $linenum .. $#shelflist ] ) {
                if ( $line =~
                    /(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/ )
                {
                    $disk   = $1;
                    $shelf  = $2;
                    $bay    = $3;
                    $serial = $4;
                    $ven    = $5;
                    $model  = $6;
                    $rev    = $7;
                }
                else {
                    next;
                }
                $storage_struct->{$disk} = {
                    'DISK'   => $disk,
                    'SHELF'  => $shelf,
                    'BAY'    => $bay,
                    'SERIAL' => $serial,
                    'VENDOR' => $ven,
                    'MODEL'  => $model,
                    'REV'    => $rev,
                };
            } ## end foreach my $line (@shelflist...
        } ## end if ($line =~ /^DISK\s+SHELF/)
    } ## end foreach $line (@shelflist)
    return $storage_struct;
}
##########################################################################################################
# Auther -  arjunl
# Description - This subroutine will delete the Non root aggregates
#               If aggregates passed externally it will delete only those aggregates if present
# 
# Usage - Mandatory paramanter - Node object , Test object, Mode of filer.
#		  Optional fields	   - array reference of the aggregates which has to get delete.
##########################################################################################################

sub aggregate_volume_delete{
my (%opts) = validate(
    @_,{	Node  => { type => OBJECT },Aggr_array =>{type=> ARRAYREF,optional => 1}}
	);
	my $Node = $opts{Node};
	my @Aggr_array;
	
	my $FILER_C=$Node->name();
	logcomment("$FILER_C : Deleting aggregates requires off-lining volume, Some of the Error message and command failed messages might occur, THESE ARE EXPECTED MESSAGES.");
	if(defined scalar @{$opts{Aggr_array}}){		
		@Aggr_array=sort{$b cmp $a} @{$opts{Aggr_array}};
		logcomment("$FILER_C : aggregates to delete @Aggr_array");
		foreach my $aggregate(@Aggr_array){
			try{
				NACL::STask::Aggregate->purge(
					command_interface => $Node,
					aggregate         => $aggregate,
					nacltask_verify  =>  1,	  
				);
			}catch NACL::Exceptions::NoElementsFound with {
				logcomment("$FILER_C : Cannot delete aggregate $aggregate ");
			}catch NACL::APISet::Exceptions::CommandFailedException with{
				try{ 
					NACL::STask::Aggregate->purge(
					command_interface => $Node,
					aggregate         => $aggregate,
					nacltask_verify=>  1); 
				}catch NACL::APISet::Exceptions::CommandFailedException with{
					logcomment("$FILER_C : Cannot delete aggregate $aggregate, trying again");
					try{
						NACL::C::StorageAggregate->delete(
							command_interface => $Node,
							aggregate         => $aggregate,
							force => 'true',
							);
					}catch NACL::APISet::Exceptions::CommandFailedException with{
						logcomment("$FILER_C :: Cannot delete aggregate $aggregate");
					};
				};	
			}catch NACL::Exceptions::VserverHasVolumesOnAnotherAggregate with{
				logcomment("$FILER_C : Cannot delete aggregate $aggregate ");
			};
		}
	}else{
		my @non_root_aggr=();
		logcomment("$FILER_C: Deletion of aggregates");
		try{	
			my @aggrs = NACL::C::Aggregate->find( command_interface => $Node,
								filter => {nodes => [$FILER_C],'root' => 'false'});
			foreach my $aggr (@aggrs) {
				my $aggregates = $aggr->get_one_state_attribute('aggregate');
				push(@non_root_aggr,$aggregates);	
			}
			@non_root_aggr = sort {$b cmp $a}@non_root_aggr;
			logcomment("$FILER_C :Non root aggregates are @non_root_aggr");
		}catch NACL::Exceptions::NoElementsFound with {
			logcomment("$FILER_C : Non root aggregates are NOT found");
		};
		foreach my $aggregate(@non_root_aggr){
			try{ 
				NACL::STask::Aggregate->purge(
				command_interface => $Node,
				aggregate         => $aggregate,
				nacltask_verify=>  1,);  
			}catch NACL::Exceptions::NoElementsFound with {
				logcomment("Inside catch NACL::Exceptions::NoElementsFound with");
				logcomment("$FILER_C : Cannot delete aggregate $aggregate ");
			}catch NACL::APISet::Exceptions::CommandFailedException with{
				 try{
                    NACL::STask::Aggregate->purge(
                    command_interface => $Node,
                    aggregate         => $aggregate,
                    nacltask_verify=>  1);
                }catch NACL::APISet::Exceptions::CommandFailedException with{
					try{ 
						NACL::STask::Aggregate->purge(
						command_interface => $Node,
						aggregate         => $aggregate,
						nacltask_verify=>  1); 
					}catch NACL::APISet::Exceptions::CommandFailedException with{
						logcomment("$FILER_C : Cannot delete aggregate $aggregate, trying again");
						try{
							NACL::C::StorageAggregate->delete(
								command_interface => $Node,
								aggregate         => $aggregate,
								force => 'true',
								);
						}catch NACL::APISet::Exceptions::CommandFailedException with{
							logcomment("$FILER_C :: Cannot delete aggregate:: $aggregate");
						};
					};	
                };

			}catch NACL::Exceptions::VserverHasVolumesOnAnotherAggregate with{
				logcomment("$FILER_C :Cannot delete aggregate $aggregate ");
			};
		}
	}
	sleep 30;
}

##########################################################################################################
# Author -  arunak
# Description - This subroutine will return time-out based on disk attached.
# Usage - Mandatory parameter - Node object , Test object
# Return - max time-out value in seconds.
##########################################################################################################
sub get_max_timeout {
    my (%opts) = validate(
        @_,
        {
            node_present => { type => ARRAYREF},
            Test        => { type => OBJECT, optional => 1, default => '' },
        }
    );
    my @Nodes = @{$opts{node_present} };
    my $Test = $opts{Test};
    my @time_out_array =();
    my $max_disk_size = 0;
    my $timeout;
    foreach my $Node (@Nodes){
        my $Transit_obj;
        my $FILER_C = $Node->name();
		my $Mode = $Node->mode();
        $Transit_obj = NACL::Transit->new( name => $FILER_C );
        my $filer_state = $Transit_obj->get_state('timeout' => 600);
        logcomment("$FILER_C : Filer is in $filer_state ");
        if ($filer_state =~ /CLI|UP/){
			if ($Mode=~/CMode/i){
	            my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
				$Api_Set_Obj->execute_raw_command('command' =>"rows 0");
	            my $output = $Api_Set_Obj->execute_raw_command('command' =>"storage disk show -fields usable-size-mb" );
    	        foreach my $line(split(/\n/,$output)){
					if (($line=~/(X;X)(\d+)(X;X)/)||($line=~/(\s+)(\d+)(\s*)/)){
	                    if($max_disk_size < $2){
	                       $max_disk_size = $2;
    	                }
        	        }
            	}
				$max_disk_size = int($max_disk_size/(1024));
				logcomment( "maximum disk size is $max_disk_size GB");
				if($max_disk_size <= 10){
					$timeout = $timeout + 1200;
				}elsif($max_disk_size <= 1000){
					$timeout = $timeout + ( 1200 * 5 );
				}else{
					$timeout = $timeout + int($max_disk_size*12);
				}
				my ($sec,$min,$hour) = gmtime($timeout);
				logcomment("MAX timeout is $timeout seconds i.e $hour HOURS $min MINUTES $sec SECONDS");
				return $timeout;
			}
			
	        logcomment("Max disk size : $max_disk_size Blocks i.e ".int(($max_disk_size/2147483648)*1000)." GB");
            if ( $max_disk_size <= 20971520 ) {	
	            $timeout = $timeout + 1200;
            } elsif ( $max_disk_size <= 2147483648 ) {
                $timeout = $timeout + ( 1200 * 5 );
            } else {
               $timeout = $timeout + int(($max_disk_size/2147483648)*(12000));
            }
			my ($sec,$min,$hour) = gmtime($timeout);
			logcomment("MAX timeout is $timeout seconds i.e $hour HOURS $min MINUTES $sec SECONDS");
			return $timeout;
        }
        if ($filer_state =~ /MAINT/){
			my $disk_size;
            my $Host = host($FILER_C);
            my $API_OBJ = NACL::APISet->new(
                                hostobj   => $Host,
                                category  => "Node",
                                interface => "CLI",
                                set       => "Maintenance"
                            );
			$API_OBJ->set_timeout( "connectrec-timeout" => 1200 );
            my $disk_list_result = disk_list_data(
                                   API_Obj => $API_OBJ,
                                );
            foreach my $dsk ( keys %$disk_list_result ) {
                $disk_size = $disk_list_result->{$dsk}->{'BLOCKS'};
                $max_disk_size = $disk_size if ( $disk_size > $max_disk_size );
            }
            logcomment("Max disk size - $max_disk_size Blocks i.e ".int(($max_disk_size/2147483648)*1000)." GB");
            if ( $max_disk_size <= 20971520 ) {
	            $timeout = $timeout + 1200;
            } elsif ( $max_disk_size <= 2147483648 ) {
    	        $timeout = $timeout + ( 1200 * 5 );
            } else {
                $timeout = $timeout + int(($max_disk_size/2147483648)*(12000));
            }
			my ($sec,$min,$hour) = gmtime($timeout);
			logcomment("MAX timeout is $timeout seconds i.e $hour HOURS $min MINUTES $sec SECONDS");
			return $timeout;
        }
    }
}

###############################################################################
##	Auther 		- Arjun.Lavu@netapp.com
##
##	Description - This subroutine will return the hash which contains all the disk data which is 
##				  obtained by after executing "storage show disk -a".
##				  EX: WWN,Vendor etc if present
##
##	Usage 		- Mandatory paramanter - Node.
##
##	Compatibility	- this subroutine will work both in FILESYSTEM and MAINTENENCE mode (C Mode /7 Mode)

sub storage_show_disk_a_data {
	my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT },
			Armadillo  => {type => SCALAR, optional => 2, default => 0},
        }
    );
	
	my $Node=$opts{Node};
	my $Mode = $Node->mode();
	my $FILER_C = $Node->name();
	my $Host    = host($FILER_C);
	my $Armadillo = $opts{Armadillo};
	
	#**************************************************
	#Checking the filer state
	#**************************************************
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	
	my($API_obj,$output);
	##############################################
	##Based on mode(UP/MAINT) API object is created
	##############################################
	logcomment("Filer : $FILER_C : is in $filer_state state");
	if($filer_state =~/(CLI|UP)/){
		$API_obj = $Node->get_7m_or_nodescope_apiset();
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		logcomment("$FILER_C : Executing storage show disk -a");
		$output = $API_obj->execute_command( 'command' => "storage show disk -a" , 'timeout' => 1200);
	}elsif($filer_state =~/MAINT/){
		$API_obj = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance"
		);
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		logcomment("$FILER_C : Executing storage show disk -a");
		$output = $API_obj->execute_raw_command('command' => "storage show disk -a");
	}else{
		logcomment("$FILER_C : Filer is not in proper state to execute command");
	}
	my $disk_data={};
	my $key_val={};
	my @data_final;
	################################################################################################################
	##Total output is split into sections and starting section which contains text Unable to load any package
	## is deleted and rest is taken into one more array which contains required data about disks
	################################################################################################################	
	my @data_total=split(/\n/,$output);	##array @data_total will be having data of each disk as separate element
	#foreach(@data_total){
	#	if($_=~/Disk Qualification Package Details/){
	#		next;
	#	}else{
	#		push(@data_final,$_);
	#	}
	#}
	##If required data present
	if(@data_total){
		my $disk;
		###########################################################
		##Total lines are split with the delimiter ":" 
		##and first part is taken as key and second part is taken as value
		###########################################################
		foreach my $var(@data_total){
			if($var=~/Disk:\s(\S+)/){
				$disk=$1;
				##checking for Boab Configuration.
				if ( ( $Armadillo == 1 ) && ( $disk =~ /(.+)\.(.+)\.(.+)L\d$/ ) ){
				    #Splitting the drive name
					$disk = substr( $disk, 0, -2 );
				}
			}
			
			if($var=~/Package Date/){
				my($res) = $var=~/Package Date:\s+(.*)/;
				$disk_data->{'PackageDate'} = $res;
			}
			if($var =~/FileName/){
				my($res) = $var=~/FileName\s*=\s*(\S+)/;
				$disk_data->{'FileName'} = $res;
			}
			if($var =~/FileVersion/){
				my($res) = $var=~/FileVersion\s*=\s*(\S+)/;
				$disk_data->{'FileVersion'} = $res;
			}
			if($var =~/DriveRecordCount/){
				my($res) = $var=~/DriveRecordCount\s*=\s*(\S+)/;
				$disk_data->{'DriveRecordCount'} = $res;
			}
			if($var =~/AliasRecordCount/){
				my($res) = $var=~/AliasRecordCount\s*=\s*(\S+)/;
				$disk_data->{'AliasRecordCount'} = $res;
			}
			
			my @data=split(/\n/,$var);
			foreach my $line(@data){
				if($line=~/(.+):\s+(.+)/){
					my($key,$value)=$line=~/(.+):\s+(.+)/;
					$key = trim($key);
					$value = trim($value);
					$key_val->{$key}=$value if($key);
				}
			}
			for my $dat(keys %$key_val){
				$disk_data->{$disk}->{$dat} =$key_val->{$dat};
			}
			$key_val={};
		}
	}
	return $disk_data;	
}

##################################################################################################
##	Auther 		- arunak@netapp.com
##	Description - This subroutine will wipe all configurations and sets the cluster using entries
##				  from tharnhost file.
##	Usage 		- Mandatory paramanter - Node(single node object)
##									   - Test object.
##				  Call to this subroutine should be made using subtest.
##	Compatibility	- This subroutine will work both in FILESYSTEM and MAINTENENCE mode (CMode)
##################################################################################################
sub wipe_config_filers {
	 my (%opts) = validate(
        @_,
        {
            node   => { type => OBJECT},
	    event_time =>{type => SCALAR,optional => 1,default => 'NO'},
        }
    );
    my $Node = $opts{node};
    my $event_time = $opts{event_time};
	my $Image = $opts{image};
    my $Home = $ENV{HOME};
	my $Node_name = $Node->name();
	my $filer_info = `cat $Home/NDATE/FILER_INFO/$Node_name`;
	my $passwd;
	($passwd) = $filer_info=~/default_password\s*=\s*(\S+)\s*/ig;
	logcomment("password is $passwd");
	#############################################################################
	
	if ($event_time !~ /NO/){
	logcomment(scalar(localtime())." Starting for $event_time time");
	}
	my $time = get_max_timeout(node_present => [$Node]);
	my $Host = host($Node_name);
    my $API_OBJ = NACL::APISet->new(
            hostobj   => $Host,
            category  => "Node",
            interface => "CLI",
            set       => "Maintenance"
        );
	$API_OBJ->set_timeout( "connectrec-timeout" => 1200 );
	my $disk_tot = disk_show_drive_maint(API_Obj =>$API_OBJ,Filer=>$Node_name);
	my @drives = @{$disk_tot->{'driveA'}};
	my $total_tomeout = ($time*(scalar @drives));
	
	#############################################################################
	my $prompt_fw ;
	my $wipeclean_timeout = 660;
	my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
    # Retreive valid prompts from NATE
	my $host = Tharn::host($Node_name);
	my $prompt_array = $host->prompt_fw();
    my $prompts = join("|",@$prompt_array);
    $prompt_fw = "($prompts)";
    logcomment("This is the prompt regex: $prompt_fw");
	logcomment("Disable cluster/HA pair");
	my $Server = new Server(no_cli=>1);
    $Server->set_execution_server(-Server => $Node_name);
#    $Server->console(cmd => "storage failover modify -node * -enabled false -auto-giveback false" );
#    logcomment("Enabled  storage failover");

	
	my $Transit_obj = NACL::Transit->new( name => $Node_name);
	my $conn = $Transit_obj->{'conn'};
	$Transit_obj->set('timeout' => 600, maxcycle => 20);
	# {
		# $Transit_obj->change_state( to => "FIRMWARE");
		# my $Server = new Server(no_cli=>1);
		# my @filer_working=$Server->servers();
		# logcomment("Filers we are working on : @filer_working");
		# my $timeout = "90000";  # Change timeout in final code.
		# $timeout = $total_tomeout if($total_tomeout>$timeout);
		# logcomment("Setting timeout : $timeout seconds");
		# $Server->set_execution_server(-Server => $Node_name); #set the execution server to the current node
		# logcomment("Execution server set to $Node_name");
		# $Server->console(cmd=>"setenv root-uses-shared-disks? false",
							# additional_prompts_timeout => $timeout,
							# ignore => $ignore_strings,
							# additional_prompts => { 
								# "$prompt_fw" => "FINAL_PROMPT"
							# }	
						# );
		# $Server->console(cmd=>"printenv",
							# additional_prompts_timeout => $timeout,
							# ignore => $ignore_strings,
							# additional_prompts => {
								# "$prompt_fw" => "FINAL_PROMPT"
							# }
						# );
	# }
	$Transit_obj->change_state( to => "BOOT_MENU");		
	logcomment("$Node_name : Filer is in boot_state");
	logcomment("$Node_name : Creating Server object");
	my $Server = new Server(no_cli=>1);
	my @filer_working=$Server->servers();
	logcomment("Filers we are working on : @filer_working");

	my $timeout = "90000";  # Change timeout in final code.
	$timeout = $total_tomeout if($total_tomeout>$timeout);
    logcomment("Setting timeout : $timeout seconds");
	logcomment("Set execution server");
	$Server->set_execution_server(-Server => $Node_name); #set the execution server to the current node
	logcomment("Boot_menu wipe clean util called ".scalar(localtime()));
	logcomment("Execution server set to $Node_name");
	logcomment("Disable password ");
	$Server->console(cmd=>"options security.passwd.rules.everyone off", noprompt=>1);
	eval {
        $Server->console(cmd => "4",
                         additional_prompts_timeout => $timeout,
                         ignore => $ignore_strings,
                         additional_prompts => {
								".*Zero disks, reset config and install a new file system.*" => "yes",
								".*reset config and install a new file.*"	=> "yes",
								".*erase all the data on the disks.*"	=> "yes",
                                ".*want to continue.*"   => "y",
                                "Rebooting to finish" => "FATAL_PROMPT",
                                "$prompt_fw" => "FINAL_PROMPT",
                                "Selection " => "FINAL_PROMPT",
                                "login"     =>  "admin",
								".*Type yes to confirm and continue.*" => 'exit',
                                "::>"       => "FINAL_PROMPT",
                                ".*Password.*" => "$passwd",
	
                                }
        );
    };

	if ( $@ ) {
        if ( $@ !~ /Err=TIMEOUT/ ) {
            if ( $@ =~ /Rebooting to finish/ ) {
				my $Transit_obj = NACL::Transit->new( name => $Node_name);
				logcomment("Changing state to firmware");
				$Server->set_execution_server(-Server => $Node_name);
				$Transit_obj->change_state( to => "FIRMWARE");
                my $conn = $Server->get_connection(type=>"console_connection");
				$Server->console(cmd => "setenv AUTOBOOT false",
										ignore => $ignore_strings,
										additional_prompts => {
											"$prompt_fw" => "FINAL_PROMPT",
											"::>"       => "FINAL_PROMPT",
											".*Type yes to confirm and continue.*" => 'exit',
										}
								);
				sleep 10;
                $Server->console(cmd => "setenv bootarg.init.boot_clustered true",
                                        ignore => $ignore_strings,
                                        additional_prompts => {
                                            "$prompt_fw" => "FINAL_PROMPT",
                                            "::>"       => "FINAL_PROMPT",
											".*Type yes to confirm and continue.*" => 'exit',
                                        }
                                );
                sleep 10;
				$Server->console(cmd => "boot_ontap",
								additional_prompts_timeout => $timeout,
								ignore => $ignore_strings,
								additional_prompts => {
									"$prompt_fw" => "FINAL_PROMPT",
									"::>"       => "FINAL_PROMPT",
									"Do you want to create a new cluster or join an existing cluster? {create, join}:" => "exit",
									"{create, join}:" => "exit",
									".*create a new cluster or join an existing.*"	=> "exit",
									".*Enter the node management interface IP address.*" => "exit",
									"Enter the node management interface port .*"   => "exit",
									".*Type yes to confirm and continue.*" => 'exit',
									".* Enter the .*"       => "exit",
									"Password:"	=> "$passwd",
									".*management interface port.*" => "exit",
									".*interface IP address.*"	=> "exit",
									".*the node management.*"	=> "exit",
									"login"     =>  "admin",
									".*Password.*" => "$passwd",
								}
				);
            } else {
                logcomment("Unknown error during wipeconfig:$@");
            }
        } else {
            logcomment("Timeout during wipeconfig:$@");
        }
    }
	logcomment("Renaming node ");
    try {
        $Server->console(cmd=>"node rename -newname $Node_name",
                         additional_prompts_timeout => $timeout,
                         ignore => $ignore_strings,
                         additional_prompts => {
                                    "$prompt_fw" => "FINAL_PROMPT",
                                    "::>"       => "FINAL_PROMPT",
                                    "login"     =>  "admin",
                                    ".*Password.*" => "$passwd",
                         }
        );
        logcomment("Changing session timeout Value");
		$Server->console(cmd=>"system timeout modify -timeout 3000",
                        additional_prompts_timeout => $timeout,
                        ignore => $ignore_strings,
                        additional_prompts => {
                                   "$prompt_fw" => "FINAL_PROMPT",
                                   "::>"       => "FINAL_PROMPT",
                                   "login"     =>  "admin",
                                   ".*Password.*" => "$passwd",
                        }
        );
    } catch NACL::Transit::Exceptions::TransitException with {
        my $exception_object = shift;
        logcomment("Exception is of type: " . ref ($exception_object));
        logcomment("Error text is: " . $exception_object->text());
    };
	logcomment("Checking State of Filer");	
	my $Transit_obj = NACL::Transit->new( name => $Node_name);
    my $conn = $Transit_obj->{'conn'};
	my $timeout = "1900";
    my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
    logcomment("Checking state ".scalar(localtime()));
	my $current_state  = $Transit_obj->get_state('timeout' => 600);
	if ($current_state =~ /USERNAME|PASSWORD/){
		$Transit_obj->change_state( to => "CLI");
	}
	logcomment("Verifying Node name ");	
	try {
		$Server->console(cmd=>"node rename -newname $Node_name",
						 additional_prompts_timeout => $timeout,
						 ignore => $ignore_strings,
						 additional_prompts => {
									"$prompt_fw" => "FINAL_PROMPT",
									"::>"       => "FINAL_PROMPT",
									"login"     =>  "admin",
									".*Password.*" => "$passwd",
						 }
		);
		logcomment("Changed node name");
    } catch NACL::Transit::Exceptions::TransitException with {
        my $exception_object = shift;
        logcomment("Exception is of type: " . ref ($exception_object));
		logcomment("Error text is: " . $exception_object->text());
    };
	logcomment("Completed 4d Booting , Proceeding with cluster create");
	        if ($event_time !~ /NO/){
        logcomment("Completed booting for $event_time time");
        }
}

##################################################################################################
##  Auther      - arunak@netapp.com
##  Description - This subroutine will setup cmode filer (wipe config and create,join cluster)
##  Usage       - Mandatory paramanter - node_present(All the node -Array reference)
##  Compatibility   - This subroutine will work both in FILESYSTEM mode CMode
##################################################################################################
sub setup_cmode_filers {
	my (%opts) = validate(
    @_,
        {
            node_present => { type => ARRAYREF},
			Test        => { type => OBJECT },
			delete_mini_disk	=>{ type => SCALAR,optional => 1,default => 'YES'},
			remove_assign_disk =>{type => SCALAR,optional => 1,default => 'YES'},
			event_time =>{type => SCALAR,optional => 1,default => 'NO'},
        }
    );
    my @Nodes = @{ $opts{node_present} };
	
	my $Test = $opts{Test};
	my $delete_mini_disk = $opts{delete_mini_disk};
	my $remove_assign_disk = $opts{remove_assign_disk};
	my $event_time = $opts{event_time};
	logcomment("Node Present :");
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		logcomment(" $FILER_C");
	}
	logcomment("Setup Cmode filer");
	my $Home = $ENV{HOME};
    my @subtests;
    my $prompt_fw;
    my $Transit_obj;
    my $Server = new Server(no_cli=>1);
# Check state and boot in maintenancae
	my @change_2_maint =();
	my $flag = 0;
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		logcomment("Checking state of filer");
		my $Transit_obj = NACL::Transit->new( name => $FILER_C );
		my $filer_state = $Transit_obj->get_state('timeout' => 600);
		logcomment("Filer : $FILER_C is in $filer_state state");
		if ($filer_state !~ /MAINT/){
			logcomment("Filer $FILER_C is not in maintenance mode, Changing state to maintenance");
			push(@change_2_maint, $FILER_C);
			$flag = 1;
		}
	}
	if ($flag == 1 ){
		my @state_subtest;
		foreach my $filer(@change_2_maint) {
			logcomment("Changing state of filer - $filer to maintenance");	
			push(@state_subtest, subtest(
                                \&boot_filer_in_req_state, -runid,
                                "change_state_to_maint_" . "$filer", -bg,
                                "--", filer_name => $filer,
								Test       => $Test,
								change_state_to => 'MAINT',
	                     )
				);
		}
		Subtest::wait_finish( subtest => [@state_subtest] );
	} else {
		logcomment("Filer is in MAINTENANCE Mode");
	}
	# get_config_status(Nodes =>[@Nodes]);
## check for chassis and controller ha configurations
    foreach my $Node(@Nodes){
        my $FILER_C = $Node->name();
        my $host        = host($FILER_C);
        my $Api_Set_Obj = NACL::APISet->new(
            hostobj   => $host,
            category  => "Node",
            interface => "CLI",
            set       => "Maintenance"
            );

        HA_config(API_Obj => $Api_Set_Obj);
    }
	destroy_root_volume(Noderef =>[@Nodes]);
	remove_partition(Noderef =>[@Nodes]);
	check_disk_owner( Noderef  => [@Nodes]);
	disk_remv_assign_ownership(Node_ref =>\@Nodes) if($remove_assign_disk=~/YES/i);
# mini disk delete
	if($delete_mini_disk=~/YES/i){	#deleting mini_disks if parameter mini_disk_delete is YES else not
		$Test->nlog("Deleting the MINI_DISKS");
		my @mini_subtests;
		foreach my $Node(@Nodes){
			my $FILER_C = $Node->name();
			push(@mini_subtests, subtest(
                                \&delete_mini_disk, -runid,
                                "delete_mini_disk_" . "$FILER_C", -bg,
                                "--", node => $Node,
                     )
			);
		}
		Subtest::wait_finish( subtest => [@mini_subtests] );
		sleep 10;
	}
	logcomment("Basic check of filer and disk completed");
	logcomment("Proceeding with wipe config and cluster setup");
	
    foreach my $Node(@Nodes){
        my $FILER_C   = $Node->name();
		my $filer_info = `cat $Home/NDATE/FILER_INFO/$FILER_C`;
		my $passwd;
		($passwd) = $filer_info=~/default_password\s*=\s*(\S+)\s*/ig;
        $Server->set_execution_server(-Server => $FILER_C);
        $Transit_obj = NACL::Transit->new( name => $FILER_C );
        my $filer_state = $Transit_obj->get_state('timeout' => 600);
		my $timeout = "1900";
	    my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
        logcomment("Filer $FILER_C is in $filer_state state");
        if ($filer_state =~ /CLI|UP/i){
            try {
				$Server->console(cmd=>"node rename -newname $FILER_C",
                        additional_prompts_timeout => $timeout,
                        ignore => $ignore_strings,
                        additional_prompts => {
                                   "$prompt_fw" => "FINAL_PROMPT",
                                   "::>"       => "FINAL_PROMPT",
                                   "login"     =>  "admin",
                                   ".*Password.*" => "$passwd",
                        }
		        );
                logcomment("Changed node name");
            } catch NACL::Transit::Exceptions::TransitException with {
                my $exception_object = shift;
                logcomment("Exception is of type: " . ref ($exception_object));
                logcomment("Error text is: " . $exception_object->text());
            };
        }
        if ($filer_state !~ /CLI|UP|MAINT/i){
            $Transit_obj->change_state(to => "MAINT");
        }
    }
    logcomment("Wipe config for the filers will be initiated".scalar(localtime()));
    if ( $event_time =~ /NO/ ){
    foreach my $Node (@Nodes){
        my $filer_name = $Node->name();
        push(@subtests, subtest(\&wipe_config_filers, -runid,
                               "wipe_config_filers_" . "$filer_name", -bg,
                               "--", node => $Node,
                         )
            );
     }
    }else {
    foreach my $Node (@Nodes){
        my $filer_name = $Node->name();
        push(@subtests, subtest(\&wipe_config_filers, -runid,
                               "wipe_config_filers_" . "$filer_name", -bg,
                               "--", node => $Node,
				event_time => $event_time,
                         )
            );
     }
    } 
     logcomment("Subtest @subtests");
     Subtest::wait_finish( subtest => [@subtests] );
    logcomment("Wipe config completed".scalar(localtime()));
     my ( $fail_cnt, $fatal_cnt );
     my @results;
     foreach my $subtest (@subtests) {
         @results = $subtest->rslts();
         foreach my $result (@results) {
             if ( $result->type() =~ /INFO/ ) {
                 logcomment("Subtest boot_filer_in_req_state completed successfully");
             } elsif ( $result->severity() >= 0 ) {
                 logcomment("Subtest boot_filer_in_req_state not completed successfully");
                 if ( $result->type() =~ /FAIL/i ) {
                     $fail_cnt++;
                 }
                 if ( $result->type() =~ /FATAL|SCRIPT|CONFIG/ ) {
                     $fatal_cnt++;
                 }
             } ## end elsif ($result->severity(...
         } ## end foreach my $result (@results)
     } ## end foreach my $subtest (@subtests)
     if ( $fail_cnt == 0 ) {
        logcomment("FILER Booted the filer successfully in required state");
     }
     my $Server = new Server(no_cli=>1);
     logcomment("Server /Nodes working :");
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		 logcomment(" $FILER_C");
	}

     my $filer_state;
    foreach my $Node (@Nodes) {
        my $FILER_C;
        try {
             $FILER_C = $Node->name();
			 logcomment("Cheking the state of filer $FILER_C");
             my $Transit_obj = NACL::Transit->new( name => $FILER_C);
             $filer_state = $Transit_obj->get_state('timeout' => 600);
             logcomment("Filer : $FILER_C is in $filer_state state");
        } catch NACL::Transit::Exceptions::TransitException with {
			logcomment("Caught TransitException exception");
            my $exception_object = shift;
            logcomment("Filer - $FILER_C : is in $filer_state state");
        };
    }
	
	logcomment("Node Present :");
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		 logcomment(" $FILER_C");
	}
    @Nodes = sort(@Nodes);
    logcomment("Node sorted :");
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		 logcomment(" $FILER_C");
	}
    foreach my $a (@Nodes){
		my $fil_name = $a->name();
        logcomment("Node name is - $fil_name");
    }
    logcomment("Creating cluster using nodes available");
    create_join_cluster(node_present => [@Nodes]);
    logcomment("Completed creating and joining cluster ");
    my @temp_nodes = NACL::C::Node->find();      # Find Nodes/Filers used in the test, Based on FILER param.
	my %nodes_filer; 
   foreach my $Node (@temp_nodes) {
        my $FILER_C = $Node->name();
        $nodes_filer{$FILER_C} = [$Node];
    }
	my @Nodes_all = map{@{$_}}grep{(/\S/)}values(%nodes_filer); # Contains Node object used for test execution.
	foreach my $Node(@Nodes_all){
		my $FILER_C   = $Node->name();
		my $Home = $ENV{HOME};
		system("rm -rf $Home/.ssh/known_hosts");
		$Home = trim($Home);
		my $host_file    = "$Home/NDATE/FILER_INFO/$FILER_C";
		my $filer_config = `cat $host_file`;
		my $def_pass;
		foreach my $line ( split /\n/, $filer_config ) {
			if($line =~/^default_password=(.*)/ ) {
				$def_pass = $1;
				logcomment("$FILER_C : Changing the diag mode password to $def_pass");
				last;
			}	
		}
		try{
			my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
			$Api_Set_Obj->execute_raw_command('command' =>"security login unlock -username diag");
			my $prompts_answers = ['Enter a new password:'=> "$def_pass",'Enter it again:'=>"$def_pass"];
	        $Api_Set_Obj->execute_raw_command('command' =>"security login password -username diag",'connectrec-match_table' => $prompts_answers); 
			$Api_Set_Obj->execute_raw_command('command' =>"version");
		}catch NATE::BaseException with{
			logcomment("$FILER_C : Caught base exception, Connection problem");
		};
	}
}
##################################################################################################
##	Auther 		- arunak@netapp.com
##	Description - This subroutine will create cluster and join cluster. All inputs are captured from
##					tharn host file.
##	Usage 		- Mandatory paramanter - node_present(All the node -Array reference)
##	Compatibility	- This subroutine will work both in FILESYSTEM mode CMode
##################################################################################################
sub create_join_cluster {
	my (%opts) = validate(
	@_,
    	{
			node_present => { type => ARRAYREF},
        }
    );
    my @Nodes = @{ $opts{node_present} };
	logcomment("Node Present :");
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		 logcomment(" $FILER_C");
	}
	logcomment("Creating Server object");
    my $Server = new Server(no_cli=>1);
#Params
	my %nodes_filer;
	my $base_license;
	my $base_license_sec ='NULL';
    my $cluste_name;
	my $cluster_port_1;
	my $cluster_ip;
	my $cluster_mask;
	my $cluster_gateway;
	my $cluster_mtu;
	my $def_pass;
	my $cluster_mgmt_inter_port;
	my $cluster_mgmt_ip;
	my $cluster_mgmt_gateway;
	my $cluster_mgmt_mask;
	my $cluster_mgmt_mtu;
	my $node_mgmt_inter_port;
	my $node_mgmt_ip;
	my $node_mgmt_gateway;
	my $node_mgmt_mask;
	my $node_mgmt_mtu;

	foreach my $Node(@Nodes){
        logcomment("Node - $Node");
        my $FILER_C = $Node->name();
        logcomment("Name - $FILER_C");
        $nodes_filer{$FILER_C}=$Node;
	}
	my @filer_working = ();
	@Nodes = keys(%nodes_filer);  # Contains Node names
	@filer_working = sort(@Nodes);
	
    logcomment("Filers we are working on : @filer_working");
	logcomment("Setting execution server to $filer_working[0]");
	my $Home = $ENV{HOME};
	$Home = trim($Home);
	my $host_file_C    = "$Home/NDATE/FILER_INFO/$filer_working[0]"."_C";
	my $host_file    = "$Home/NDATE/FILER_INFO/$filer_working[0]";
	system("sudo cp -rf $host_file_C $host_file");
	my $filer_config = `cat $host_file`;
	foreach my $line ( split /\n/, $filer_config ) {
		if ( $line =~ /^\#/ ) {
	        next;    # skip overall result report starting with a '#'.
        }
		elsif ( $line =~ /^CLUSTER_NAME=(.*)/ ) {
			$cluste_name = $1;
		}
		elsif ( $line =~ /^BASE_LICENSE=(.*)/ ) {
			$base_license = $1;
		}
		elsif ( $line =~ /^SECONDARY_BASE_LICENSE=(.*)/i ) {
			my $temp = $1;
			$temp=~s/^\s+|\s+$//g;
			if($temp=~/^NULL$/i){
				$base_license_sec = $base_license;
			}else{
				$base_license_sec = $temp;
			}
		}
        elsif ( $line =~ /^CLUSTER_PORT1=(.*)/ ) {
            $cluster_port_1 = $1;
        }
        elsif ( $line =~ /^CLUSTER_IP1=(.*)/ ) {
            $cluster_ip = $1;
        }
        elsif ( $line =~ /^CLUSTER_MASK1=(.*)/ ) {
            $cluster_mask = $1;
        }
		elsif ( $line =~ /^CLUSTER_GATEWAY1=(.*)/ ) {
			$cluster_gateway = $1;
		}
		elsif ( $line =~ /^CLUSTER_MTU1=(.*)/ ) {
			$cluster_mtu = $1;
		}
		elsif ( $line =~ /^default_password=(.*)/ ) {
			$def_pass = $1;
		}
		elsif ( $line =~ /^CLUSTER_MGMT_PORT=(.*)/ ) {
			$cluster_mgmt_inter_port = $1;
		}
		elsif ( $line =~ /^CLUSTER_MGMT_IP=(.*)/ ) {
			$cluster_mgmt_ip = $1;
		}
		elsif ( $line =~ /^CLUSTER_MGMT_GATEWAY=(.*)/ ) {
			$cluster_mgmt_gateway = $1;
		}
		elsif ( $line =~ /^CLUSTER_MGMT_MASK=(.*)/ ) {
			$cluster_mgmt_mask = $1;
		}
		elsif ( $line =~ /^CLUSTER_MGMT_MTU=(.*)/ ) {
			$cluster_mgmt_mtu = $1;
		}
		elsif ( $line =~/^MGMT_PORT=(.*)/ ) {
            $node_mgmt_inter_port = $1;
        }
        elsif ( $line =~ /^MGMT_IP=(.*)/ ) {
            $node_mgmt_ip = $1;
        }
        elsif ( $line =~ /^MGMT_GATEWAY=(.*)/ ) {
            $node_mgmt_gateway = $1;
        }
        elsif ( $line =~ /^MGMT_MASK=(.*)/ ) {
            $node_mgmt_mask = $1;
        }
        elsif ( $line =~ /^MGMT_MTU=(.*)/ ) {
            $node_mgmt_mtu = $1;
		}
	}
	$base_license_sec = $base_license if($base_license_sec=~/^NULL$/i); ##if param SECONDARY_BASE_LICENSE is not present in filer_conig
	$Server->set_execution_server(-Server => $filer_working[0]); #set the execution server to the current node
	logcomment("Server is set to $filer_working[0]");
	my $timeout = "1900";
	my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
	my $host = Tharn::host($filer_working[0]);
    my $prompt_array = $host->prompt_fw();
    my $prompts = join("|",@$prompt_array);
    my $prompt_fw = "($prompts)";
    logcomment("This is the prompt regex: $prompt_fw");
	
	####################################################################
	my $Transit_obj = NACL::Transit->new( name => $filer_working[0]);
	my $state = $Transit_obj->get_state('timeout' => 600);
	
	if($state=~/USERNAME|pass/ig){			##if filer is in USERNAME mode that means filer is in CMODE, so for safety reading
		logcomment("password is - $def_pass");
		try{
			$Server->console(cmd => "\n",
				additional_prompts_timeout => 600,
				ignore => $ignore_strings,
				additional_prompts => {
					".*login.*" => "admin",
					".*Password.*" => $def_pass,
					".*::>.*" => "FINAL_PROMPT",
					".*Login incorrect.*" => 'FATAL_PROMPT',
					"$prompt_fw" => "FINAL_PROMPT",
				}
			);
		}catch NATE::BaseException with{
			logcomment("FILER  - $filer_working[0] : WARNING : Incorrect login, Please check the configuration file ");
		};
	}else{
		logcomment("Filer $filer_working[0] state is - $state");
		
		if($state=~/FIRMWARE|MAINT/i){
			logcomment("Filer : $filer_working[0] : is in $state state, so cannot create the cluster");
			logresult('FATAL',"Filer : $filer_working[0] : is in $state state, so cannot create the cluster");
		}
	}
	
	####################################################################
	try{
		logcomment("Executing cluster setup");
		$Server->console(cmd => "cluster setup",
                        additional_prompts_timeout => $timeout,
                        ignore => $ignore_strings,
						additional_prompts => {
                                "want to continue"   => "y",
                                "Rebooting to finish" => "FATAL_PROMPT",
                                "$prompt_fw" => "FINAL_PROMPT",
                                "Selection " => "FINAL_PROMPT",
                                "Starting AUTOBOOT" => "\cc",
                                "Do you want to create a new cluster or join an existing cluster? {create, join}:" => "create",
								".*{join}.*" => "FATAL_PROMPT",
								"Do you want to create a new cluster or join an existing cluster? {join}:"	=> "FATAL_PROMPT",
                                "{create, join}:" => "create",
                                "login"     =>  "admin",
								".*DNS.*"	=> "\013",
								"Do you intend for this node to be used as a single node cluster?"  => "no",
								"Do you want to use this configuration? {yes, no} [yes]:"	=> "no",
								"Do you want to use this configuration?" => "no",
								".*to reboot now to set storage failover (SFO) to HA mode.*"	=> "no",
								".*{yes, no} [yes]:.*"	=> "no",
								".*Do you want to reboot now to set storage failover (SFO) to HA mode.*" => "no",
								".*reboot now to set storage failover (SFO).*" => "no",
								".*Enable IPv4 DHCP on the service processor interface.*" => "no",
								"Do you want to use these defaults?" => "no",
								"List the private cluster network ports"	=> $cluster_port_1,
								".*Enter the cluster ports' MTU size.*"	=>	$cluster_mtu,
								"Enter the cluster network netmask"		=> $cluster_mask,
								"Enter the cluster interface IP address for port" => $cluster_ip,
								".*Enter the IP address of an interface on the.*"=> $cluster_ip,
								"Will the cluster network be configured to use network switches?" => "no",
								"Enter the cluster name:"	=> $cluste_name,
								"Enter the cluster base license key:" =>  $base_license,
								".*The base license key for the cluster can be obtained from your sales or support.*" => $base_license_sec,
								".*the value \"$base_license_sec\" is invalid for.*" => "FATAL_PROMPT",
								".*Enter an additional license key.*" => "\013",
								".*Enter the system config backup destination address.*" => "\013",
                                "::>"       => "FINAL_PROMPT",
                                ".*Password.*" => $def_pass,
								".*Retype the password.*" => $def_pass,
								".*cluster management interface port.*"	=> $cluster_mgmt_inter_port,
								".*cluster management interface IP address.*" => $cluster_mgmt_ip,
								".*cluster management interface netmask.*"	=> $cluster_mgmt_mask,
								".*cluster management interface default gateway.*" => $cluster_mgmt_gateway,
								".*Enter the DNS domain names:.*"	=> "\013",
								".*Where is the controller located.*" => "SVL",
								".*cluster administrator's.*"	=> $def_pass,
								".*Password.*"	=> $def_pass,
								".*node management interface port.*"    => $node_mgmt_inter_port,
								".*node management interface IP address.*"	=>$node_mgmt_ip,
								".*node management interface netmask.*"  => $node_mgmt_mask,
								".*node management interface default gateway.*" => $node_mgmt_gateway,
								".*Enter the service processor interface IP address.*" =>'1.1.1.1',
								".*Enter the service processor interface netmask.*" => $node_mgmt_mask,
								".*Enter the service processor interface default gateway.*" =>'1.1.1.1',
								".*Error.*"	=> "FATAL_PROMPT",
								".*Exiting the cluster setup wizard.*"	=> "FINAL_PROMPT",
								"::*>"	=> "FINAL_PROMPT",
								".*Cluster setup is now complete.*"	=>	"FINAL_PROMPT",
								".*::>.*"   =>"FINAL_PROMPT",
								".*reboot now to set storage failover.*"    => "no",
                                }
        );
	}catch NACL::Transit::Exceptions::TransitException with {
			my $exception_object = shift;
			logcomment("Exception is of type: " . ref ($exception_object));
			logcomment("Error text is: " . $exception_object->text());
	}catch NATE::BaseException with{
		logcomment("CAUGHT BASE Exception ");
		sleep 10;
		my $string = $Server->console(cmd =>"exit",
		additional_prompts_timeout => '120',
                        ignore => $ignore_strings,
                        additional_prompts => {
						"$prompt_fw" => "FINAL_PROMPT",
						".*::>.*"   =>"FINAL_PROMPT",
					}
			);
		logcomment("FATAL error is : $string");
		logresult('FATAL',"Error occured during cluster creation");
	};
	logcomment("Cluster created");
	sleep 10;
	logcomment("Joining cluster ");
	logcomment("Node $filer_working[1] is being joined to $filer_working[0]");
	my $Home = $ENV{HOME};
    $Home = trim($Home);
	my $host_file_C    = "$Home/NDATE/FILER_INFO/$filer_working[1]"."_C";
	my $host_file    = "$Home/NDATE/FILER_INFO/$filer_working[1]";
	system("sudo cp -rf $host_file_C $host_file");
    my $host_file    = "$Home/NDATE/FILER_INFO/$filer_working[1]";
    my $filer_config = `cat $host_file`;
	my $cluster_port_1;
	my $cluster_mtu_2;
	my $cluster_mask;
	my $cluster_ip;
	my $node_mgt_inter_ip;
	my $node_mgt_inter_port;
	my $node_mgt_inter_mask;
	my $node_mgt_inter_gateway;
	my $MTU_error;
	my $def_pass;
    foreach my $line ( split /\n/, $filer_config ) {
        if ( $line =~ /^\#/ ) {
            next;    # skip overall result report starting with a '#'.
        }
		elsif ( $line =~ /^CLUSTER_NAME=(.*)/ ) {
            $cluste_name = $1;
        }
        elsif ( $line =~ /^CLUSTER_PORT1\=(.*)/ ) {
            $cluster_port_1 = $1;
        }
        elsif ( $line =~ /^CLUSTER_IP1=(.*)/ ) {
            $cluster_ip = $1;
		}
		elsif ( $line =~ /^CLUSTER_MTU1=(.*)/ ) {
			$cluster_mtu_2 = $1;
		}
		elsif ( $line =~ /^CLUSTER_MASK1=(.*)/ ) {
            $cluster_mask = $1;
        }
		elsif ( $line =~ /^MGMT_IP=(.*)/ ) {
            $node_mgt_inter_ip = $1;
        }
		elsif ( $line =~ /^MGMT_PORT=(.*)/ ) {
            $node_mgt_inter_port = $1;
        }
		elsif ( $line =~ /^MGMT_MASK=(.*)/ ) {
            $node_mgt_inter_mask = $1;
        }
		elsif ( $line =~ /^MGMT_GATEWAY=(.*)/ ) {
            $node_mgt_inter_gateway = $1;
        }
		elsif ( $line =~ /^default_password=(.*)/ ) {
            $def_pass = $1;
        }
	}
	if($cluster_mtu!~/^$cluster_mtu_2$/){
		logcomment("MTU value of the filer $filer_working[1] is not same as MTU value of the filer $filer_working[0], \nSo for cluster joining MTU values $cluster_mtu is considered");
		$cluster_mtu_2 = $cluster_mtu;
	}
	logcomment("Setting execution server to $filer_working[1]");
    $Server->set_execution_server(-Server => $filer_working[1]);

	####################################################################
	my $Transit_obj2 = NACL::Transit->new( name => $filer_working[1]);
	my $state2 = $Transit_obj2->get_state('timeout' => 600);
	if($state2=~/USERNAME|pass/ig){			##if filer is in USERNAME mode that means filer is in CMODE, so for safety reading
		logcomment("password is - $def_pass");
		try{
			$Server->console(cmd => "\n",
				additional_prompts_timeout => 600,
				ignore => $ignore_strings,
				additional_prompts => {
					".*login.*" => "admin",
					".*Password.*" => $def_pass,
					".*::>.*" => "FINAL_PROMPT",
					".*Login incorrect.*" => 'FATAL_PROMPT',
					"$prompt_fw" => "FINAL_PROMPT",
				}
			);
		}catch NATE::BaseException with{
			logcomment("FILER  - $filer_working[1] : WARNING : Incorrect login, Please check the configuration file ");
		};
	}else{
		logcomment("State of filer is : $state2");
		if($state2=~/FIRMWARE|MAINT/i){
			logcomment("Filer : $filer_working[1] : is in $state2 state, so cannot join the cluster");
			logresult('FATAL',"Filer : $filer_working[1] : is in $state2 state, so cannot join the cluster");
		}
	}
	sleep 60;
	my $join_cnt =0;
	my $joining_output;
	####################################################################
	join_again:
	if($MTU_error == 1){
		my $Api_Set_Obj = $nodes_filer{$filer_working[0]}->get_7m_or_nodescope_apiset(connid => "console");
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		my $prompts_answers = [ ".*Do you want to continue.*" => 'y' ];
		$Api_Set_Obj->execute_raw_command('command' =>"broadcast-domain show");
		$Api_Set_Obj->execute_raw_command('command' =>'broadcast-domain modify -mtu 1500 *','connectrec-match_table' => $prompts_answers );
		$Api_Set_Obj->execute_raw_command('command' =>"broadcast-domain show");
		$Api_Set_Obj->execute_raw_command('command' =>'broadcast-domain modify -mtu 1500 *','connectrec-match_table' => $prompts_answers );
		$Api_Set_Obj->execute_raw_command('command' =>"broadcast-domain show");
		# my $Server = new Server(no_cli=>1);
		$Server->set_execution_server(-Server => $filer_working[1]);
		try{
		$Server->console(cmd => "net port modify -node $filer_working[1] -port \* -mtu 1500",
                         additional_prompts_timeout => $timeout,
                         ignore => $ignore_strings,
                         additional_prompts => {
                                ".*Do you want to continue.*"   => "y",
								"$prompt_fw" => "FINAL_PROMPT",
								"::>"	=> "FINAL_PROMPT",
						}
				);
		$Server->console(cmd => "net port show",
                    additional_prompts_timeout => $timeout,
                    ignore => $ignore_strings,
                    additional_prompts => {
                           ".*Do you want to continue.*"   => "y",
						   "$prompt_fw" => "FINAL_PROMPT",
						   "::>"	=> "FINAL_PROMPT",
				}
		);
		}catch NATE::BaseException with{
			logcomment("Caught exception in setting MTU values");
		};
		$cluster_mtu_2=1500;
	}
		try{
			logcomment("Joining cluster");
			$joining_output = $Server->console(cmd => "cluster setup",
                         additional_prompts_timeout => $timeout,
                         ignore => $ignore_strings,
                         additional_prompts => {
                                "want to continue"   => "y",
                                "$prompt_fw" => "FINAL_PROMPT",
                                "Starting AUTOBOOT" => "\cc",
                                "Do you want to create a new cluster or join an existing cluster? {create, join}:" => "join",
								"Do you want to create a new cluster or join an existing cluster? {join}:"  => "join",
                                "{create, join}:" => "join",
								".*create a new cluster or join an existing.*"	=> "join",
								".*{join}.*"	=> "join",
                                "login"     =>  "admin",
								".*private cluster network ports.*"	=>	$cluster_port_1,
								".*cluster ports' MTU size.*"	=> $cluster_mtu_2,
								".*cluster network netmask.*"	=> $cluster_mask,
								".*cluster interface IP address for port.*"	=> $cluster_ip,
								".*Enter the IP address of an interface on the.*"=> $cluster_ip,
								".*Enter the name of the cluster you would like to join.*"	=> $cluste_name,
								".*the node management interface port.*"	=> $node_mgt_inter_port,
								".*Restarting Cluster Setup.*" => "FATAL_PROMPT",
								".*node management interface IP address.*"  =>$node_mgt_inter_ip,
                                ".*node management interface netmask.*"  =>$node_mgt_inter_mask,
                                ".*node management interface default gateway.*" => $node_mgt_inter_gateway,
								".*Enter the service processor interface IP address.*" =>'1.1.1.1',
								".*Enter the service processor interface netmask.*" => $node_mgt_inter_mask,
								".*Enter the service processor interface default gateway.*" =>'1.1.1.1',
								".*Enter the system config backup destination address.*"	=> "\013",
                                "Do you intend for this node to be used as a single node cluster?"  => "no",
                                "Do you want to use this configuration? {yes, no} [yes]:"   => "no",
                                "Do you want to use this configuration?" => "no",
								".*Enter the system config backup destination address.*" => "\013",
								".*Enable IPv4 DHCP on the service processor interface.*" => "no",
                                ".*{yes, no} [yes]:.*"  => "no",
                                "Do you want to reboot now to set storage failover (SFO) to HA mode?" => "no",
								".*Do you want to reboot now to set storage failover (SFO) to HA mode.*" => "no",
                                ".*reboot now to set storage failover (SFO).*" => "no",
								".*an additional license key.*"	=> "\013",
								".*reboot now to set storage failover.*"	=> "no",
                                "Do you want to use these defaults?" => "no",
								".*Password.*"  => $def_pass,
								".*Exiting the cluster setup wizard.*"	=>"FINAL_PROMPT",
								".*DNS.*"   => "\013",
								"::>"	=> "FINAL_PROMPT",
						}
					);
		}catch NACL::Transit::Exceptions::TransitException with {
			my $exception_object = shift;
			logcomment("Exception is of type: " . ref ($exception_object));
			logcomment("Error text is: " . $exception_object->text());
		}catch NATE::BaseException with{
			$join_cnt++;
			
			logcomment("CAUGHT BASE Exception in cluster Joining");
			$MTU_error = 1;
			sleep 10;
			my $string = $Server->console(cmd =>"exit",
			additional_prompts_timeout => '120',
                        ignore => $ignore_strings,
                        additional_prompts => {
						"$prompt_fw" => "FINAL_PROMPT",
						".*::>.*"   =>"FINAL_PROMPT",
					}
			);
			if($join_cnt>1){
				logcomment("ERROR occured during the cluster joinig, script tried two times but cluster joining failed");
				logresult('FATAL',"Error occured during cluster Joining");
			}	
			logcomment("Error occured during cluster joinig, Creating Cluster join again");
			goto join_again;
		};
	logcomment("Cluster join completed");
	logcomment("Add license to the cluster");
	logcomment("Reboot nodes");
	my $Transit_obj;
	my @re_subtest =();
	foreach my $filer_name (@filer_working) {
		$Transit_obj = NACL::Transit->new( name => $filer_name);
	    logcomment("Calling change_state ".scalar(localtime()));
		push(@re_subtest, subtest(\&boot_filer_in_req_state, -runid, "shutdown_node_". "$filer_name", -bg, "--", 
									filer_name => $filer_name,
									change_state_to => 'FIRMWARE'));
	}
    Subtest::wait_finish( subtest => [@re_subtest] );
	logcomment("Booting Filers in FIRMWARE");
	my @new_subtest =();
	foreach my $filer_name (@filer_working) {
		logcomment("Rebooting.....");
		push(@new_subtest, subtest(\&boot_filer_in_req_state, -runid, "reboot_filer_". "$filer_name", -bg, "--",
									filer_name => $filer_name,
									change_state_to => 'CLI'));
	}
	Subtest::wait_finish( subtest => [@new_subtest] );
	logcomment("Rebooting Filers");
	logcomment("Enabling storage failover");
	my $Server = new Server(no_cli=>1);
	my $timeout = "1900";
	my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
	$Server->set_execution_server(-Server => $filer_working[0]);
	my $filer_info = `cat $Home/NDATE/FILER_INFO/$filer_working[0]`;
	my $passwd;
	($passwd) = $filer_info=~/default_password\s*=\s*(\S+)\s*/ig;
    $Server->console(cmd => "storage failover modify -node * -enabled true -auto-giveback true",
						additional_prompts_timeout => $timeout,
						ignore => $ignore_strings,
						additional_prompts => {
                                    "$prompt_fw" => "FINAL_PROMPT",
                                    ".*::>.*"       => "FINAL_PROMPT",
                                    "login"     =>  "admin",
                                    ".*Password.*" => "$passwd",
                         }
 					);
	logcomment("Enabled storage failover");
}


##################################################################################################
##	Auther 		- arjun.lavu@netapp.com
##	Description - This subroutine will list all the disk attached to the filer.
##	Usage 		- Mandatory paramanter - Node(single node object.
##  Return 		- Array of disk.
##	Compatibility	- This subroutine will work both in FILESYSTEM and MAINTENENCE mode CMode and 7Mode
##################################################################################################
sub list_of_disk {
	my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT },
        }
    );

	my $Node=$opts{Node};	
    my $Mode = $Node->mode();
    my $FILER_C = $Node->name();
	my $Host = host($FILER_C);
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
   	my $filer_state = $Transit_obj->get_state('timeout' => 600);
    logcomment("Filer state is : $filer_state");
	my @disk_list;
	my $API_Object;
	if ($filer_state =~ /MAINT/){
		$API_Object = NACL::APISet->new(
	                        hostobj   => $Host,
                            category  => "Node",
                            interface => "CLI",
                            set       => "Maintenance"
                            );
		$API_Object->set_timeout( "connectrec-timeout" => 1200 );
		my $return = disk_list_data(API_Obj =>$API_Object);
		@disk_list = keys(%$return);
	}
	if ($filer_state =~ /CLI|UP/) {
		my $return = disk_show_v(Node =>$Node);
		@disk_list = keys(%$return);
	}
	logcomment("Total disks attached : @disk_list");
	return @disk_list;
}


##########################################################################################################
# Auther - arjun.lavu@netapp.com
# Description - Execute disk_qual t 12 for particuler disk.
# Supports - Cmode (Maintenance) 7Mode (Maintenance)
# Usage - Mandatory param ; API ; disk_attached_to_filer -> disk_list_local 
# All => pass the values as 'all' if you want to run on all the drives
##########################################################################################################
sub run_disk_qual_t12{
    my (%opts) = validate(
        @_,
        {
            API_Obj => { type => OBJECT },
            disk_list_local   => { type => ARRAYREF },
			All => { type => SCALAR, default => undef, optional => 1 },
        }
    );
    my $API_obj  = $opts{API_Obj};
	my $FILER_C =$API_obj->get_name();
	my $ALL = $opts{All} if(defined $opts{All});
	my @disk_array_local = @{ $opts{disk_list_local}};
	my ($value,$command);
	my $params = NATE::ParamSet->new(global => 1);
	my $SATA_SETUP = $params->get('SATA_SETUP' , default => 'N');
	$value  = '-n 1' if($SATA_SETUP =~/Y/i);
    my $result = {};
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
    my $filer_state = $Transit_obj->get_state('timeout' => 600);
    logcomment("$FILER_C : Filer is in $filer_state ");
	if($filer_state =~/CLI/i){
		if($ALL){
			$command = "priv set -q test;disk_qual start -t 12 $value -d all";
		}else{
			$command = "priv set -q test;disk_qual start -t 12 $value -d @disk_array_local";
		}
	}else{
		if($ALL){
			$command = "disk_qual start -t 12 $value -d all";
		}else{
			$command = "disk_qual start -t 12 $value -d @disk_array_local";
		}
	}
	my $wait_time = ((scalar @disk_array_local)*60)+200;
	my $timeout = $API_obj->get_timeout();
	my $TIME_OUT;
	if($timeout>$wait_time){
		$TIME_OUT = $timeout;
	}else{
		$TIME_OUT = $wait_time;
	}
	$API_obj->set_timeout( "connectrec-timeout" => $TIME_OUT );
    my $after = $API_obj->execute_raw_command( 'command' => "$command");
    sleep(120);
    my $result   = {};
    my @lines    = split( /\n/, $after );
    my $cur_disk = "";
    foreach my $line (@lines) {
        if ( $line =~ /\[(\S+)\]:\s+Starting PRINT LOG SENSE DATA test/ ) {
            $cur_disk = $1;
            $result->{$cur_disk} = {};
        }
        elsif ( $line =~ /\S+:(.*):\s+(\S+)/ ) {
            next if ( !defined( $result->{$cur_disk} ) );
            my $paramname = $1;
            my $paramval  = $2;
			$paramval=~ s/^\s+|\s+$//g;
            $paramname =~ s/^\s+|\s+$//g;
            $result->{$cur_disk}->{$paramname} = $paramval;
        }
    } ## end foreach my $line (@lines)
    return $result;
} ## end sub disk_qual_t12_cmode

##########################################################################################################
# Auther - arjun.lavu@netapp.com
# Description - Gives the list of all the disks of particular filer
# Usage -		CMODE(MAINT/CLI) 7Mode(MAINT/CLI)
##########################################################################################################
sub disk_show_drive_maint{
   my (%opts) = validate(
        @_,
        {
            API_Obj => { type => OBJECT },
            Filer   => { type => SCALAR },
        }
      );
    my $Api_Set_Obj  = $opts{API_Obj};
    my $filer    = $opts{Filer};
	my ($Mode,$cmd);
	my @temp_nodes = NACL::C::Node->find();
	#logcomment ("Nodes @temp_nodes");
	foreach my $node (@temp_nodes){
		my $FILER_C = $node->name();
		if($filer eq $FILER_C){
			$Mode = $node->mode();
			last;
		}
	}
	
	my $Host = host($filer);
	my $transit_obj = NACL::Transit->new(name => $Host);
	my $filer_state = $transit_obj->get_state('timeout' => 600);
	if( ($filer_state =~/(UP|CLI)/i)){
		$cmd = "run local disk show -a";
	}else{
		$cmd = "disk show -a";
	}
	
    my $dsk_output =  $Api_Set_Obj->execute_raw_command( 'command' => "$cmd" );
    my @lines = split( /\n/, $dsk_output );
    my @driveA = ();
    my @driveB = ();
	my %disk_filer;
    my $disk_values;
	  foreach my $line ( @lines ){
		if ( $line !~ /DISK|OWNER|POOL|SERIAL NUMBER|HOME/){
			if (($line =~ /(\S+)\s+$filer\s*\(\d+\)\s+(\S+)\s+(\S+)\s+(\S+)\s*\(\d+\)/) || ($line =~ /(\S+)\s+$filer\(\S+\)\s+(\S+)\s+(\S+)\s+(\S+)/)|| ($line =~ /(\S+)\s+$filer\s*\(\S+\)\s+(\S+)\s+(\S+)/)) {
                push ( @driveA , $1 );
				$disk_filer{$1} = $filer;
			} elsif(($line =~ /(\S+)\s+(\S+)\s*\(\d+\)\s+(\S+)\s+(\S+)\s+(\S+)\s*\(\d+\)/) || ($line =~ /(\S+)\s+(\S+)\s*\(\d+\)\s+(\S+)\s+(\S+)\s+(\S+)/)||( $line =~ /(\S+)\s+(\S+)\s*\(\d+\)\s+(\S+)\s+(\S+)/)){
                push ( @driveB , $1 );
				$disk_filer{$1} = $2;
			}
		}
    }
    $disk_values = {
        'driveA'      => [@driveA],
        'driveB'      => [@driveB],
		%disk_filer
    };

    return ( $disk_values );
}

##########################################################################################################
# Auther - Arjun.Lavu@netapp.com
# Description - This subroutine will stop the disk_qual process.
# Usage - Mandatory paramanter - Node , API_Obj
# Optional parameters  - disk_list which is array refrence of disks present in the particular Filer
# Return Value - 1 if passed, 0 if failed.
###########################################################################################################

sub disk_qual_abort {
    my (%opts) = validate(
        @_,
        {
            Node  	  => { type => OBJECT },
			API_Obj	  => { type  =>  OBJECT },
            disk_list => { type => ARRAYREF, optional => 1,default => undef },
            timeout   => { type => SCALAR, default => 1200, optional => 1 },
        }
    );
	my $Node = $opts{Node};
	my $API_Obj =$opts{API_Obj};
	my $timeout = $opts{timeout};
	
	my ( $match,@disks );
	my $FILER_C = $Node->name();
	#Checking the status of disk_qual 
	my $match = $API_Obj->execute_raw_command('command' => "disk_qual status");
	if ( $match =~ /idle/ ) {
        logcomment("$FILER_C : disk qual is idle");
	    return 1;
	}
	logcomment("$FILER_C : disk qual is not idle, waiting for the 'disk_qual stop' to complete");
    if ( defined scalar @{$opts{disk_list}}){
		@disks = @{$opts{disk_list}};
        logcomment("Re-using the output from disk_list");
    }else {
        @disks = @{disk_show_drive_maint( API_Obj => $API_Obj, Filer => $FILER_C)->{'driveA'}};
    }
	my $command = "disk_qual stop -d @disks";
    # $timeout = ((scalar(@disks) * 60 )+ 300);
	$API_Obj->set_timeout("connectrec-timeout" => 18000);	
    my $dis_qua_stop = $API_Obj->execute_raw_command('command' =>$command);
	logcomment("Waiting 120 seconds to get first prompt from 'disk_qual stop'");
	if($dis_qua_stop=~/disk_qual not found/){
		logcomment("**WARNING** : Filer : $FILER_C : disk_qual is not supported in the kernel");
		return (0);
	}
	sleep(120);
	$API_Obj->execute_raw_command('command' =>"\013");
	#***********************************************
	#setting the time out value
	#***********************************************
	
	my $kill_time = time + $timeout;
	while ( $kill_time > time ) {
		my $result = $API_Obj->execute_raw_command('command' =>" ");
		if($result=~/\*\>/){
			my $status = $API_Obj->execute_raw_command('command' => "disk_qual status");
			if ($status !~ /idle/ ) {
				sleep 120;	#waiting for 1 min and again checking the while loop condition
			}elsif($status !~ /disk_qual not found/ ) {
				logcomment("**WARNING** : Filer : $FILER_C : disk_qual is not supported in the kernel");
				return (0);
			}else{
				logcomment("disk_qual is stopped ");
				return (1);
			}
		}else{
			if($kill_time < time ){
				sleep 120;	#waiting for 1 min and again checking the while loop condition if time-out has not occurred
			}else{
				last;
		    }
		}
	}
	###################################################################################	
	##Checking again the status of disk_qual, if it is not idle return 0; else return 1;
	###################################################################################
	my $stat = $API_Obj->execute_raw_command('command' => "disk_qual status");
	if ( $stat !~ /idle/ ) {
		return (0);
	}else{
		return (1);
	}
}

##########################################################################################################
# Auther - Arjun.Lavu@netapp.com
# Description - This subroutine will give particular disk of filer.
# Usage - Mandatory paramanter - Node , API_Obj, Test
# Supports - 7Mode (/Maint) Cmode (maint)
# Return Value - array of disk.
###########################################################################################################

sub get_disk_information{
    my (%opts) = validate(
        @_,
        {
            API_Obj => { type => OBJECT },
            Filer   => { type => SCALAR },
            Test    => { type => OBJECT,optional => 1, default => undef},
        }
    );
	my $sysid;
    my $Api_Set_Obj = $opts{API_Obj};
    my $filer       = $opts{Filer};
	my $Transit_obj = NACL::Transit->new( name => $filer );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
    my $Test        = $opts{Test};
    my ( @disk_show_disks, @failed_disks, $curr_adpt, $diskL, $cmd );
    my $sysconf_out = $Api_Set_Obj->execute_raw_command( 'command' => "sysconfig -v" );
    chomp( my @sysconf_lines = split( /\r?\n/, "$sysconf_out" ) );
		foreach my $i ( 0 .. $#sysconf_lines ) {
        if ( $sysconf_lines[$i] =~ /^\s+\S+\s+ID:\s+(\d+)/ ) {
            $sysid = $1;
        }
        if ( $sysconf_lines[$i] =~ /Host Adapter/ ) {
            my @temp_arr = split( /\s+/, $sysconf_lines[$i] );
            $curr_adpt = $temp_arr[6];
        }
        elsif ( $sysconf_lines[$i] =~ /Failed\)/ ) {
            my @temp_arr = split( /\s+/, $sysconf_lines[$i] );
            my $last_char_t = substr( $temp_arr[1], -1 );
            if ( $last_char_t =~ /\:/ ) {
                chop( $temp_arr[1] );
            }
            push( @failed_disks, "$curr_adpt.$temp_arr[1]" );
        }
		} ## end foreach my $i (0 .. $#sysconf_lines)
		if (   ( $sysid =~ /^\s$/ ) || ( $sysid eq '' ) || ( $curr_adpt =~ /^\s$/ ) || ( $curr_adpt eq '' ) ){
		my $sysconf_out = $Api_Set_Obj->execute_raw_command( 'command' => "sysconfig -v" );
        chomp( my @sysconf_lines = split( /\r?\n/, "$sysconf_out" ) );
        foreach my $i ( 0 .. $#sysconf_lines ) {
            if ( $sysconf_lines[$i] =~ /^\s+\S+\s+ID:\s+(\d+)/ ) {
                $sysid = $1;
            }
            if ( $sysconf_lines[$i] =~ /Host Adapter/ ) {
                my @temp_arr = split( /\s+/, $sysconf_lines[$i] );
                $curr_adpt = $temp_arr[6];
            }
            elsif ( $sysconf_lines[$i] =~ /Failed\)/ ) {
                my @temp_arr = split( /\s+/, $sysconf_lines[$i] );
                my $last_char_t = substr( $temp_arr[1], -1 );
                if ( $last_char_t =~ /\:/ ) {
                    chop( $temp_arr[1] );
                }
                push( @failed_disks, "$curr_adpt.$temp_arr[1]" );
            }
			} ## end foreach my $i (0 .. $#sysconf_lines)
			}
		if ( ( $sysid =~ /^\s$/ ) || ( $sysid eq '' ) ) {
		my $after = $Api_Set_Obj->execute_raw_command( 'command' => "sysconfig -v" );
        if ( ( $after =~ /\s*System ID:\s+(\d+)\s+(.*)/ ) ) {
            $sysid = $1;
        }
		}
		if ( ( $sysid =~ /^\s$/ ) || ( $sysid eq '' ) ) {
		logresult( 'FAIL',"System ID of the filer could not be captured through sysconfig -v and storage show initiators command. This may lead to failure in further commands. Exiting from the script");
		}
		if (@failed_disks) {
			if($filer_state=~/CLI/i){
				$Api_Set_Obj->execute_command( 'command' => "disk unfail all");
			}else{
				$Api_Set_Obj->execute_raw_command( 'command' => "disk unfail all") ;
			}		
		} ## end if (@failed_disks)

		$cmd = "disk show -s $sysid ";
		my $output = $Api_Set_Obj->execute_raw_command( 'command' => "$cmd");

		# --------------------------------------------
		#  The empty list is considered as not an error.
		# ---------------------------------------------
		#
		if ( $output =~ /disk show: No disks match option/ ) {
			logcomment( "WARNING : No disk attached to the filer, $output" );
			return @disk_show_disks;
		}
		if (   $output =~ /disk show:/  || $output !~ /DISK/  || $output eq ""  || $output =~ /disk:/ ){
			logcomment( "Re trying the disk show command since absence os expected output");
			$cmd = "disk show -s $sysid ";
			my $output1 = $Api_Set_Obj->execute_raw_command( 'command' => "$cmd");
			if ( $output1 =~ /disk show: No disks match option/ ) {
				logcomment( "WARNING : No disk attached to the filer, $output1" );
				return @disk_show_disks;
			}
			if (   $output1 =~ /disk show:/ || $output1 !~ /DISK/ || $output1 eq "" || $output1 =~ /disk:/ )
			{
				logcomment("Disk show command failed due to: $output");
				$Api_Set_Obj->execute_raw_command( 'command' => "");
			}
		}

		my @lines = split( /\r*\n/, $output );
		# --------------------------------------------------------
		# removes the header lines
		# --------------------------------------------------------
		shift(@lines);
		shift(@lines);
		foreach(@lines) {
			s/^\s*//;
			if (/^(\S+)\s+\S+\s*\(/){
				push( @disk_show_disks, $1);
			}elsif (/^(\S+)\s*\(\S+\)\s*\S+/){
				push( @disk_show_disks, $1);
			}
		} ## end foreach (@lines)
		logcomment("Total Number of drives attached to filer $filer are ".scalar @disk_show_disks." and the drives are @disk_show_disks")if(@disk_show_disks);
		logcomment("No drives are assigned to the filer $filer")if(!@disk_show_disks);;
    return @disk_show_disks;
}



#######################################################################################
##	author - Arjun.Lavu@netapp.com
##	applicable to ERT tests MAINTNENCE mode
##
##	sub check_ert_config()
##	Node -> required param
##	disk_list -> optional param [ARRAY reference of disks belongs to filer]
## 	ert_config -> path of ERT disks/platform file
##
#######################################################################################
sub check_ert_config{
	my (%opts) = validate(
        @_,
        {
            Node   => { type => OBJECT},
			disk_list =>{type => ARRAYREF},
			ert_config =>{type => SCALAR, optional => 1,default => undef},
        }
    );
	my $Node =  $opts{Node};
	my $FILER_C = $Node->name();
	my $Home = $ENV{HOME};
	my $ert_config;
	my @disk_array;
	my($min_drives,$max_drives,$found);
	if ( defined( $opts{ert_config} ) ) {
        $ert_config = $opts{ert_config};
    } else {
        $ert_config = "$Home/NDATE/ERT_CONFIG";
    }
	my $Host = host($FILER_C);
    my $API_obj = NACL::APISet->new(
        hostobj   => $Host,
        category  => "Node",
        interface => "CLI",
        set       => "Maintenance"
    );
	$API_obj->set_timeout( "connectrec-timeout" => 1200 );
	my $sysconfig = sysconfig_v_data(node => $Node);
	my $model = $sysconfig->{model};
	open FH, "$ert_config" or die "Unable to open the file $ert_config";
	while (<FH>) {
        next if ( $_ =~ /\#/ );
        if ( $_ =~ /$model\s+(\d+)\s+(\d+)/ ) {
            $min_drives = $1;
            $max_drives = $2;
            $found      = 1;
            last;
        }
    }
	close FH;
    if ( $found == 0 ) {
        logcomment("Filer - $FILER_C - Model $model not present in the list, Please fill the details in the file $ert_config and start agaign the test");
		logresult('FATAL',"$FILER_C : Filer Model $model not present in the list $ert_config");
    }
	if(defined $opts{disk_list}){
		@disk_array = @{$opts{disk_list}};
	}else{
		@disk_array = get_disk_information(
						API_Obj => $API_obj,
						Filer   => $FILER_C
					);
	}
	logcomment("Filer - $FILER_C : disks present are ".scalar @disk_array." and the disks are @disk_array");
	logresult('FATAL',"No drives present to filer $FILER_C")if(!scalar @disk_array);
	
	if ( ( scalar @disk_array < $min_drives ) || ( scalar @disk_array > $max_drives ) ) {
        logresult( 'FAIL',"Number of drives available in the filer are ".scalar @disk_array." but drives expected are between $min_drives and $max_drives for ERT test to continue");
        return 0;
    }
	return 1;
}
##########################################################################################################
# Auther -  arjunl
# Description - This subroutine will boot the filer 24/7 mode
###########################################################################################################
sub boot_in_twenty_four_seven_cmode{
	my (%opts) = validate(
        @_,
        {
            node   => { type => OBJECT},
        }
    );
	my $Node = $opts{node};
	destroy_root_volume(Noderef =>[$Node]);
	clean_config(Node  =>$Node);
}	
##########################################################################################################
# Auther -  arjunl
# Description - This subroutine will boot the filer 24/7 mode
###########################################################################################################
sub twenty_four_bar_seven{
	my (%opts) = validate(
        @_,
        {
            nodes   => { type => ARRAYREF},
        }
    );
	my @Nodes = @{$opts{nodes}};
	disk_remv_assign_ownership(Node_ref => [@Nodes]);
	my @subtests;
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		push(@subtests, subtest( \&boot_in_twenty_four_seven_cmode, -runid,
								"boot_in_twenty_four_seven_cmode_" . "$FILER_C", -bg,
								"--", node   => $Node,
								)
						);
	}
	logcomment("Subtest @subtests");
	Subtest::wait_finish( subtest => [@subtests] );
	foreach my $Node(@Nodes){
		my $Node_name = $Node->name();
		my $Home = $ENV{HOME};
		my $filer_info = `cat $Home/NDATE/FILER_INFO/$Node_name`;
		my $passwd;
		($passwd) = $filer_info=~/default_password\s*=\s*(\S+)\s*/ig;
		my $prompt_fw ;
		my $wipeclean_timeout = 660;
		my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
		my $host = Tharn::host($Node_name);
		my $prompt_array = $host->prompt_fw();
		my $prompts = join("|",@$prompt_array);
		$prompt_fw = "($prompts)";
		logcomment("This is the prompt regex: $prompt_fw");
		logcomment("Disable cluster/HA pair");
		my $Server = new Server(no_cli=>1);
		$Server->set_execution_server(-Server => $Node_name);
		my $Transit_obj = NACL::Transit->new( name => $Node_name);
		my $conn = $Transit_obj->{'conn'};
		$Transit_obj->set('timeout' => 600, maxcycle => 20);
		$Transit_obj->change_state( to => "BOOT_MENU");
		logcomment("$Node_name : Filer is in boot_state");
		logcomment("$Node_name : Creating Server object");
		my $Server = new Server(no_cli=>1);
		my @filer_working=$Server->servers();
		logcomment("Filers we are working on : @filer_working");
		my $timeout = "3600";  # Change timeout in final code.
		logcomment("Setting timeout : $timeout");
		logcomment("Set execution server");
		$Server->set_execution_server(-Server => $Node_name); #set the execution server to the current node
		logcomment("Boot _menu wipr clean util called ".scalar(localtime()));
		logcomment("Execution server set to $Node_name");
		logcomment("Disable password ");
		$Server->console(cmd=>"options security.passwd.rules.everyone off", noprompt=>1);
		eval {
			$Server->console(cmd => "24/7",
				additional_prompts_timeout => $timeout,
				ignore => $ignore_strings,
				additional_prompts => {
					".*Install new file system without zeroing disks.*" => "yes",
					".*REALLY install file system without zeroing disks.*"	=> "yes",
					".*How many disks should be designated as spares.*" => "\n",
					".*How many volumes.*"	=> "\n",
					".*Number of RAID groups per volume.*"   => "\n",
					".*Type yes to confirm and continue.*"=> "yes",
					".*Enter the node management interface port.*"=>"exit",
					".*Do you want to create a new cluster or join an existing cluster.*" => "exit",
					".*login.*"     =>  "admin",
					".*Password.*" => "$passwd",
					"::>"       => "FINAL_PROMPT",
					"$prompt_fw" => "FINAL_PROMPT",
					"Selection " => "FINAL_PROMPT"
				}
			);
		};
		
		my $timeout = "1900";
		my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
		logcomment("Changing Node Name");
		try {
			$Server->console(cmd=>"node rename -newname $Node_name",
				additional_prompts_timeout => $timeout,
				ignore => $ignore_strings,
				additional_prompts => {
							"$prompt_fw" => "FINAL_PROMPT",
							"::>"       => "FINAL_PROMPT",
							"login"     =>  "admin",
							".*Password.*" => "$passwd",
						}
			);
			logcomment("Changed node name");
		} catch NACL::Transit::Exceptions::TransitException with {
			my $exception_object = shift;
			logcomment("Exception is of type: " . ref ($exception_object));
			logcomment("Error text is: " . $exception_object->text());
		};
	}
	create_join_cluster(node_present =>[@Nodes]);
}

################################################################################################################
## Author arjun.lavu@netapp.com
## Description :: this subroutine will check for multiple filer names under disk show -a output
#################################################################################################################

sub check_multiple_filer_names{
	my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT },
        }
    );
	
	my $Node = $opts{Node};
	my $Mode = $Node->mode();
	my $FILER_C = $Node->name();
	my $Host = host($FILER_C);
	
	#**************************************************
	#Checking the filer state
	#**************************************************
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state;
	try{
		$filer_state = $Transit_obj->get_state('timeout' => 600);
	}catch NACL::Transit::Exceptions::Timeout with {
        logcomment("Expected: Caught a Timeout exception");
        $filer_state = $Transit_obj->get_state('timeout' => 600);
    }catch NACL::Transit::Exceptions::TransitException with {
        my $exception_object = shift;
        logcomment("Exception is of type: " . ref ($exception_object));
        logcomment("Error text is: " . $exception_object->text());
    };
	
	my($API_obj,$output,@lines);
	##############################################
	##Based on mode(UP/MAINT) API object is created
	##############################################
	logcomment("$FILER_C : Filer state is $filer_state");
	if($filer_state =~/(CLI|UP)/){
		$API_obj = $Node->get_7m_or_nodescope_apiset();
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		logcomment("$FILER_C : Executing  disk show -a");
		$output = $API_obj->execute_raw_command( 'command' => "run local disk show -a");
	}else{
		$API_obj = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance"
		);
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		logcomment("$FILER_C : Executing  disk show -a");
		$output = $API_obj->execute_raw_command( 'command' => "disk show -a");
	}
	my $n = 0;
	my %result;
	@lines  = split( /\n/, $output );
	# skip to the start of table contents
	while ( $n <= $#lines ) {
		$lines[$n] =~s/^\s*//;
		last if ( $lines[$n] =~ /^-----/ );
		$n++;
	}
	$n++;
    foreach my $line ( @lines[ $n .. $#lines ] ) {
		$line =~s/^\s*//;
		if($line =~/^(\S+)\s+(\S+)\s*\((\S+)\)\s+/){	
			my ($disk,$owner,$system_id,$pool,$serial_number ) = ( $line =~/^(\S+)\s+(\S+)\s*\((\S+)\)\s+/);
            push(@{$result{$owner}{'DISK'}},$disk);
			$result{$owner}{'SYSTEM_ID'}= $system_id;
		}	
    }
    return %result;
}
####################################################################################################
#Author - Arjun Lavu
# Description :: Disk remove assigning in maintenance mode
####################################################################################################
sub remv_assign_ownership_maint {
	my (%opts) = validate( 
		@_,
		{	Node_ref		 =>	{ type => ARRAYREF },
			disk_ref      	 => { type => ARRAYREF,default=>undef, optional => 1 },
			assign_disk_to	 => {type  => OBJECT,default=>undef,optional =>1},
			remove_disk_from => {type  => OBJECT,default=>undef,optional =>1},
	   }
     );
	my @Nodes		= @{$opts{Node_ref}};
	my $FILER_C 	= $Nodes[0]->name();
	my $Test        = $opts{Test};
	my %Node_unowned = ();
	my (@API_ARRAY,@Filer,@disks,$assign_api,$assign_node);
	my $Mode = $Nodes[0]->mode();
	if(defined($opts{disk_ref})){
		@disks = @{$opts{disk_ref}};
	}

	my $disk_max_sup = 50;
	my $delay_time = 120;
	my %Node_Api;
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	logcomment("Filer state $filer_state ");
	my @total_disks;
	foreach my $node(@Nodes){
		my $FILER = $node->name();
		push(@Filer,$FILER);
		my $Host 	= host($FILER);
		my $console = Tharn::connect("$FILER#console");
		# Set the properties for the Connectrec used for creating the APIset
        $console->{prompts} = [qr/\*>/];
        $console->{max_idle} = "600";
        $console->{on_idle} = sub { $console->execute(""); };
        my $API_obj = NACL::APISet->new(connection => $console,
                                        category => "Node",
                                        interface => "CLI",
                                        set => "Maintenance");
		$API_obj->set_timeout( "connectrec-timeout" => "1200" );
		$Node_Api{$node} = $API_obj;		
		push (@API_ARRAY,$API_obj);	
	}	
	my $remove;
	my $unowned_disks;
	logcomment ("Inside Remove assign ownership");
	my $sys_id;
	my $disk_list_result = disk_list_data(
                           API_Obj => $API_ARRAY[0],
                         );
	@total_disks = keys(%$disk_list_result);
	if(!@total_disks){
		logresult('FATAL',"disk_list result shows no disks present in the filers, So exiting from the rest of test");
	}else{
		my $disks = @total_disks; 
		logcomment("Total number of disks available in the filers are $disks"); 
		if($disks < 6){
			logcomment("WARNING : disks present in the filers are less than 6,\nit may lead to system PANIC if the filers are booted in filesystem mode");
		}	
	}
	my %filer_ret = check_multiple_filer_names(Node => $Nodes[0]);
	# logcomment("Dumping ".Dumper(\%filer_ret));
	my @ret_filers = keys(%filer_ret);
	logcomment("Number of filers present in the system are @ret_filers");
	foreach(@ret_filers){
		logcomment"------------------------------------------------------------------";
		my @drives = @{$filer_ret{$_}{'DISK'}};
		logcomment("Drives assigned to the filer $_ are @drives");
		logcomment("System Id of the filer $_ captured from the command disk show -a is ".$filer_ret{$_}{'SYSTEM_ID'});
	}
	if(!@ret_filers){
		logcomment("No owner found for any of the drives in the system which could be either all the drives are unowned \n or no owner name found for the drives so releasing the ownership of drives");
		$API_ARRAY[0]->execute_raw_command('command' =>"disk remove_ownership all -f");
		sleep 60;
		$API_ARRAY[0]->execute_raw_command('command' =>"disk remove_ownership all -f");
		$API_ARRAY[0]->execute_raw_command('command' =>"storage release disks -f");
	}
	if(scalar @ret_filers >2){
		logcomment("Filers found in the system are more than two, which is not acceptable so releasing the ownership of drives");
		$API_ARRAY[0]->execute_raw_command('command' =>"disk remove_ownership all -f");
		sleep 60;
		$API_ARRAY[0]->execute_raw_command('command' =>"disk remove_ownership all -f");
		$API_ARRAY[0]->execute_raw_command('command' =>"storage release disks -f");
	}
	$remove= scalar @total_disks;
	if ( ( $remove > 50 ) && ( $remove <= 100 ) ) {
		$delay_time = 180;
	}elsif ( ( $remove > 100 ) && ( $remove <= 150 ) ) {
		$delay_time = 250;
	}elsif ( ( $remove > 150 ) && ( $remove <= 200 ) ) {
		$delay_time = 300;
	}elsif ( $remove > 200 ) {
		$delay_time = 400;
	}
	
	if(scalar @Nodes == 1){
		my $params = NATE::ParamSet->new(global => 1);
		my $LOGDIR = $params->get('LOGDIR', default => undef);
		my $TEST_CONFIG = $params->get('TEST_CONFIG', default => undef);
		my $FILER_NAMES = $params->get('FILER', default => undef);
		my $FILER_B;
		my $FILER = $Nodes[0]->name();
		my @FILERS = split(/\n/,$FILER_NAMES);
		foreach(@FILERS){
			if($_!~/^$FILER$/){
				$FILER_B = $_;
				last;
			}
		}
		
		my $Host = host($FILER);
		my $Host_b = host($FILER_B);
		disable_debug_msg(Node => $Nodes[0]);
		# disable_dbg_msgs( host => $Host, filermode => "maint" );
		# disable_dbg_msgs( host => $Host_b, filermode => "maint" );
		logcomment("only one node is passed : $FILER");
		my $API_obj = $Node_Api{$Nodes[0]};
		my @temp_disk_info = get_disk_information(
								API_Obj => $API_obj,
								Filer   => $FILER
							);
		logcomment("Total drives present in the filer $FILER are ".scalar @temp_disk_info." and the drives are @temp_disk_info");
		$API_obj->execute_raw_command('command' => "\013");
		# my $unowned = disk_show_n(Node =>$Nodes[0]);
		my @unowned_disks = keys %{disk_show_n(Node =>$Nodes[0])};
		logcomment("Total Number of drives which are currently unassigned are ".scalar @unowned_disks." and the drives are @unowned_disks")if(@unowned_disks);
		logcomment("No un-assigned drives are present")if(!@unowned_disks);;
		if(@unowned_disks){
			my ($sysid,$API_obj_B);
			{
				my $console = Tharn::connect("$FILER_B#console");
				#Set the properties for the Connectrec used for creating the APIset
				$console->{prompts} = [qr/\*>/];
				$console->{max_idle} = 600;
				$console->{on_idle} = sub { $console->execute(""); };
				$API_obj_B = NACL::APISet->new(connection => $console,
												category => "Node",
												interface => "CLI",
												set => "Maintenance");
			}								
			$API_obj->set_timeout( "connectrec-timeout" => 1200 );	
			$API_obj_B->set_timeout( "connectrec-timeout" => 1200 );			
			logcomment("Executing sysconfig -v to capture system ID");
			my $after = $API_obj->execute_raw_command('command' => "sysconfig -v");
			if (($after =~/\s*System ID:\s+(\d+)\s+/)){
				$sysid   = $1;
			}else{
				logcomment("Couldn't found the sysid for the filer $FILER");
				logresult('FATAL',"Couldn't found the sysid for the filer $FILER");
			}
			my(@partition_drives,@container_drives);
			if(@disks){
				logcomment("$FILER : Number of drives passed by the user to assign to the filer $FILER are ".scalar @disks." and the drives are @disks");
				my @drives_need_to_assign = commom_drives([@unowned_disks],[@disks]);
				if(@drives_need_to_assign){
					logcomment("$FILER : Out of these drives, number of drives which got unassigned are ".scalar @drives_need_to_assign." and the drives are @drives_need_to_assign");
				}else{
					logcomment("$FILER : No drives are matched to unassigned drives");
					return 0;
				}
				
				grep{if($_=~/P\d+$/){push (@partition_drives,$_)}else{push(@container_drives,$_)}}@drives_need_to_assign;
				if(@container_drives){
					logcomment("Total number container drives which need to assign the filer : $FILER are ".scalar @container_drives." and the drives are @container_drives" );
				}
				if(@partition_drives){
					logcomment("Total number partitioned drives which need to assign the filer : $FILER are ".scalar @partition_drives." and the drives are @partition_drives" );
				}
				if(@container_drives){
					my $disk_max_sup = 40;
					my @copy_drives_need_to_assign = @container_drives;
					while(@copy_drives_need_to_assign){
						my $loop_no     = 0;
						my @disk_list_q = ();
						while ($loop_no < $disk_max_sup) {
							push @disk_list_q,pop @copy_drives_need_to_assign;
							$loop_no++;
							last if (!(@copy_drives_need_to_assign));
						}
						logcomment("Assigning the drives @disk_list_q to filer $FILER");
						$API_obj->execute_raw_command('command' =>"disk assign @disk_list_q -o $FILER -s $sysid -f");
						sleep((@disk_list_q*5)+60);
						$API_obj->execute_raw_command('command' => "\013");
					}	
				}
				if(@partition_drives){
					my $status = disk_show_drive_maint( API_Obj =>$API_obj,Filer=>$FILER);
					my @drives_A = @{$status->{'driveA'}};
					my @drives_B = @{$status->{'driveB'}};
					logcomment("Drives a @drives_A and drviesb @drives_B");
					my %disk_api;
					$disk_api{$FILER} = $API_obj;
					$disk_api{$FILER_B} = $API_obj_B;
					my $prompts_answers = ["Do you want to continue"=> 'y'];
					foreach my $dsk(@partition_drives){
						(my $tmp = $dsk)=~s/P\d+$//;
						$disk_api{$status->{$tmp}}->execute_raw_command('command' =>"disk assign $dsk -o $FILER -s $sysid -f",'connectrec-match_table' => $prompts_answers) if($disk_api{$status->{$tmp}});
						sleep 1;
					}	
				}
				# return 0;
			}else{
				my @actual_disks;
				my $disks_file= "$LOGDIR/../../../"."Pre_post_Drives_Details_"."$FILER";
				if (-f $disks_file) {
					open(H_LOGFILE, "<$disks_file ")or die ">>>>> read: Failed opening $disks_file <<<<<";
					foreach my $line (<H_LOGFILE>) {
						chomp($line);
						next if($line !~/\S/);
						$line=~s/(^\s+)|(\s+$)//ig;
						push @actual_disks, $line;
					}
					close H_LOGFILE;
					logcomment("Drives which found in the file $disks_file are ". scalar @actual_disks." and the drives are @actual_disks");
					my @drives_need_to_assign = commom_drives([@unowned_disks],[@actual_disks]);
					logcomment("Out of un-owned drives, drives which are common are ". scalar @drives_need_to_assign." and the drives are @drives_need_to_assign");
					if(@drives_need_to_assign){
						logcomment("$FILER :: Out of these drives, number of drives which got unassigned are ".scalar @drives_need_to_assign." and the drives are @drives_need_to_assign");
					}else{
						logcomment("$FILER :: No drives are matched to unassigned drives");
						return 0;
					}
					grep{if($_=~/P\d+$/){push (@partition_drives,$_)}else{push(@container_drives,$_)}}@drives_need_to_assign;
					if(@container_drives){
						logcomment("Total number container drives which need to assign the filer : $FILER are ".scalar @container_drives." and the drives are @container_drives" );
					}
					if(@partition_drives){
						logcomment("Total number partitioned drives which need to assign the filer : $FILER are ".scalar @partition_drives." and the drives are @partition_drives" );
					}
					if(@container_drives){
						my $disk_max_sup = 40;
						my @copy_drives_need_to_assign = @container_drives;
						while(@copy_drives_need_to_assign){
							my $loop_no     = 0;
							my @disk_list_q = ();
							while ($loop_no < $disk_max_sup) {
								push @disk_list_q,pop @copy_drives_need_to_assign;
								$loop_no++;
								last if (!(@copy_drives_need_to_assign));
							}
							logcomment("Assigning the drives @disk_list_q to filer $FILER");
							$API_obj->execute_raw_command('command' =>"disk assign @disk_list_q -o $FILER -s $sysid -f");
							sleep((@disk_list_q*5)+60);
							$API_obj->execute_raw_command('command' => "\013");
						}	
					}
					if(@partition_drives){
						my $status = disk_show_drive_maint( API_Obj =>$API_obj,Filer=>$FILER);
						my @drives_A = @{$status->{'driveA'}};
						my @drives_B = @{$status->{'driveB'}};
						logcomment("Drives a @drives_A and drviesb @drives_B");
						my %disk_api;
						$disk_api{$FILER} = $API_obj;
						$disk_api{$FILER_B} = $API_obj_B;
						my $prompts_answers = ["Do you want to continue"=> 'y'];
						foreach my $dsk(@partition_drives){
							(my $tmp = $dsk)=~s/P\d+$//;
							$disk_api{$status->{$tmp}}->execute_raw_command('command' =>"disk assign $dsk -o $FILER -s $sysid -f",'connectrec-match_table' => $prompts_answers) if($disk_api{$status->{$tmp}});
							sleep 1;
						}
					}	
				}
			}
			sleep 60;
			my $unassigned = disk_show_n(Node =>$Nodes[0]);
			my @unassigned_disks = keys %$unassigned;
			if(@unassigned_disks){
				logresult('FATAL',"Cannot assign disks to filer $FILER");
			}else{
				return 0;
			}
		}else{
			logcomment("No un-assigned disks found on the filer $FILER");
			return 0;
		}
	}

	if(defined($opts{assign_disk_to})){
		$assign_node = $opts{assign_disk_to};
		my $filer_assign = $assign_node->name();
		my $Host = host($filer_assign);
		my $console = Tharn::connect("$filer_assign#console");
		# Set the properties for the Connectrec used for creating the APIset
        $console->{prompts} = [qr/\*>/];
        $console->{max_idle} = 600;
        $console->{on_idle} = sub { $console->execute(""); };
        $assign_api = NACL::APISet->new(connection => $console,
                                        category => "Node",
                                        interface => "CLI",
                                        set => "Maintenance");
		$assign_api->set_timeout( "connectrec-timeout" => 1200 );
		$assign_api->execute_raw_command('command' => "storage release disks -f");
	}
	if((defined($opts{remove_disk_from}))&&(defined($opts{assign_disk_to}))){		##If remove_disk_from and assign_disk_to are defined then only
		my $remove_disk_node = $opts{remove_disk_from};								## remove disks from remove_disk_from node
		my $filer_remove = $remove_disk_node->name();
		
		my $console = Tharn::connect("$filer_remove#console");
		# Set the properties for the Connectrec used for creating the APIset
        $console->{prompts} = [qr/\*>/];
        $console->{max_idle} = 600;
        $console->{on_idle} = sub { $console->execute(""); };
        my $remove_disk_from_api = NACL::APISet->new(connection => $console,
                                        category => "Node",
                                        interface => "CLI",
                                        set => "Maintenance");
		my $filer_name = $remove_disk_from_api->get_name();
		my @temp_disk_info = get_disk_information(
			API_Obj => $remove_disk_from_api,
			Filer   => $filer_name
		);
		if(@temp_disk_info){
			logcomment("Total number of drives assigned to filer : $filer_name are ".scalar @temp_disk_info." and the drives are @temp_disk_info")if(scalar @temp_disk_info);
			logcomment("No drives are assigned to the filer : $filer_name")if(!@temp_disk_info);
			$remove_disk_from_api->execute_raw_command('command' => "storage release disks -f");
			logcomment("Removing all disks :: $filer_name");
			# $remove_disk_from_api->execute_raw_command('command' => "disk show -a");
			$remove_disk_from_api->execute_raw_command('command' => "disk remove_ownership all -f");
			sleep 120;
			$remove_disk_from_api->execute_raw_command('command' => "\013");
			sleep 10;
			$remove_disk_from_api->execute_raw_command('command' => "\013");
			$remove_disk_from_api->execute_raw_command('command' => "storage release disks -f");
			my $drives= disk_show_drive_maint(API_Obj =>$remove_disk_from_api,Filer =>$filer_remove);
			if((@{$drives->{'driveA'}})||(@{$drives->{'driveB'}})){
				logcomment("Still few more drives are left");
				$remove_disk_from_api->execute_raw_command('command' => "disk remove_ownership all -f");
				sleep 120;
				$remove_disk_from_api->execute_raw_command('command' => "\013");
				sleep 10;
				$remove_disk_from_api->execute_raw_command('command' => "\013");
				$remove_disk_from_api->execute_raw_command('command' => "storage release disks -f");
			}
		}else{
			logcomment("No drives are assigned to filer : $filer_remove");
		}
		
	}
	if($assign_api ){
		my $FILER = $assign_api->get_name();
		my @unassigned_disks = keys%{disk_show_n(Node => $opts{remove_disk_from})};
		if(!scalar @unassigned_disks){
			logcomment("No unassigned disks are available on the filers");
			return 0;
		}else{
			my $Host = host($FILER);
			my($sys_id);
			logcomment("Total number of un-assigned drives are ".scalar @unassigned_disks." and the drives are @unassigned_disks")if(@unassigned_disks);
			logcomment("Un-assigned drives are not available")if(!@unassigned_disks);
			my $after = $assign_api->execute_raw_command('command' => "sysconfig");
			if (($after =~/\s*System ID:\s+(\d+)\s+/)){
				$sys_id = $1;
			}
			logcomment("Assigning all th drives to filer :: $FILER ");
			my $cnt=2;
			while($cnt>0){
				my $result=$assign_api->execute_raw_command('command' => "disk assign all -o $FILER -s $sys_id -f");
				sleep($delay_time);
				if($result=~/Assign failed/){
					logresult( 'FATAL',"$FILER : Disk assign is failed on the filer.Existing from the test.Please manualy assign the disks to the filer"
					);
				}
				sleep (scalar @disks+1)*5;
				$assign_api->execute_raw_command('command' => "\013");
				$assign_api->execute_raw_command('command' => "\013");
				sleep 2;
				$assign_api->execute_raw_command('command' => "\013");
				disable_debug_msg(Node => $assign_node);
				# disable_dbg_msgs( host => $Host, filermode => "maint" );
				@unassigned_disks = keys%{disk_show_n(Node => $opts{remove_disk_from})};
				if(!scalar @unassigned_disks){
					return 0;
				}else{
					$cnt--;
					logcomment("$FILER : Some drives are not assigned, again trying to assign the drives");
				}
			}
			sleep 60;
			$assign_api->execute_raw_command('command' => "\013");
			disable_debug_msg(Node => $assign_node);
			# disable_dbg_msgs( host => $Host, filermode => "maint" );
			@unassigned_disks = keys%{disk_show_n(Node => $opts{remove_disk_from})};
			if(scalar @unassigned_disks){
				logcomment("Couldn't assign disks to Filer $FILER");
				return 1;
			}else{
				return 0;
			}
		}
	}
	##If no parameters are passed excep Nodes and Api object
	my $FilerA = $Nodes[0]->name();
	my $FilerB = $Nodes[1]->name();
	my $HostA  = host($FilerA);
	my $HostB  = host($FilerB);
	my $Api_filerA = $Node_Api{$Nodes[0]};
	my $Api_filerB = $Node_Api{$Nodes[1]};
	$Api_filerB->execute_raw_command('command' => "storage release disks -f");
	$Api_filerA->execute_raw_command('command' => "storage release disks -f");
	my $hash        = {};
	my ($sysid,$sysid_p);
	{
		my $after = $Api_filerA->execute_raw_command('command' => "sysconfig -v");
		if ($after =~/\s*System ID:\s+(\d+)\s+/){
			$sysid   = $1;
		}
		$after = $Api_filerB->execute_raw_command('command' => "sysconfig -v");
		if ($after =~/\s*System ID:\s+(\d+)\s+/){
			$sysid_p   = $1;
		}
	}	
    logcomment("System ID of Filer $FilerA is: $sysid");
    logcomment("partner ID of Filer $FilerB is: $sysid_p");	
	
	my $disksA        = 0;
    my $disksB        = 0;
    my $unowned_disks = 0;
    my $filer_name;
    my $filer_nameA;
    my $filer_nameB;
	my @Filer_disksA =  get_disk_information(
							API_Obj => $Api_filerA,
							Filer   => $FilerA,
						);
	$disksA = @Filer_disksA;
	my @Filer_disksB = get_disk_information(
							API_Obj => $Api_filerB,
							Filer   => $FilerB,
						);
	$disksB = @Filer_disksB;
	my $unowned = disk_show_n(Node =>$Nodes[0]);
	my @unowned_disks = keys %$unowned;
	$unowned_disks = @unowned_disks;
	logcomment(" Total number of un-assigned disks are $unowned_disks and the disks are @unowned_disks" ) if(@unowned_disks);
	logcomment("No un-assigned drives found in the filer setup")if(!@unowned_disks);;
    logcomment(" Drives present in filer $FilerA - $disksA");
    logcomment(" Drives present in filer $FilerB - $disksB");
	
	if ( @unowned_disks > 0 ) {
        logcomment(" WARNING : No owner found for some of the drives :: @unowned_disks " );
    }
	my $numberAB = 0;
    my $numberA  = 0;
    my $numberB  = 0;
    my $number   = 0;
	
	my $disk_diff = abs( $disksA - $disksB );
    if ( $unowned_disks > 0 ) {
		my ($sys_id,$filer_name_b);
        if ( $disk_diff > $unowned_disks ) {
			logcomment("Total disk difference $disk_diff which is greater than un-assigned disks $unowned_disks");
            if(($disk_diff/2) <= $unowned_disks){
				logcomment("1/2 of drives difference i.e $disk_diff is lesser than un-assigned drives $unowned_disks ");
				if ( $disksA > $disksB ) {
					$filer_name = $FilerB;
					$filer_name_b = $FilerA;
					$sys_id =  $sysid_p;
				}
				elsif ( $disksB > $disksA ) {
					$filer_name = $FilerA;
					$filer_name_b = $FilerB;
					$sys_id =  $sysid;
				}
				@unowned_disks = sort {	if(($a=~/P\d+/)&&($b!~/P\d+/)){
										return 1;
									}elsif(($a!~/P\d+/)&&($b=~/P\d+/)){
										return -1;
									}elsif(($a=~/P\d+/)&&($b=~/P\d+/)){
										my($tst1)=$a=~/P(\d+)/;
										my($tst2)=$b=~/P(\d+)/;
										return $tst1 <=> $tst2;
									}else{
										return $a <=> $b;
									}
								}@unowned_disks;
				my(@partition_drives,@container_drives);			
				grep{if($_=~/P\d+$/){push (@partition_drives,$_)}else{push(@container_drives,$_)}}@unowned_disks;
				if(@container_drives){
					logcomment("Total number container drives which need to assign the filer : $filer_name are ".scalar @container_drives." and the drives are @container_drives" );
				}
				if(@partition_drives){
					logcomment("Total number partitioned drives which need to assign the filer : $filer_name are ".scalar @partition_drives." and the drives are @partition_drives" );
				}
				if(@container_drives){
					my $disk_max_sup = 40;
					my @copy_drives_need_to_assign = @container_drives;
					while(@copy_drives_need_to_assign){
						my $loop_no     = 0;
						my @disk_list_q = ();
						while ($loop_no < $disk_max_sup) {
							push @disk_list_q,pop @copy_drives_need_to_assign;
							$loop_no++;
							last if (!(@copy_drives_need_to_assign));
						}
						logcomment("Assigning the drives @disk_list_q to filer $filer_name");
						$Api_filerA->execute_raw_command('command' =>"disk assign @disk_list_q -o $filer_name -s $sysid -f");
						sleep((@disk_list_q*5)+60);
						$Api_filerA->execute_raw_command('command' => "\013");
					}	
				}
				if(@partition_drives){
					my $status = disk_show_drive_maint( API_Obj =>$Api_filerA,Filer=>$filer_name);
					my @drives_A = @{$status->{'driveA'}};
					my @drives_B = @{$status->{'driveB'}};
					my (%disk_api,%disk_sys);
					$disk_api{$FilerA} = $Api_filerA;
					# $disk_sys{$FilerA} = $sysid;
					$disk_api{$FilerB} = $Api_filerB;
					# $disk_sys{$FilerA} =$sysid_p;
					my $prompts_answers = ["Do you want to continue"=> 'y'];
					foreach my $dsk(@partition_drives){
						(my $tmp = $dsk)=~s/P\d+$//;
						$disk_api{$status->{$tmp}}->execute_raw_command('command' =>"disk assign $dsk -o $filer_name -s $sysid -f",'connectrec-match_table' => $prompts_answers) if($disk_api{$status->{$tmp}});
						sleep 1;
					}
				}	
				$Api_filerA->execute_raw_command('command' => "disk show -a");
			}else{
				logcomment("1/2 of drives difference i.e $disk_diff is greater than un-assigned drives drives $unowned_disks  ");
				$Api_filerA->execute_raw_command('command' =>"disk remove_ownership all -f");
				sleep 10;
				$Api_filerA->execute_raw_command('command' =>"disk remove_ownership all -f");
				$Api_filerA->execute_raw_command('command' =>"storage release disks -f");
				$Api_filerB->execute_raw_command('command' =>"storage release disks -f");
				sleep($delay_time);
				my $output = $Api_filerA->execute_raw_command('command' =>"disk show -n");
				if($output=~/No disks match option -n|No unassigned disks/){
					logresult( "FATAL"," Disk assign , remove ownership has not done properly");
				}
				my @free_drives = keys %{disk_show_n(Node =>$Nodes[0])};
				my(@partition_drives,@container_drives,@assign_arr,%filer_details);
				grep{if($_=~/P\d+$/){push (@partition_drives,$_)}else{push(@container_drives,$_)}}@free_drives;
				if(@container_drives){
					logcomment("Total number of container drives are ".scalar @container_drives." and the drives are @container_drives");
				}
				if(@partition_drives){
					logcomment("Total number of partition drives are ".scalar @partition_drives." and the drives are @partition_drives");
				}
				logcomment("Removing and assigning disks between the filers as one of the filer is having less than 3 drives");
				
				if(@container_drives){
					my $unowned = @container_drives;
					if ( $unowned % 2 == 0 ) {
						$numberA = $unowned / 2;
					}
					else {
						$numberB = $unowned + 1;
						$numberA = $numberB / 2;
					}
					my @numberA = @container_drives[0..$numberA];
					my @numberB = @container_drives[($numberA+1)..$#container_drives];
					my $returnA = $Api_filerA->execute_raw_command('command' =>"disk assign @numberA -o $FilerA -s $sysid -f") if(@numberA);
					sleep($delay_time);
					if($returnA=~/Assign failed/ ){
						logresult( 'FATAL',"Disk assign is failed on the filer.Existing from the test.Please manualy assign the disks to the filer");
					}
					my $returnB = $Api_filerA->execute_raw_command('command' =>"disk assign @numberB -o $FilerB -s $sysid_p -f")if(@numberB);
					sleep($delay_time);
					if($returnB=~/Assign failed/ ){
						logresult( 'FATAL',"Disk assign is failed on the filer.Existing from the test.Please manualy assign the disks to the filer");
					}
				}	
				
				if(@partition_drives){
					my $status = disk_show_drive_maint( API_Obj =>$Api_filerA,Filer=>$FilerA);
					# print"dumping ".Dumper($status);
					my @drives_A = @{$status->{'driveA'}};
					my @drives_B = @{$status->{'driveB'}};
					logcomment("Drives a @drives_A and drviesb @drives_B");
					my $unowned = @partition_drives;
					if ( $unowned % 2 == 0 ) {
						$numberA = $unowned / 2;
					}
					else {
						$numberB = $unowned + 1;
						$numberA = $numberB / 2;
					}
					my @numberA = @partition_drives[0..$numberA];
					my @numberB = @partition_drives[($numberA+1)..$#partition_drives];
					my $num_A_ref = \@numberA ;
					my $num_B_ref = \@numberB;
					$filer_details{$num_A_ref} = "-o $FilerA -s $sysid";
					$filer_details{$num_B_ref} = "-o $FilerB -s $sysid_p";
					my %disk_api;
					$disk_api{$FilerA} = $Api_filerA;
					$disk_api{$FilerB} = $Api_filerB;
					my $prompts_answers = ["Do you want to continue"=> 'y'];
					push(@assign_arr,$num_A_ref)if(@numberA);
					push(@assign_arr,$num_B_ref)if(@numberB);
					foreach my $disk_ref (@assign_arr){
						my @drives = @{$disk_ref};
						# logcomment("drives ::: @drives");
						foreach my $dsk(@drives){
							(my $tmp = $dsk)=~s/P\d+$//;
							$disk_api{$status->{$tmp}}->execute_raw_command('command' =>"disk assign $dsk $filer_details{$disk_ref} -f",'connectrec-match_table' => $prompts_answers) if($disk_api{$status->{$tmp}});
							sleep 1;
						}	
					}
				}
				$Api_filerA->execute_raw_command('command' => "disk show -a");
			}
		}else{
			logcomment("Total disk difference $disk_diff which is lesser than un-owned disks $unowned_disks");
			if ( $disksA < $disksB ) {
                $numberA = $disk_diff;
            }
            elsif ( $disksB < $disksA ) {
                $numberB = $disk_diff;
            }
			$number =  sprintf( "%d", ( ( $unowned_disks - $disk_diff ) / 2 ) );
            $numberA = $numberA + $number;
            $numberB = $numberB + $number;
			@unowned_disks = sort {	if(($a=~/P\d+/)&&($b!~/P\d+/)){
										return 1;
									}elsif(($a!~/P\d+/)&&($b=~/P\d+/)){
										return -1;
									}elsif(($a=~/P\d+/)&&($b=~/P\d+/)){
										my($tst1)=$a=~/P(\d+)/;
										my($tst2)=$b=~/P(\d+)/;
										return $tst1 <=> $tst2;
									}else{
										return $a <=> $b;
									}
								}@unowned_disks;
			
			
			my(@partition_drives,@container_drives,@assign_arr,%filer_details);
			grep{if($_=~/P\d+$/){push (@partition_drives,$_)}else{push(@container_drives,$_)}}@unowned_disks;
			if(@container_drives){
				logcomment("Total number of container drives are ".scalar @container_drives." and the drives are @container_drives");
			}
			if(@partition_drives){
				logcomment("Total number of partition drives are ".scalar @partition_drives." and the drives are @partition_drives");
			}
			logcomment("Removing and assigning disks between the filers as one of the filer is having no drives");
			if(@container_drives){
				my @drives = @container_drives;
				my $unowned = @drives;
				if ( $unowned % 2 == 0 ) {
					$numberA = $unowned / 2;
				}
				else {
					$numberB = $unowned + 1;
					$numberA = $numberB / 2;
				}
				my @numberA = @container_drives[0..$numberA];
				my @numberB = @container_drives[($numberA+1)..$#container_drives];
				my $returnA = $Api_filerA->execute_raw_command('command' =>"disk assign @numberA -o $FilerA -s $sysid -f") if(@numberA);
				sleep($delay_time);
				if($returnA=~/Assign failed/ ){
					logresult( 'FATAL',"Disk assign is failed on the filer.Existing from the test.Please manualy assign the disks to the filer");
				}
				my $returnB = $Api_filerA->execute_raw_command('command' =>"disk assign @numberB -o $FilerB -s $sysid_p -f")if(@numberB);
				sleep($delay_time);
				if($returnB=~/Assign failed/ ){
					logresult( 'FATAL',"Disk assign is failed on the filer.Existing from the test.Please manualy assign the disks to the filer");
				}
			}	
			if(@partition_drives){
				my $status = disk_show_drive_maint( API_Obj =>$Api_filerA,Filer=>$FilerA);
				# print"dumping ".Dumper($status);
				my @drives_A = @{$status->{'driveA'}};
				my @drives_B = @{$status->{'driveB'}};
				# logcomment("Drives a @drives_A and drviesb @drives_B");
				my $unowned = @partition_drives;
				if ( $unowned % 2 == 0 ) {
					$numberA = $unowned / 2;
				}
				else {
					$numberB = $unowned + 1;
					$numberA = $numberB / 2;
				}
				my @numberA = @partition_drives[0..$numberA];
				my @numberB = @partition_drives[($numberA+1)..$#partition_drives];
				my $num_A_ref = \@numberA ;
				my $num_B_ref = \@numberB;
				$filer_details{$num_A_ref} = "-o $FilerA -s $sysid";
				$filer_details{$num_B_ref} = "-o $FilerB -s $sysid_p";
				my %disk_api;
				$disk_api{$FilerA} = $Api_filerA;
				$disk_api{$FilerB} = $Api_filerB;
				my $prompts_answers = ["Do you want to continue"=> 'y'];
				push(@assign_arr,$num_A_ref)if(@numberA);
				push(@assign_arr,$num_B_ref)if(@numberB);
				foreach my $disk_ref (@assign_arr){
					my @drives = @{$disk_ref};
					# logcomment("drives ::: @drives");
					foreach my $dsk(@drives){
						(my $tmp = $dsk)=~s/P\d+$//;
						$disk_api{$status->{$tmp}}->execute_raw_command('command' =>"disk assign $dsk $filer_details{$disk_ref} -f",'connectrec-match_table' => $prompts_answers) if($disk_api{$status->{$tmp}});
						sleep 1;
					}	
				}
			}
			$Api_filerA->execute_raw_command('command' => "disk show -a");
		}
	} elsif ( ( $disksA == 0 ) || ( $disksB == 0 ) ) {
		logcomment("Either the filers disks are zero and no un-assigned disks are present");
		$Api_filerA->execute_raw_command('command' =>"disk remove_ownership all -f");
		sleep 5;
		$Api_filerA->execute_raw_command('command' =>"disk remove_ownership all -f");
		$Api_filerA->execute_raw_command('command' =>"storage release disks -f");
		$Api_filerB->execute_raw_command('command' =>"storage release disks -f");
		sleep($delay_time);
		my @unown_disks = keys %{disk_show_n(Node =>$Nodes[0])};
		my $unowned = @unown_disks;
		if($unowned < 1 ){
			logresult( 'FATAL'," Disk assign , remove ownership has not done properly");
		}
		logcomment("Total number of un-owned disks are $unowned and the disks @unown_disks")if(@unown_disks);
		logcomment("No un-owned drives available")if(!@unown_disks);
		my(@partition_drives,@container_drives,@assign_arr,%filer_details);
		grep{if($_=~/P\d+$/){push (@partition_drives,$_)}else{push(@container_drives,$_)}}@unown_disks;
		if(@container_drives){
			logcomment("Total number of container drives are ".scalar @container_drives." and the drives are @container_drives");
		}
		if(@partition_drives){
			logcomment("Total number of partition drives are ".scalar @partition_drives." and the drives are @partition_drives");
		}
		logcomment("Removing and assigning disks between the filers as one of the filer is having no drives");
		if(@container_drives){
			my @drives = @container_drives;
			my $unowned = @drives;
			if ( $unowned % 2 == 0 ) {
				$numberA = $unowned / 2;
			}
			else {
				$numberB = $unowned + 1;
				$numberA = $numberB / 2;
			}
			my @numberA = @drives[0..$numberA];
			my @numberB = @drives[($numberA+1)..$#drives];
			my $returnA = $Api_filerA->execute_raw_command('command' =>"disk assign @numberA -o $FilerA -s $sysid -f") if(@numberA);
			sleep($delay_time);
			if($returnA=~/Assign failed/ ){
				logresult( 'FATAL',"Disk assign is failed on the filer.Existing from the test.Please manualy assign the disks to the filer");
			}
			my $returnB = $Api_filerA->execute_raw_command('command' =>"disk assign @numberB -o $FilerB -s $sysid_p -f")if(@numberB);
			sleep($delay_time);
			if($returnB=~/Assign failed/ ){
				logresult( 'FATAL',"Disk assign is failed on the filer.Existing from the test.Please manualy assign the disks to the filer");
			}
		}	
		if(@partition_drives){
			my $status = disk_show_drive_maint( API_Obj =>$Api_filerA,Filer=>$FilerA);
			# print"dumping ".Dumper($status);
			my @drives_A = @{$status->{'driveA'}};
			my @drives_B = @{$status->{'driveB'}};
			logcomment("Drives a @drives_A and drviesb @drives_B");
			my $unowned = @partition_drives;
			if ( $unowned % 2 == 0 ) {
				$numberA = $unowned / 2;
			}
			else {
				$numberB = $unowned + 1;
				$numberA = $numberB / 2;
			}
			my @numberA = @partition_drives[0..$numberA];
			my @numberB = @partition_drives[($numberA+1)..$#partition_drives];
			my $num_A_ref = \@numberA ;
			my $num_B_ref = \@numberB;
			$filer_details{$num_A_ref} = "-o $FilerA -s $sysid";
			$filer_details{$num_B_ref} = "-o $FilerB -s $sysid_p";
			my %disk_api;
			$disk_api{$FilerA} = $Api_filerA;
			$disk_api{$FilerB} = $Api_filerB;
			my $prompts_answers = ["Do you want to continue"=> 'y'];
			push(@assign_arr,$num_A_ref)if(@numberA);
			push(@assign_arr,$num_B_ref)if(@numberB);
			foreach my $disk_ref (@assign_arr){
				my @drives = @{$disk_ref};
				logcomment("drives ::: @drives");
				foreach my $dsk(@drives){
					(my $tmp = $dsk)=~s/P\d+$//;
					$disk_api{$status->{$tmp}}->execute_raw_command('command' =>"disk assign $dsk $filer_details{$disk_ref} -f",'connectrec-match_table' => $prompts_answers) if($disk_api{$status->{$tmp}});
					sleep 1;
				}	
			}
		}
		$Api_filerA->execute_raw_command('command' => "disk show -a");
		
	}elsif((( $disksA < int((scalar @total_disks)/2) ) || ( $disksB < int((scalar @total_disks)/2)))){
		if((abs( $disksA - $disksB ))>=2){
			logcomment("One of the Filer's disks are less than half of the total drives");
			$Api_filerA->execute_raw_command('command' =>"disk remove_ownership all -f");
			sleep 5;
			$Api_filerB->execute_raw_command('command' =>"disk remove_ownership all -f");
			$Api_filerA->execute_raw_command('command' =>"storage release disks -f");
			$Api_filerB->execute_raw_command('command' =>"storage release disks -f");
			sleep($delay_time);
			my $output = $Api_filerA->execute_raw_command('command' =>"disk show -n");
			if($output=~/No disks match option -n|No unassigned disks/){
				logresult( "FATAL"," Disk assign , remove ownership has not done properly , please assign the disk manually to the filer");
			}
			my @free_drives = keys %{disk_show_n(Node =>$Nodes[0])};
			
			my(@partition_drives,@container_drives,@assign_arr,%filer_details);
			grep{if($_=~/P\d+$/){push (@partition_drives,$_)}else{push(@container_drives,$_)}}@free_drives;
			if(@container_drives){
				logcomment("Total number of container drives are ".scalar @container_drives." and the drives are @container_drives");
			}
			if(@partition_drives){
				logcomment("Total number of partition drives are ".scalar @partition_drives." and the drives are @partition_drives");
			}
			if(@container_drives){
				my @drives = @container_drives;
				my $unowned = @drives;
				if ( $unowned % 2 == 0 ) {
					$numberA = $unowned / 2;
				}
				else {
					$numberB = $unowned + 1;
					$numberA = $numberB / 2;
				}
				my @numberA = @drives[0..$numberA];
				my @numberB = @drives[($numberA+1)..$#drives];
				my $returnA = $Api_filerA->execute_raw_command('command' =>"disk assign @numberA -o $FilerA -s $sysid -f") if(@numberA);
				sleep($delay_time);
				if($returnA=~/Assign failed/ ){
					logresult( 'FATAL',"Disk assign is failed on the filer.Existing from the test.Please manualy assign the disks to the filer");
				}
				my $returnB = $Api_filerA->execute_raw_command('command' =>"disk assign @numberB -o $FilerB -s $sysid_p -f")if(@numberB);
				sleep($delay_time);
				if($returnB=~/Assign failed/ ){
					logresult( 'FATAL',"Disk assign is failed on the filer.Existing from the test.Please manualy assign the disks to the filer");
				}
			}
			
			if(@partition_drives){
				my $status = disk_show_drive_maint( API_Obj =>$Api_filerA,Filer=>$FilerA);
				# print"dumping ".Dumper($status);
				my @drives_A = @{$status->{'driveA'}};
				my @drives_B = @{$status->{'driveB'}};
				logcomment("Drives a @drives_A and drviesb @drives_B");
				my $unowned = @partition_drives;
				if ( $unowned % 2 == 0 ) {
					$numberA = $unowned / 2;
				}
				else {
					$numberB = $unowned + 1;
					$numberA = $numberB / 2;
				}
				my @numberA = @partition_drives[0..$numberA];
				my @numberB = @partition_drives[($numberA+1)..$#partition_drives];
				my $num_A_ref = \@numberA ;
				my $num_B_ref = \@numberB;
				$filer_details{$num_A_ref} = "-o $FilerA -s $sysid";
				$filer_details{$num_B_ref} = "-o $FilerB -s $sysid_p";
				my %disk_api;
				$disk_api{$FilerA} = $Api_filerA;
				$disk_api{$FilerB} = $Api_filerB;
				my $prompts_answers = ["Do you want to continue"=> 'y'];
				push(@assign_arr,$num_A_ref)if(@numberA);
				push(@assign_arr,$num_B_ref)if(@numberB);
				foreach my $disk_ref (@assign_arr){
					my @drives = @{$disk_ref};
					# logcomment("drives ::: @drives");
					foreach my $dsk(@drives){
						(my $tmp = $dsk)=~s/P\d+$//;
						$disk_api{$status->{$tmp}}->execute_raw_command('command' =>"disk assign $dsk $filer_details{$disk_ref} -f",'connectrec-match_table' => $prompts_answers) if($disk_api{$status->{$tmp}});
						sleep 1;
					}	
				}
			}
			$Api_filerA->execute_raw_command('command' => "disk show -a");
		}
	}else{
		logcomment("Disk are already asigned properly");
		return 0;
	}
}

####################################################################################################
#Author - Arjun Lavu
# Description :: Disk remove assigning in file-system mode
####################################################################################################
sub remv_assign_ownership_cli{
	my (%opts) = validate( 
		@_,
		{	Node_ref		 =>	{ type => ARRAYREF },
			disk_ref      	 => { type => ARRAYREF,default=>undef, optional => 1 },
			assign_disk_to	 => {type  => OBJECT,default=>undef,optional =>1},
			remove_disk_from => {type  => OBJECT,default=>undef,optional =>1},
			delete_aggr		=>{type  => SCALAR,default=>undef,optional =>1},
	   }
     );
	my @Nodes		= @{$opts{Node_ref}};
	my @disks;
	my $assign_node;
	my $remove_disk_from;
	my $assign_api;
	my $remove_disk_from_api;
	my %Node_unowned;
	my @disk_A;
	my @disk_B;
	my @unassigned_disk;
	my @unowned;
	my @broken_disk_A;
	my @broken_disk_B;
	my @Total_spare;
	my $sysid_A;
	my $sysid_B;
	my $assign_filer_name;
	my $remove_disk_from_filer;
	logcomment("Inside remove assign ownership");
	my $params = NATE::ParamSet->new(global => 1);
    my $Kernel = $params->get('KERNEL', default => 'FS');
	my $Mode = $Nodes[0]->mode();
	if(defined($opts{disk_ref})){
		@disks = @{$opts{disk_ref}};
	}
	foreach my $Node(@Nodes){
		my $Mode = $Node->mode();
		diag_password_change_cmode(Node_ref=>[$Node]);
	}
	
	if(scalar @Nodes == 1){
		my $params = NATE::ParamSet->new(global => 1);
		my $LOGDIR = $params->get('LOGDIR', default => undef);
		my $TEST_CONFIG = $params->get('TEST_CONFIG', default => undef);
		logcomment("Only one filer ".$Nodes[0]->name()." is present");
		my $FILER_C = $Nodes[0]->name();
		#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		#Checking whether any broken disks in CMode or FAILED disks in 7Mode present, if present unfailing them to spare drives
		{	
			my @broken;
			try{
				my %hash = (filter => {'container-type' => "broken",'owner' => $FILER_C});
				my @broken_obj = NACL::C::Disk->find(
								command_interface => $Nodes[0],
								%hash,
							);
				foreach my $state_obj (@broken_obj){
					my $free_disk = $state_obj->disk();
					if ($free_disk =~ /(\S+)\:(\S+)/){
						$free_disk = $2;
					}
					push( @broken,$free_disk);
				}
				if(@broken){
					logcomment("$FILER_C : Number of broken disks are ".scalar @broken." and the disks are @broken");
				}
			}catch NACL::Exceptions::NoElementsFound with{
				logcomment("$FILER_C : No broken disks found for the filer");
			};
			foreach my $boken (@broken){
				try{
					NACL::C::StorageDisk->unfail( command_interface => $Nodes[0],
															disk => $boken,
															spare => "true",
															'method-timeout'  => 1200);
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					my $Filer = $Nodes[0]->name();
					logcomment("WARNING : $Filer : Couldn't unfail the disk $boken");
				}catch NATE::BaseException with {
					logcomment("Unfailing the drive is interupted, may be because of timeout issue, So trying again to unafail after 5 minutes");
					sleep 300;
					try{
						NACL::C::StorageDisk->unfail( command_interface => $Nodes[0],
															disk => $boken,
															spare => "true",
															'method-timeout'  => 1200);
					}catch NATE::BaseException with {
						logcomment("Unfailing the drive is not successfull");
					};
				};												
			}
		}
		
		#****************************************************************************************
		#Check for any un-assigned disks
		#****************************************************************************************
		my @disk_obj_unown = NACL::C::Disk->find(
						command_interface => $Nodes[0],
						filter            => { owner => "-" },
						allow_empty => 1,
					);
		foreach my $state_obj (@disk_obj_unown){
			my $free_disk = $state_obj->disk();
			if ($free_disk =~ /(\S+)\:(\S+)/){
				$free_disk = $2;
			}
			push( @unassigned_disk , $free_disk);
		}
		logcomment("Number of container un-assigned drives are ".scalar @unassigned_disk." and the drives are @unassigned_disk");
		my @temp_part;		
		if($Kernel=~/FS/i){
			try{
				logcomment("Checking for partitioned unowned drives if present");
				my @disk_obj = NACL::CS::StorageDiskPartition->fetch(
							command_interface => $Nodes[0],
							filter => { "owner-node-name" => "-" },
							requested_fields  => [qw(partition)],
							allow_empty => 1,
						);
				foreach (@disk_obj){
					push( @temp_part,$_->partition());
				}
				logcomment("Number of un-assigned partition drives found are @temp_part ". scalar @temp_part." and the drives are @temp_part");
			}catch NACL::Exceptions::NoElementsFound with{
				logcomment("No un-assigned partitioned drives found in the filer $FILER_C");
			};
			push(@unassigned_disk,@temp_part) if (@temp_part);
		}
		
		logcomment("Total number of unassiged disks are ".scalar @unassigned_disk." and the disks are @unassigned_disk")if(@unassigned_disk);
		logcomment("No unassigned disks available")if(!@unassigned_disk);
		if(@unassigned_disk){
			my $remove_disk_from_api = $Nodes[0]->get_7m_or_nodescope_apiset();
			my $sysid;
			if($Mode =~/CMode/){
				my $return = $remove_disk_from_api->execute_raw_command('command' => "system node show -fields systemid -node $FILER_C");
				if($return =~/$FILER_C(\D*)(\d+)(\D*)/){
					$sysid = $2;
				}
			}else{
				my $return = $remove_disk_from_api->execute_raw_command('command' => "sysconfig -v");
				if($return =~/\s*System(\D*)ID:(\D*)(\d+)(\D*)/){
					$sysid = $3;
				}
			}	
			if(@disks){
				logcomment("$FILER_C : Drives passed by the user to assign to the filer $FILER_C are ".scalar @disks." and the drives are @disks");
				my @drives_need_to_assign = commom_drives([@unassigned_disk],[@disks]);
				logcomment("$FILER_C : Out of these drives, drives which got unassigned are ".scalar @drives_need_to_assign." and the drives are @drives_need_to_assign");
				if(@drives_need_to_assign){
					logcomment("Assigning the drives @drives_need_to_assign to filer $FILER_C");
					foreach my $disk(@drives_need_to_assign){
						if($disk!~/P\d+$/){
							try{
								NACL::C::StorageDisk->assign( 
														command_interface => $Nodes[0],
														owner           => $FILER_C,
														disk            =>  $disk,
														sysid 			=> $sysid,
														force           =>'true',
														'method-timeout'  => 1200
														);
							}catch NACL::APISet::Exceptions::CommandFailedException with {
								logcomment("WARNING : $disk is not assigned to filer $FILER_C");
							}catch NATE::BaseException with {
								sleep 120;
								logcomment("May be the timeout exception");
								my $API = $Nodes[0]->get_7m_or_nodescope_apiset();
								$API->set_timeout( "connectrec-timeout" => 1200 );
								$API->execute_command('command' =>"disk show -a");
							};
						}else{
							try{
								NACL::C::StorageDiskPartition->assign(
									command_interface => $Nodes[0],
									partition         => $disk,
									owner             => $FILER_C,
									sysid 				=> $sysid,
									force           	=>'true',
									'method-timeout'  	=> 1200);	
							}catch NACL::APISet::Exceptions::CommandFailedException with {
								logcomment("WARNING : Partitioned $disk is not assigned to filer $FILER_C");
							};
						}
					}
					# return 0;
				}else{
					logcomment("$FILER_C : No drives are matched to unassigned drives");
				}
				return 0;
			}else{
				my @actual_disks;
				my $disks_file= "$LOGDIR/../../../"."Pre_post_Drives_Details_"."$FILER_C";
				if (-f $disks_file) {
					open(H_LOGFILE, "<$disks_file ")or die ">>>>> read: Failed opening $disks_file <<<<<";
					foreach my $line (<H_LOGFILE>) {
						chomp($line);
						$line=~s/(^\s+)|(\s+$)//ig;
						next if($line !~/\S/);
						push @actual_disks, $line;
					}
					close H_LOGFILE;
					logcomment("Drives which found in the file $disks_file are @actual_disks");
					my @drives_need_to_assign = commom_drives([@unassigned_disk],[@actual_disks]);
					if(@drives_need_to_assign){
						foreach my $disk(@drives_need_to_assign){
							logcomment("Out of the un-owned drives, drives which are common are :: @drives_need_to_assign");
							logcomment("Assigning the drives @drives_need_to_assign to the Filer ::: $FILER_C");
							if($disk!~/P\d+$/){
								try{
									NACL::C::StorageDisk->assign( 
															command_interface => $Nodes[0],
															owner           => $FILER_C,
															disk            =>  $disk,
															sysid 			=> $sysid,
															force           =>'true',
															'method-timeout'  => 1200
															);
								}catch NACL::APISet::Exceptions::CommandFailedException with {
									logcomment("WARNING : $disk is not assigned to filer $FILER_C");
								};
							}else{
								try{
									NACL::C::StorageDiskPartition->assign(
										command_interface => $Nodes[0],
										partition         => $disk,
										owner             => $FILER_C,
										sysid 				=> $sysid,
										force           	=>'true',
										'method-timeout'  	=> 1200
										);
								}catch NACL::APISet::Exceptions::CommandFailedException with {
									logcomment("WARNING :: Partitioned disk $disk is not assigned to filer $FILER_C");
								};
							}
						}
					}else{
						logcomment("$FILER_C : No drives are matched to unassigned drives when compared to file : $disks_file");
					}
					return 0;
				}
			}

			if(@disk_obj_unown){
				try{
					NACL::C::StorageDisk->assign( 
												command_interface => $Nodes[0],
												all              => 'true',
												node			 => $Nodes[0],
												force            =>'true',
												'method-timeout'  => 1200
												);
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					my $Filer = $Nodes[0]->name();
					logcomment("WARNING : $Filer : Some of the disks are not assigned");
				};
			}
			
			if(@temp_part){
			try{
				NACL::C::StorageDiskPartition->assign( 
											command_interface => $Nodes[0],
											all              => 'true',
											node			 => $Nodes[0],
											force            =>'true',
											'method-timeout'  => 1200
											);
			}catch NACL::APISet::Exceptions::CommandFailedException with {
				my $Filer = $Nodes[0]->name();
                logcomment("WARNING :: $Filer : Some of the Partitioned disks are not assigned");
            };
			return 0;
			}
		}else{
			logcomment("No un-assigned disks found in the filers");
			return 0;
		}
		#****************************************************************************************
	}

	if(defined($opts{assign_disk_to})){
		$assign_node = $opts{assign_disk_to};
		$assign_filer_name = $assign_node->name();
		$assign_api = $assign_node->get_7m_or_nodescope_apiset();
		if($Mode=~/CMode/i){
			$assign_api->execute_raw_command('command' => "storage disk option modify -node $assign_filer_name -autoassign off");
		}else{
			$assign_api->execute_raw_command('command' => "options disk.auto_assign off");
		}
	}
	#------------------------------------------------------------------
	if(defined($opts{remove_disk_from})){
		$remove_disk_from = $opts{remove_disk_from};
		$remove_disk_from_api = $remove_disk_from->get_7m_or_nodescope_apiset();
		$remove_disk_from_filer = $remove_disk_from->name();
		if($Mode=~/CMode/){
			$remove_disk_from_api->execute_raw_command('command' => "storage disk option modify -node $remove_disk_from_filer -autoassign off");
		}else{
			$remove_disk_from_api->execute_raw_command('command' => "options disk.auto_assign off");
		}	
	}	
	if(($remove_disk_from_filer)&&($assign_filer_name)){ 					##If remove_disk_from and assign_disk_to are defined then only	
		my @disk_obj;														## remove disks from remove_disk_from node
		my @unowned_remove;
		my @spare_remove;
		
		#deleting aggregates from the node where spare disks has to be removed
		#vserver_delete(Node => $remove_disk_from) if($Mode =~/CMode/i);
		aggregate_volume_delete(Node => $remove_disk_from);
		
		#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		#Checking whether any broken disks in CMode or FAILED disks in 7Mode present, if present unfailing them to spare drives
		{	
			my $type="broken" if ($Mode=~/CMode/i);
			try{
				my %hash = (filter => {'container-type' => "broken",'owner' => $remove_disk_from_filer});
				my @broken_obj = NACL::C::Disk->find(
								command_interface => $remove_disk_from,
								%hash,
							);
				foreach my $state_obj (@broken_obj){
					my $free_disk = $state_obj->disk();
					if ($free_disk =~ /(\S+)\:(\S+)/){
						$free_disk = $2;
					}
					push( @broken_disk_B,$free_disk);
				}
				if(@broken_disk_B){
					logcomment("$remove_disk_from_filer : Number of broken disks are ".scalar @broken_disk_B." and the disks are @broken_disk_B");
				}
			}catch NACL::Exceptions::NoElementsFound with{
				logcomment("$remove_disk_from_filer : No broken disks found for the filer");
			};
			foreach my $boken (@broken_disk_B){
				try{
					NACL::C::StorageDisk->unfail( command_interface => $remove_disk_from,
															disk => $boken,
															spare => "true",
															'method-timeout'  => 1200);
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					my $Filer = $remove_disk_from->name();
					logcomment("WARNING : $Filer : Couldn't unfail the disk $boken");
				}catch NATE::BaseException with {
					my $Filer = $remove_disk_from->name();
					logcomment("$Filer : WARNING : Unfailing the drive is interupted, may be because of timeout issue, So trying again to unafail after 5 minutes");
					sleep 300;
					try{
						NACL::C::StorageDisk->unfail( command_interface => $remove_disk_from,
															disk => $boken,
															spare => "true",
															'method-timeout'  => 1200);
					}catch NATE::BaseException with {
						logcomment("$Filer : Unfailing the drive is not successfull");
					};
				};		
			}
		}

		{	
			my $type="broken" if ($Mode=~/CMode/i);
			try{
				my %hash = (filter => {'container-type' => "broken",'owner' => $assign_filer_name});
				my @broken_obj = NACL::C::Disk->find(
								command_interface => $assign_node,
								%hash,
							);
				foreach my $state_obj (@broken_obj){
					my $free_disk = $state_obj->disk();
					if ($free_disk =~ /(\S+)\:(\S+)/){
						$free_disk = $2;
					}
					push( @broken_disk_A,$free_disk);
				}
				if(@broken_disk_A){
					logcomment("$assign_filer_name : Number of broken disks are ".scalar @broken_disk_A." and the disks are @broken_disk_A");
				}
			}catch NACL::Exceptions::NoElementsFound with{
				logcomment("$assign_filer_name : No broken disks found for the filer");
			};
		
			foreach my $boken (@broken_disk_A){
				try{
					NACL::C::StorageDisk->unfail( command_interface => $assign_node,
															disk => $boken,
															spare => "true",
															'method-timeout'  => 1200);
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					my $Filer = $assign_node->name();
					logcomment("WARNING : $Filer : Couldn't unfail the disk $boken");
				}catch NATE::BaseException with {
					my $Filer = $assign_node->name();
					logcomment("$Filer :: WARNING : Unfailing the drive is interrupted,may be because of timeout issue, So trying again to unafail after 5 minutes");
					sleep 300;
					try{
						NACL::C::StorageDisk->unfail( command_interface => $assign_node,
															disk => $boken,
															spare => "true",
															'method-timeout'  => 1200);
					}catch NATE::BaseException with {
						
						logcomment("$Filer :: WARNING : Unfailing the drive is not successfull");
					};
				};	
			}	
		}
		#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		
		##$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		#Check for any un-owned disks and assign back them to its parent node
	
		try{
			my %hash=(filter => {'container-type' => "unknown",'home'=>$remove_disk_from_filer });
			my @unown;
			my @unowned_obj = NACL::C::Disk->find(
									command_interface => $remove_disk_from,
									%hash,
								);
			foreach my $state_obj (@unowned_obj){
				my $free_disk = $state_obj->disk();
				if ($free_disk =~ /(\S+)\:(\S+)/){
					$free_disk = $2;
				}
				push( @unown , $free_disk);
			}
			if(@unown){
				push(@unowned_remove,@unown);	#Total unowned disks
				logcomment("$remove_disk_from_filer : UNOWNED DISKS ARE @unown");
			}
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("$remove_disk_from_filer : No unowned disks found");
		};
		
		if($Kernel=~/FS/i){
			try{
				my %hash=(filter => { "owner-node-name" => $remove_disk_from_filer, 'container-type'=>"unknown" });
				my @unown;
				my @unowned_obj = NACL::CS::StorageDiskPartition->fetch(
										command_interface => $remove_disk_from,
										%hash,
										requested_fields  => [qw(partition)]
									);
	
				foreach my $state_obj (@unowned_obj){
					my $free_disk = $state_obj->partition();
					if ($free_disk =~ /(\S+)\:(\S+)/){
						$free_disk = $2;
					}
					push( @unown , $free_disk);
				}
				if(@unown){
					push(@unowned_remove,@unown);	#Total unowned disks
					logcomment("$remove_disk_from_filer : unowned partitioned disks are @unown");
				}
			}catch NACL::Exceptions::NoElementsFound with{
				logcomment("$remove_disk_from_filer :: No unowned partitioned disks found");
			};
		}
		##Assigning back to its owner if present then these disks will become spare drives 
		if(@unowned_remove){
			my $sysid;
			my $return = $remove_disk_from_api->execute_raw_command('command' => "system node show -fields systemid -node $remove_disk_from_filer");
			if($return =~/$remove_disk_from_filer(\D*)(\d+)(\D*)/){
				$sysid = $2;
			}
			
			foreach my $disk(@unowned_remove){
				if($disk!~/P\d+$/){
					try{
						NACL::C::StorageDisk->assign( 
												command_interface => $remove_disk_from,
												owner           => $remove_disk_from_filer,
												disk            =>  $disk,
												sysid 			=> $sysid,
												force           =>'true',
												'method-timeout'  => 1200
												);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING : $disk is not assigned to filer $remove_disk_from_filer");
					}; 	
				}else{
					try{
						NACL::C::StorageDiskPartition->assign( 
												command_interface => $remove_disk_from,
												owner           => $remove_disk_from_filer,
												partition            =>  $disk,
												sysid 			=> $sysid,
												force           =>'true',
												'method-timeout'  => 1200
												);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING :: Partitioned disk $disk is not assigned to filer $remove_disk_from_filer");
					}; 	
				}
			}
		}	
		##$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
		
		#****************************************************************************************
		#Check for any un-assigned disks
		my @disk_obj_unown = NACL::C::Disk->find(
						command_interface => $remove_disk_from,
						filter            => { owner => "-" },
						allow_empty => 1,
					);
		foreach my $state_obj (@disk_obj_unown){
			my $free_disk = $state_obj->disk();
			if ($free_disk =~ /(\S+)\:(\S+)/){
				$free_disk = $2;
			}
			push( @unassigned_disk , $free_disk);
		}
		
		my @temp_part;	
		if($Kernel=~/FS/i){		
			try{
				logcomment("Checking for partitioned unowned drives if present");
				my @disk_obj = NACL::CS::StorageDiskPartition->fetch(
							command_interface => $remove_disk_from,
							filter => { "owner-node-name" => "-" },
							requested_fields  => [qw(partition)],
							allow_empty => 1,
						);
				foreach (@disk_obj){
					push( @temp_part,$_->partition());
				}
				logcomment("Number of un-assigned partition drives found are @temp_part ". scalar @temp_part." and the drives are @temp_part");
			}catch NACL::Exceptions::NoElementsFound with{
				logcomment("No un-assigned partitioned drives found in the filer $remove_disk_from_filer");
			};
			push(@unassigned_disk,@temp_part) if (@temp_part);
		}
		logcomment("Total number of unassiged partitioned disks are ".scalar @unassigned_disk." and the disks are @unassigned_disk")if(@unassigned_disk);
		logcomment("No un-assigned partition drives found")if(!@unassigned_disk);
		
		if(@unassigned_disk){
			logcomment("Number of unassiged disks are ".scalar @unassigned_disk." and the disks are @unassigned_disk");
			push(@disks,@unassigned_disk);			#pushing to @disks even these disks also will get assign.
			@unassigned_disk =();					# resetting the array;
		}else{
			logcomment("No un-assigned disks found in the filers");
		}
		
		#****************************************************************************************
		
		################################################################################################
		#getting spare drives of the filer
		
		my @spare_remove = spare_count_cmode(Node =>$remove_disk_from,waiting =>'no');
		
		logcomment("Removing the ownership of drives @spare_remove") if(@spare_remove);
		foreach my $disk(@spare_remove){
			if($disk!~/P\d+$/){
				NACL::C::StorageDisk->removeowner(command_interface => $remove_disk_from,
											disk              => $disk,
											force             => 'true',
											'method-timeout'  => 600
										    );
			}else{
				NACL::C::StorageDiskPartition->removeowner(command_interface => $remove_disk_from,
												'partition'              => $disk,
												force             => 'true',
												'method-timeout'  => 600
										    );
			}
		}
		if(@spare_remove){
			push(@disks,@spare_remove);	
		}
		sleep 60;
		################################################################################################
	}
	if($assign_filer_name ){
		if(@disks){
			logcomment("Drives which are assigning to filer $assign_filer_name are :: @disks");
			my $sysid;
			if($Mode=~/CMode/){
				my $return = $assign_api->execute_raw_command('command' => "system node show -fields systemid -node $assign_filer_name");
				if($return =~/$assign_filer_name(\D*)(\d+)(\D*)/){
					$sysid = $2;
				}
			}else{
				my $return = $assign_api->execute_raw_command('command' => "sysconfig -v");
				if($return =~/\s*System(\D*)ID:(\D*)(\d+)(\D*)/){
					$sysid = $3;
				}
			}
			sleep 60;
			foreach my $disk(@disks){
				if($disk!~/P\d+$/){
					try{
						NACL::C::StorageDisk->assign( 
												command_interface => $assign_node,
												owner           => $assign_filer_name,
												disk            =>  $disk,
												sysid 			=> $sysid,
												force           =>'true',
												'method-timeout'  => 1200
												);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING : $assign_filer_name : Some of the disks are not assigned");
					};	
				}else{
					try{
						NACL::C::StorageDiskPartition->assign( 
												command_interface => $assign_node,
												owner           => $assign_filer_name,
												partition            =>  $disk,
												force           =>'true',
												'method-timeout'  => 1200
												);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING : $assign_filer_name : Some of the disks are not assigned");
					};	
				
				}
			}
			return 0;
		}else{
			logcomment("No spare disks are available on the filer $remove_disk_from_filer and no unknown,unassigned disks are also not available");
			return 0;
		}
	}	

	logcomment("If no disks,remove node, assign node are passed then disk will be allocated between the filers appropriately");
	###If disk_ref,remove_disk_from, assign_disk_to	parameters are not passed then disks are allocated according to below conditions 
	
	##listing all the disks attached to filers
	#try{
	{
		my @disk_list_common = get_disks_list( Node => $Nodes[0]);
		#my @disk_list_common_obj = NACL::C::StorageDisk->find( command_interface => $Nodes[0]);
		#foreach my $disk (@disk_list_common_obj) {
		#	push( @disk_list_common, $disk->get_one_state_attribute('disk') );
		#}
		if(!scalar @disk_list_common){
			logresult('FATAL',"No disks are attached to the filers");
		}
		logcomment("Total number of disks attached to filers are ".scalar @disk_list_common." and the disks are @disk_list_common");
		
	}	
	#}catch NACL::Exceptions::NoElementsFound with{
			
	#};	
	##If nothing is passed except nodes, delete all the aggregates except root, so that all the spare drives will be available to assign them 
	## equally on both the nodes.
	foreach my $node(@Nodes){
		my $FILER_C = $node->name();
		my $API_obj = $node->get_7m_or_nodescope_apiset();
		##Stopping all the SCRUB and hammer process , so that we can delete volumes
		try{
			$API_obj->hammer_abort();
			my @test_aggr = NACL::C::Aggregate->find(
									command_interface => $node,
									filter => {nodes => [$FILER_C]}
							);
			foreach my $aggr_c (@test_aggr){
        	    my $status = $aggr_c->scrub( action => "status" );
            	if ($status =~ /Percentage Completed/gi){
                    logcomment("Scrub status - $status");
                    logcomment("Stopping Scrub process");
                	$aggr_c->scrub( action => "stop" );
	            }else{
    	           logcomment("Scrub is not in progress, Proceeding with next steps");
        	    }
			}	
		}catch NACL::Exceptions::NoElementsFound with {
			logcomment ("$FILER_C : No Aggregate found, re_initilize filer to create root aggregate");
		};
		if(defined $opts{delete_aggr}){
			vserver_delete(Node =>$node);		#Vserver deletion
			aggregate_volume_delete(Node => $node);
		}
	}
	
	foreach my $node(@Nodes){
		my $api = $node->get_7m_or_nodescope_apiset();
		my $Filer = $node->name();
		$api->execute_raw_command('command' => "storage disk option modify -node $Filer -autoassign off");
	}
	#AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
	#Check for any un-owned disks on both the filers
	foreach my $node (@Nodes){
		my $FILER_C = $node->name();
		try{
			my %hash = (filter => {'container-type' => "unknown",'home'=>$FILER_C});
			my @unown;
			my @unowned_obj = NACL::C::Disk->find(
									command_interface => $node,
									%hash,
								);
			foreach my $state_obj (@unowned_obj){
				my $free_disk = $state_obj->disk();
				if ($free_disk =~ /(\S+)\:(\S+)/){
					$free_disk = $2;
				}
				push( @unown , $free_disk);
			}
			if(@unown){
				$Node_unowned{$node} = [@unown];
				push(@unowned,@unown);	#Total unowned disks
				logcomment("$FILER_C : UNOWNED DISKS ARE @unown");
			}
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("$FILER_C : No unowned disks found");
		};
		
		if($Kernel=~/FS/){
			try{
				my %hash=(filter => { "owner-node-name" => $FILER_C, 'container-type'=>"unknown" });
				my @unown;
				my @unowned_obj = NACL::CS::StorageDiskPartition->fetch(
										command_interface => $node,
										%hash,
										requested_fields  => [qw(partition)]
									);
	
				foreach my $state_obj (@unowned_obj){
					push( @unown , $state_obj->partition());
				}
				if(@unown){
					$Node_unowned{$node} = [@unown];
					push(@unowned,@unown);	#Total unowned disks
					logcomment("$FILER_C : UNOWNED PARTITIONED DISKS ARE @unown");
				}
			}catch NACL::Exceptions::NoElementsFound with{
				logcomment("$FILER_C : No unowned partitioned disks found");
			};	
		}
	}
	##Assigning back to its owner then these disks will become spare drives 
	foreach my $node(@Nodes){
		my $FILER = $node->name();
		my $api = $node->get_7m_or_nodescope_apiset();
		my $return = $api->execute_raw_command('command' => "system node show -fields systemid -node $FILER");
		if($Node_unowned{$node}){
			my @assign = @{$Node_unowned{$node}};
			my $sysid;
			my $return = $api->execute_raw_command('command' => "system node show -fields systemid -node $FILER");
			if($return =~/$remove_disk_from_filer(\D*)(\d+)(\D*)/){
				$sysid = $2;
			}
			foreach my $disk(@assign){
				if($disk!~/P\d+$/){
					try{
						NACL::C::StorageDisk->assign( 
												command_interface => $node,
												owner           => $FILER,
												disk            =>  $disk,
												sysid 			=> $sysid,
												force           =>'true',
												'method-timeout'  => 1200
												);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING : $disk is not assigned to filer $FILER");
					};	
				}else{
					try{
						NACL::C::StorageDiskPartition->assign( 
												command_interface => $node,
												owner           => $FILER,
												partition            =>  $disk,
												force           =>'true',
												'method-timeout'  => 1200
												);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING ::: Partitioned unknowned disk $disk is not assigned to filer $FILER");
					}; 	
				}
			}
		}
	}		
	#AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA	
	my $API_obj_A = $Nodes[0]->get_7m_or_nodescope_apiset();	#Creating Api objects
	my $filer_a = $Nodes[0]->name();
	my $API_obj_B = $Nodes[1]->get_7m_or_nodescope_apiset();
	my $filer_b = $Nodes[1]->name();
	#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		#Checking whether any broken disks in CMode or FAILED disks in 7Mode present, if present unfailing them to spare drives
		###Checking for filer A
	{
		try{
			my $FILER_C = $Nodes[0]->name();
			my %hash;
			%hash = (filter => {'container-type' => "broken","owner" => $FILER_C});
			my @broken_obj = NACL::C::Disk->find(
								command_interface => $Nodes[0],
								%hash,
							);
			foreach my $state_obj (@broken_obj){
				my $free_disk = $state_obj->disk();
				if ($free_disk =~ /(\S+)\:(\S+)/){
					$free_disk = $2;
				}
				push( @broken_disk_A,$free_disk);
			}
			if(@broken_disk_A){
				logcomment("$filer_a : Number of broken disks are ".scalar @broken_disk_A." and the disks are @broken_disk_A");
			}
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("$filer_a : No broken disks found for the filer");
		};

		foreach my $boken (@broken_disk_A){
			try{
				NACL::C::StorageDisk->unfail( command_interface => $Nodes[0],
                                                disk => $boken,
                                                spare => "true",
												'method-timeout'  => 1200);
			}catch NACL::APISet::Exceptions::CommandFailedException with {
				my $Filer = $Nodes[0]->name();
				logcomment("WARNING : $Filer : Couldn't unfail the disk $boken");
			}catch NATE::BaseException with {
				logcomment("Unfailing the drive is interupted, may be because of timeout issue, So trying again to unafail after 5 minutes");
				sleep 300;
				try{
					NACL::C::StorageDisk->unfail( command_interface => $Nodes[0],
                                                disk => $boken,
                                                spare => "true",
												'method-timeout'  => 1200);
				}catch NATE::BaseException with {
					logcomment("Unfailing the drive is not successfull");
				};
			};								
		}
	}
		
###Checking for filer B
	{	
		try{
			my $FILER_C = $Nodes[1]->name();
			my %hash = (filter => {'container-type' => "broken",'owner' => $FILER_C});
			my @broken_obj = NACL::C::Disk->find(
								command_interface => $Nodes[1],
								%hash,
							);
			foreach my $state_obj (@broken_obj){
				my $free_disk = $state_obj->disk();
				if ($free_disk =~ /(\S+)\:(\S+)/){
					$free_disk = $2;
				}
				push( @broken_disk_B,$free_disk);
			}
			if(@broken_disk_B){
				logcomment("$filer_b : Number of broken disks are ".scalar @broken_disk_B." and the disks are @broken_disk_B");
			}
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("$filer_b : No broken disks found for the filer");
		};

		foreach my $boken (@broken_disk_B){
			try{
				NACL::C::StorageDisk->unfail( command_interface => $Nodes[1],
                                                disk => $boken,
                                                spare => "true",
												'method-timeout'  => 1200);
			}catch NACL::APISet::Exceptions::CommandFailedException with {
				my $Filer = $Nodes[1]->name();
				logcomment("WARNING : $Filer : Couldn't unfail the disk $boken");
			}catch NATE::BaseException with {
				logcomment("WARNING : Unfailing the drive is interupted, may be because of timeout issue, So trying again to unafail after 5 minutes");
				sleep 300;
				try{
					NACL::C::StorageDisk->unfail( command_interface => $Nodes[1],
                                                disk => $boken,
                                                spare => "true",
												'method-timeout'  => 1200);
				}catch NATE::BaseException with {
					logcomment("WARNING : Unfailing the drive is not successfull");
				};
			};
		}
	}	
	
	##Checking for disks which are failed in 7mode/broken in CMODE but have no owner
	{	
		my @broken_disk_U;
		try{
			my $FILER_C = $Nodes[1]->name();
			my %hash = (filter => {'container-type' => "broken",'owner' => "-"});
			my @broken_obj = NACL::C::Disk->find(
								command_interface => $Nodes[1],
								%hash,
								allow_empty => 1,
							);
			foreach my $state_obj (@broken_obj){
				my $free_disk = $state_obj->disk();
				if ($free_disk =~ /(\S+)\:(\S+)/){
					$free_disk = $2;
				}
				push( @broken_disk_U,$free_disk);
			}
			if(@broken_disk_U){
				logcomment("$FILER_C : Number of broken disks are ".scalar @broken_disk_U." and the disks are @broken_disk_U");
			}
		}catch NACL::Exceptions::NoElementsFound with{
			my $FILER_C = $Nodes[1]->name();
			logcomment("$FILER_C : No broken disks found for the filer");
		};

		foreach my $boken (@broken_disk_U){
			try{
				NACL::C::StorageDisk->unfail( command_interface => $Nodes[1],
                                                disk => $boken,
                                                spare => "true",
												'method-timeout'  => 1200);
			}catch NACL::APISet::Exceptions::CommandFailedException with {
				try{
					NACL::C::StorageDisk->unfail( command_interface => $Nodes[1],
                                                disk => $boken,
												'method-timeout'  => 1200);
					sleep 20;							
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					my $FILER_C = $Nodes[1]->name();
					logcomment("WARNING : $FILER_C : Couldn't unfail the disk : $boken");
				};
				
			}catch NATE::BaseException with {
				logcomment("Unfailing the drive is interrupted, may be because of timeout issue, So trying again to unafail after 5 minutes");
				sleep 300;
				try{
					NACL::C::StorageDisk->unfail( command_interface => $Nodes[1],
                                                disk => $boken,
                                                spare => "true",
												'method-timeout'  => 1200);
				}catch NATE::BaseException with {
					logcomment("Unfailing the drive is not successfull");
				};
			};
		}
	}	
		
	#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	{
		my $ret_A = $API_obj_A->execute_raw_command('command' => "system node show -fields systemid -node $filer_a");
		my @sys_id_A = split(/\n/,$ret_A);
		foreach(@sys_id_A){
			if($_ =~/$filer_a(\D*)(\d+)(\D*)/){
				$sysid_A = $2;
				last;
			}
		}
		my $ret_B = $API_obj_B->execute_raw_command('command' => "system node show -fields systemid -node $filer_b");
		my @sys_id_B = split(/\n/,$ret_B);
		foreach(@sys_id_B){
			if($_ =~/$filer_b(\D*)(\d+)(\D*)/){
				$sysid_B = $2;
				last;
			}
		}
	}
	logcomment("System ID of Filer  $filer_a is: $sysid_A");
    logcomment("partner ID of Filer  $filer_b is: $sysid_B");

	########## finding total spare count of filera ##################################################
	@disk_A = spare_count_cmode(Node =>$Nodes[0],waiting =>'no');
	if( @disk_A){
		logcomment("Total Spare drives in filer $filer_a are " .scalar @disk_A." and the disks are @disk_A");
	}else{
		logcomment("$filer_a : No Spare drives present in the filer");
	}
	
	####################################################################################################
	
	########## Finding total spare count of filerb ########################################
	@disk_B = spare_count_cmode(Node =>$Nodes[1],waiting =>'no');
	if(@disk_B){
		logcomment("Total Spare drives in filer $filer_b are " .scalar @disk_B." and the disks are @disk_B");
	}else{
		logcomment("$filer_b : No Spare drives present in the filer");
	}
	
	###############################################################################################

	
	#***********Total Spare drives are***********************
	push(@Total_spare,@disk_A) if(@disk_A);
	push(@Total_spare,@disk_B) if(@disk_B);
	if(@Total_spare){
		logcomment("Total Spare drives present in the system are ".scalar @Total_spare." and the drives are @Total_spare");
	}
	
	#UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
	#Check for any un-assigned disks
	try{
		my @disk_obj_unown = NACL::C::Disk->find(
								command_interface => $Nodes[0],
								filter            => { owner => "-" },
								allow_empty => 1,
							);
		foreach my $state_obj (@disk_obj_unown){
			my $free_disk = $state_obj->disk();
			if ($free_disk =~ /(\S+)\:(\S+)/){
				$free_disk = $2;
			}
			push( @unassigned_disk , $free_disk);
		}
		if(@unassigned_disk){
			logcomment("Total un-assigned container disks are ".scalar @unassigned_disk." and the disks are @unassigned_disk");
		}	
	}catch NACL::Exceptions::NoElementsFound with{
			logcomment("No unassigned disks found on the filers");
	};
	if($Kernel=~/FS/i){
		try{
			my @temp_part;
			logcomment("Checking for partitioned unowned drives if present");
			my @disk_obj = NACL::CS::StorageDiskPartition->fetch(
						command_interface => $Nodes[0],
						filter => { "owner-node-name" => "-" },
						requested_fields  => [qw(partition)],
						allow_empty => 1,
					);
			foreach (@disk_obj){
				push( @temp_part,$_->partition());
			}
			push(@unassigned_disk,@temp_part)if @temp_part;
			logcomment("Number of un-assigned partition drives found are @temp_part ". scalar @temp_part." and the drives are @temp_part");
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("No un-assigned partitioned drives found in the filer ".$Nodes[0]->name());
		};
	}
	logcomment("Total number of unknowed drives are ".scalar @unassigned_disk." and the drives are @unassigned_disk")if (@unassigned_disk);
	#UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
	
	my $disksA = @disk_A;
	my $disksB = @disk_B;
	my ($filer_nameA,$filer_nameB,$numberA,$numberB,$number,$filer_name);
	my $unowned_disks = @unassigned_disk;
	my $disk_diff = abs( $disksA - $disksB );
    if ( $unowned_disks > 0 ) {
        if ( $disk_diff > $unowned_disks ) {
			logcomment("Spare disks difference $disk_diff is greater than unowned disks $unowned_disks "); 
			if(($disk_diff/2) <= $unowned_disks){
				logcomment("1/2 of Spare disks difference i.e $disk_diff is greater than unowned drives unowned_disks $unowned_disks ");
				my ($sys_id,$node);
				if ( $disksA > $disksB ) {
					$filer_name = $filer_a;
					$sys_id = $sysid_B;
					$node  = $Nodes[1];
				}
				elsif ( $disksB > $disksA ) {
					$filer_name = $filer_b;
					$sys_id = $sysid_A;
					$node  = $Nodes[0];
				}
				foreach my $disk(@unassigned_disk){
					if($disk!~/P\d+$/){
						try{
							NACL::C::StorageDisk->assign( 
														command_interface => $node,
														owner           => $filer_name,
														disk            =>  $disk,
														sysid 			=> $sys_id,
														force           =>'true',
														'method-timeout'  => 1200
														);
						}catch NACL::APISet::Exceptions::CommandFailedException with {
							logcomment("WARNING : $filer_name : container disk $disk not assigned");
						};	
					}else{
						try{
							NACL::C::StorageDiskPartition->assign(
									command_interface => $node,
									partition         => $disk,
									owner             => $filer_name,
									force           	=>'true',
									'method-timeout'  	=> 1200);	
						}catch NACL::APISet::Exceptions::CommandFailedException with {
							logcomment("WARNING : Partitioned $disk is not assigned to filer $filer_name");
						};
					}
				}
			}else{
				logcomment("1/2 of Spare disks difference i.e $disk_diff is lesser than unowned drives $unowned_disks  ");
				foreach my $disk(@disk_A){
					if($disk!~/P\d+$/){
						NACL::C::StorageDisk->removeowner(command_interface => $Nodes[0],
													disk              => $disk,
													force             => 'true',
													'method-timeout'  => 600
												);
					}else{
						NACL::C::StorageDiskPartition->removeowner(command_interface => $Nodes[0],
												'partition'              => $disk,
												force             => 'true',
												'method-timeout'  => 600
										    );
					}
				}
				foreach my $disk(@disk_B){
					if($disk!~/P\d+$/){
						NACL::C::StorageDisk->removeowner(command_interface => $Nodes[1],
												disk              => $disk,
												force             => 'true',
												'method-timeout'  => 600
											);
					}else{
						NACL::C::StorageDiskPartition->removeowner(command_interface => $Nodes[1],
												'partition'              => $disk,
												force             => 'true',
												'method-timeout'  => 600
										    );
					}
				}
				my (@final_count,@final_count_a,@final_count_b);
				push(@final_count,@disk_B,@disk_A,@unassigned_disk);
				if ( @final_count % 2 == 0 ) {
					$numberA = @final_count / 2;
				}
				else {
					$numberB = @final_count + 1;
					$numberA = $numberB / 2;
				}
				$numberB = (scalar @final_count)-$numberA;
				sleep 30;
				@final_count = sort @final_count;
				@final_count_a = @final_count[0..$numberA];
				@final_count_b = @final_count[($numberA+1)..$#final_count];
				@final_count_a = grep{/\S/}@final_count_a;
				@final_count_b = grep{/\S/}@final_count_b;
				logcomment("Total number of drives assigning to the filer $filer_a are ".scalar @final_count_a." and the drives are @final_count_a")if(@final_count_a);
				logcomment("No drives are assigned to the filer : $filer_a")if(!@final_count_a);
				foreach my $disk(@final_count_a){
					if($disk!~/P\d+/){
						try{
							NACL::C::StorageDisk->assign( 
											command_interface => $Nodes[0],
											owner           => $filer_a,
											disk           => $disk	,
											sysid 			=> $sysid_A,
											force            =>'true',
											'method-timeout'  => 1200
										);
						}catch NACL::APISet::Exceptions::CommandFailedException with {
							logcomment("WARNING : $filer_a : container disk $disk not assigned");
						};
					}else{
						try{
							NACL::C::StorageDiskPartition->assign(
								command_interface => $Nodes[0],
								partition         => $disk,
								owner             => $filer_a,
								force           	=>'true',
								'method-timeout'  	=> 1200
								);
						}catch NACL::APISet::Exceptions::CommandFailedException with {
							logcomment("WARNING ::: Partitioned disk $disk is not assigned to filer $filer_a");
						};
					}
				}
				logcomment("Total number of drives assigning to the filer $filer_b are ".scalar @final_count_b." and the drives are @final_count_b")if(@final_count_b);
				logcomment("No drives are available to asign to the filer : $filer_b")if(!@final_count_b);
				foreach my $disk(@final_count_b){
					if($disk!~/P\d+/){
						try{
							NACL::C::StorageDisk->assign( 
											command_interface => $Nodes[1],
											owner           => $filer_b,
											disk           => $disk	,
											sysid 			=> $sysid_B,
											force            =>'true',
											'method-timeout'  => 1200
										);
						}catch NACL::APISet::Exceptions::CommandFailedException with {
							logcomment("WARNING : $filer_b : container disk $disk not assigned");
						};
					}else{
						try{
							NACL::C::StorageDiskPartition->assign(
								command_interface => $Nodes[1],
								partition         => $disk,
								owner             => $filer_b,
								force           	=>'true',
								'method-timeout'  	=> 1200
								);
						}catch NACL::APISet::Exceptions::CommandFailedException with {
							logcomment("WARNING ::: Partitioned disk $disk is not assigned to filer $filer_b");
						};
					}
				}
			}
		}elsif($disk_diff < $unowned_disks){
			logcomment("Spare disk difference :: $disk_diff is lesser than unowned disks $unowned_disks ");
			if ( $disksA < $disksB ) {
                $numberA = $disk_diff;
            }
            elsif ( $disksB < $disksA ) {
                $numberB = $disk_diff;
            }
			$filer_nameA = $filer_a;
            $filer_nameB = $filer_b;
			$number =  sprintf( "%d", ( ( $unowned_disks - $disk_diff ) / 2 ) );
            $numberA = $numberA + $number;
            $numberB = $numberB + $number;
			
			if( $numberA){
				
				my @numberA = @unassigned_disk[0..$numberA];
				@numberA = grep{/\S/}@numberA;
				
				logcomment("Total number of drives assigning to the filer $filer_nameA are ".scalar @numberA." and the drives are @numberA")if(@numberA);
				logcomment("No drives are available to assign to the filer $filer_nameA")if(!@numberA);
				foreach my $disk(@numberA){
					if($disk!~/P\d+/){
						try{
							NACL::C::StorageDisk->assign( 
													command_interface => $Nodes[0],
													owner           => $filer_nameA,
													disk           => $disk	,
													sysid 			=> $sysid_A,
													force            =>'true',
													'method-timeout'  => 1200
												);
						}catch NACL::APISet::Exceptions::CommandFailedException with {
							logcomment("WARNING : $filer_nameA : container disk $disk not assigned");
						};
					}else{
						try{
							NACL::C::StorageDiskPartition->assign(
								command_interface => $Nodes[0],
								partition         => $disk,
								owner             => $filer_nameA,
								force           	=>'true',
								'method-timeout'  	=> 1200
								);
						}catch NACL::APISet::Exceptions::CommandFailedException with {
							logcomment("WARNING - Partitioned disk $disk is not assigned to filer $filer_nameA");
						};
					}
				}
			}
			my @numberB = @unassigned_disk[($numberA+1)..$#unassigned_disk];
			@numberB = grep{/\S/}@numberB;
			logcomment("Total number of drives assigning to the filer $filer_nameB are ".scalar @numberB." and the drives are @numberB")if(@numberB);
			logcomment("No drives are available to assign to the filer $filer_nameB") if(!@numberB);
			foreach my $disk(@numberB){
				if($disk!~/P\d+/){
					try{
						NACL::C::StorageDisk->assign( 
												command_interface => $Nodes[1],
												owner           => $filer_nameB,
												disk           => $disk	,
												sysid 			=> $sysid_B,
												force            =>'true',
												'method-timeout'  => 1200
											);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING : $filer_nameB : container disk $disk not assigned");
					};
				}else{
					try{
						NACL::C::StorageDiskPartition->assign(
							command_interface => $Nodes[1],
							partition         => $disk,
							owner             => $filer_nameB,
							force           	=>'true',
							'method-timeout'  	=> 1200
							);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING - Partitioned disk $disk is not assigned to filer $filer_nameB");
					};
				}
			}
		}else{
			logcomment("Spare disks difference of both the filers is $disk_diff which is equal to unassigned disks $unowned_disks ");
			my ($sys_id,$node);
			if ( $disksA < $disksB ) {
				$sys_id = $sysid_A;
				$node  = $Nodes[0];
            }
            elsif ( $disksB < $disksA ) {
				$sys_id = $sysid_B;
				$node  = $Nodes[1];
            }
			my $Filer = $node->name();
			foreach my $disk(@unassigned_disk){
				if($disk!~/P\d+/){
					try{
						NACL::C::StorageDisk->assign( 
										command_interface => $node,
										owner           => $Filer,
										disk           => $disk	,
										sysid 			=> $sys_id,
										force            =>'true',
										'method-timeout'  => 1200
									);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING : $Filer : container disk $disk assigned");
					};
				}else{
					try{
						NACL::C::StorageDiskPartition->assign(
							command_interface => $node,
							partition         => $disk,
							owner             => $Filer,
							force           	=>'true',
							'method-timeout'  	=> 1200
							);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING - Partitioned disk $disk is not assigned to filer $Filer");
					};
				}
			}
		}	
	}elsif( ( $disksA == 0 ) || ( $disksB == 0 ) ) {
		logcomment("Either or both the filers spare disks are 0");
		my $node;
		if($disksA == 0 ){
			$node = $Nodes[1];
		}else{
			$node = $Nodes[0];
		}
		foreach my $disk(@Total_spare){
			if($disk!~/P\d+/){
				NACL::C::StorageDisk->removeowner(command_interface => $node,
												disk              => $disk,
												force             => 'true',
												'method-timeout'  => 600
											);
											
			}else{
				NACL::C::StorageDiskPartition->removeowner(command_interface => $node,
												'partition'		=> $disk,
												force             => 'true',
												'method-timeout'  => 600
										    );
			
			}
		}
		sleep 60;
		my $disk_diff = abs( $disksA - $disksB );
		logcomment("Differance between disks of both filers is $disk_diff");
		if ( $disk_diff % 2 == 0 ) {
            $numberA = $disk_diff / 2;
        }
        else {
            $numberB = $disk_diff + 1;
            $numberA = $numberB / 2;
        }
		my @numberA = @Total_spare[0..$numberA] if(@Total_spare);
		my @numberB = @Total_spare[($numberA+1)..$#Total_spare] if(@Total_spare);
		@numberA = grep{/\S/}@numberA;
		@numberB = grep{/\S/}@numberB;
		logcomment("Total number of drives assigning to the filer $filer_a are ".scalar @numberA." and the drives are @numberA");
		logcomment("No drives are available to assign to the filer : $filer_a")if(!@numberA);
		foreach my $disk (@numberA){
			if($disk!~/P\d+/){
				try{
					NACL::C::StorageDisk->assign( 
										command_interface => $Nodes[0],
										owner           => $filer_a,
										disk           => $disk,
										sysid 			=> $sysid_A,
										force            =>'true',
										'method-timeout'  => 1200
									);
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					logcomment("WARNING :$filer_a : container disk $disk not assigned");
				};
			}else{
				try{
					NACL::C::StorageDiskPartition->assign(command_interface => $Nodes[0],
												'partition'		=> $disk,
												owner             => $filer_a,
												force             => 'true',
												'method-timeout'  => 600
										    );
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					logcomment("WARNING :$filer_a :: partition disk $disk not assigned");
				};
			}
		}
		
		logcomment("Total number of drives assigning to the filer $filer_b are ".scalar @numberB." and the drives are @numberB")if(@numberB);
		logcomment("No drives are available to assign to the filer : $filer_b")if(!@numberB);
		foreach my $disk (@numberB){
			if($disk!~/P\d+/){
				try{
					NACL::C::StorageDisk->assign( 
										command_interface => $Nodes[1],
										owner           => $filer_b,
										disk           => $disk,
										sysid 			=> $sysid_B,
										force            =>'true',
										'method-timeout'  => 1200
									);
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					logcomment("WARNING :$filer_b : container disk $disk not assigned");
				};
			}else{
				try{
					NACL::C::StorageDiskPartition->assign(command_interface => $Nodes[1],
												'partition'		=> $disk,
												owner             => $filer_b,
												force             => 'true',
												'method-timeout'  => 600
										    );
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					logcomment("WARNING :$filer_b :: partition disk $disk not assigned");
				};
			}
		}
	}elsif(( $disksA < int((scalar @Total_spare)/2)) || ( $disksB < int((scalar @Total_spare)/2))){
		if((abs( $disksA - $disksB ))>3){
			logcomment("One of the filer spare disks are less than total number of disks and the difference between filer's disks are greater than 3");
			logcomment("Removing and assigning disks between the filers");
			foreach my $disk(@disk_A){
				if($disk!~/P\d+$/){
					try{
						NACL::C::StorageDisk->removeowner(command_interface => $Nodes[0],
											disk              => $disk,
											force             => 'true',
											'method-timeout'  => 600
										);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING :$filer_a - container disk $disk not assigned");
					};
				}else{
					try{
						NACL::C::StorageDiskPartition->removeowner(command_interface => $Nodes[0],
												'partition'		=> $disk,
												force             => 'true',
												'method-timeout'  => 600
										    );
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING :$filer_a - partition disk $disk not assigned");
					};
				}
			}
			foreach my $disk(@disk_B){
				if($disk!~/P\d+$/){
					try{
						NACL::C::StorageDisk->removeowner(command_interface => $Nodes[1],
											disk              => $disk,
											force             => 'true',
											'method-timeout'  => 600
										);
					}catch 	NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING :$filer_b - container disk $disk not assigned");
					};				
				}else{
					try{
						NACL::C::StorageDiskPartition->removeowner(command_interface => $Nodes[1],
											'partition'		=> $disk,
											force             => 'true',
											'method-timeout'  => 600
										);
					}catch 	NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING :$filer_b - partition disk $disk not assigned");
					};		
				}
			}
			sleep 90;
			my $unowned = @Total_spare;
			
			if ( $unowned % 2 == 0 ) {
				$numberA = $unowned / 2;
			}
			else {
				$numberB = $unowned + 1;
				$numberA = $numberB / 2;
			}
			my @numberA = @Total_spare[0..$numberA];
			my @numberB = @Total_spare[($numberA+1)..$#Total_spare];
			@numberA = grep{/\S/}@numberA;
			@numberB = grep{/\S/}@numberB;
			logcomment("Total number of drives assigning to the filer $filer_a are ".scalar @numberA." and the drives are @numberA")if(@numberA);
			logcomment("No drives are available to assign the filer $filer_a")if(!@numberA);
			foreach my $disk(@numberA){
				if($disk!~/P\d+$/){
					try{
						NACL::C::StorageDisk->assign( 
													command_interface => $Nodes[0],
													owner           => $filer_a,
													disk			=> $disk,
													sysid 			=> $sysid_A,
													force            =>'true',
													'method-timeout'  => 1200
												);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING :$filer_a : container disk $disk not assigned");
					};	
				}else{
					try{
						NACL::C::StorageDiskPartition->assign(command_interface => $Nodes[1],
											'partition'		=>  $disk,
											force             => 'true',
											owner             => $filer_a,
											'method-timeout'  => 600
										);
					}catch 	NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING :$filer_a : Partitioned disk $disk not assigned");
					};	
				
				}
			}
			logcomment("Total number of drives assigning to the filer $filer_b are ".scalar @numberB." and the drives are @numberB")if(@numberB);
			logcomment("No drives are assugned to the filer :: $filer_b")if(!@numberB);
			foreach my $disk(@numberB){
				if($disk!~/P\d+/){
					try{
						NACL::C::StorageDisk->assign( 
													command_interface => $Nodes[1],
													owner           => $filer_b,
													disk			=> $disk,
													sysid 			=> $sysid_B,
													force            =>'true',
													'method-timeout'  => 1200
												);
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING :$filer_b : container disk $disk not assigned");
					};	
				}else{
					try{
						NACL::C::StorageDiskPartition->assign(command_interface => $Nodes[1],
											'partition'		=>  $disk,
											force             => 'true',
											owner             => $filer_b,
											'method-timeout'  => 600
										);
					}catch 	NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("WARNING :$filer_b : Partitioned disk $disk not assigned");
					};	
				
				}
			}
		}else{
			logcomment("drives are already assigned properly");
		}
	}else{
		logcomment("Disks are already assigned properly");
		return 0;
	}

}

################################################################################
## Author Arjun Lavu
## Description :: this subroutine will delete the vserver in the filer 
################################################################################
sub vserver_delete{
	my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT},
            vserver_name  => {type => SCALAR, default => undef, optional => 1 },
        }
	);
	my $node = $opts{Node};
	my $Filer = $node->name();
	my $vserver = $opts{vserver_name};
	my @vservers;
	logcomment("Deleting the Vservers");
	if($vserver){
		try{
			my $name = NACL::STask::Vserver->find(
				command_interface => $node,
				filter            => { vserver => $vserver,},
			);
			if( $name->get_one_state_attribute("vserver") =~ /^($vserver)$/ ) {
				NACL::STask::Vserver->purge(
					command_interface => $node,
					vserver           => $vserver,
				);
			}
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("$Filer : No vserver found with the name $vserver");
		}catch NACL::APISet::Exceptions::CommandFailedException with {
			logcomment("WARNING : Couldn't delete vserver $vserver");
		}; 
	}else{
		try{
			@vservers = NACL::STask::Vserver->find(
							command_interface => $node,
							filter => {'admin-state' => "stopped|running|starting|stopping"},
						);
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("$Filer : No vservers found in the filers");
		};	
		foreach my $vser_obj(@vservers){
			try{
				$vser_obj->purge();
			}catch NACL::APISet::Exceptions::CommandFailedException with {
				logcomment("WARNING : Couldn't delete vservers");
			}; 
		}
	}
}	
##################################################################################################################
## Author Arjun Lavu
## Inputs - This subroutine will call the remove_assign ownership based on the filer mode
## return value - null
#################################################################################################################
sub disk_remv_assign_ownership{
	my %opts = @_;
	if(defined $opts{Node_ref}){
		my @Nodes = @{$opts{Node_ref}};
		my $FILER_C = $Nodes[0]->name();
		my $Transit_obj = NACL::Transit->new( name => $FILER_C );
		my $filer_state = $Transit_obj->get_state('timeout' => 600);
		if($filer_state=~/MAINT/g){
			remv_assign_ownership_maint(\%opts);
		}elsif($filer_state =~/CLI|UP/g){
			remv_assign_ownership_cli(\%opts);
		}else{
			logresult('FATAL',"Filer is not in neither Maintanence nor Filesystem Mode");
		}
	}else{
		logresult('FATAL',"Mandatory parameter Node_ref is not passed");
	}
}	

###################################################################################################################
#	Author Arjun Lavu
#   Description
###################################################################################################################

sub check_mode_nodes{
	 my (%opts) = validate(
        @_,
        {
            Node_ref => { type => ARRAYREF},
			BOOT_MODE => {type => SCALAR},
        }
    );
	my %compare_state;
	my $Node_ref = $opts{Node_ref};
	my $BOOT_MODE = $opts{BOOT_MODE};
	my $actual_state;
	if($BOOT_MODE == 1){
		$actual_state = "CLI";
	}elsif($BOOT_MODE == 5){
		$actual_state = "MAINT";
	}else{
		$actual_state = $BOOT_MODE;
	}
	my @Nodes = @{$Node_ref};
	if(scalar @Nodes > 1){
		logcomment("Filer present are ".$Nodes[0]->name()." and ".$Nodes[1]->name());
		foreach(@Nodes){
			my $FILER_C = $_->name();
			my $Transit_obj = NACL::Transit->new( name => $FILER_C );
			my $filer_state = $Transit_obj->get_state('timeout' => 600);
			if($filer_state =~/MAINT/ig){
				$compare_state{$FILER_C} = 'MAINT';
			}elsif($filer_state =~/CLI/ig){
				$compare_state{$FILER_C} = 'CLI';
			}else{
				logresult('FATAL',"Filer $FILER_C : is not in neither Maintanence nor Filesystem Mode");
			}
		}
		my @filers = keys %compare_state;
		if($compare_state{$filers[0]} ne $compare_state{$filers[1]}){
			logcomment("Filer : $filers[0] state is not same as filer $filers[1] state");
			logcomment("Sate of filer $filers[0] is $compare_state{$filers[0]}");
			logcomment("Sate of filer $filers[1] is $compare_state{$filers[1]}");
		}
		my $flag =0;
		foreach(@filers){
			if($compare_state{$_}!~/$actual_state/ig){
				if($compare_state{$_}=~/CLI/ig){
					logcomment("Filer $_ : Is in file-system Mode but script needs to run in MAINT mode, So changing state to MAINT");
					$flag ="MAINT";
				}elsif($compare_state{$_}=~/MAINT/i){ 
					logcomment("Filer $_ : Is in MAINT Mode but the script needs to run in CLI state, so changing state to CLI if Root volume exist,else changing state to MAINT");
					my $Host = host($_);
					my $Api_Set_Obj = NACL::APISet->new(
						hostobj   => $Host,
						category  => "Node",
						interface => "CLI",
						set       => "Maintenance"
					);
					$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
					my $aggr_output = $Api_Set_Obj->execute_raw_command( command => "aggr status -r" );
					if (($aggr_output =~ /aggr0/i) && ($aggr_output !~ /No root aggregate/i)) {
						logcomment("Root aggregate exist on Filer $_, so changing state to CLI");
						$flag ="CLI";
					} else {
						logcomment("Root aggregate not exist on Filer $_");
						$flag ="MAINT";
						last;
					}
				}else{
					logcomment("Filer : $_:  Mode choosed by the user is $actual_state, so changing state to maintenance as of now.");
					my $Transit_obj = NACL::Transit->new( name => $_ );
					my $filer_state = $Transit_obj->get_state('timeout' => 600);
					$Transit_obj->change_state( to => "MAINT" );
				}
			}
		}
		foreach(@filers){
			if($flag){
				my $Transit_obj = NACL::Transit->new( name => $_ );
				my $filer_state = $Transit_obj->get_state('timeout' => 600);
				$Transit_obj->change_state( to => "$flag" );
			}
		}
	}
	
}

###########################################################################
## Author Arjun Lavu
## Description :: This subroutine will return the unknown disk names(dblade names)
##########################################################################
sub disk_show_n {
	my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT },
        }
    );
	
	my $Node=$opts{Node};
	my $Mode = $Node->mode();
	my $FILER_C = $Node->name();
	my $Host    = host($FILER_C);
	
	#**************************************************
	#Checking the filer state
	#**************************************************
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state;
	try{
		$filer_state = $Transit_obj->get_state('timeout' => 600);
	}catch NACL::Transit::Exceptions::Timeout with {
        logcomment("Expected: Caught a Timeout exception");
        $filer_state = $Transit_obj->get_state('timeout' => 600);
    }catch NACL::Transit::Exceptions::TransitException with {
        my $exception_object = shift;
        logcomment("Exception is of type: " . ref ($exception_object));
        logcomment("Error text is: " . $exception_object->text());
    };
	
	my($API_obj,$output,@lines);
	##############################################
	##Based on mode(UP/MAINT) API object is created
	##############################################
	logcomment("$FILER_C : Filer state is $filer_state");
	if($filer_state =~/(CLI|UP)/){
		$API_obj = $Node->get_7m_or_nodescope_apiset();
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		logcomment("$FILER_C : Executing  disk show -n");
		#$API_obj->execute_raw_command( 'command' => "run local");
		#$API_obj->execute_raw_command( 'command' => "priv set -q test");
		$output = $API_obj->execute_raw_command( 'command' => "run local disk show -n");
	}else{
		$API_obj = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance"
		);
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		logcomment("$FILER_C : Executing  disk show -n");
		$output = $API_obj->execute_raw_command( 'command' => "disk show -n");
	}
	my $n = 0;
	my $result= {};
	if($output=~/No disks match option -n|No unassigned disks/){
		logcomment("$FILER_C : Currrently no unowned disks available in the filer ");
		return $result ;
	}else{
		@lines  = split( /\n/, $output );
		# skip to the start of table contents
		while ( $n <= $#lines ) {
			last if ( $lines[$n] =~ /^-----/ );
			$n++;
		}
		$n++;
	}	
    foreach my $line ( @lines[ $n .. $#lines ] ) {
        my ($disk, $owner, $pool, $serial_number ) = ( $line =~/(\S+)\s+(\S+\s+\S+)\s+(\S+)\s+(\S+)/);
        if ( ( $line =~ /Not Owned/ ) ) {
            $result->{$disk} = {
					'DISK'      	 => $disk,
					'OWNER'     	 => $owner,
					'POOL'    		 => $pool,
					'SERIAL_NUMBER'  => $serial_number,
            };
        }
    }
    return $result;
}
#######################################################################################
## Author Arjun Lavu
## Description :: This subroutine will initiate the disk zeroing if drives are not zeroed
#######################################################################################
sub zero_spares{
    my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT },
        }
    );
	#spare_disk_list =>  { type => ARRAYREF, default => undef, optional => 1 },
	my $Node=$opts{Node};
	my $Mode = $Node->mode();
	my $FILER_C = $Node->name();
	my $flag =0;
	my @spare_disk;
	
	#if(defined $opts{spare_disk_list}){
	#	@spare_disk = @{$opts{spare_disk_list}};
	#	logcomment("Filer : $FILER_C :  Number of Spares passed are ".scalar @spare_disk." and the spares are @spare_disk");
	#}else{
	#	@spare_disk = spare_count_cmode(Node   => $Node, run_local => 'Y');
	#	logcomment("Filer : $FILER_C :  Number of Spares drives belongs to the filer are ".scalar @spare_disk." and the spares are @spare_disk");
	#}
	
	@spare_disk = spare_count_cmode(Node => $Node, run_local => 'Y',waiting =>'yes');
	if(scalar @spare_disk){
		logcomment("Filer : $FILER_C :  Number of Spares drives belongs to the filer are ".scalar @spare_disk." and the spares are @spare_disk");
	}else{
		logcomment("Filer : $FILER_C : No spare drives available on the filer: HINT :- drives might be failed/No spares present");
		return 0;
	}
	my $max_time = get_max_timeout(node_present => [$Node]);	
	my $max_timeout_sec = int(($max_time*2)+300);
	my $max_time_hr = $max_timeout_sec/(3600);
	logcomment("Filer : $FILER_C : Script will wait maximum of $max_time_hr Hrs to zero the spares"); 
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if($filer_state =~/(CLI|UP)/){
		my $API_obj = $Node->get_7m_or_nodescope_apiset();
		$API_obj->execute_command( 'command' => "disk zero spares");
		sleep 180;
		my $kill_time = time + $max_timeout_sec;
		while($kill_time > time ){
			my $out = $API_obj->execute_command( 'command' => "aggr status -s");
			if($out !~/not zeroed|zeroing/ig){
				logcomment("Filer : $FILER_C : Disk zero spares completed.");
				$flag = 1;
				last;
			}else{
				logcomment("Filer : $FILER_C : Disk zero spares is in progress, waiting for disk zero spares to complete");
				sleep 300;
			}
		}
		if($flag){
			return 1;
		}else{
			logcomment("Filer : $FILER_C : disks didn't get zeroed after waiting for a time of $max_time_hr");
			return 0;
		}
	}else{
		logcomment("Filer : $FILER_C : Filer is not in CLI/UP, disk zero spares command will not work, so returning to main script");
		return 0;
	}
	
}
#######################################################################################
=head2 comp_disk_qual_t12
	Arjun.lavu@netapp.com
    my $ret = comp_disk_qual_t12(disk_qual_t12_before => $hash_add_before, disk_qual_t12_after => $hash_add_after);
    This routine returns 1 on suceess and 0 on faliure

The following named arguments are accepted,

=over

=item disk_qual_t12_before

(Required) : hash address of  disk_qual structure before

=item disk_qual_t12_after

(Required) : hash address of disk_qual structure later

=item nm_error
(Optional) : Non-medium error neeeds to compare?

=back

=cut
#######################################################################################
sub compare_disk_qual_t12 {
    my (%opts) = validate(
        @_,
        {
            disk_qual_t12_before => { type => HASHREF },
            disk_qual_t12_after  => { type => HASHREF },
            nm_error => { type => SCALAR, default => 'Y', optional => 1 },
        }
    );
	my $fail = 0;
    my $disk_qual_t12_before = $opts{disk_qual_t12_before};
    my $disk_qual_t12_after  = $opts{disk_qual_t12_after};
	my $nm_error			 = $opts{nm_error};

	my @before = keys %{$disk_qual_t12_before};
	my @after  = keys %{$disk_qual_t12_after};
	if(scalar @before != scalar @after){
		logcomment("WARNING : disk_qual has not run properely for all the drives");
		logcomment("disk_qual has run before for ".scalar @before." number of drives and the drives are @before");
		logcomment("disk_qual has run after for ".scalar @after." number of drives and the drives are @after");
		$fail = 1;
		return (0);
	}
	
    foreach my $dsk ( keys %$disk_qual_t12_before ) {
		#logcomment("-------------------------------------------------------------------------------------");
		logcomment("-------------------------------------------------------------------------------------\n================ COMPARING THE disk_qual OUTPUT OF THE DISK : $dsk ================ ");
		my (@keys,@keys1);
		@keys = keys %{$disk_qual_t12_before->{$dsk}} if(defined $disk_qual_t12_before->{$dsk});
		@keys1 = keys %{$disk_qual_t12_after->{$dsk}} if(defined $disk_qual_t12_after->{$dsk});
		if(scalar @keys != scalar @keys1){
			# logcomment("For the DISK : $dsk : there is a difference in list of data from both the disk_qual commands");
			# logcomment("WARNING :: For the DISK : $dsk : Number of Attributes before are :: ".scalar @keys." and AFTER are :: ".scalar @keys1);
			# $fail = 1;
		}
		if($nm_error ne 'Y'){
			foreach (@keys){
				my $after = $disk_qual_t12_after->{$dsk}->{$_};
				$after =~s/^\s*|\s*$//g;
				my $before = $disk_qual_t12_before->{$dsk}->{$_};
				$before =~s/^\s*|\s*$//g;
				
				if($before != $after){
					logcomment("$dsk : WARNING : For the disk the values of [$_] are not matching");
					logcomment("The values of [$_] are ---->before ($before) and after ($after) <----");
					$fail = 1;
				}else{
					logcomment("$dsk : For the disk the values of $_ are matching");
				}		
			}
		}else{
			foreach (@keys){
				if($_=~/Non-medium Error Count/i){
					my $after = $disk_qual_t12_after->{$dsk}->{$_};
					$after =~s/^\s*|\s*$//g;
					my $before = $disk_qual_t12_before->{$dsk}->{$_};
					$before =~s/^\s*|\s*$//g;
					if($before > $after){
						logcomment("Disk - $dsk : WARNING : For the disk the value of $_ is greater when compared with after value");
						logcomment("The values of [$_] are ----> before ($before) and after ($after) <----");
						$fail = 1;
					}else{
						logcomment("Disk - $dsk : values of $_ are fine");
					}
				}elsif($_=~/Total Write errors|Total Read errors|Power on time|Total bytes proces|Read ECC OTF/ig){
					my $after = $disk_qual_t12_after->{$dsk}->{$_};
					$after =~s/^\s*|\s*$//g;
					my $before = $disk_qual_t12_before->{$dsk}->{$_};
					$before =~s/^\s*|\s*$//g;
					if($before > $after){
						logcomment("Disk - $dsk : WARNING : For the disk the value of [$_] is greater when compared with after value");
						logcomment("The values of [$_] are ----->before ($before) and after ($after) <-----");
						$fail = 1;
					}else{
						logcomment("Disk - $dsk : values of $_ are fine");
					}
				}else{
					my $after = $disk_qual_t12_after->{$dsk}->{$_};
					$after =~s/^\s*|\s*$//g;
					my $before = $disk_qual_t12_before->{$dsk}->{$_};
					$before =~s/^\s*|\s*$//g;
					if($before != $after){
						logcomment("$dsk : WARNING : For the disk the values of [$_] are not matching");
						logcomment("The values of [$_] are --->before ($before) and after ($after) <---");
						$fail = 1;
					}else{
						logcomment("Disk - $dsk : values of $_ are matching");
					}	
				}
			}
		}
	}
=head
	
        my $sec_id;
        if ( $disk_qual_t12_before->{$dsk}->{'Secondary'} ) {
            $sec_id = $disk_qual_t12_before->{$dsk}->{'Secondary'};
        }

        if ( $disk_qual_t12_before->{$dsk}->{'Non-medium Error Count'} eq "" ) {
            $disk_qual_t12_before->{$dsk}->{'Non-medium Error Count'} =
              $disk_qual_t12_before->{$sec_id}->{'Non-medium Error Count'};
        }

        if ( $disk_qual_t12_after->{$sec_id}->{'Non-medium Error Count'} eq "" ) {
            $disk_qual_t12_after->{$sec_id}->{'Non-medium Error Count'} =
              $disk_qual_t12_after->{$sec_id}->{'Non-medium Error Count'};
        }
	
        if ( $disk_qual_t12_before->{$dsk}->{'Non-medium Error Count'} <
            $disk_qual_t12_after->{$sec_id}->{'Non-medium Error Count'} )
        {
              $fail = 1; 
            print(
"DISK: $dsk Non-medium Error Count : Before - $disk_qual_t12_before->{$dsk}->{'Non-medium Error Count'}  After - $disk_qual_t12_after->{$sec_id}->{'Non-medium Error Count'}\n"
            );
        }

        if ( $disk_qual_t12_before->{$dsk}->{'Total Write errors'} eq "" ) {
            $disk_qual_t12_before->{$dsk}->{'Total Write errors'} =
              $disk_qual_t12_before->{$sec_id}->{'Total Write errors'};
        }

        if ( $disk_qual_t12_after->{$sec_id}->{'Total Write errors'} eq "" ) {
            $disk_qual_t12_after->{$sec_id}->{'Total Write errors'} =
              $disk_qual_t12_after->{$sec_id}->{'Total Write errors'};
        }

        if ( $disk_qual_t12_before->{$dsk}->{'Total Write errors'} >
            $disk_qual_t12_after->{$sec_id}->{'Total Write errors'} )
        {
            $fail = 1;
            print(
"DISK: $dsk Total Write errors : Before - $disk_qual_t12_before->{$dsk}->{'Total Write errors'} Total Write errors: After - $disk_qual_t12_after->{$sec_id}->{'Total Write errors'}\n"
            );
        }

        if ( $disk_qual_t12_before->{$dsk}->{'Total Read errors'} eq "" ) {
            $disk_qual_t12_before->{$dsk}->{'Total Read errors'} =
              $disk_qual_t12_before->{$sec_id}->{'Total Read errors'};
        }

        if ( $disk_qual_t12_after->{$dsk}->{'Total Read errors'} eq "" ) {
            $disk_qual_t12_after->{$dsk}->{'Total Read errors'} =
              $disk_qual_t12_after->{$sec_id}->{'Total Read errors'};
        }
        if ( $disk_qual_t12_before->{$dsk}->{'Total Read errors'} >
            $disk_qual_t12_after->{$sec_id}->{'Total Read errors'} )
        {
            $fail = 1;
            print(
"DISK: $dsk Total Read errors: Before - $disk_qual_t12_before->{$dsk}->{'Total Read errors'} Total Read errors: After - $disk_qual_t12_after->{$sec_id}->{'Total Read errors'}\n"
            );
        }
    } ## end foreach my $dsk (keys %$disk_qual_t12_before)
=cut
    if ( $fail == 1 ) {
        return (0);
    }
    return (1);
} ## end sub compare_disk_qual_t12

#######################################################################################
## Author Arjun Lavu
## Description :: This subroutine will delete the mini_disks if present in the filer
#######################################################################################
sub delete_mini_disk{
	my (%opts) = validate(
				@_,
				{
					node => { type => OBJECT},
					verify => {type => SCALAR, optional => 1, default => 'N'},
					zero_after_delete => {type => SCALAR,optional => 1, default => 'n'}
				}	
			);	
	my $node = $opts{node};
	my $zero_after_delete = $opts{zero_after_delete};
	if($zero_after_delete =~/y/i){
		$zero_after_delete = 'y';
	}else{
		$zero_after_delete = 'n';
	}
	my $verify = $opts{verify};
	my $FILER = $node->name();
	my $Host = host($FILER);
	my $transit_obj = NACL::Transit->new(name => $Host);
	my $filer_state = $transit_obj->get_state('timeout' => 600);
	my (%disk_object,@disks);
	if($filer_state =~/MAINT/i){
		my $console = Tharn::connect("$FILER#console");
		# Set the properties for the Connectrec used for creating the APIset
		$console->{prompts} = [qr/\*>/];
		$console->{max_idle} = 600;
		$console->{on_idle} = sub { $console->execute(""); };
		my $Api_Set_Obj = NACL::APISet->new(connection => $console,
										category => "Node",
										interface => "CLI",
										set => "Maintenance");
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		my (@dele_mini,@normal_disk,$flag);
		logcomment("$FILER :Checking if any minidisk present in the filer");
		my $check = $Api_Set_Obj->execute_raw_command('command' =>"mini_disk list");
		if($check =~/this command is only available in development kernels/){
			logresult('FATAL',"$FILER : Kernel doesn't support the mini_disk options");
		}			
		my $res = $Api_Set_Obj->mini_disk_list();
		my @disks_obj = @{$res->get_parsed_output()};
		foreach (@disks_obj){
			push(@disks, $_->{disk});
			$disk_object{$_->{disk}} = $_;
		}	
		logcomment("$FILER : mini_disk list output gives total ".scalar @disks." number of disks and the disks are @disks");
		my $filer_disks = disk_show_drive_maint(API_Obj =>$Api_Set_Obj,Filer=>$FILER);
		my @filer_disks = @{$filer_disks->{'driveA'}};
		logcomment("$FILER : Total disks of the filer are ".scalar @filer_disks." and the disks are @filer_disks");
		logcomment("$FILER : Checking, out of these disks all are mini disks are not");
		my @matched_mini_disks = _intersect(\@filer_disks,\@disks);
		logcomment("$FILER : matched number of disks of the filer are".scalar @matched_mini_disks." and the disks are @matched_mini_disks");
		
		foreach my $drive (@matched_mini_disks) {
			my $disk = $disk_object{$drive};	##returns the disk object;
			if($disk->{type} ne "NORMAL disk") {
				push(@dele_mini,$disk->{disk});
			}elsif($disk->{type} eq "NORMAL disk"){
				push(@normal_disk,$disk->{disk});
			}
		}
		if((@normal_disk)&&(@dele_mini)){
			logcomment("$FILER : Number of minidisks already present are ".scalar @dele_mini." and the disks are @dele_mini");
			logcomment("$FILER : Number of normal disks present are ".scalar @normal_disk." and the disks are @normal_disk");
			$flag = 1;
		}elsif((@dele_mini) && ($verify =~/Y/i)){
			logcomment("$FILER : Number of minidisks already present are ".scalar @dele_mini." and the disks are @dele_mini");
			$flag = 0;
		}elsif((@dele_mini) && ($verify =~/N/i)){
			logcomment("$FILER : Number of minidisks present are ".scalar @dele_mini." and the disks are @dele_mini");
			$flag = 1;
		}else{
			$flag = 2;
		}
		if($flag == 1){
			logcomment("$FILER : Deleting Mini disks");
			try {
				my $prompts_answers = ['Are you sure you want to continue?'=> 'y','Would you like to zero newly deleted minidisks now?'=>"$zero_after_delete"];
				$Api_Set_Obj->execute_raw_command( 'command' => "mini_disk delete @dele_mini",'connectrec-match_table' => $prompts_answers);
				sleep 60;
				#$Test->nlog( "Response get_parsed_output:\n". Dumper( $response->get_parsed_output() ) );
			}catch NACL::APISet::Exceptions::ResponseException with {
				my $exception_object = shift;
				my $resp             = $exception_object->get_response_object();
				logcomment( "Caught a " . ref($exception_object) . "!" );
				logcomment( "Error is: " . $exception_object->text() );
				logcomment( "Raw output was:\n" . $resp->get_raw_output() );
				logresult('FATAL',"$FILER : Couldn't delete mini-disks");
			};
			return 1;
		}else{
			if($flag == 0){
				logcomment("$FILER : user selected option verify 'y', so not deleting the the Minidisks @dele_mini");
				return "ignore";
			}elsif($flag == 2){
				logcomment("$FILER : No Minidisks present in the filer");
				return undef;
			}
		}
	}else{
		logcomment("WARNING : Filer : $FILER is not in maintenance mode, so cannot delete the mini_disks");
		logresult('FATAL',"$FILER : is not in maintanence Mode, So cannot create mini_disk");
	}
	#sub _intersect(\@\@);
	sub _intersect($$) {
		my %e = map { $_ => undef } @{$_[0]};
		return grep { exists( $e{$_} ) } @{$_[1]};
	}
}	
##########################################################################################################
## Author Arjun Lavu
## Description :: This subroutine will create the new node object based on the nodes which are passed
########################################################################################################
sub node_new_obj{
	my (%opts) = validate(
			@_,
			{
				node_array => { type => ARRAYREF},
			}	
		);
	my $node_ref = $opts{node_array};
	my @Nodes_array = @{$node_ref};
	my @NODES_FINAL;

	my $Mode = $Nodes_array[0]->mode();
	logcomment("Mode of the filer passed is $Mode");
	foreach(@Nodes_array){
		my $Filer = $_->name();
		logcomment("Getting the new object for the $Filer");
	}	
	my @temp_nodes = NACL::C::Node->find(); # Find Nodes/Filers used in the test, Based on FILER param.
	my %nodes_filer;
	foreach my $Node(@temp_nodes){
		my $FILER_C = $Node->name();
		$nodes_filer{$FILER_C}=[$Node];
	}
	my @Nodes_again = map{@{$_}} values(%nodes_filer);
	if($Mode =~/CMode/i){
		foreach my $main (@Nodes_array){
			foreach my $sub (@Nodes_again){
				my $first = $main->name();
				my $sec = $sub->name();
				if($first eq $sec){
					push(@NODES_FINAL,$sub);
				}
			}
		}
	}else{
		logcomment("Filer is in 7Mode, subroutine will not work");
		return @Nodes_array;
	}
	return @NODES_FINAL;
}
##########################################################################################################
## Author Arjun Lavu
## Description :: This subroutine will create mini_disks
## parameters :: size - size of mini_disk, node- Node object
##########################################################################################################
sub create_mini_disk{
	my (%opts) = validate(
			@_,
			{
				node => { type => OBJECT},
				size => {type => SCALAR}
			}	
		);	
	my $node = $opts{node};
	my $size = $opts{size};
	my $FILER = $node->name();
	my $Host = host($FILER);
	my $transit_obj = NACL::Transit->new(name => $Host);
	my $filer_state = $transit_obj->get_state('timeout' => 600);
	if($filer_state =~/MAINT/i){
		my $console = Tharn::connect("$FILER#console");
		# Set the properties for the Connectrec used for creating the APIset
		$console->{prompts} = [qr/\*>/];
		$console->{max_idle} = 600;
		$console->{on_idle} = sub { $console->execute(""); };
		my $Api_Set_Obj = NACL::APISet->new(connection => $console,
										category => "Node",
										interface => "CLI",
										set => "Maintenance");
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		my $result = $Api_Set_Obj->execute_raw_command( 'command' => "sysconfig -v"); 
		my @group = $result=~/:\s*\S+\s*\S+\s+\S+\s+(\S+)GB/g;
		my ($least_size,$mini_size);
		@group = sort {$a<=>$b}@group;
		$least_size = $group[0];
		logcomment("Minimum disk size is $least_size GB");
		if($size=~ /1/ ) {
			$mini_size = sprintf( "%.0f", $least_size * .1 );
		}else{
			$mini_size = sprintf( "%.0f", $least_size * .5 );
		}
		if ( $mini_size < 10 ) {
			logcomment("Since the size calculated $mini_size GB is less than 10GB, the size of mini disks which will be created will be 10GB");
			$mini_size = 10000;
		}elsif ( $mini_size > 70 ) {
			logcomment("Since the size calculated $mini_size GB is more than 72000MB, the size of mini disks which will be created will be 72000MB");
			$mini_size = 72000;
		}else {
			$mini_size = $mini_size * 1000;
		} 
		logcomment("Size of the mini disk is : $mini_size MB");
		$mini_size = $mini_size."MB";
		my $disk = disk_show_drive_maint( API_Obj => $Api_Set_Obj, Filer =>$FILER);
		my @disks = @{$disk->{'driveA'}};
		if(!scalar @disks){
			logcomment("Filer - $FILER : No disks available on the filer to create mini_disks");
			logresult('FATAL',"Filer - $FILER : No disks available on the filer to create mini_disks");
			#return 0;
		}
		logcomment("$FILER : all the drives on which mini_disks are going to create are @disks");
		my $TIME_OUT = (scalar @disks*100)+300; 
		$Api_Set_Obj->set_timeout("connectrec-timeout" => $TIME_OUT);
		try {
			my $prompts_answers = ['Are you sure you want to continue?'=> 'y','Would you like to zero newly created minidisks now?'=>'n'];
			$Api_Set_Obj->execute_raw_command( 'command' => "mini_disk create $mini_size @disks",'connectrec-match_table' => $prompts_answers);
			sleep 60;
		}catch NACL::APISet::Exceptions::ResponseException with {
			my $exception_object = shift;
			my $resp             = $exception_object->get_response_object();
			logcomment( "Caught a " . ref($exception_object) . "!" );
			logcomment( "Error is: " . $exception_object->text() );
			logcomment( "Raw output was:\n" . $resp->get_raw_output() );
			logresult('FATAL',"$FILER : Mini_disk creation failed");
		};
		return 1;
	}else{
		logcomment("Filer : $FILER : is not in maintanence Mode, So cannot create mini_disk");
		logresult('FATAL',"$FILER : is not in maintanence Mode, So cannot create mini_disk");
	}
}	


##########################################################################################################
## Author Arjun Lavu
## Description :: Displays the version of pNATE and NDATE
##########################################################################################################
sub  pnate_versions_display{
	# my (%opts) = validate(
		# @_,
			# {
				# Test   => { type => OBJECT },
			# }
       # );
	# my $Test = $opts{Test};
	my $Home=$ENV{HOME};
	$Home = trim($Home);
	if ((-e "$Home/.pnate_ndate_debug") || (-d "$Home/NDATE/pnate")) {
		my $Home=$ENV{HOME};
		$Home = trim($Home);
		my $NDATE_path = "$Home/NDATE_ver";
			
		#push(@INC, "$Home/archives/install/lib"); # Req for old pnate installation
		if (-d "$Home/NDATE/pnate/lib") {
			push(@INC, "$Home/NDATE/pnate/lib");
			require PNATE;
		}

		if (-d "$Home/NDATE/pnate/bin") {
			my $osversion = `$Home/NDATE/pnate/bin/sfwmnt`;
			$osversion = trim($osversion);
			logcomment("Running on the OS: $osversion");
		}
		# my ($staf_os) = @_;
		my ($stf_ver, $inst,@staf);
		##get the staf version
		#opendir(READDIR, "$Home/NDATE/pSTAF/$staf_os");# Req for old pnate installtion
		opendir(READDIR, "$Home/NDATE/pSTAF");
		@staf = readdir(READDIR);
		closedir(READDIR);
	
		foreach my $dirs (@staf) {
			#if ($dirs =~ /staf\-/){ #Req for old pnate install
			if ($dirs =~ /startSTAF/){
				$dirs = trim($dirs);
				#$path = "$Home/NDATE/pSTAF/$staf_os/" . $dirs; # Req for old pnate install
				my $path = "$Home/NDATE/pSTAF";
				# logcomment("Presently I am in directry $path");
				open(INST, "$path/install.properties");
	
				while ($inst = <INST>) {
					if ($inst =~ /version=(\S+)/i) {
						$stf_ver = $1;
						# logcomment("Installed STAF version $stf_ver");
						last;
					}
				}
				close(INST);
				last;
			}
		}
		# Get the pNATE build version
		open(READ, "$Home/README") || logcomment("Failed to read the README file");
		my $pbuild;
		while ($inst = <READ>) {
			if ($inst =~ /pnate\_(\w+)\.zip(?:.*)PNATE/) {
				$pbuild = $1;
				last;
			}
		}
		close(READ);
		# Reading NDATE_ver file to get the version number and build date
		my ($major, $minor, $patch, $date);
		my @ver_arr;
		open(NDATEVER, "$NDATE_path")|| logcomment("cannot open file $NDATE_path");
		my $var;
		while($var = <NDATEVER>) {
			$var =~ s/^\s+//;
			$var =~ s/\s+$//;
			@ver_arr = split("=", $var);
			if ($var =~ /NDTE_MAJOR_VERSION/) {
				$major = $ver_arr[1];
			} elsif ($var =~ /NDTE_MINOR_VERSION/) {
				$minor = $ver_arr[1];
			} elsif ($var =~ /NDTE_PATCH_VERSION/) {
				$patch = $ver_arr[1];
			} elsif ($var =~ /DATE/) {
				$date = $ver_arr[1];
			} 
		}
		close NDATEVER;
		my $VERSION = "$major.$minor.$patch";
		my $BUILD_DATE = "$date";
		
		#HARD CODED need to be modified
		$pbuild = '12-21-2014';
		my $version_str =
"NDATE Build Version used      : $VERSION
NDATE Build Date              : $BUILD_DATE
PNATE Build Date              : $pbuild
PNATE Build Version           : ".PNATE::version_string().
"\nPNATE NATE Version            : ".NATE::version_string().
"\nPNATE STAF Version            : ". "$stf_ver";
	logcomment("\n======================================================================================\n$version_str\n======================================================================================");
		# $Test->nlog("======================================================================================");
		#$Test->nlog("--------------------------------------------------------------------------------------");
		#logcomment("pNATE is installed - Following are pNATE versions");
		# $Test->nlog("NDATE Build Version used     : $VERSION ");
		# $Test->nlog("NDATE Build Date             : $BUILD_DATE ");
		# $Test->nlog("PNATE Build Date             : ". $pbuild);
		# $Test->nlog("PNATE Build Version          : ". PNATE::version_string());
		# $Test->nlog("PNATE NATE  Version          : ". NATE::version_string());
		# $Test->nlog("PNATE STAF  Version          : ". $stf_ver);
		#$Test->nlog("--------------------------------------------------------------------------------------");
		# $Test->nlog("======================================================================================");
	
	}
}

################################################
###	Author Arjun.lavu@netapp.com
### description : update new kernel image on the filer
#################################################
sub compact_flash{
	my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT },
            tar_file  => { type => SCALAR },
        }
    );
	my $Node = $opts{Node};
	my $Home = $ENV{HOME};
	$Home = trim($Home);
	my $FILER = $Node->name();
	my $tar_file = $opts{tar_file};
	my $flag = 0;
	logcomment("Filer - $FILER : Installing Image");
	logcomment("Filer - $FILER : Image file given by the user is - $tar_file");
	my $host = host($FILER);
	my $Mode = $Node->mode();
	my($network_port,$node_mgmt_ip,$net_mask,$gateway);
	if( -e "$Home/NDATE/FILER_INFO/$FILER"){
		logcomment("Configuration file found for the filer $FILER");
	}else{
		logcomment("WARNING : Couldn't find the configuration file for the filer $FILER");
	}
	if($Mode =~/CMode/ig){
		my $host_file = "$Home/NDATE/FILER_INFO/$FILER";
		my $filer_config = `cat $host_file`;
		if(!$filer_config){
			logcomment("WARNING : No data found in the configuration file $host_file")
		}
		foreach my $line ( split /\n/, $filer_config ) {
			$line = trim($line);
			if($line =~/^MGMT_PORT\s*=\s*(\S+)/){
				$network_port = $1;
				logcomment("Filer - $FILER : NODE_MANAGEMENT/NETWORK port of the filer is $network_port");
			}elsif ( $line =~ /^MGMT_IP\s*=\s*(\S+)/) {
				$node_mgmt_ip = $1;
				logcomment("Filer - $FILER : NODE_MANAGEMENT_IP of the filer is $node_mgmt_ip");
			}elsif($line =~ /^MGMT_MASK\s*=\s*(\S+)/) {
				$net_mask = $1;
				logcomment("Filer - $FILER : NET_MASK of the filer is $net_mask");
			}elsif ( $line =~ /^MGMT_GATEWAY\s*=\s*(\S+)/ ) {
				$gateway = $1;
				logcomment("Filer - $FILER : GATEWAY of the filer is $gateway");
			}
		}	
	}else{
		my $host_file = "$Home/NDATE/FILER_INFO/$FILER";
		my $filer_config = `cat $host_file`;
		if(!$filer_config){
			logcomment("WARNING : No data found in the configuration file $host_file")
		}
		foreach my $line ( split /\n/, $filer_config ) {
			$line = trim($line);
			if($line =~/^IFC\s*=\s*(\S+)/){
				$network_port = $1;
				logcomment("Filer - $FILER : NETWORK port of the filer is $network_port");
			}elsif($line =~ /^default_ip\s*=\s*(\S+)/) {
				$node_mgmt_ip = $1;
				logcomment("Filer - $FILER : Ip is $node_mgmt_ip");
			}elsif($line =~ /^MASK\s*=\s*(\S+)/){
				$net_mask = $1;
				logcomment("Filer - $FILER : NET_MASK of the filer is $net_mask");
			}elsif ( $line =~ /^GATEWAY\s*=\s*(\S+)/ ) {
				$gateway = $1;
				logcomment("Filer - $FILER : GATEWAY of the filer is $gateway");
			}
		}
	}
	
	#---------------------------------------------------------------------
	#Checking whether all required values are properly read or not
	#---------------------------------------------------------------------
	logcomment("WARNING : IFC port not found ") if(!$network_port);
	logcomment("WARNING : FILER Ip not found ")if(!$node_mgmt_ip);
	logcomment("WARNING : Net_mask value not found ")if(!$net_mask);
	logcomment("WARNING : Gateway Ip not found ")if(!$gateway);
	
	if((!$network_port)||(!$node_mgmt_ip )||(!$net_mask )||(!$gateway)){
		logresult('FATAL',"One or more important credentials of the filer - $FILER are missing, Please check the Filer configuration file and re-run the test again");
	}
	#---------------------------------------------------------------------
	#Checking the Filer state, at the end filer will be booted with the current state at the moment
	#---------------------------------------------------------------------
	my $Transit_obj = NACL::Transit->new( name => $FILER);
	$Transit_obj->set('timeout' => 600, maxcycle => 20);
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	logcomment("Filer - $FILER state is $filer_state");
	
	################################################
	##requirements to create server object
	################################################
	my $prompt_fw ;
	my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
	my $prompt_array = $host->prompt_fw();
    my $prompts = join("|",@$prompt_array);
    $prompt_fw = "($prompts)";
    logcomment("This is the prompt regex: $prompt_fw");
	my $Server = new Server(no_cli=>1);
    $Server->set_execution_server(-Server => $FILER); 	 #set the execution server to the current node
	my @filer_working = $Server->servers();
	logcomment("Number of filers working are @filer_working");
	my $timeout = "7200";  # Change time-out in final code.


	#########################################################################################################
	#------ Changing state to LOADER setting AUTOBOOT to false then changing state to BOOT-MENU -------###
	#########################################################################################################
	try{
		logcomment(" Filer - $FILER : Changing state to LOADER to set the option AUTOBOOT to false");
		$Transit_obj->change_state( to => "FIRMWARE" );
		my $state = $Transit_obj->get_state('timeout' => 180);
		if ( $state =~ /FIRMWARE/ ) {
			logcomment("FILER is in LOADER prompt, setting AUTOBOOT to false");
			$Server->console(cmd => 'setenv AUTOBOOT false;unsetenv bootarg.bsdportname',
				additional_prompts_timeout => 60,
				ignore => $ignore_strings,
				additional_prompts => {
					"$prompt_fw" => "FINAL_PROMPT",
				}
			);
		}	
		logcomment(" Filer - $FILER : Changing state to boot-menu");
		$Transit_obj->change_state( to => "BOOT_MENU");
	} catch NACL::Transit::Exceptions::RetriesExceeded with {
        logcomment("Expected: Caught a RetriesExceeded exception");
       
    } catch NACL::Transit::Exceptions::TransitException with {
        my $exception_object = shift;
        logcomment("Exception is of type: " . ref ($exception_object));
        logcomment("Error text is: " . $exception_object->text());
    } finally {
        logcomment( "Reset fields 'timeout' and 'maxcycle'");
        $Transit_obj->set('timeout' => 700, maxcycle => 30);
        $Transit_obj->set('change_state_timeout' => 600);
        logcomment( "New object settings for timeout and maxcycle are: " . Dumper $Transit_obj->get('timeout', 'maxcycle') );
		$Transit_obj->change_state( to => "BOOT_MENU");
    };

	##########################################################
	######  giving option 7 in the boot menu	###########
	##########################################################
	try{
		logcomment("Filer - $FILER entering the option 7 to install image");
        $Server->console(cmd => "7",
            additional_prompts_timeout => $timeout,
            ignore => $ignore_strings,
            additional_prompts => {
				".*Do you want to continue.*" =>'y',
				".*Select the network port you want to use for the download.*" => "$network_port",
				".*The node needs to reboot for this setting to take effect.*" => 'y',
				".*The node must be rebooted to start using the newly installed software.*" =>'y',
				".*Rebooting.*" => "FATAL_PROMPT",
				"$prompt_fw" => "FINAL_PROMPT",
            }
        );
    }catch NACL::Transit::Exceptions::Timeout with{
		logcomment("Filer - $FILER : timeout exception");
		try{
			$Server->console(cmd => " ",
				additional_prompts_timeout => $timeout,
				ignore => $ignore_strings,
				additional_prompts => {
					".*Enter the IP address for port.*" =>"$node_mgmt_ip",
					".*Enter the netmask for port.*" => "$net_mask",
					".*Enter IP address of default gateway.*" => "$gateway",
					".*What is the URL for the package.*" => "$tar_file",
					".*Verify that the network is properly configured, that the gateway is set.*" => "FATAL_PROMPT",
					".*Verify that the URL is correct and points to a Data ONTAP.*" => "FATAL_PROMPT",
					".*Verify that the gateway entered is correct.*" => "FATAL_PROMPT",
					".*Verify that the server is configured correctly.*" => "FATAL_PROMPT",
					".*contact Customer Support.*" => "FATAL_PROMPT",
					".*not supported by this package.*" => "FATAL_PROMPT",
					".*Verify file permissions on the server, and your user permissions.*" =>"FATAL_PROMPT",
					".*Retry.*" => 'FATAL_PROMPT',
					".*Please choose one of the following.*" => '8',
					".*Reboot now.*" => 'y',
					".*What is the user name on.*" => "\n",
					".*What is the password for.*" => "\013",
					".*Do you want to set the newly installed software as the default to be used for.*" =>'y',
					".*The node must be rebooted to start using the newly installed software.*" => 'y',
					".Rebooting.*" => "FINAL_PROMPT",
					"$prompt_fw" => "FINAL_PROMPT",
				}
			);
		}catch NATE::BaseException with{
			logcomment("FILER  - $FILER : WARNING : Verify that the network is properly configured, that the gateway is set OR Verify that the URL is correct and points to a Data ONTAP OR IMAGE is compatible or not");
			$Server->console(cmd => " ",
			additional_prompts_timeout => $timeout,
			ignore => $ignore_strings,
			additional_prompts => {
				".*Retry.*" => 'n',
				".*Please choose one of the following.*" => '8',
				".*Reboot now.*" => 'y',
				"$prompt_fw" => "FINAL_PROMPT",
				}	
			);
			$flag = 1;
		}; 	
		logcomment("Jumping to boot in require state");
		goto long;
	}catch NATE::BaseException with{
		sleep 120;
		my $state = $Transit_obj->get_state('timeout' => 120);
		if($state eq 'FIRMWARE'){
			logcomment("Filer - $FILER : successfully rebooted");
		}elsif($state !~/FIRMWARE|MAINT|CLI|UP/i){
			logcomment("Filer - $FILER : Something went wrong with the rebooting, Changing filer state back to original state - $filer_state");
			$Transit_obj->change_state( to => "$filer_state");
			$flag = 1;
			goto long;
		}
	};
	
	#####################################################################################
	## giving the option boot_ontap in the boot-menu to give ip,mask,gateway etc ####
	#####################################################################################
	try {
        $Server->console(cmd => "boot_ontap",
			additional_prompts_timeout => $timeout,
			ignore => $ignore_strings,
			additional_prompts => {
				".*Enter the IP address for port.*" =>"$node_mgmt_ip",
				".*Enter the netmask for port.*" => "$net_mask",
				".*Enter IP address of default gateway.*" => "$gateway",
				".*What is the URL for the package.*" => "$tar_file",
				".*Verify that the network is properly configured, that the gateway is set.*" => "FATAL_PROMPT",
				".*Verify that the URL is correct and points to a Data ONTAP.*" => "FATAL_PROMPT",
				".*contact Customer Support.*" => "FATAL_PROMPT",
				".*Verify that the server is configured correctly.*" => "FATAL_PROMPT",
				".*Verify that the gateway entered is correct.*" => "FATAL_PROMPT",
				".*not supported by this package.*" => "FATAL_PROMPT",
				".*Verify file permissions on the server, and your user permissions.*" =>"FATAL_PROMPT",
				".*Retry.*" => 'FATAL_PROMPT',
				".*Please choose one of the following.*" => '8',
				".*Reboot now.*" => 'y',
				".*What is the user name on.*" => "\n",
				".*What is the password for.*" => "\013",
				".*Do you want to set the newly installed software as the default to be used for.*" =>'y',
				".*The node must be rebooted to start using the newly installed software.*" => 'y',
				".Rebooting.*" => "FINAL_PROMPT",
				"$prompt_fw" => "FINAL_PROMPT",
			}
		);
	} catch NATE::BaseException with{
		logcomment("FILER  - $FILER : WARNING : Verify that the network is properly configured, that the gateway is set or Verify that the URL is correct and points to a Data ONTAP ");
		$Server->console(cmd => " ",
			additional_prompts_timeout => $timeout,
			ignore => $ignore_strings,
			additional_prompts => {
				".*Retry.*" => 'n',
				".*Please choose one of the following.*" => '8',
				".*Reboot now.*" => 'y',
				"$prompt_fw" => "FINAL_PROMPT",
			}	
		);	
		$flag = 1;
	}; 	
	$Server = undef;
	#####################################################################################
	## Changing state to filer state which was $filer_state[which was there before] ####
	#####################################################################################
	sleep 60;
	long:my $state = $Transit_obj->get_state('timeout' => 240);
	if($state =~/FIRMWARE/ig){
		logcomment("Filer - $FILER changing state to $filer_state");
		$Transit_obj->change_state( to => "$filer_state");
	}
	
	if($flag == 1){
		logcomment("Filer - $FILER : WARNING : IMAGE INSTALLATION HAS NOT DONE.");
		logresult('FAIL',"$FILER : IMAGE INSTALLATION HAS NOT DONE");
		return 1;
	}
}
#################################################
### Author Arjun.lavu@netapp.com
### description : disk_qual stop in only file system
### Usage : Only or FullSteam kernel
#################################################
sub disk_qual_stop_file_system{
	my (%opts) = validate(
			@_,
			{
				Node  => { type => OBJECT },
				disk_list => { type => ARRAYREF, optional => 1,default => undef },
			}
		);
	my $Node  = $opts{Node};
	my $Mode = $Node->mode();
	my $FILER_C = $Node->name();
	my $command = "run local \"priv set -q test;disk_qual stop -d all\"";
	my @disks;
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);	##/etc/diskqual_output: No such file or directory
	logcomment("$FILER_C : FILER State is $filer_state");
	if(($filer_state!~/CLI|UP/ig)||($Mode!~/CMode/ig)){
		logcomment("Filer : $FILER_C - Filer is not either in CMode or in 7Mode Filesystem, So returning from the subroutine");
		return 0;
	}
	my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
	$Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;rm /etc/diskqual_output\"");
	$Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;disk_qual status\"");
	my $dsk_out = $Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;rdfile /etc/diskqual_output\"");
	if ($dsk_out =~ /idle/){
		logcomment("Filer : $FILER_C - Disk qual is idle");
		return 1;
	}elsif($dsk_out =~/No such file or directory/){
		logcomment("Filer : $FILER_C - Disk qual output file is not generated");
		return 0;
	}
	logcomment("$FILER_C : disk qual is not idle, waiting for the 'disk_qual stop' to complete");
    if ( defined scalar @{$opts{disk_list}}){
		@disks = @{$opts{disk_list}};
        logcomment("Re-using the output from disk_list");
    }else {
        @disks = list_of_disk( Node => $Node);
    }
	$Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;rm /etc/diskqual_output\""); ##or else previous output will get mix
	my $dis_qua_stop = $Api_Set_Obj->execute_raw_command('command' =>$command);
	my $timeout = ((scalar(@disks) * 60 )+ 600);
	logcomment("Filer : $FILER_C - Waiting 120 seconds to get first prompt from 'disk_qual stop'");
	sleep(120);
	$Api_Set_Obj->execute_raw_command('command' =>"\013");
	$Api_Set_Obj->set_timeout("connectrec-timeout" => $timeout);	
	my $kill_time = time + $timeout;
	while ( $kill_time > time ) {
		$Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;rm /etc/diskqual_output\""); 
		$Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;disk_qual status\"");
		my $dsk_output = $Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;rdfile /etc/diskqual_output\"");
		if($dsk_output!~/idle/ ) {
			sleep 60;	#waiting for 1 min and again checking the while loop condition
		}elsif($dsk_output=~/No such file or directory/i){
			logcomment("Filer : $FILER_C - disk_qual output file is not created, there must be some error");
			return (0);
		}elsif($dsk_output=~/idle/ ) {
			logcomment("Filer : $FILER_C - disk_qual is stopped");
			return (1);
		}
	}	
	$Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;rm /etc/diskqual_output\""); 
	$Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;disk_qual status\"");
	my $dsk_output = $Api_Set_Obj->execute_raw_command('command' => "run local \"priv set -q test;rdfile /etc/diskqual_output\"");
	if($dsk_output!~ /idle/ ) {
		return (0);
	}else{
		logcomment("Filer : $FILER_C - Something wrong with the disk_qual stop");
		return (1);
	}
}

####################################
## Author : arjun.lavu@netapp.com
## executing wipeconfig command on the boot-menu
####################################
 sub clean_config{
		my (%opts) = validate(
				@_,
			{
					Node  => { type => OBJECT },
			}
		);
	my $Node  = $opts{Node};
	my $FILER = $Node->name();
	logcomment("Filer : $FILER - Cleaning the configuration");
	#$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	
	my $prompt_fw ;
	my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
	my $host = host($FILER);
	my $prompt_array = $host->prompt_fw();
	my $prompts = join("|",@$prompt_array);
	$prompt_fw = "($prompts)";
	logcomment("This is the prompt regex: $prompt_fw");
	my $Server = new Server(no_cli=>1);
	#my $Server = new Server(nodes =>$FILER,no_cli=>1,filers_on_demand =>1);
	$Server->set_execution_server(-Server => $FILER); 	 #set the execution server to the current node
	my @filer_working = $Server->servers();
	logcomment("Number of filers working are @filer_working");
	my $timeout = 3600;
	#$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	
	#logcomment("Filer - $FILER : Cleaning the configuration");
	my $Transit_obj = NACL::Transit->new( name => $FILER);
	$Transit_obj->set('timeout' => 600, maxcycle => 5);
	
	## Changing state to LOADER and setting AUTOBOOT false
	logcomment("Filer - $FILER : Changing state to LOADER and setting AUTOBOOT false");
	$Transit_obj->change_state( to => "FIRMWARE" );
	try {
		$Server->console(cmd => "setenv AUTOBOOT false",
			additional_prompts_timeout => $timeout,
			ignore => $ignore_strings,
			additional_prompts => {
				"$prompt_fw" => "FINAL_PROMPT",
			}
		);	
	}catch NATE::BaseException with{
		logcomment("Filer : $FILER something went wrong in setting AUTOBOOT");
	};
		
	logcomment("Filer : $FILER : Changing state to boot-menu");
	$Transit_obj->change_state( to => "BOOT_MENU" );
	logcomment("Filer : $FILER executing wipeconfig on the boot_menu");
	try {
		$Server->console(cmd => "wipeconfig",
			additional_prompts_timeout => $timeout,
			ignore => $ignore_strings,
			additional_prompts => {
				".*Are you sure you want to continue.*" => 'yes',
				"$prompt_fw" => "FINAL_PROMPT",
			}
		);	
	}catch NATE::BaseException with{
		logcomment("Filer : $FILER  inside first base exception");
	};
		
	try {
		$Server->console(cmd => "boot_ontap",
			additional_prompts_timeout => $timeout,
			ignore => $ignore_strings,
			additional_prompts => {
				"$prompt_fw" => "FINAL_PROMPT",
			}
		);	
	}catch NATE::BaseException with{
		logcomment("Filer : $FILER  inside second base exception");
	};	
	$Server = undef;
}
				

######################################################################
##Arjun.lavu@netapp.com 
## Description :: Destroys root aggrgate in the filers
#################################################################
sub destroy_root_volume{
	my (%opts) = validate(
        @_,
        {
            Noderef => { type => ARRAYREF },
        }
    );
	# my %FILER_API;
	my @Nodes = @{$opts{Noderef}};
	foreach my $Node (@Nodes) {
        my $FILER_C = $Node->name();
		my $Host = host($FILER_C);
		my $Transit_obj = NACL::Transit->new( name => $FILER_C );
		my $filer_state = $Transit_obj->get_state('timeout' => 600);
		logcomment("FILER : $FILER_C state is $filer_state");
		$Transit_obj->change_state(to => "MAINT") if($filer_state!~/MAINT/i);
        logcomment(" Creating API object for filer - $FILER_C");
		my $console = Tharn::connect("$FILER_C#console");
		# Set the properties for the Connectrec used for creating the APIset
        $console->{prompts} = [qr/\*>/];
        $console->{max_idle} = 600;
        $console->{on_idle} = sub { $console->execute(""); };
        my $API_obj = NACL::APISet->new(connection => $console,
                                        category => "Node",
                                        interface => "CLI",
                                        set => "Maintenance");
        # $FILER_API{$FILER_C} = $API_obj;
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		disable_debug_msg(Node => $Node);
		# disable_dbg_msgs( host => $Host, filermode => "maint" );
		my $output = $API_obj->execute_raw_command( 'command' =>"aggr status");
		if($output=~/No root aggregate/ig){
			logcomment("No root volume exist on the filer $FILER_C");
			next;
		}else{
			foreach my $var (split(/\n/,$output)){
				if($var=~/root/i){
					logcomment("destroying the root aggrgates on the filer $FILER_C ");
					$var=~s/^\s+|\s+$//gi;		
					my ($aggr)=$var=~/^(\S+)\s*/i;
					logcomment("Root aggregate name found on the filer is $aggr");
					my $prompts_answers = [".*you sure want to take the root aggregate.*"=> 'yes'];
					$API_obj->execute_raw_command( 'command' =>"aggr offline $aggr",'connectrec-match_table' => $prompts_answers);
					my $prompts_answers1 = [".*you sure you want to destroy this aggregate.*"=> 'yes'];
					$API_obj->execute_raw_command( 'command' =>"aggr destroy $aggr",'connectrec-match_table' => $prompts_answers1);
				}
			}
		}
	}
}


#######################################################################################################
# Auther - arjunl
# Description - cm_disk_firmware
# Supported Mode - CMode
######################################################################################################

sub cm_disk_firmware {
    my (%opts) = validate(
        @_,
        {
            Node             => { type => OBJECT},
            disk_fw_location => { type => SCALAR },
            timeout   => { type => SCALAR, default => 1200,     optional => 1 },
        }
    );

     my $Node = $opts{Node};
     my $disk_fw_path = $opts{disk_fw_location};
     my $sudo         = "/usr/bin/sudo";
     my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
     my $Mode = $Node->mode();
     my %new_disk_fw = ();
     my $new_disk_fw_p = [];
     $new_disk_fw_p = \%new_disk_fw;
     my %model =();
     my %rev =();
     my @disk_fw        = `cd $opts{disk_fw_location};ls *.LOD`;
	 my @failed_array;
	logcomment("Following Firmwares found in the directory $opts{disk_fw_location}:" );
    logcomment("@disk_fw");

    # This function validates the same firmwares with same product id's

     if ( @disk_fw < 1 ) {
        logcomment("No disk firmware files are available");
        return ($new_disk_fw_p);
 	 }
	 my $ver = $Api_Set_Obj->execute_raw_command('command' => "version"); 
	my @disk_list;
	my @list_of_disk = list_of_disk(Node => $Node);
	foreach my $dsk (@list_of_disk) {
		if ($dsk =~ /(P\d+)$/) {
			next;
		}
		push (@disk_list, $dsk);
	}
	logcomment("Disk Available : @disk_list");
	# $Api_Set_Obj->execute_raw_command('command' => "set -rows 2000");
	my %sto_show_dsk = ();
	$sto_show_dsk{$Node} = storage_show_disk_a_data(Node=>$Node);
	foreach my $disk (@disk_list) {
		my $mdl = $sto_show_dsk{$Node}->{$disk}->{'Model'};
		my $rvs = $sto_show_dsk{$Node}->{$disk}->{'Rev'};
		$model{$disk} = $mdl ;
		$rev{$disk} = $rvs ;
	}

		foreach my $dsk (@disk_list){
			my $model_name = $model{$dsk};
			my $rev_num = $rev{$dsk};
			my $flag=0;
			foreach my $fw (@disk_fw) {
				$fw=~s/^\s+|\s+$//g;
				$model_name=~s/^\s+|\s+$//g;
		        if ( $fw =~ /^$model_name\.\S+\.LOD$/ ) {
					logcomment(" Disk : $dsk ::: Model : $model_name ::: Rve No : $rev_num");
		            $flag = 1;
					if ( !( $new_disk_fw{$dsk} ) ) {
						$new_disk_fw{$dsk} = $fw;
					}
	        	} ## if ( $fw =~ /$model_name/ )
	        }  ## end foreach my $fw (@disk_fw)
			if ( $flag == 0) {
				push(@failed_array,"No firmware file found for the disk $dsk with model number : $model_name and version $rev_num");
            }
		} ## foreach my $dsk (@disk_list)
		grep{logcomment("$_")}@failed_array;
		return ($new_disk_fw_p);

	}
#######################################################################################################
# Auther - skaran
# Description - copy_files_to_filer_from_client
# Supported Mode - CMode
######################################################################################################
sub copy_files_to_filer_from_client{
         my (%opts) = validate(
        @_,
        {
     node_present => { type => OBJECT},
     filer_path => { type => SCALAR },
    file_To_transfer => { type => ARRAYREF},
    }
    );

my $node=$opts{node_present};
my $filer_path=$opts{filer_path};
#my $client_path=$opts{client_path};
my $file_transfer=$opts{file_To_transfer};
my $Client = NACL::C::Client->find();
logcomment("Client is $Client" );
my %Ipv6_opts;
my $Is_ipv6_addr= '';
$Ipv6_opts{use_ipv6_address} = 1 if ($Is_ipv6_addr);
	my $Home = $ENV{HOME};
	my $Node_name = $node->name();
	my $filer_info = `cat $Home/NDATE/FILER_INFO/$Node_name`;
	my $passwd;
	($passwd) = $filer_info=~/default_password\s*=\s*(\S+)\s*/ig;
 my $scp = NACL::MTask::SCP->new(
        source_command_interface => $Client,
        target_command_interface => $node,
         target_username => 'diag',
         target_password => "$passwd",
    );
 my $files = [$file_transfer];
    $scp->copy_from_source_to_target(
        'files_to_copy'         => $file_transfer,
        set_directory_on_target => $filer_path,
        %Ipv6_opts
        );
}


=head
#######################################################################################################
## Author Arjun Lavu
## Description -  sasadmin_expander_map
## The following named arguments are accepted:
## item Node
## (Required) : Node object to execute a command.
## item adapter_name
## (Optional) : Specific channel for which the information is
## required. Default is all
## Supported Mode - CMode/CLI/MAINT]
#######################################################################################################
sub sasadmin_expander_map {
	my (%opts) = validate(@_,
		{
			node     => { type => OBJECT },
			adapter_name   => {type=>SCALAR, default=>undef, optional=>1},
		}
	);
	my $Node = $opts{node};
	my $Mode = $Node->mode();
	my $API_obj;
	my $FILER_C = $Node->name();
	my $adapter = undef ;
	my $output = "";
	
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if(defined($opts{adapter_name})){
		$adapter = $opts{adapter_name};
	}
	my %structure =();
	my $cmd = "sasadmin expander_map $adapter";
	if($filer_state=~/MAINT/gi){
		my $Host = host($FILER_C);
		$API_obj = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance"
		);
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $API_obj->execute_raw_command('command' => "$cmd");
	}elsif($filer_state=~/(CLI|UP)/gi){
		$API_obj = $Node->get_7m_or_nodescope_apiset();
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $API_obj->execute_command('command' => "$cmd");
	}
	
	if($output !~ /Expanders on channel/){
		logcomment("$FILER_C : WARNING : No expected output appeared");
		return ;
	}
	$output=~s/'|,|://g;  #removing all (' and : and ,)
	my(@tot_channels,$total);
	@tot_channels=$output=~/Expanders on channel\s(\S+)/g;
	$total=@tot_channels;
	my $hba;
	my @lines = split(/\r*\n/, $output);
	foreach (@lines) {
		if($_ =~ /Expanders on channel\s(\S+)/){
			$hba = $1;
		}
		if($_ =~ /^Level/) {
			my @fields = split(/\s+/, $_);
			$structure{$hba}{"$fields[3]"}{'Level'} = $fields[1];
			$structure{$hba}{"$fields[3]"}{'ID'} = $fields[5];
			$structure{$hba}{"$fields[3]"}{'SerialNumber'} = $fields[8];
			$structure{$hba}{"$fields[3]"}{'Product'} = $fields[10];
			$structure{$hba}{"$fields[3]"}{'Rev'} = $fields[12];
			$structure{$hba}{"$fields[3]"}{'Slot'} = $fields[14];
		}
	}
	my $up_chan = 0;
	my @up_channles=keys(%structure);
	$up_chan = @up_channles;
	#logcomment("$FILER_C : Total number of channels are $total and the channels are @tot_channels");
	logcomment("$FILER_C : Total number of UP channels are $up_chan and the channels are @up_channles");
	return \%structure;
}

#######################################################################################################
# Auther - priya3
# Description -  sasadmin_dev_stats
# Supported Mode - CMode
######################################################################################################
sub sasadmin_dev_stats {
 my (%opts) = validate(@_,{
     node     => { type => OBJECT },
     adapter_name   => {type=>SCALAR, default=>undef, optional=>1},
  }
 );
 my $Node = $opts{node};
 my $Mode = $Node->mode();
 my $API_obj;
 my $FILER_C = $Node->name();
 my $adapter = undef ;
 my $output = "";
 if(defined($opts{adapter_name})){
  $adapter = $opts{adapter_name};
 }
	my %structure =();
	my $cmd = "sasadmin dev_stats";
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if($filer_state=~/MAINT/gi){
		my $Host = host($FILER_C);
			$API_obj = NACL::APISet->new(
				hostobj   => $Host,
				category  => "Node",
				interface => "CLI",
				set       => "Maintenance"
			);
		$output = $API_obj->execute_raw_command('command' => "$cmd");
	}elsif($filer_state=~/(CLI|UP)/gi){
		$API_obj = $Node->get_7m_or_nodescope_apiset();
		$output = $API_obj->execute_command('command' => "$cmd");
	}
	$API_obj->set_timeout( "connectrec-timeout" => 1200 );
	if($output !~ /Device stats on channel/){
	logcomment("$FILER_C : WARNING : No expected output appeared");
	return ;
	}
	$output=~s/'|,|://g;  #removing all (' and : and ,)
	my(@tot_channels,$total);
	@tot_channels=$output=~/Expanders on channel\s(\S+)/g;
	$total=@tot_channels;
	my $hba;
	my @lines = split(/\r*\n/, $output);
	foreach (@lines) {
	if($_ =~ /Device stats on channel\s(\S+)/){
	
	$hba = $1;
	}
	if($_ =~ /(^$hba\.\S+)\s+/) {
	
	my @fields = split(/\s+/, $_);
	$structure{$hba}{"$fields[0]"}{'Device'} = $fields[0];
	$structure{$hba}{"$fields[0]"}{'CmdsCmpltGood'} = $fields[1];
	$structure{$hba}{"$fields[0]"}{'CmdsCmpltError'} = $fields[2];
	$structure{$hba}{"$fields[0]"}{'FramesIn'} = $fields[3];
	$structure{$hba}{"$fields[0]"}{'FramesOut'} = $fields[4];
	$structure{$hba}{"$fields[0]"}{'VctmAbrt'} = $fields[5];
	$structure{$hba}{"$fields[0]"}{'QsceCnt'} = $fields[6];
	$structure{$hba}{"$fields[0]"}{'UdrnCnt'} = $fields[7];
	$structure{$hba}{"$fields[0]"}{'OvrnCnt'} = $fields[8];
	$structure{$hba}{"$fields[0]"}{'TrnsErrCnt'} = $fields[9];
	$structure{$hba}{"$fields[0]"}{'SCSIPtclErrCnt'} = $fields[10];
	$structure{$hba}{"$fields[0]"}{'CRCErrCnt'} = $fields[11];
	$structure{$hba}{"$fields[0]"}{'OPENErrCnt'} = $fields[12];
	$structure{$hba}{"$fields[0]"}{'InvdCnt'} = $fields[13];
	$structure{$hba}{"$fields[0]"}{'DlayCnt'} = $fields[14];
	$structure{$hba}{"$fields[0]"}{'SATAInitFailCnt'} = $fields[15];
	$structure{$hba}{"$fields[0]"}{'TO1Ct'} = $fields[16];
	$structure{$hba}{"$fields[0]"}{'TO2Ct'} = $fields[17];
	$structure{$hba}{"$fields[0]"}{'TO3Ct'} = $fields[18];
	$structure{$hba}{"$fields[0]"}{'TO4Ct'} = $fields[19];
	}
	}
	my $up_chan=0;
	my @up_channles=keys(%structure);
	$up_chan=@up_channles;
	logcomment("$FILER_C : Total number of channels are $total and the channels are @tot_channels");
	logcomment("$FILER_C : Total number of UP channels are $up_chan and the channels are @up_channles");
	return \%structure;
}
=cut


sub compare_disk_lists {
    my (%opts) = validate(
        @_,
        {
            diskL_add_before => { type => ARRAYREF },
            diskL_add_after  => { type => ARRAYREF },
        }
    );
    my @diskL_add_before = @{ $opts{diskL_add_before} };
    my @diskL_add_after  = @{ $opts{diskL_add_after} };

    #remove the null elements if any
    @diskL_add_before = grep( !/^$/, @diskL_add_before );
    @diskL_add_after  = grep( !/^$/, @diskL_add_after );

    my $d_before = @diskL_add_before;
    my $d_after  = @diskL_add_after;

    logcomment("The no. of disk before = $d_before");
    logcomment("The no. of disk after = $d_after");
    if ( $d_before != $d_after ) {
        return 0,;
    }
    else {
        return 1;
    }
} ## end sub compare_disk_lists

=head2 compare_fcadmin_link_stats

    my $ret = compare_fcadmin_link_stats(fcadmin_lnkstats_add_before => $fcadmin_lnkstats_add_before, fcadmin_lnkstats_add_after => $fcadmin_lnkstats_add_after);

This routine returns 1 on sucess and 0 on failure:

The following named arguments are accepted,

=over

=item fcadmin_lnkstats_add_before

(Required) : hash address returned by fcadmin_link_stats method on first instance

=item fcadmin_lnkstats_add_after

(Required) : hash address returned by fcadmin_link_stats method on second instance

=back

=cut

sub compare_fcadmin_link_stats {
    my (%opts) = validate(
        @_,
        {
            fcadmin_lnkstats_add_before => { type => HASHREF },
            fcadmin_lnkstats_add_after  => { type => HASHREF },
        }
    );
    my $fcadmin_lnkstats_add_before = $opts{fcadmin_lnkstats_add_before};
    my $fcadmin_lnkstats_add_after  = $opts{fcadmin_lnkstats_add_after};
    for my $state ( keys %$fcadmin_lnkstats_add_before ) {
        if (
            defined(
                $fcadmin_lnkstats_add_before->{$state}->{'TransportErrorCount'}
            )
          )
        {
            if ( $fcadmin_lnkstats_add_before->{$state}->{'TransportErrorCount'}
                ne
                $fcadmin_lnkstats_add_after->{$state}->{'TransportErrorCount'} )
            {
                my $error_count =
                  $fcadmin_lnkstats_add_after->{$state}
                  ->{'TransportErrorCount'} -
                  $fcadmin_lnkstats_add_before->{$state}
                  ->{'TransportErrorCount'};
                logcomment(
"Difference between fcadmin_lnkstats_add_after and fcadmin_lnkstats_add_before is:$error_count"
                );
                logcomment(
"fcadmin_lnkstats_add_after:$fcadmin_lnkstats_add_after->{$state}->{'TransportErrorCount'}\nfcadmin_lnkstats_add_before:$fcadmin_lnkstats_add_before->{$state}->{'TransportErrorCount'}"
                );
                return (0);
            }
        }
    }
    return (1);
} ## end sub compare_fcadmin_link_stats

=head2 compare_fcadmin_fcal_stats

    my $ret = compare_fcadmin_fcal_stats(fcadmin_fclstats_add_before => $fcadmin_fclstats_add_before, fcadmin_fclstats_add_after => $fcadmin_fclstats_add_after);

This routine returns 1 on sucess and 0 on failure:

The following named arguments are accepted,

=over

=item fcadmin_fclstats_add_before

(Required) : hash address returned by fcadmin_fclstats_add_before method on first instance

=item fcadmin_fclstats_add_after

(Required) : hash address returned by fcadmin_fclstats_add_after method on second instance

=back

=cut

sub compare_fcadmin_fcal_stats {
    my (%opts) = validate(
        @_,
        {
            fcadmin_fclstats_add_before => { type => HASHREF },
            fcadmin_fclstats_add_after  => { type => HASHREF },
        }
    );

    my $fcadmin_fclstats_add_before = $opts{fcadmin_fclstats_add_before};
    my $fcadmin_fclstats_add_after  = $opts{fcadmin_fclstats_add_after};

    for my $state ( keys %$fcadmin_fclstats_add_before ) {
        if (
            defined(
                $fcadmin_fclstats_add_before->{$state}
                  ->{'device_transport_error_cnt'}
            )
          )
        {
            if ( $fcadmin_fclstats_add_before->{$state}
                ->{'device_transport_error_cnt'} ne
                $fcadmin_fclstats_add_after->{$state}
                ->{'device_transport_error_cnt'} )
            {

                my $error_count =
                  $fcadmin_fclstats_add_after->{$state}
                  ->{'device_transport_error_cnt'} -
                  $fcadmin_fclstats_add_before->{$state}
                  ->{'device_transport_error_cnt'};

                logcomment(
"Difference between fcadmin_fclstats_add after and fcadmin_fclstats_add before is:$error_count"
                );

                logcomment(
"fcadmin_fclstats_add after:$fcadmin_fclstats_add_after->{$state}->{'device_transport_error_cnt'}\nfcadmin_fclstats_add before:$fcadmin_fclstats_add_before->{$state}->{'device_transport_error_cnt'}"
                );

                return (0);
            }
        }
    }
    return (1);
} ## end sub compare_fcadmin_fcal_stats

=head2 compare_sasadmin_dev_stats

        compare_sasadmin_dev_stats(initial_stats=>$initial,final_stats=>$final);

This functions compares structures returned by sasadmin_dev_stats and reports any unexpected increase in error counters
Returns 1 for pass and 0 for failure

Following error counters stats are compared:

1. Trns Err Cnt
2. SCSI Ptcl Err Cnt
3. CRC Err Cnt
4. SATA Init Fail Cnt


Example to use compare_sasadmin_dev_stats and sasadmin_dev_stats function

Get sas device states before doing operations

$initial = sasadmin_dev_stats(host => $host,timeout => $timeout);

Do some operations

Get sas device stats after operations

$final = sasadmin_dev_stats(host => $host,timeout => $timeout);


Compare two values

compare_sasadmin_dev_stats(initial_stats=>$initial, final_stats=>$final);


The following arguments are accepted:

=over

=item initial_stats

(Required): Initial data structure return by sasadmin_dev_stats()

=item final_stats

(Required): Final data structure return by sasadmin_dev_stats()

=back

=cut

sub compare_sasadmin_dev_stats {

    my (%opts) = validate(
        @_,
        {
            initial_stats => { type => HASHREF },
            final_stats   => { type => HASHREF },

        }
    );

    my @initial_sas_adapters = keys %{ $opts{initial_stats} };
    my @final_sas_adapters   = keys %{ $opts{final_stats} };
    my $ret_val              = 1;
    foreach my $adapter (@initial_sas_adapters) {

        my @initial_disks = keys %{ $opts{initial_stats}->{$adapter} };

        my $dev_error = 0;
        foreach my $disk (@initial_disks) {

            if ( $opts{initial_stats}->{$adapter}->{$disk}->{TrnsErrCnt} <
                $opts{final_stats}->{$adapter}->{$disk}->{TrnsErrCnt} )
            {
                $dev_error =
                  ( $opts{final_stats}->{$adapter}->{$disk}->{TrnsErrCnt} -
                      $opts{initial_stats}->{$adapter}->{$disk}->{TrnsErrCnt} );

                logcomment(
                    "$disk : Trans Error count increased by : $dev_error");
                $ret_val = 0;
            }

            if ( $opts{initial_stats}->{$adapter}->{$disk}->{SCSIPtclErrCnt} <
                $opts{final_stats}->{$adapter}->{$disk}->{SCSIPtclErrCnt} )
            {
                $dev_error =
                  ( $opts{final_stats}->{$adapter}->{$disk}->{SCSIPtclErrCnt} -
                      $opts{initial_stats}->{$adapter}->{$disk}
                      ->{SCSIPtclErrCnt} );
                logcomment(
                    "$disk : SCSI Ptcl Err count increased by : $dev_error");
                $ret_val = 0;
            }

            if ( $opts{initial_stats}->{$adapter}->{$disk}->{SATAInitFailCnt} <
                $opts{final_stats}->{$adapter}->{$disk}->{SATAInitFailCnt} )
            {
                $dev_error =
                  ( $opts{final_stats}->{$adapter}->{$disk}->{SATAInitFailCnt} -
                      $opts{initial_stats}->{$adapter}->{$disk}
                      ->{SATAInitFailCnt} );
                logcomment(
                    "$disk : SATA init Fail count increased by : $dev_error");
                $ret_val = 0;
            }
            if ( $opts{initial_stats}->{$adapter}->{$disk}->{CRCErrCnt} <
                $opts{final_stats}->{$adapter}->{$disk}->{CRCErrCnt} )
            {
                $dev_error =
                  ( $opts{final_stats}->{$adapter}->{$disk}->{CRCErrCnt} -
                      $opts{initial_stats}->{$adapter}->{$disk}->{CRCErrCnt} );
                logcomment("$disk : CRC err count increased by : $dev_error");
                $ret_val = 0;
            }

        } ## end foreach my $disk (@initial_disks)

    } ## end foreach my $adapter (@initial_sas_adapters)
    my $initial_count = @initial_sas_adapters;
    my $final_count   = @final_sas_adapters;
    if ( $initial_count != $final_count ) {
        $ret_val = 0;
        logcomment(
"The no. of drives captured before is not identical to no. of drives captured after"
        );
    }
    return $ret_val;
} ## end sub compare_sasadmin_dev_stats

################################################################
# arjun.lavu@netapp.com
## Description :: Compare sas-admin sxpander_map output
################################################################
sub compare_sasadmin_expander_map {
    my (%opts) = validate(
        @_,
        {
            sasadmin_addr_before => { type => HASHREF },
            sasadmin_addr_after  => { type => HASHREF },
        }
    );

    my $sasadmin_addr_before = $opts{sasadmin_addr_before};
    my $sasadmin_addr_after  = $opts{sasadmin_addr_after};

    for my $channels ( keys %$sasadmin_addr_before ) {
        my $channel_addr = $sasadmin_addr_before->{$channels};
        for my $wwn ( keys %$channel_addr ) {

            my $map_addr = $sasadmin_addr_before->{$channels}->{$wwn};

            foreach my $val ( keys %$map_addr ) {

                if ( $sasadmin_addr_before->{$channels}->{$wwn}->{$val} ne
                    $sasadmin_addr_after->{$channels}->{$wwn}->{$val} )
                {
                    logcomment(
"$wwn: $val before is $sasadmin_addr_before->{$channels}->{$wwn}->{$val}, $val after is $sasadmin_addr_after->{$channels}->{$wwn}->{$val}\n"
                    );
                    return (0);
                }
            } ## end foreach my $val (keys %$map_addr)

        } ## end for my $wwn (keys %$channel_addr)
    } ## end for my $channels (keys ...

    return (1);
} ## end sub compare_sasadmin_expander_map

=head2 compare_storage_show

    my $ret = compare_storage_show(storage_addr_before => $storage_addr_before, storage_addr_after => $storage_addr_after);

This routine returns 1 on sucess and 0 on failure:

The following named arguments are accepted,

=over

=item storage_addr_before

(Required) : hash address returned by storage_show  method on first instance

=item storage_addr_after

(Required) : hash address returned by storage_show method on second instance

=cut

sub compare_storage_show {

    my (%opts) = validate(
        @_,
        {
            storage_addr_before => { type => HASHREF },
            storage_addr_after  => { type => HASHREF },
        }
    );

    my $storage_addr_before = $opts{storage_addr_before};
    my $storage_addr_after  = $opts{storage_addr_after};
    my $flag                = 0;
    my $flag1               = 0;
    for my $channels ( keys %$storage_addr_before ) {

       for my $channela ( keys %$storage_addr_before ) {
          if ( $channels eq  $channela )
             {
               $flag1 = 1;
             #logcomment("Channel in before : $channels Channel in after : $channela ");
             }
       }
      if ( $flag1   == 1)
      {
       if ( $storage_addr_before->{$channels}->{'State'} ne
            $storage_addr_after->{$channels}->{'State'} )
        {

            if (
                (
                    $storage_addr_after->{$channels}->{'State'} =~
                    /Disabled|Enabled/i
                )
                && ( $storage_addr_before->{$channels}->{'State'} =~
                    /Disabled|Enabled/i )
              )
            {

                $flag = 1;
                logcomment(
"Flag: '$flag' Channel:'$channels' After:$storage_addr_after->{$channels}->{'State'} Before:$storage_addr_before->{$channels}->{'State'}"
                );
            }
        }
        my $channel_addr = $storage_addr_before->{$channels};

        for my $shelf ( keys %$channel_addr ) {

            next if ( $shelf !~ /\d+/ );

            for my $disk ( keys %{ $channel_addr->{$shelf} } ) {

                if ( $disk =~ /\d+/ ) {

                    if ( $storage_addr_before->{$channels}->{$shelf}->{$disk}
                        ->{CRCErrorCount} ne
                        $storage_addr_after->{$channels}->{$shelf}->{$disk}
                        ->{CRCErrorCount} )
                    {

                        logcomment(
"$disk: Before CRCErrorCount:$storage_addr_before->{$channels}->{$shelf}->{$disk}->{CRCErrorCount},After CRCErrorCount:$storage_addr_after->{$channels}->{$shelf}->{$disk}->{CRCErrorCount}\n"
                        );
                        $flag = 1;
                    }

                } ## end if ($disk =~ /\d+/)

            } ## end of for my $shelf (keys %$channel_addr)
        } ## end for my $disk (keys %$channel_addr)
      } ## end of if ($flag1 === 1)
    } ## end for my $channels (keys ...

    if ( $flag == 1 ) {
        return 0;

    }
    else {
        return 1;
    }
} ## end sub compare_storage_show

#*************************************************************************
## Author - himangin@netapp.com
## This subroutine will calculate the time between the command executed and the ems message appeared for a particular disk
## Parameters required - either Start_string or Start_time any one is compulsarily required, Logfile and End_string are mandatory
## Returns the time difference in seconds
#*************************************************************************

sub time_taken_for_frm_dwnld {
    my (%opts) = validate(
        @_,
        {
            Start_string  => { type => SCALAR, default => undef, optional => 1 },
            Start_time    => { type => SCALAR, default => undef, optional => 1 },
            Logfile       => { type => ARRAYREF },
            End_string    => { type => SCALAR },
	    Filer         => { type => SCALAR, default => undef, optional => 1 },
        }
    );
    my $start_string  = $opts{Start_string};
    my $end_string = $opts{End_string};
    my $start_time = $opts{Start_time};
    my $FILER = $opts{Filer};
        my @logfile = @{$opts{Logfile}};
        my ($date, $time) = 0;
        my ($stime, $etime);
        foreach my $line (@logfile) {
                if (defined $start_string) {
			if (($line =~ /^(\d+)\s+(\d+)/)&&($line =~ /$start_string/g)) {
                                ($date,$time) = $line =~ /^(\d+)\s+(\d+)/;
                                my $value = convert_to_date(date_val => $date, time_val => $time);
                                $stime = convertTime(time_val => $value );
				last;
                        }
                } elsif (defined $start_time) {
                        $stime = convertTime(time_val => $start_time);
			last;
                }
	}
	foreach my $line (@logfile) {
		if (($line !~ /console/)&&($line =~ /$end_string/)&&($line =~ /\"(\d+\/\d+\/\d+\s+\d+\:\d+\:\d+)\"/)){
			logcomment("The last firmware download message obtained from ems logs for filer $FILER is ".$end_string." at time $1") if (defined $FILER);
                                                my $y = $1;
                                                $y =~ s/\://g;
                                                my %convert = ('0'=>'00','1' =>'01','2'=>'02','3'=>'03','4'=>'04','5'=>'05','6'=>'06','7'=>'07','8'=>'08','9'=>'09','10'=>'10','11'=>'11','12'=>'12');
                                                if ($y =~ /(\d+)\/(\d\d)\/(\d+)(.*)/){
                                                        $date = "$3"."$convert{$1}"."$2", $time = $4;
                                                } elsif ($y =~ /(\d+)\/(\d)\/(\d+)(.*)/){
							my $x = "0"."$2";
                                                        $date = "$3"."$convert{$1}"."$x", $time = $4;
                                                }
                        my $value = convert_to_date(date_val => $date, time_val => $time);
                        $etime = convertTime(time_val => $value );
			last;
                }
        }
        my $diff = $etime - $stime;
        return $diff;
}

#*************************************************************************
##Sub-routine which will return the date time stamp in localtime format
##eg - 20150528 084216 will be returned as May 28 08:42:16 2015
#*************************************************************************
sub convert_to_date {
    my (%opts) = validate(
        @_,
        {
            date_val => { type => SCALAR },
            time_val => { type => SCALAR },
        }
    );

    my $date_val = $opts{date_val};
    my $time_val = $opts{time_val};
    my $date;
    $date_val =~ /(\d\d\d\d)(\d\d)(\d\d)/;
    my $year = $1;
    my $mont = $2;
    my $day  = $3;
    my %mon  = (
        '01' => 'JAN',
        '02' => 'FEB',
        '03' => 'MAR',
        '04' => 'APR',
        '05' => 'MAY',
        '06' => 'JUN',
        '07' => 'JUL',
        '08' => 'AUG',
        '09' => 'SEP',
        '10' => 'OCT',
        '11' => 'NOV',
        '12' => 'DEC',

    );
    my $MONTH = $mon{$mont};
    $time_val =~ /(\d\d)(\d\d)(\d\d)/;
    my $hr   = $1;
    my $min  = $2;
    my $sec  = $3;
    my $time = join( ':', $hr, $min, $sec );
    $date = join( ' ', $MONTH, $day, $time, $year );
    return $date;
}

#*************************************************************************
##Sub-routine which will return the localtime format time in seconds.
##eg - time formats - (May 28 08:42:16 2015) or (Fri May 29 02:53:30 2015) will be returned in seconds
#*************************************************************************
sub convertTime {
    my (%opts) = validate(
        @_,
        {
            time_val => { type => SCALAR },
        }
    );

        my $time = $opts{time_val};
        $time=~s/\:/ /g;
   my ($month,$day,$hour,$minute,$sec,$year) = $time  =~/(\w+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)/;
    if ( $year eq '' ) {
        my $nyear = localtime;
        if ( $nyear =~ /\S+\s\S+\s\d+\s\d+:\d+:\d+\s(\d+)/ ) {
            $year = $1;
        }
    }

    my $oneday = 24 * 3600;                                    #for convenience
    my $utime = $sec + ( $minute * 60 ) + ( $hour * 3600 );    ## time in seconds on the day in question

    my %mon = (
        JAN => 0,
        FEB => 1,
        MAR => 2,
        APR => 3,
        MAY => 4,
        JUN => 5,
        JUL => 6,
        AUG => 7,
        SEP => 8,
        OCT => 9,
        NOV => 10,
        DEC => 11,
    );
    my $mont = uc($month);
    my $month = $mon{$mont};
    my @months = ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );
    for ( my $i = 0 ; $i < ( $month - 1 ) ; $i++ ) {
        $utime += ( $months[$i] * $oneday );
    }
    $utime += ( ( ( $year - ( $year % 4 ) ) / 4 ) * $oneday );    ## take leap years into account
    if ( ( $year % 4 ) == 0 && $month < 3 ) { $utime -= $oneday; }
    $utime += ( ( $day - 1 ) * $oneday );
    $utime += ( $year * 365 * $oneday );
    return $utime;
} ## end sub convertTime



##########################################################################################################
# Author -  vpankaj
# Description - This subroutine will return max disk size based on disk attached.
# Usage - Mandatory parameter - Node object , Test object
# Mode - CMode (UP/CLI)
# Return - max disk size in GB.
##########################################################################################################
sub get_max_disk_size {
    my (%opts) = validate(
        @_,
        {
            node_present => { type => ARRAYREF},
        }
    );
    my @Nodes = @{$opts{node_present} };
    my $max_disk_size = 0;
    my $max_disk_size_GB = 0;
    foreach my $Node (@Nodes){
        my $Transit_obj;
        my $Mode = $Node->mode();
        my $FILER_C = $Node->name();
        $Transit_obj = NACL::Transit->new( name => $FILER_C );
        my $filer_state = $Transit_obj->get_state('timeout' => 600);
        logcomment("$FILER_C : Filer is in $filer_state ");
        if ($filer_state =~ /CLI|UP/){
            my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
            $Api_Set_Obj->execute_raw_command('command' =>"rows 1000");
            my $output = $Api_Set_Obj->execute_raw_command('command' =>"storage disk show -fields usable-size-mb" );
            foreach my $line(split(/\n/,$output)){
                if (($line=~/(X;X)(\d+)(X;X)/)||($line=~/(\s+)(\d+)(\s*)/)){
                    if($max_disk_size < $2){
                       $max_disk_size = $2;
                    }
                }
            }
            $max_disk_size = int($max_disk_size/(1024));
            logcomment( "maximum disk size is $max_disk_size GB");
            return $max_disk_size;
        }
    }
}


##########################################################################################################
# Author -  arjunl
#Description : Returns the common values from two arrays
##########################################################################################################
sub intersection($$) {
	my %e = map { $_ => undef } @{$_[0]};
	return grep { exists( $e{$_} ) } @{$_[1]};
}


##########################################################################################################
# Author -  arjunl
## Description : Returns the common drives
##########################################################################################################
sub commom_drives($$) {
	my($drive_a,$drives_b) = @_;
	my (%unique_drive_one,%unique_drive_two);
	foreach my $dsk(@{$drive_a}){
		( my $drive = $dsk ) =~s/(\w+\.)//;
		$unique_drive_one{$drive} = $dsk;
	}
	foreach my $dsk(@{$drives_b}){
		( my $drive = $dsk ) =~s/(\w+\.)//;
		$unique_drive_two{$drive} = $dsk;
	}
	my @common = grep {/\S/} intersection([sort keys %unique_drive_two],[sort keys %unique_drive_one]);
	logcomment("Common drives are : @common");
	my @final_array;
	foreach(@common){
		push(@final_array,$unique_drive_one{$_}) if($_=~/\S/);
	}
	return @final_array;
}

### Arjun.Lavu
sub max_drives_count{
 my (%opts) = validate(
    @_,
        {
            Node => { type => OBJECT},
        }
    );
    my $Node=$opts{Node};
    my $Mode = $Node->mode();
    my $FILER_C = $Node->name();
    my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset(connid    => "console");
    my $after;
    my @array=();
    my @array_count=();
    my %freq = ();
    if ($Mode eq 'CMode'){
    $after= $Api_Set_Obj->execute_raw_command('command' => "run local sysconfig -r");
    }
    else{
    $after=$Api_Set_Obj->execute_raw_command('command' => "sysconfig -r");
    }
    foreach my $line (split(/\n/,$after)){
    if ($line =~ /spare\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+(\S+)\s+\S+\s+\S+\s+\S+/){
    push (@array,$1);
    }
    }
    foreach  $_ (@array)
    {
       $freq{$_}++;
    }
    foreach $_ (values %freq)
    {
        push (@array_count ,$_);
    }
    my $max = (sort { $b <=> $a } @array_count)[0];
    return $max;
}

##########################################################################################################
# Author -  arjun.lavu@netapp.com
## Description : Format of printing test steps
##########################################################################################################
sub eye_catcher{
    my (%opts) = validate(
        @_,
        {
            Test  => { type => OBJECT},
    string =>{type => SCALAR ,default => undef, optional => 1 },
    }
    );
    my $Test = $opts{Test};
    my $string = $opts{string};
    $Test->nlog("=====================================================================================================");
    $Test->nlog("=== $string");
    $Test->nlog("=====================================================================================================");
}
##########################################################################################################
# Author -  arjun.lavu@netapp.com
## Description : Subroutine will check for the file Pre_post_Drives_Details, if not present remove_assign will be called
##########################################################################################################
sub check_for_drive_ownership{
	 my (%opts) = validate(
        @_,
        {
            Node_ref =>{ type => ARRAYREF},
		}
    );
	my @Nodes = @{$opts{Node_ref}};
	my $params = NATE::ParamSet->new(global => 1);
	my $LOGDIR = $params->get('LOGDIR', default => undef);
	my $TEST_CONFIG = $params->get('TEST_CONFIG', default => undef);
	if($TEST_CONFIG!~/E|C/gi){
		my $FILER_C  = $Nodes[0]->name();
		my @actual_disks;
		my $disks_file= "$LOGDIR/../../../"."Pre_post_Drives_Details_"."$FILER_C";
		if (-f $disks_file) {
			open(H_LOGFILE, "<$disks_file ")or die ">>>>> read: Failed opening $disks_file <<<<<";
			foreach my $line (<H_LOGFILE>) {
				chomp($line);
				$line=~s/(^\s+)|(\s+$)//ig;
				if(defined $line){
					push @actual_disks, $line;
				}
			}
			close H_LOGFILE;
			logcomment("Assigning the drives @actual_disks to the filer :: $FILER_C");
			disk_remv_assign_ownership(Node_ref => [$Nodes[0]],disk_ref=>\@actual_disks,assign_disk_to=>$Nodes[0]);
		}else{
			disk_remv_assign_ownership(Node_ref =>\@Nodes);
		}
	}else{
		disk_remv_assign_ownership(Node_ref =>\@Nodes);
	}
}

##########################################################################################################
# Author -  arjun.lavu@netapp.com
## Description : This subroutine sets the diag password 6 times with, that is useful in setting new password(7Mode)
##########################################################################################################
sub change_diag_more_than_6(){
	my ($c,$filer) = @_; 
	# $c = shift;
	# $filer=shift;
	for(0..6){
		my $temp = "temp"."$$"."_"."$_";
		say($c,"priv set -q test",-prompt, "$filer*>",-timeout, 30, -ok);
		say($c, "useradmin diaguser unlock ", -prompt, "$filer*>", -timeout, 120, -ok);
		logcomment("Temp Password is $temp");
		my (undef, undef, $after_diag, $prompt_diag) = say( $c,"useradmin diaguser password",-prompt, ['Enter a new password:','Enter it again:'], -timeout, 120, -ok);
		if (($prompt_diag =~/Enter a new password/i)||($after_diag=~/Enter a new password/i)) {
			my (undef, undef, $after_diag_1, $prompt_diag_1) = say($c, "$temp", -prompt,['Enter it again:'],"$filer*>", -timeout, 120, -ok);
			if (($prompt_diag_1 =~/Enter it again/i)||($after_diag_1=~/Enter it again/i)) {
				my (undef, undef, $after_diag_2, $prompt_diag_2) = say($c, "$temp", -prompt, "$filer*>",-timeout, 120,-ok);
			}
		}
	}
}
##########################################################################################################
# Author -  arjun.lavu@netapp.com
## Description : Sets the diag password of CMODE
##########################################################################################################
sub diag_password_change_cmode{
	my (%opts) = validate(
        @_,
        {
            Node_ref =>{ type => ARRAYREF},
		}
    );
	my @Nodes = @{$opts{Node_ref}};
	foreach my $Node(@Nodes){
		my $FILER_C   = $Node->name();
		my $Home = $ENV{HOME};
		system("rm -rf $Home/.ssh/known_hosts");
		$Home = trim($Home);
		my $host_file    = "$Home/NDATE/FILER_INFO/$FILER_C";
		my $filer_config = `cat $host_file`;
		my $def_pass;
		foreach my $line ( split /\n/, $filer_config ) {
			if($line =~/^default_password\s*=\s*(\S+)/ ) {
				$def_pass = $1;
				logcomment("$FILER_C :: Changing the Diag mode password to $def_pass");
				last;
			}	
		}
		try{
			my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
			$Api_Set_Obj->execute_raw_command('command' =>"security login unlock -username diag");
			my $prompts_answers = ['Enter a new password:'=> "$def_pass",'Enter it again:'=>"$def_pass"];
			my $output = $Api_Set_Obj->execute_raw_command('command' =>"security login password -username diag",'connectrec-match_table' => $prompts_answers); 
			if($output=~/different than last 6 passwords/i){
				change_diag_more_than_6_cmode(Node => $Node);
				$Api_Set_Obj->execute_raw_command('command' =>"security login unlock -username diag");
				my $prompts_answers = ['Enter a new password:'=> "$def_pass",'Enter it again:'=>"$def_pass"];
				my $output = $Api_Set_Obj->execute_raw_command('command' =>"security login password -username diag",'connectrec-match_table' => $prompts_answers); 
			}
			$Api_Set_Obj->execute_raw_command('command' =>"version");
		}catch NATE::BaseException with{
			logcomment("$FILER_C : Caught base exception, Connection problem");
		};
	}
}	
##########################################################################################################
# Author -  arjun.lavu@netapp.com
## Description : This subroutine sets the diag password 6 times with, that is useful in setting new password(CMODE)
##########################################################################################################
sub change_diag_more_than_6_cmode(){
	my (%opts) = validate(
        @_,
        {
            Node =>{ type => OBJECT},
		}
    );
	my @Nodes = $opts{Node};
	foreach my $Node(@Nodes){
		my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		for(0..6){
			my $temp = "temp_"."$$"."_"."$_";
			my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
			$Api_Set_Obj->execute_raw_command('command' =>"security login unlock -username diag");
			my $prompts_answers = ['Enter a new password:'=> "$temp",'Enter it again:'=>"$temp"];
	        $Api_Set_Obj->execute_raw_command('command' =>"security login password -username diag",'connectrec-match_table' => $prompts_answers); 
			sleep 5;
		}
	}
}	

#################################################################################################
### Author
###	Arjun Lavu
#################################################################################################
sub filer_disk_create(){
	my $params = NATE::ParamSet->new(global => 1);
	my $LOGDIR = $params->get('LOGDIR', default => undef);
	my $TEST_CONFIG = $params->get('TEST_CONFIG', default => undef);
	my $filer_state;
	if($TEST_CONFIG=~/E/gi){
		handle_run_local_error();
		my (%nodes_filer,$Nodes);
		my @Nodes_temp = NACL::C::Node->find();
		foreach my $Node (@Nodes_temp) {
			my $FILER_C = $Node->name();
			$nodes_filer{$FILER_C} = $Node;
		}
		my @Nodes = values(%nodes_filer);
		foreach my $node(@Nodes){
			my $FILER_C = $node->name();
			my $file_name= "$LOGDIR/../../../"."Pre_post_Drives_Details_"."$FILER_C";
			if(-e $file_name){
				logcomment("Already disk list file $file_name exist for the filer $FILER_C");
				return;
			}
		}	
		my %filer_vol;
		foreach my $node(@Nodes){
			my $FILER_C = $node->name();
			my $Transit_obj = NACL::Transit->new( name => $FILER_C );
			$filer_state = $Transit_obj->get_state('timeout' => 600);
			if($filer_state=~/CLI/){
				check_aggr_vol_offline(Node=>$node);
				my @arr = check_non_root_volumes(Node=>$node);
				if (@arr){
					$filer_vol{$FILER_C} = [@arr];
				}else{
					$filer_vol{$FILER_C} = undef;
				}
			}else{
				check_disk_owner( Noderef  => [@Nodes]);
			}
		}
		if($filer_state=~/CLI/){
			my @keys = keys %filer_vol;
			if((defined $filer_vol{$keys[0]})&&(defined $filer_vol{$keys[1]})){
				disk_remv_assign_ownership(Node_ref =>[@Nodes]);
			}else{
				logcomment("Either one or two nodes doesn't have volumes");
				logcomment("Deleting all the aggregates and assigning spares between the systems");
				disk_remv_assign_ownership(Node_ref =>[@Nodes],delete_aggr => 'yes');
			}
			foreach(@Nodes){
				logcomment("Checking for aggregates which doesn't have any volume and deleting them");
				delete_aggregates_with_no_volumes(Node => $_);
			}
			my @subtests;
			foreach my $Node(@Nodes){
				my $FILER_C = $Node->name();
				push(@subtests,	subtest(\&check_recons_sickdisk, -runid, "check_recons_sickdisk_$FILER_C", -bg,"--", Node =>$Node));
			}
			Subtest::wait_finish(subtest => [@subtests]);
		}else{
			disk_remv_assign_ownership(Node_ref =>[@Nodes]);
		}
		# check_disk_owner( Noderef  => [@Nodes]) if ($filer_state=~/MAINT/); ##call only for MAINT MODE as of now
		# disk_remv_assign_ownership(Node_ref =>[@Nodes]);
		logcomment("Current logdir is $LOGDIR");
		my $API_obj;
		my @drives;
		foreach my $node(@Nodes){
			my $FILER_C = $node->name();
			my $Transit_obj = NACL::Transit->new( name => $FILER_C );
			my $filer_state = $Transit_obj->get_state('timeout' => 600);
			if($filer_state=~/MAINT/g){
				my $FILER_C = $node->name();
				my $Host = host($FILER_C);
				$API_obj = NACL::APISet->new(
					hostobj   => $Host,
					category  => "Node",
					interface => "CLI",
					set       => "Maintenance"
				);
				$API_obj->set_timeout( "connectrec-timeout" => 1200 );
				@drives = @{disk_show_drive_maint(API_Obj =>$API_obj,Filer=>$FILER_C)->{'driveA'}};
			}else{
				$API_obj = $node->get_7m_or_nodescope_apiset(connid=> "console");
				$API_obj->set_timeout( "connectrec-timeout" => 1200 );
				@drives = get_disks_list(Node =>$node,FILER => $FILER_C);
				@drives = sort {	if(($a=~/P\d+/)&&($b!~/P\d+/)){
										return 1;
									}elsif(($a!~/P\d+/)&&($b=~/P\d+/)){
										return -1;
									}elsif(($a=~/P\d+/)&&($b=~/P\d+/)){
										my($tst1)=$a=~/P(\d+)/;
										my($tst2)=$b=~/P(\d+)/;
										return $tst1 <=> $tst2;
									}else{
										return $a <=> $b;
									}
								}@drives;
			}
			
			logcomment("$FILER_C : Number of drives assigned are :: @drives");
			my $file_name= "$LOGDIR/../../../"."Pre_post_Drives_Details_"."$FILER_C";
			open(FH,">$file_name")|| print "WARNING cannot create file $file_name";
			foreach my $line(@drives){
				if ($line =~ /(^\s+$)|(^\.+$)/g) {
					next;
				}
				print(FH "$line \n");
			}
			close FH;
		}
	}else{
		logcomment("Test-config is not equal to E");
	}
}

######################
#Author -- Arjun Lavu
######################

sub check_disk_owner{
	my (%opts) = validate(
        @_,
        {
            Noderef  => { type => ARRAYREF},
		}
    );
	my @Nodes = @{$opts{Noderef}};
	my $Mode = $Nodes[0]->mode();
	foreach my $Node (@Nodes){
		my $FILER_C = $Node->name();
		my $host = host($FILER_C);
		my $Transit_obj = NACL::Transit->new( name => $FILER_C );
        my $filer_state = $Transit_obj->get_state('timeout' => 600);
		my $API_Object;
		if($filer_state=~/MAINT/){
			$API_Object = NACL::APISet->new(
                            hostobj   => $host,
                            category  => "Node",
                            interface => "CLI",
                            set       => "Maintenance",
						);
			$API_Object->set_timeout( "connectrec-timeout" => 1200 );
		}elsif($filer_state=~/CLI|UP/i){
			$API_Object = $Node->get_7m_or_nodescope_apiset();
			$API_Object->set_timeout( "connectrec-timeout" => 1200 );
		}
		my @arr_get_disks = get_disk_information(API_Obj =>$API_Object,Filer =>$FILER_C);
		@arr_get_disks =  sort @arr_get_disks;
		logcomment("Number of drives from disk show -s command are ".scalar @arr_get_disks." and the drives are @arr_get_disks");
		my @drives_disk_show_a = @{disk_show_drive_maint(API_Obj => $API_Object,Filer => $FILER_C)->{'driveA'}}; 
		@drives_disk_show_a =  sort @drives_disk_show_a;
		logcomment("Number of drives from disk show -a command are ".scalar @drives_disk_show_a." and the drives are @drives_disk_show_a");
		if(scalar @arr_get_disks!= scalar @drives_disk_show_a){
			if(scalar @arr_get_disks > scalar @drives_disk_show_a){
				my @diff = array_diff(\@arr_get_disks,\@drives_disk_show_a);
				logcomment("$FILER_C  : In disk show -a command owner name is missing for the drives @diff");
				# logcomment("$FILER_C : Removing the disk ownership and assigning in a proper way");
				$API_Object->set_timeout("connectrec-timeout" => 600);
				my $system_id = sysconfig_v_data(node =>$Node, API_Obj =>$API_Object)->{'system_id'};
				# $API_Object->execute_raw_command('command' => "storage release disks -f");
				$API_Object->execute_raw_command('command' => "disk remove_ownership all -f");
				sleep 60;
				$API_Object->execute_raw_command('command' => "disk remove_ownership all -f");
				disk_remv_assign_ownership(Node_ref =>[@Nodes]);
			}	
			last;
		}
	}
}	

#################################################################################################
### Author
###	Arjun Lavu
## diference in two arrays
#################################################################################################
sub array_diff{
    my %e = map { $_ => undef } @{ $_[1] };
    return @{
        [
            ( grep { ( exists $e{$_} ) ? ( delete $e{$_} ) : (1) } @{ $_[0] } ),
            keys %e
        ]
    };
}


#################################################################################################
### Author
###	Arjun Lavu
### Description:: Remove the partition drives in maintenance mode and return 1 if partition is done
#################################################################################################
sub remove_partition{
	my (%opts) = validate(
        @_,
        {
            Noderef  => { type => ARRAYREF},
		}
    );
	my @Nodes = @{$opts{Noderef}};
	my $Mode = $Nodes[0]->mode();
	my $FILER_C = $Nodes[0]->name();
	my $FILER_D = $Nodes[1]->name();
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $Transit_obj_two = NACL::Transit->new( name => $FILER_D );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	my $filer_state1 = $Transit_obj_two->get_state('timeout' => 600);
    logcomment("$FILER_C : Filer is in $filer_state ");
	if($filer_state!~/MAINT/i){
		logcomment("$FILER_C : Filer is  not in required mode, Changing state to MAINT");
		$Transit_obj->change_state( to => "MAINT");
	}
	if($filer_state1!~/MAINT/i){
		logcomment("$FILER_D : Filer is in required mode, Changing state to MAINT");
		$Transit_obj_two->change_state( to => "MAINT");
	}
	$filer_state = $Transit_obj->get_state('timeout' => 600);
	my ($API_Object,$data,@disk_part);
	if($filer_state=~/MAINT/){
		my $host = host($FILER_C);
        $API_Object = NACL::APISet->new(
                            hostobj   => $host,
                            category  => "Node",
                            interface => "CLI",
                            set       => "Maintenance",
                            );
		$data = $API_Object->execute_raw_command('command' => "disk show -v");
		$API_Object->set_timeout("connectrec-timeout" => 600);
	}elsif(($filer_state=~/CLI/)&&($Mode=~/CMode/i)){
		$API_Object = $Nodes[0]->get_7m_or_nodescope_apiset(connid => "console");
		$API_Object->set_timeout("connectrec-timeout" => 600);
		$data = $API_Object->execute_raw_command('command' => "disk show -v");
	}
	
	my @data=split(/\n/,$data);
	foreach my $line(@data){
		if ($line =~ /(\S+)\s+\S+\s*\(\d+/){
			my $disk = $1;
			if($disk=~/P\d+$/){
				push(@disk_part, $disk );
			}
		}
	}
	foreach my $Node (@Nodes) {
		my $FILER_C = $Node->name();
		logcomment("$FILER_C : Checking the partitioned drives un-owned pool");
		my $return = disk_show_n(Node=>$Node);
		if(keys %{$return}){
			push(@disk_part, keys %{$return});
		}
	}	
	if(@disk_part){
		my (%filter,%FILER_API);
		logcomment("$FILER_C : Partitioned drives found on the system and the drives are ". scalar @disk_part." and the drives are @disk_part");
		logcomment("$FILER_C : Changing state to MAINTENANCE Mode");
		$Transit_obj->change_state( to => "MAINT");
		logcomment($Nodes[1]->name()." : Changing state to MAINTENANCE Mode");
		$Transit_obj_two->change_state( to => "MAINT");
		foreach my $Node (@Nodes) {
			my $FILER_C = $Node->name();
			logcomment(" Creating API object for filer - $FILER_C");
			my $Host = host($FILER_C);
			my $console = Tharn::connect("$FILER_C#console");
			# Set the properties for the Connectrec used for creating the APIset
			$console->{prompts} = [qr/\*>/];
			$console->{max_idle} = 300;
			$console->{on_idle} = sub { $console->execute(""); };
			my $API_obj = NACL::APISet->new(connection => $console,
											category => "Node",
											interface => "CLI",
											set => "Maintenance");
			$FILER_API{$FILER_C} = $API_obj;
		}
		logcomment("Assigning all the drives from ".$Nodes[1]->name()." to ".$Nodes[0]->name());
		disk_remv_assign_ownership(Node_ref =>[@Nodes],assign_disk_to =>$Nodes[0], remove_disk_from => $Nodes[1]);
		my $return = disk_show_drive_maint(API_Obj => $API_Object,Filer => $FILER_C);
		my @drives = @{$return->{'driveA'}}; 
		foreach my $var (@drives){
			$var =~s/^\s|\s+$//g;
			if($var=~/P\d+$/){
				$var=~s/P\d+$//g;
				$filter{$var}=undef;
			}
		}
		my $prompts_answers = ["Abort unpartition"=> 'n'];
		my @partitioned = keys %filter;
		logcomment("Unpartitioning the drives @partitioned");
		foreach(keys %filter){
			logcomment("$FILER_C : unpartitioning the drive $_");
			$API_Object->execute_raw_command('command' =>"disk unpartition $_",'connectrec-match_table' => $prompts_answers);
		}
		disk_remv_assign_ownership(Node_ref =>[@Nodes]);
		return 1;
	}else{
		logcomment("No partitioned drives found on the system");
		return 0;
	}
}


sub boot_it_good_Maint {
    my (%opts) = validate(
        @_,
        {
            Test  => { type => OBJECT },
            Filer => { type => SCALAR },
        }
    );
    my $Test  = $opts{Test};
    my $filer = $opts{Filer};

    my $filer_state;
    my $Transit_obj;
    logcomment("Boot to Maintenance mode");
    $Transit_obj = NACL::Transit->new( name => $filer );
    $filer_state = $Transit_obj->get_state('timeout' => 600);
    if ( ( $filer_state =~ /^(CLI|FIRMWARE|BOOT_MENU|HALTED|CFE_BANNER|LOADER_BANNERFIRMWARE)/ ) || ( $filer_state !~ /MAINT/ ) )
    {
        $Transit_obj->change_state( to => "MAINT" );
    }
    $filer_state = $Transit_obj->get_state('timeout' => 600);
    if ( $filer_state !~ /^(MAINT)/ )
    {
        $Transit_obj->change_state( to => "MAINT" );
    }
}

##########################################################################################################
# Auther - arunak
# Description - returns hash consisting data of all disk attached, like block, disk name, type etc..
# Supported - CMode - Maint 
# Usage - Mandatory - API, 
##########################################################################################################
sub disk_list_data {
    my (%opts) = validate(
        @_,
        {
            API_Obj => { type => OBJECT },
        }
    );
    my $Api_Set_Obj  = $opts{API_Obj};
	my $Mode = $opts{mode};
	my $dsk_output =  $Api_Set_Obj->execute_raw_command( 'command' => "disk_list" );
	my $dsk_result = {};
	my @lines  = split( /\n/, $dsk_output );
	my $n      = 0;
	while ( $n <= $#lines ) {
		last if ( $lines[$n] =~ /^-----/ );
		$n++;
	}
	$n++;
	foreach my $line ( @lines[ $n .. $#lines ] ) {
		my (
			$disk,     $chan, $ven,    $prodid, $rev,
			$serialno, $hw,   $blocks, $bps,    $dq
		)  = ( $line =~/(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/);
		if ( ( $line =~ /\d\w\.\d\d/ ) || ( $line =~ /\d\w\.\d\d\.\d\d/ ) ) {
			$dsk_result->{$disk} = {
				'DISK'       => $disk,
				'CHAN'       => $chan,
				'VENDOR'     => $ven,
				'PRODUCT_ID' => $prodid,
				'REV'        => $rev,
				'SERIAL'     => $serialno,
				'HW'         => $hw,
				'BLOCKS'     => $blocks,
				'BPS'        => $bps,
				'DQ'         => $dq
			};
		}
	}
	return $dsk_result;
}


#######################################################################################################
# Auther - arjun.lavu@netapp.com
# Description - disk list command for Cmode
# Usage - Mandatory paramanter - Node
# Supported Mode - CMode (CLI/UP and MAINT) 
# Return - array of disks attached
#######################################################################################################
sub get_disks_list {
	my (%opts) = validate(
    @_,
		{
			Node => { type => OBJECT },
			FILER =>{ type => SCALAR,default=>undef, optional => 1 },
		}
	);

    my $Node=$opts{Node};
	my $filer_passed = $opts{FILER};
    my $FILER_C = $Node->name();
	my @disk_list = ();
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
    logcomment("Filer state $filer_state");
    if ($filer_state =~ /MAINT/){
      	@disk_list = list_of_disk( Node => $Node );
    } else {
		try {	
			logcomment("getting the drives which belongs to filer $filer_passed");
			my %hash;
			%hash = (filter => {'owner'=>$filer_passed})if(defined $filer_passed);
            my @disk_obj = NACL::C::StorageDisk->find(
                command_interface => $Node,
                %hash,
            );
            foreach my $state_obj (@disk_obj) {
                my $free_disk = $state_obj->disk();
                push( @disk_list, $free_disk );
            }
			logcomment("Total number of container drives are ".scalar @disk_list." and the drives are @disk_list")if(@disk_list);
			logcomment("No container drives are available")if(!@disk_list);
        }catch NACL::Exceptions::NoElementsFound with {
            logcomment("No disks found from the filer $FILER_C");
        };
		my @disk_partitioned;
		try{
			my %hash;
			%hash=(filter => { "owner-node-name" => $filer_passed}) if(defined $filer_passed);
			logcomment("Checking for partitioned drives if present");
			my @disk_obj = NACL::CS::StorageDiskPartition->fetch(
				command_interface => $Node,
				%hash,
			);
			foreach my $state_obj (@disk_obj){
				my $free_disk = $state_obj->partition();
				push( @disk_partitioned,$free_disk);
			}
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("No partitioned drives found in the filer $FILER_C");
		};
		if(@disk_partitioned){
			logcomment("Total number partitioned drives are ".scalar @disk_partitioned." and the drives are @disk_partitioned");
			push(@disk_list,@disk_partitioned);
		}
    }
	return @disk_list;
}


sub trim($) {
    my $string = shift;
    $string =~ s/^\s+|\s+$//gm;
    return $string;

}


#########################
##Author - Arjun Lavu
#########################

sub create_aggr_volume{
	my (%opts) = validate(
		@_,
			{	Node => { type => OBJECT },
				disk_list =>{ type =>ARRAYREF},
				size => {type =>SCALAR,optional => 1, default => '90'},
				partition =>{type => SCALAR,optional => 1, default => 'no'},
			}
		);
	my %hash;
	my %size;
	my $stask_vol;
	my $aggr_size;
	my $vol_size;
	my $node = $opts{Node};
	my $filer = $node->name();
	my @spares = @{$opts{disk_list}};
	my $Mode = $node->mode();
	my @spares_t = @spares;
	my $aggr_flag=0;
    while (@spares_t) {
		if($aggr_flag==0){
			# logcomment("spares :: $AGGR_CNT->{$filer}  @spares_t");
			if((defined $AGGR_CNT->{$filer})&&(@spares_t >=$AGGR_CNT->{$filer})){
				logcomment("$filer : Total number of aggregates already present in the filer are ".$AGGR_CNT->{$filer}." so leaving the spares ".$AGGR_CNT->{$filer}." before creating aggregates from the available spares ".scalar @spares_t);
				for((1..$AGGR_CNT->{$filer})){
					shift(@spares_t);
				}
			}
			$aggr_flag=1;
		}
		my $disk_max_sup = 13;
		my $temp_disk;
        my $loop_no     = 0;
        my @disk_list_q = ();
        while ($loop_no < $disk_max_sup) {
            $temp_disk = pop(@spares_t);
            push(@disk_list_q, $temp_disk);
            $loop_no++;
            last if (!(@spares_t));
        }
		
		my $spare_cnt = scalar @disk_list_q;
		if(@disk_list_q>3){
			my $left = shift(@disk_list_q);
			logcomment("$filer : leaving drive : $left in the spare pool to avoid potential errors");
			logcomment("Spares using to create aggregate are : ".scalar @disk_list_q." and the spares are @disk_list_q");
			if($opts{partition}=~/yes/i){
				%hash = (partitionlist =>[@disk_list_q]);
			}else{
				# %hash = (disklist =>[@disk_list_q]);
				%hash = (diskcount => scalar @disk_list_q,node => $filer);
			}	
		}else{
			logcomment("No enough spares are available to create aggregate");
			return;
		}
		my $num = 0;	
		my $vserver_name;
		my $append_name = $filer;
		if($filer=~/\-/){
			$append_name =~s/\-/_/g;
		}
		my @temp;
		my $agg="aggr_"."$append_name"."_1";
		my $job;
		my @aggrs = NACL::C::Aggregate->find( command_interface => $node,filter => {nodes => [$filer]} );
		my (@aggr_names,$num_aggr,@n_aggr,%num_obj);
		
		foreach my $aggr (@aggrs) {
			my $ag = $aggr->get_one_state_attribute('aggregate');
			push(@aggr_names,$ag);
			if ( $ag =~/(\d+)$/g ) {
				push(@n_aggr,$1);
				$num_obj{$1}=$aggr;
			}
		}
		@n_aggr = sort{$a<=>$b}@n_aggr;
		my $aggr_obj;
		$num_aggr = $n_aggr[-1]; ##the value will have maximum digit value
		logcomment("Current max suffix value of aggregates : $num_aggr");
		$aggr_obj = $num_obj{$num_aggr};
		logcomment("$filer : Total number of aggregates present in the system are ".scalar @aggr_names." and the aggregates are @aggr_names");
		$AGGR_CNT->{$filer} = scalar @aggr_names;
		
		
		my (@vol_names,$num_vol);
		my @vol = NACL::C::Volume->find( command_interface => $node,filter => {node => $filer} );
		foreach my $vols (@vol) {
			my $vg = $vols->get_one_state_attribute('volume');
			push(@vol_names,$vg);
			if ( $vg =~/(\d+)$/g ) {
				if ( $num_vol < $1 ) {
					$num_vol = $1;
				}
			}
		}
		logcomment("$filer : Total number of volumes present in the system are ".scalar @vol_names." and the volumes are @vol_names");
		
		my $vol_flag = 0;
		my $other_vol_flag = 0;
		if(defined $aggr_obj){
			my $agg_test = $aggr_obj->get_one_state_attribute('aggregate');
			logcomment("Finding the number of volumes present in the aggregate $agg_test");
			my @aggr_obj;
			try{
				@aggr_obj = $aggr_obj->get_volumes();
			}catch NATE::BaseException with {
				logcomment("No Volumes found in the aggregate $agg_test");
				$vol_flag = 1;
			};
			foreach my $vol_obj(@aggr_obj){
				my $vol_test = $vol_obj->get_one_state_attribute('volume');
				logcomment("Volume present on the aggregate $agg_test are : $vol_test");
				$vol_test=~s/^\s+|\s+$//g;
				if($vol_test=~/volvs/i){
					logcomment("$filer : Vsever volume volvs found on the aggregate $agg_test");
					$vol_flag = 1;
				}elsif($vol_test=~/vol0/i){
					logcomment("$filer : Root volume found on the aggregate $agg_test");
					$other_vol_flag = 1;
				}else{	
					logcomment("$filer : Volume found with the name $vol_test on the aggregate $agg_test ");
					$other_vol_flag = 1;
				}
			}
		}
		my $aggr_ret_flag=0;
		# $num = $num_aggr; 
		$num = $num_aggr+1;
		# if(($vol_flag)&&(!$other_vol_flag)&&($num_vol!=$num_aggr)){
			# $num = $num_aggr ;
		# }else{
			# $num = $num_aggr+1;
		# }
		logcomment("the number will get appended is to the aggregate name is : $num ");
		try{
			$agg  = "aggr_"."$append_name"."_"."$num";
			my $stask_aggr_obj = NACL::STask::Aggregate->create(
				command_interface => $node,
				aggregate         => $agg,
				nacltask_if_exists => 'reuse',
				nacltask_wait      => '1',
				job_component     => \$job,
				polling_interval => '600',
				%hash,
			);
			#'allow-mixed-rpm'  =>'true',
		}catch NACL::APISet::Exceptions::CommandFailedException with {
			if(!$AGGR_CREATE_CNTR){
				$AGGR_CREATE_CNTR++;
				logcomment("**WARNING** :: $filer : $agg reached unexpected state, checking and creating again");
				create_flex_vol(Node => $node);
			}else{
				logcomment("**WARNING** :: $filer : script tries to create aggregate $agg two times but failed");
				$aggr_ret_flag = 1;
			}
			# logcomment("WARNING : Couldn't create aggregate");
			
		}catch NACL::Exceptions::UnexpectedState with{
			if(!$AGGR_CREATE_CNTR){
				$AGGR_CREATE_CNTR++;
				logcomment("**WARNING** : $filer : $agg reached unexpected state, checking and creating again");
				create_flex_vol(Node => $node);
			}else{
				logcomment("**WARNING** : $filer : script tries to create aggregate $agg two times but failed");
				$aggr_ret_flag=1;
			}
			
		}; 	
		if($aggr_ret_flag ==1){
			logcomment("**WARNING** : $filer : Could not create aggregate $agg");
			return undef;
		}
		my $skip=0;
		{
			my $root         = "volvs";
			my $aggr_v       = "$agg";
			my $ns           = "file";
			my $sec          = "mixed";
			my $vser_flag = 0;
			$vserver_name = "vser_$filer";
			try{
				my $name = NACL::STask::Vserver->find(
					command_interface => $node,
					filter            => { vserver => $vserver_name},
				);
				if( $name->get_one_state_attribute("vserver") =~ /^($vserver_name)$/ ) {
					my $vol = $name->get_one_state_attribute("rootvolume");
					logcomment("Vserver root volume is $vol");
					$vol=~s/^\s+$//;
					if(($vol =~/^\-$/g)||(!$vol)){
						logcomment("For vserver : $vserver_name : no volume is there");
						logcomment("Deleting the vserver $vserver_name");
						$name->purge();	#deleting the Vserver if no volume present for the Vserver
						$vser_flag = 1;
					}
				} 
			}catch NACL::Exceptions::NoElementsFound with{
				logcomment("No vserver found with the name $vserver_name");
				$vser_flag = 1;
			};
			if($vser_flag == 1){
				
				try{
						my $vserver_obj  = NACL::STask::Vserver->create(
						command_interface           => $node,
						vserver                     => $vserver_name,
						nacltask_if_exists          => 'reuse',
						rootvolume                  => $root,
						aggregate                   => $aggr_v,
						"ns-switch"                 => $ns,
						"rootvolume-security-style" => $sec
					);
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					if(!$AGGR_CREATE_CNTR){
						$AGGR_CREATE_CNTR++;
						logcomment("$filer : $vserver_name : Could not create vserver, checking and creating again");
						create_flex_vol(Node => $node);
					}else{
						logcomment("**WARNING** :: $filer : script tried to create vserver $vserver_name two times but failed");
						logcomment("**WARNING** : Could not create vserver $vserver_name, returning from the subroutine");
						$skip=1;
					}
				};	
				
			}	
		}
		return undef if($skip);
	#___---___---___---____---___---____---____---______---____---_____---____---______
	
	##Calculating the aggregate size and calculating the volume size to create on the aggregate based on the user input
		my @aggrs = NACL::C::Aggregate->find(
							command_interface => $node,
						);
		foreach my $aggr (@aggrs) {
			my $name = $aggr->aggregate();
			if($name eq $agg ){
				$aggr_size = $aggr->get_one_state_attribute('availsize');
				logcomment("Initial aggregate size $aggr_size bytes");
				$aggr_size = int($aggr_size/(1024*1024));
				logcomment("Total size of aggregate $agg in MB is $aggr_size MB"); 
			}
		}
		if($aggr_size== 0){
			logcomment("**WARNING** : total size of aggregate : $agg : is zero , so cannot create volumes on this aggregate");
			return;
		}
		my $vol_size = 90;
		{
			if(($vol_size)>100){
				logcomment("Size of Volume cannot be created more than the Aggregate size so making the size of volume equal to 100% of Aggreagte");
				$vol_size = 100;
			}
			my $required_size = int(($vol_size/100)*$aggr_size);
				if($required_size > 50000000){
						logcomment("Volume size is coming more than 50TB, so restricting the volume size to 50TB");
						$required_size = '50000000';
				}
			$required_size = $required_size."m";		##treating in MB's
			logcomment("Size of volume which will get created on aggregate $agg is $required_size"); 
			%size = (size => $required_size);
		}
	#___---___---___---____---___---____---____---______---____---_____---____---______
	
		my $vol_name  = "vol_"."$append_name"."_"."$num";
		if ( $Mode eq 'CMode' ) {
			$stask_vol = NACL::STask::Volume->create(
			command_interface => $node,
			vserver           => $vserver_name,
			volume            => $vol_name,
			nacltask_if_exists => 'reuse',
			nacltask_wait      => '1',
			aggregate         => $agg,
			if_exists         => "reuse",
			%size,
			);
		}
		my $Api_Set_Obj = $node->get_7m_or_nodescope_apiset();
		logcomment("Checking volume status");
		$Api_Set_Obj->execute_command('command' => "vol status");
		logcomment("Checking aggregate status");
		$Api_Set_Obj->execute_command('command' => "aggr status");
	}
}


#######################################################################################################
# Auther - vpankaj@netapp.com
# Description - version command for Cmode
# Usage - Mandatory paramanter - Node
# Supported Mode - CMode (CLI/UP)
# Return - Status
#######################################################################################################
sub display_version{
     my (%opts) = validate(
        @_,
        {
            Node     => { type => OBJECT },
        }
        );
    my $Node    = $opts{Node};
    my $FILER_C = $Node->name();
    my $Host = host($FILER_C);
    my $Transit_obj = NACL::Transit->new( name => $FILER_C );
    my $filer_state = $Transit_obj->get_state('timeout' => 600);
    logcomment("Node $Node is in the Filer state $filer_state");
    my $node_version;
	if ($filer_state =~/UP|CLI/i) {
                         my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
						 $Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
                        $node_version = $Api_Set_Obj->execute_command('command' => 'version');
						if ($node_version =~ /<1d>/i)
						{
							logcomment("DEBUG kernel : $node_version");
						}
						else
						{
                            logcomment("NON-DEBUG kernel : $node_version");
                        }
                } elsif ($filer_state =~/MAINT/i) {
                        my $API_Object = NACL::APISet->new(
                                        hostobj   => $Host,
                                        category  => "Node",
                                        interface => "CLI",
                                        set       => "Maintenance"
                                        );
						$API_Object->set_timeout( "connectrec-timeout" => 1200 );				
                        $node_version = $API_Object->execute_raw_command( command => "version" );
						if ($node_version =~ /<1d>/i)
                        {
                            logcomment("DEBUG kernel : $node_version");
                        }
                        else
                        {
                            logcomment("NON-DEBUG kernel : $node_version");
                        }
                }

     if ( $node_version ne '' ) {
            logcomment("FILER - $FILER_C  version : $node_version");
            return 0;
     } else {
            logcomment("Version command failed for filer $FILER_C");
            return 1;
     }
}


###########################################
##
## @Author - Arjun
## Description :  Delete the aggregates with no volumes
##
###########################################

sub delete_aggregates_with_no_volumes{
	my (%opts) = validate(
        @_,
			{
				Node => { type => OBJECT }
			}
		);
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	my @aggrs = NACL::C::Aggregate->find( command_interface => $Node,filter => {nodes => [$FILER_C]} );
	my @aggr_names;
    foreach my $aggr (@aggrs) {
        my $ag = $aggr->get_one_state_attribute('aggregate');
		push(@aggr_names,$ag);
    }
	logcomment("$FILER_C : Total number of aggregates present in the system are ".scalar @aggr_names." and the aggregates are @aggr_names");
	foreach my $aggr_obj (@aggrs) {
		my $vol_flag = 0;
		my $agg_test = $aggr_obj->get_one_state_attribute('aggregate');
		logcomment("Trying to find the volumes present in the aggregate $agg_test");
		my @vol_obj;
		try{
			my @volu;
			@vol_obj = $aggr_obj->get_volumes();
			foreach(@vol_obj){
				push(@volu,$_->get_one_state_attribute('volume'));
				logcomment("$FILER_C : Volumes present in the aggragate $agg_test are : @volu");
			}
		}catch NATE::BaseException with {
			logcomment("$FILER_C : No Volumes found in the aggregate $agg_test, So deleting the aggregate");
			$vol_flag = 1;
		};
		if($vol_flag){
			try{ 
				NACL::STask::Aggregate->purge(
				command_interface => $Node,
				aggregate         => $agg_test,
				nacltask_verify=>  1,);  
			}catch NACL::Exceptions::NoElementsFound with {
				logcomment("Inside catch NACL::Exceptions::NoElementsFound with");
				logcomment("$FILER_C : WARNING : Cannot delete the aggregate $agg_test ");
			}catch NACL::APISet::Exceptions::CommandFailedException with{
				try{
                    NACL::STask::Aggregate->purge(
                    command_interface => $Node,
                    aggregate         => $agg_test,
                    nacltask_verify=>  1);
                }catch NACL::APISet::Exceptions::CommandFailedException with{
                    logcomment("$FILER_C : WARNING : Cannot delete aggregate $agg_test");
                };
			}catch NACL::Exceptions::VserverHasVolumesOnAnotherAggregate with{
				logcomment("$FILER_C :WARNING : Cannot delete aggregate $agg_test ");
			};
		}
	}
}	


#############################################
## himangin@netapp.com
## The subroutine will check for chassis and controller HA and Non-Ha configurations during initialization
## No return value, called in support scripts
#############################################

sub HA_config {
	my (%opts) = validate(
    @_,
       {
		API_Obj => { type => OBJECT}
       }
    );
	my $Api_Set_Obj = $opts{API_Obj};
	my $FILER_C = $Api_Set_Obj->get_name();
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	my $config;
	if($filer_state=~/CLI/){
		$config = $Api_Set_Obj->execute_command(command => "ha-config show");
	}else{
		$config = $Api_Set_Obj->execute_raw_command(command => "ha-config show");
	}
    my @array;
    foreach (split (/\n/,$config)){
        if ($_ =~ /(Chassis|Controller)(.*)\:\s*(\S+)/){
                push (@array , $3);
        }
    }
    if ($array[0] eq $array[1]){
		logcomment ("$FILER_C : Chassis and controller are configured same");
    } else {
        logcomment ("**WARNING** : $FILER_C : Chassis and controller are not configured same. Modifying chassis and controller to same configuration");
        my $prompts_answers = [".*Do you want to continue??.*" => 'y'];
		if($filer_state=~/CLI/){
			$Api_Set_Obj->execute_command(command => "ha-config modify controller ha", 'connectrec-match_table' => $prompts_answers);
			$Api_Set_Obj->execute_command(command => "ha-config modify chassis ha", 'connectrec-match_table' => $prompts_answers);
		}else{
			$Api_Set_Obj->execute_raw_command(command => "ha-config modify controller ha", 'connectrec-match_table' => $prompts_answers);
			$Api_Set_Obj->execute_raw_command(command => "ha-config modify chassis ha", 'connectrec-match_table' => $prompts_answers);
		}
    }
}

sub eye_catcher{
    my (%opts) = validate(
        @_,
        {
            Test  => { type => OBJECT},
			string =>{type => SCALAR ,default => undef, optional => 1 },
		}
    );
    my $Test = $opts{Test};
    my $string = $opts{string};
    $Test->nlog("=====================================================================================================");
    $Test->nlog("=== $string");
    $Test->nlog("=====================================================================================================");
}

##Arjun Lavu
sub create_flex_vol {
	my (%opts) = validate(
        @_,
        {	Node => { type => OBJECT },
			disk_list =>{ type =>ARRAYREF,optional => 1, default => undef},
			size => {type =>SCALAR,optional => 1, default => '90'},
			
		});
	my $node = $opts{Node};
	my $filer=$node->name();
	my %hash;
	my %size;
	my $stask_vol;
	my $aggr_size;
	my $vol_size;
	my(@spares,@normal_spares);
	check_aggr_vol_offline(Node=>$node);
	@spares = @{$opts{disk_list}} if (defined $opts{disk_list});
	if(@spares){
		logcomment("$filer : Spare drives which passed from the script to create aggregate are ". scalar @spares ." and the drives are @spares");
	}else{
		@spares = spare_count_cmode(Node =>$node );
	}
	logcomment("Total spare drives are : ".scalar @spares." and the spare drives are :: @spares");
	my(%part_spares);
	foreach(@spares){
		if($_=~/(P\d+)$/){
			push(@{$part_spares{$1}},$_);
		}else{
			push(@normal_spares,$_);
		}
	}
	my @partitions = keys %part_spares;
	if(@partitions){
		logcomment("Number of partitions present are :: @partitions");
		foreach(@partitions){
			logcomment("Number of drives present under the partition $_ : are ". scalar @{$part_spares{$_}}." and the drives are @{$part_spares{$_}}");
			if(@{$part_spares{$_}}<4){
				logcomment("$filer : Cannot create aggregate for the partiton drives $_, because number of spare are less than 4");
				next;
			}else{
				create_aggr_volume(Node => $node,disk_list =>$part_spares{$_},size =>$opts{size},partition=>'yes');
			}
		}
	}
	if(@normal_spares){
		if(@normal_spares<4){
			logcomment("$filer : Cannot create aggregate, because spare drives are are less than 4");
		}else{
			# logcomment("Creating volumes with the drives ". scalar @normal_spares." and the drives are @normal_spares");
			create_aggr_volume(Node => $node,disk_list =>[@normal_spares],size =>$opts{size});
		}
	}
}

sub fcadmin_fcal_stats {
   	my (%opts) = validate(@_,
		{
			Node     => { type => OBJECT },
			channel_name   => {type=>SCALAR, default=>undef, optional=>1},
		}
	);
	my $Node = $opts{Node};
	my $API_obj;
	my $FILER_C = $Node->name();

    my $cmd = "fcadmin fcal_stats $opts{channel_name}";
	my $output = "";
	
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
    my $cmd = "fcadmin link_stats $opts{channel_name}";
	if($filer_state=~/MAINT/gi){
		my $Host = host($FILER_C);
		$API_obj = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance"
		);
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $API_obj->execute_raw_command('command' => "$cmd");
	}elsif($filer_state=~/(CLI|UP)/gi){
		$API_obj = $Node->get_7m_or_nodescope_apiset();
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $API_obj->execute_command('command' => "$cmd");
	}
	my %HoH =();
    if ($output =~ /fcadmin fcal_stats: No such channel/) {
        if($opts{channel_name}){
			logresult('FAIL',"No channel found");
			return \%HoH;
		}
    }
    my @lines = split(/\r*\n/, $output);
    my ($slot_name, @mailbox_fields, @device_fields);
    foreach (@lines) {
        #Get the slot
        if($_ =~ /driver statistics for slot (\w+)/) {
            $slot_name = $1;
        }
        #Get adapter-related information
        elsif($_ =~ /adap_/) {
            $_ =~ s/^\s+//;
            my @adap_fields = split(/:\s*/, $_);
            $adap_fields[1] =~ s/\s+//;

            $HoH{$slot_name}{$adap_fields[0]} = $adap_fields[1];
        }
        #Get mailbox-related information
        elsif($_ =~ /mailbox status: (.*)/) {
            @mailbox_fields = split(/\s+/, $1);
        }
        elsif(($_ =~ /(issued)(.*)/) || ($_ =~ /(failed)(.*)/) || ($_ =~ /(timed out)(.*)/)) {
            my $mailbox_status = "mailbox_".$1;
            my $mailbox_status_fields = $2;
            $mailbox_status =~ s/\s+//;
            $mailbox_status_fields =~ s/\s+//;
            my @fields = split(/\s+/, $mailbox_status_fields);
          my $count;
            for($count = 0 ; $count < @mailbox_fields ; $count++) {
                my $mailbox_name = $slot_name."\.".$mailbox_fields[$count];

                $HoH{$mailbox_name}{$mailbox_status} = $fields[$count];
            }
        }
        #Get device-related information
        elsif($_ =~ /device status:\s+(.*)/) {
            @device_fields = split(/\s+/, $1);
        }
        elsif($_ =~ /device_/) {
            my ($device_status, @fields);
            $_ =~ s/^\s+//;
            if($_ =~ /^\w+:/) {
                $_ =~ /(\w+:?\s*\d*)\s+(.*)/;
                $device_status = $1;
                @fields = split(/\s+/, $2);
            }
            else {
                $_ =~ /(\w+)\s+(.*)/;
                $device_status = $1;
                @fields = split(/\s+/, $2);
            }
            my $count = 0;
            for($count = 0 ; $count < @device_fields ; $count++) {
                my $device_name = $slot_name."\.".$device_fields[$count];

                $HoH{$device_name}{$device_status} = $fields[$count];
            }
            my $total = $device_status."_total";
            $HoH{$slot_name}{$total} = $fields[$count+1];
        }
    }
    return \%HoH;
}

##########################################################################################################
# Author -arjun.lavu@netapp,com
##########################################################################################################
sub disk_show_v {
        my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT },
        }
    );
 
	my $Node=$opts{Node};
    my $Mode = $Node->mode();
    my $FILER_C = $Node->name();
	my $Host = host($FILER_C);
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
    logcomment("Filer state :: $filer_state");
    my $API_Object;
	my $dsk_output ;
    if ($filer_state =~ /MAINT/){
        $API_Object = NACL::APISet->new(
                        hostobj   => $Host,
                    category  => "Node",
                    interface => "CLI",
                    set       => "Maintenance"
                    );
    }
    if ($filer_state =~ /CLI|UP/) {
		$API_Object = $Node->get_7m_or_nodescope_apiset();
		$dsk_output =  $API_Object->execute_command('command' => "disk show -v");
    }
   
    if ($filer_state =~ /MAINT/i){
        $dsk_output =  $API_Object->execute_raw_command( 'command' => "disk show -v" );
    }
   
    my $dsk_result = {};
    my @lines  = split( /\n/, $dsk_output );
    my $n      = 0;
    my ($disk, $owner, $pool, $serialno, $home, $chksum);
    while ( $n <= $#lines ) {
            last if ( $lines[$n] =~ /^-----/ );
            $n++;
    }
    $n++;
    foreach my $line ( @lines[ $n .. $#lines ] ) {
        $line =~ s/^\s+|\s+$//g;
        if ( $line =~ /FAILED/i) {
            if ( $line =~ /^\S+\s*FAILED\s*\S+/) {
				$line =~ /(\S+)\s*(FAILED)\s*(\S+)/;
				($disk, $owner, $pool, $serialno, $home, $chksum) = ($1, undef, 'FAILED', $3, undef, undef);
            }
            else{
				($disk, $owner, $pool, $serialno, $home, $chksum) = ( $line =~/(\S+)\s+(\S+)\s*\(\d+\)\s+(\S+)\s+(\S+)\s+(\S+)\s*\(\d+\)\s+(\S+)/);
            }
        }else{
			($disk, $owner, $pool, $serialno, $home, $chksum) = ( $line =~/(\S+)\s+(\S+)\s*\(\d+\)\s+(\S+)\s+(\S+)\s+(\S+)\s*\(\d+\)\s+(\S+)/);
        }
		$disk=~s/^\s+|\s+$//g;
		next if($disk!~/\S/);
        $dsk_result->{$disk} = {
            'DISK'		=> $disk,
            'OWNER'		=> $owner,
            'POOL'		=> $pool,
            'SERIAL'	=> $serialno,
            'HOME'	    => $home,
            'CHKSUM'	=> $chksum
            };
    }
    return $dsk_result;
}

##########################################################################################################
# Author - skaran@netapp.com
# Usage - Mandatory paramanter - scsi_disk_error_before, scsi_disk_error_after
#
##########################################################################################################
sub compare_scsi_disk {
    my (%opts) = validate(
        @_,
        {
            scsi_disk_error_before => { type => HASHREF },
            scsi_disk_error_after  => { type => HASHREF },
            nm_error => { type => SCALAR, default => 'Y', optional => 1 },
        }
    );

    my $beforeref = $opts{scsi_disk_error_before};
    my $afterref  = $opts{scsi_disk_error_after};
         my $flag = 0;
    foreach my $value ( keys %{$beforeref} ) {
        my $dsk;
        if ($value =~ /\w+\.\w+\.\w+/){
        ( $dsk = $value ) =~ s/(\w+\.)//; # removing the adapters from the disk to matching only the actual name
        } else { $dsk = $value;}            # for armadillo setups
        foreach my $parm ( keys %{ $beforeref->{$dsk} } ) {

            #Comparing all paramaters present in hash.
            #if ( $beforeref->{$dsk}{$parm} != $afterref->{$dsk}{$parm} ) {
            #    print "\n\n$dsk---->$parm mismatched\n\n";
            #   }
            if ( $parm eq 'Number of glist entries' ) {
                if ( $beforeref->{$dsk}->{'Number of glist entries'} !=
                    $afterref->{$dsk}->{'Number of glist entries'} )
                {
                    logcomment("Number of glist entries is different");
                    logcomment(
"Before - $dsk:Number of glist entries:$beforeref->{$dsk}->{'Number of glist entries'} | After - $dsk:Number of glist entries:$afterref->{$dsk}->{'Number of glist entries'}"
                    );
                    $flag = 1;
                }
            }
            if ( $parm eq 'Soft errors on read since boot' ) {
                if ( $beforeref->{$dsk}->{'Soft errors on read since boot'} !=
                    $afterref->{$dsk}->{'Soft errors on read since boot'} )
                {
                    logcomment("Soft errors on read since boot is different");
                    logcomment(
"Before - $dsk:Soft errors on read since boot:$beforeref->{$dsk}->{'Soft errors on read since boot'} | After - $dsk:Soft errors on read since boot:$afterref->{$dsk}->{'Soft errors on read since boot'}"
                    );
                    $flag = 1;
                }
            }
            if ( $parm eq 'Soft errors on write since boot' ) {
                if ( $beforeref->{$dsk}->{'Soft errors on write since boot'} !=
                    $afterref->{$dsk}->{'Soft errors on write since boot'} )
                {
                    logcomment("Soft errors on write since boot is different");
                    logcomment(
"Before - $dsk:Soft errors on write since boot is different:$beforeref->{$dsk}->{'Soft errors on write since boot'} | After - $dsk:Soft errors on write since boot:$afterref->{$dsk}->{'Soft errors on write since boot'}"
                    );
                    $flag = 1;
                }
            }
            if ( $parm eq 'Hard errors on read since boot' ) {
                                 if ( $beforeref->{$dsk}->{'Hard errors on read since boot'} !=
                    $afterref->{$dsk}->{'Hard errors on read since boot'} )
                {
                    logcomment("Hard errors on read since boot is different");
                    logcomment(
"Before - $dsk:Hard errors on read since boot is different:$beforeref->{$dsk}->{'Hard errors on read since boot'} | After - $dsk:Hard errors on read since boot:$afterref->{$dsk}->{'Hard errors on read since boot'}"
                    );
                    $flag = 1;
                }
            }
            if ( $parm eq 'Hard errors on write since boot' ) {
                if ( $beforeref->{$dsk}->{'Hard errors on write since boot'} !=
                    $afterref->{$dsk}->{'Hard errors on write since boot'} )
                {
                    logcomment("Hard errors on write since boot is different");
                    logcomment(
"Before - $dsk:Hard errors on write since boot:$beforeref->{$dsk}->{'Hard errors on write since boot'}| After - $dsk:Hard errors on write since boot:$afterref->{$dsk}->{'Hard errors on read since boot'}"
                    );
                    $flag = 1;
                }
            }
        }    #end of foreach parm
    }    #end of foreach dsk
    if ( $flag == 1 ) {
        return (1);
    }
    else {
        return (0);
    }
}

#######################################################
### Author
###        Arjun Lavu
## description :: returns the status of two sub tests
#######################################################

sub status_return{
	my (%opts) = validate(
    @_,
    {
		subtest_ref  => { type => ARRAYREF},
	}
	);

    my @subtests = @{$opts{subtest_ref}};
    my @results;
    my $state = 0;
    foreach my $subtest (@subtests) {
        @results = $subtest->rslts();
        foreach my $result (@results) {
            if ( $result->type() =~ /INFO/ ) {
                $state = $result->{messages}->[0];
                if($state =~/^1$/){
					# logcomment("dumping $state");
					return $state;
                }
            }
        }
    }
    return $state;
}


=head2     my $email_subject = "$TC_name - $FILER : Test Aborted";
    my  $email_body    = "Test aborted due to filer is not in proper state"."\nLog location :$LOGDIR\n";
    send_message(mail_subject => $email_subject,
                 mail_body => $email_body,
                 MAIL_FROM => $MAIL_FROM,
                 MAIL_TO   => $MAIL_TO,
                 EOE       => 3,
                 EMAIL     => 'Y'  );

returns 1 on success and 0 on failure

The following named arguments are accepted,

=over

=item mail_subject
(Required): Subject of email to be included

=item mail_body
(Required) : Email boby along with log location

=item MAIL_FROM
(Required) : email id of person running test.

=item MAIL_TO
(Required) : list of names as the recipients wants to receive email.

=item EOE
(Required) : option to set the test suite termmination TYPE

=item EMAIL
(Required) : Send email message is enabled/disabled on an the test of the test suite

=back

=cut

sub send_message {

    my (%opts) = validate(
        @_,
        {
            mail_body    => { type => SCALAR },
            mail_subject => { type => SCALAR, },
            MAIL_FROM    => { type => SCALAR },
            MAIL_TO      => { type => SCALAR },
            EOE          => { type => SCALAR },
            EMAIL        => { type => SCALAR },
        }
    );
    my $mail_subject = $opts{mail_subject};
    my $mail_body    = $opts{mail_body};
    my $MAIL_FROM    = $opts{MAIL_FROM};
    my $MAIL_TO      = $opts{MAIL_TO};
    my $EOE          = $opts{EOE};
    my $EMAIL        = $opts{EMAIL};

    my $string;
    my $fail_msg;

    my $san_obj = new San( \*ntest::NTEST_STDOUT );
    if ( $san_obj->error() ) {
        logresult( 'FATAL',
            "Failed to instantiate San object" . $san_obj->errmsg() );
    }

    my %mail_params = (
        HTML    => $mail_body,
        Text    => $mail_body,
        From    => $MAIL_FROM,
        To      => $MAIL_TO,
        Subject => $mail_subject,
    );

    if ( $mail_body =~ /([\w\s\,\:\;\-\.\/]+)\.\s*(Log Location)*/ ) {
        $fail_msg = $1;
    }

    $mail_params{HTML} = "<HTML><pre>$mail_params{Text}<\><\\HTML>";
    my $mail = HTML::Mail->new(%mail_params);

    if ( $mail_subject =~ /\:\s(FAIL)$/ ) {
        $string = $1;
    }
    elsif ( $mail_subject =~ /\:\s(FATAL)$/ ) {
        $string = $1;
    }
    elsif ( $mail_subject =~ /\:\s(INSPECT)$/ ) {
        $string = $1;
    }
    my $flag = 1;
    if (   ( $string eq "FAIL" )
        && ( $EOE != 3 )
        && ( $EMAIL =~ /No/i || $EMAIL =~ /N/i ) )
    {

        $flag = 0;
        $san_obj->sanlog( -msg =>
" Email not sent for failure  because EOE is not set to 3 and EMAIL set to NO by user, Reason for FAIL - $fail_msg "
              . scalar( localtime() ) );
        return 0;
    }
    elsif (( $string eq "FAIL" )
        && ( $EOE != 3 )
        && ( $EMAIL =~ /Yes/i || $EMAIL =~ /Y/i ) )
    {
        $mail->send() or logresult( "CONFIG", "trouble sending mail" );
        $san_obj->sanlog(
            -msg => " Email  sent successfully Reason for FAIL - $fail_msg  "
              . scalar( localtime() ) );
        logcomment("Mail sent successfully and reason is  - $fail_msg");
        return 1;

        #croak("-T option set to either 1 or 2");

    }
    elsif ( $EMAIL =~ /d/i ) {
        logcomment("Email not sent because EMAIL set to Debug by user.");
    }
    else {
        $mail->send() or logresult( "CONFIG", "trouble sending mail" );
        if ( $string eq "FAIL" ) {
            $san_obj->sanlog( -msg =>
                  " Email  sent successfully and reason for FAIL - $fail_msg  "
                  . scalar( localtime() ) );
        }
        logcomment("Mail sent successfully and reason is  - $fail_msg");
        return 1;
    }
} ## end sub send_message($$$$$)

################################
### Copy firmware files to filer
################################
sub copy_FW_files_to_filer_directory {
        my (%opts) = validate(@_,
                {
                    Node  => { type => OBJECT },
                    Files_path => { type => SCALAR, default => undef,optional => 1 },
                    Files => { type => ARRAYREF, default => undef,optional => 1 }
                }
        );

        my $Node        = $opts{Node};
        my $files       = $opts{Files};
        my $files_path  = $opts{Files_path};
        my $FILER_C     = $Node->name();
        my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
        my $Mode        = $Node->mode();
        my $Host        = host($FILER_C);
		my(@files_to_remove_dup,@files_to_remove,@files_to_transfer,@fw_files);
        logcomment("Deleting all the previous files present in /mroot/etc/disk_fw directory.");
        my $Api_Set_Obj_SS = NACL::APISet->new(
                hostobj   => $Host,
                category  => "Node",
                interface => "CLI",
                set       => "Systemshell",
        );
        my $fw_path = "/mroot/etc/disk_fw";
        my $Filer_apiset = $Node->apiset(
                category  => 'Node',
                interface => 'CLI',
                set       => "Systemshell",
        );
        $Api_Set_Obj_SS->execute_raw_command( command => "sudo chmod 777 /mroot/etc/disk_fw" );
        my $File_on_filer = $Filer_apiset->execute_raw_command( command => "ls /mroot/etc/disk_fw" );
        chomp($File_on_filer);
        my @files_to_remove = grep{/LOD$/}sort split( /\s+/, $File_on_filer );
       
		my @actual_disks_t_dup = @files_to_remove;
		my $disk_max_sup=3;
		my $str;
		while (@actual_disks_t_dup) {
            my $loop_no     = 0;
            my @disk_list_q;
            while ($loop_no < $disk_max_sup) {
                push @disk_list_q,pop @actual_disks_t_dup;
                $loop_no++;
                last if (!(@actual_disks_t_dup));
            }
			my $local_str = join(" ",@disk_list_q);
			$str = "$str"."$local_str"."\n";
		}
		logcomment("Firmware files present under $fw_path  are :\n $str");
		
	#	foreach my $curr_file (@files_to_remove) {
        #    trim($curr_file);
        #    if ( $curr_file =~ /LOD$/ ) {
                $Api_Set_Obj_SS->execute_raw_command( command => "rm -f /mroot/etc/disk_fw/*" );
        #        logcomment(" File :: $curr_file deleted from /mroot/etc/disk_fw.");
        #    } 
        #}    
		if((defined $files)&&(!defined $files_path)){
                        foreach my $file (@{$files}) {
                                chomp($file);
                                if($file=~/LOD$/){
                                        copy_files_to_filer (Node => $Node, dest_path => $fw_path, files_to_transfer => [$file]) if($file);
                                }
                        }
		}elsif(defined $files){
			foreach my $file (@{$files}) {
				chomp($file);
				if($file=~/LOD$/){
					my $tmp = $files_path."/".$file;
					copy_files_to_filer (Node => $Node, dest_path => $fw_path, files_to_transfer => [$tmp]) if($tmp);
				}	
			}
		}elsif(defined $files_path){
			my @files;
			opendir( FH, "$files_path" ) || die("Cannot open directory");
			my @thefiles = readdir(FH);
			closedir(FH);
			grep{push(@files,$_)if($_=~/LOD$/)}@thefiles;
			logcomment("The number of files to copy : ".scalar @files." and the files are @files");
			foreach my $file (@files) {
				chomp($file);
				my $temp = $files_path."/".$file;
				copy_files_to_filer (Node => $Node, dest_path => $fw_path, files_to_transfer => [$temp]) if($temp);
			}
		}
        
        logcomment("$FILER_C : Verifying whether the firmware files are successfully copied to filer directory");
        my $firmware_files = $Filer_apiset->execute_raw_command( command => "ls /mroot/etc/disk_fw" );
        chomp($firmware_files);
        my @total_files = split(/\s+/, $firmware_files);
		grep{push(@fw_files,$_)if($_=~/LOD$/)}@total_files;
		my @actual_disks_t_dup = @fw_files;
		my $disk_max_sup=3;
		my $str;
		while (@actual_disks_t_dup) {
            my $loop_no     = 0;
            my @disk_list_q;
            while ($loop_no < $disk_max_sup) {
                push @disk_list_q,pop @actual_disks_t_dup;
                $loop_no++;
                last if (!(@actual_disks_t_dup));
            }
			my $local_str = join(" ",@disk_list_q);
			$str = "$str"."$local_str"."\n";
		}
	logcomment("$FILER_C : Total number of firmware files present in filer directory are ".scalar(@fw_files)." and the files are \n $str");
    return @fw_files;
}


sub copy_files_to_filer {
    my (%opts) = validate(
        @_,
        {
			Node => { type => OBJECT},
			dest_path => { type => SCALAR },
			files_to_transfer => { type => ARRAYREF},
		}
    );

	my $Node = $opts{Node};
	my $dest_path = $opts{dest_path};
	my $files_to_transfer = $opts{files_to_transfer};
	my $Client = NACL::C::Client->find();
	logcomment("Source client is : ".$Client->name() );
	my $FILER_C = $Node->name();
	my $Host =  host($FILER_C);
	my $passwd = $Host->{default_password};
	my $scp = NACL::MTask::SCP->new(
        source_command_interface => $Client,
        target_command_interface => $Node,
        target_username => 'diag',
        target_password => "$passwd",
    );
	logcomment("$FILER_C : Files to transfer :: @$files_to_transfer");
	try{
		$scp->copy_from_source_to_target(
			'files_to_copy'         => $files_to_transfer,
			set_directory_on_target => $dest_path,
        );
	}catch NATE::BaseException with {
		logcomment("Could not copy the file");# from ".@{$files_to_transfer});
	}
}
##########################################################################################################
# Author -arjun.lavu@netapp,com
##########################################################################################################
sub unique {
    return keys %{ { map { $_ => undef } @_ } };
}
##########################################################################################################
# Author -arjun.lavu@netapp,com
##########################################################################################################
sub scsi_disk_errors {
	my (%opts) = validate(
		@_,
		{
			Node   => { type => OBJECT },
		}
	);
	my $Node    = $opts{Node};
	my $FILER_C = $Node->name();
    my $Host = host($FILER_C);
    my $Transit_obj = NACL::Transit->new( name => $FILER_C );
    my $filer_state = $Transit_obj->get_state('timeout' => 600);
	logcomment("Filer state is :$filer_state");
    my $API_Object;
    if ($filer_state =~ /MAINT/){
		$API_Object = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance"
        );
		
    }elsif ($filer_state =~ /CLI|UP/) {
		$API_Object = $Node->get_7m_or_nodescope_apiset(connid    => "console" );
    }
	$API_Object->set_timeout("connectrec-timeout"=>7200);
    my $raw_output ;
    if ($filer_state =~ /MAINT/i){
        $raw_output =  $API_Object->execute_raw_command( 'command' => "scsi disk_errors" );
    }
    if ($filer_state =~ /CLI|UP/i){
		$raw_output =  $API_Object->execute_command( 'command' => "scsi disk_errors" );
    }             
	my $cur_disk;
    my $result={};
    my ($paramname, $paramval);
    foreach my $line(split(/\n/, $raw_output )) {
        $line =~ s/^\s+|\s+$//g;
        if ( $line =~ /\[(\S+)\]:\s+Serial number/ ) {
			$cur_disk = $1;
        }
        if ($line =~ /\S+:\s+(.*):\s+(.*)/){
            $paramname = $1;
            $paramval  = $2;
            $paramname =~ s/^\s+|\s+$//g;
            $paramval =~ s/^\s+|\s+$//g;                                           
            $result->{$cur_disk}->{$paramname} = $paramval;
        }                             
    }
    return $result;
}
 
 
sub compare_sysconfig {

    my (%opts) = validate(
        @_,
        {
            sys_addr_before => { type => HASHREF },
            sys_addr_after  => { type => HASHREF },
        }
    );

    my $sys_addr_before = $opts{sys_addr_before};
    my $sys_addr_after  = $opts{sys_addr_after};
    my $flag            = 0;
    my $i;
    my @upchannels_before;
    my @normaldisks_before;
    my @faileddisks_before;
    my @bypassdisks_before;
        my @upchannels_after;
        my @normaldisks_after;
        my @faileddisks_after;
        my @bypassdisks_after;

#Upchannels compare
        @upchannels_before = @{ $sys_addr_before->{'upchannels'} };
        @upchannels_after  = @{ $sys_addr_after->{'upchannels'} };
        foreach my $val (@upchannels_before){
                if ( grep /$val/, @upchannels_after ){
                        next;
                }else{
                        $flag = 1;
                        logcomment ("Upchannel - $val is different from captured sysconfig -v command\n");
                }
        }

#Normal disk comapre
        @normaldisks_before = @{ $sys_addr_before->{'normaldisks'} };
        @normaldisks_after =  @{ $sys_addr_after->{'normaldisks'} };
        foreach my $val (@normaldisks_before){
                if ( grep /$val/, @normaldisks_after){
                        next;
                }else{
                        $flag = 1;
                        logcomment ("Normal disk $val is different from captured sysconfig -v command\n");
                }
        }

#Failed drives
        @faileddisks_before = @{ $sys_addr_before->{'faileddisks'} };
        @faileddisks_after = @{ $sys_addr_after->{'faileddisks'} };
        foreach my $val (@faileddisks_before){
                if ( grep /$val/,@faileddisks_after){
                        next;
                }else{
                        $flag = 1;
                        logcomment ("Failed disk - $val is different from captured sysconfig -v command\n");
                }
        }

#Bypass drives
        @bypassdisks_before = @{ $sys_addr_before->{'bypassdisks'} };
        @bypassdisks_after = @{ $sys_addr_after->{'bypassdisks'} };
        foreach my $val (@faileddisks_before){
                if ( grep /$val/,@faileddisks_after){
                        next;
                }else{
                        $flag = 1;
                        logcomment ("Bypassed drive - $val is different from captured sysconfig -v command\n");
                }
        }
######
#    @upchannels = @{ $sys_addr_before->{'upchannels'} };
#
#    for ( $i = 0 ; $i <= $#upchannels ; $i++ ) {
#
#        if ( $sys_addr_before->{'upchannels'}->[$i] ne
#            $sys_addr_after->{'upchannels'}->[$i] )
#        {
#
#            logcomment(
#"Before upchannels @{$sys_addr_before->{'upchannels'}},after upchannels @{$sys_addr_after->{'upchannels'}}\n"
#            );
#           $flag = 1;
#        }
#    } ## end for ($i = 0 ; $i < $#upchannels...
#    @normaldisks = @{ $sys_addr_before->{'normaldisks'} };
#
#    for ( $i = 0 ; $i <= $#normaldisks ; $i++ ) {
#
#        if ( $sys_addr_before->{'normaldisks'}->[$i] ne
#            $sys_addr_after->{'normaldisks'}->[$i] )
#        {
#
#            logcomment(
#"Before normaldisks @{$sys_addr_before->{'normaldisks'}},after normaldisks @{$sys_addr_after->{'normaldisks'}}\n"
#            );
#
#           $flag = 1;
#        }
#    } ## end for ($i = 0 ; $i < $#normaldisks...
#
#    @faileddisks = @{ $sys_addr_before->{'faileddisks'} };
#
#    for ( $i = 0 ; $i <= $#faileddisks ; $i++ ) {
#        if ( $sys_addr_before->{'faileddisks'}->[$i] ne
#            $sys_addr_after->{'faileddisks'}->[$i] )
#        {
#
#            logcomment(
#"Before faileddisks @{$sys_addr_before->{'faileddisks'}},after faileddisks @{$sys_addr_after->{'faileddisks'}}\n"
#            );
#            $flag = 1;
#        }
#    }
#
#    @bypassdisks = @{ $sys_addr_before->{'bypassdisks'} };
#
#    for ( $i = 0 ; $i <= $#bypassdisks ; $i++ ) {
#        if ( $sys_addr_before->{'bypassdisks'}->[$i] ne
#            $sys_addr_after->{'bypassdisks'}->[$i] )
#        {
#
#            logcomment(
#"Before bypassdisks @{$sys_addr_before->{'bypassdisks'}},after bypassdisks @{$sys_addr_after->{'bypassdisks'}}\n"
#            );
#            $flag = 1;
#        }
#
#    } ## end for ($i = 0 ; $i < $#bypassdisks...
######

    if ( $flag == 0 ) {
        return 1;
    }
    else {
        return 0;
    }

} ## end sub compare_sysconfig


=head2 compare_fcadmins

    my $ret = compare_fcadmins(fcadmin_add_before => $fcadmin_add_before, fcadmin_add_after => $fcadmin_add_after);

This routine returns 1 on sucess and 0 on failure:

The following named arguments are accepted,

=over

=item fcadmin_add_before

(Required) : hash address returned by fcadmin_device_map method on first instance

=item fcadmin_add_after

(Required) : hash address returned by fcadmin_device_map method on second instance

=back

=cut

sub compare_fcadmins {
    my (%opts) = validate(
        @_,
        {
            fcadmin_add_before => { type => HASHREF },
            fcadmin_add_after  => { type => HASHREF },
        }
    );

    my $disk_index;
    my $start              = 0;
    my $end                = 13;
    my $fcadmin_add_before = $opts{fcadmin_add_before};
    my $fcadmin_add_after  = $opts{fcadmin_add_after};
    for my $channels ( keys %$fcadmin_add_before ) {
        my $channel_add = $fcadmin_add_before->{$channels};
        for my $status ( keys %$channel_add ) {
            if ( $status =~ /(\d+)/ ) {
                for (
                    $disk_index = $start ;
                    $disk_index <= $end ;
                    $disk_index++
                  )
                {
                    if ( $fcadmin_add_before->{$channels}->{$status}
                        ->{'ShelfMapping'}[$disk_index] !=
                        $fcadmin_add_after->{$channels}->{$status}
                        ->{'ShelfMapping'}[$disk_index] )
                    {
                        logcomment(
"fcadmin_add ShelfMapping disk found after:$fcadmin_add_after->{$channels}->{$status}->{'ShelfMapping'}[$disk_index]\nfcadmin_add  ShelfMapping disk found before:$fcadmin_add_before->{$channels}->{$status}->{'ShelfMapping'}[$disk_index]"
                        );
                        return (0);
                    }
                }
            }
            elsif ( $status eq "Unknown" ) {
                print("Configuration issue in loop\n");
            }
        } ## end for my $status (keys %$channel_add)
    } ## end for my $channels (keys ...
    return (1);
} ## end sub compare_fcadmins


sub scrub_stop{
	my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT},
        }
    );
    my $Node=$opts{Node};
    logcomment("Checking for Scub");
    my $Mode = $Node->mode();
    my $FILER_C = $Node->name();
    my $Host = host($FILER_C);
    my $API_Object_maint;
    logcomment("Mode of the filer $FILER_C is $Mode");
    my $Transit_obj = NACL::Transit->new( name => $FILER_C );
    my $filer_state = $Transit_obj->get_state('timeout' => 600);
	logcomment("Filer state $filer_state");
    if ($filer_state =~ /MAINT/){
        $API_Object_maint = NACL::APISet->new(
                                hostobj   => $Host,
                                category  => "Node",
                                interface => "CLI",
                                set       => "Maintenance"
                                );
        $API_Object_maint->set_timeout( "connectrec-timeout" => 1200 );
		$API_Object_maint->execute_raw_command('command' => "aggr scrub stop");
		sleep 30;
    }
	if ($filer_state=~/(CLI|UP)/gi){
		my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset(connid => "console");
        $Api_Set_Obj->execute_command('command' => "aggr scrub stop");
        sleep 10;
        $Api_Set_Obj->execute_command('command' => "disk scrub stop");
        sleep 10;
       logcomment("Scrub has been stopped");
    }
}



#######################################################################################################
#Subroutine Defn Begins
###
###
# Auther         - vpankaj@netapp.com
# Description    - This subroutine is used in all the test for pre test process.
# Pre Functions  -  check state and change to required state
#                   version
#                   disk_list
#                   sysconfig -v
#                   sysconfig -r
#                   sasadmin dev_stats
#                   storage show
#                   sasadmin expander_map
#                   vol status -s
#                   df command to display size
#                   disk_qual start -t 12 -d all
#                   start media scrub
#                   check for failed and zeroing drives.
#                   set log sense interval to 4 hrs
#                   Set disk_mfg_test 0
#                   Check for mini-disks. Send out Notification mail
#                   Check for fan speed and set to default.
#                   Stop error injection
#                   sasadmin dev_stats
# Supported Mode -  Cmode
###
#######################################################################################################

sub execute_pre_test {
    my (%opts) = validate(
        @_,
        {
                        filer_mode      => { type => SCALAR },
                        node_present => { type => ARRAYREF},
                        Test            => { type => OBJECT },
                        change_state_to => { type => SCALAR, optional => 1, default => 'CLI'},
                        LOGDIR                  => {type => SCALAR, optional => 1, default => ''},
                        test_setup              => {type => SCALAR, optional => 1, default => 'SAS'},
						BOOT_TYPE               => {type => SCALAR, optional => 1, default => 'A'},
        }
        );

        my @Nodes = @{ $opts{node_present} };
		handle_run_local_error();
		my @Nodes = NACL::C::Node->find();
        my $Filer_mode = $opts{filer_mode};
        my $Test = $opts{Test};
        my $change_to = $opts{change_state_to};
        my $TEST_CONFIG = $opts{test_config};
        my $test_setup = $opts{test_setup};
        my $exit_test = 0;
        my @Filer_array = ();
        my $execution_state ;
        my @disk_list ;
        my $node_ref;
        my @disk_array;
        my %FILER_API = ();
        my @disk_array;
        my $timeout;
        my $Api_Set_Obj;
		my $disk_capacity_total = 0;
		my $disk_capacity_total_GB = 0;
        my $LOGDIR = $opts{LOGDIR};
        my $params = NATE::ParamSet->new(global => 1);
        my $EOE                 = $params->get('EOE', default => 'default' );
        my $EMAIL               = $params->get('EMAIL',default => 'y' );
        my $MAIL_TO             = $params->get('MAIL_TO', default => 'Email to');
        my $MAIL_FROM           = $params->get('MAIL_FROM', default => 'Email from');

        if ($opts{LOGDIR}){
                $LOGDIR = $opts{LOGDIR};
        }else{
                $LOGDIR = $ENV{HOME};
        }
        my $TEST_NAME;
        opendir( DIR_LOG31, $LOGDIR );
        my @files_DIR_LOG31 = readdir(DIR_LOG31);
        foreach my $file (@files_DIR_LOG31) {
                if ( ($file =~ /(.*_NADQ02.*)\.log/) && ($file !~ /results|END_FILER_CONFIG/ )) {
                        $TEST_NAME = $1;
                }
        }
        $node_ref = \@Nodes;
        foreach my $temp_node (@Nodes){
        my $Filer = $temp_node->name();
        push (@Filer_array, $Filer);
    }

        # Check state of filer and Execute based on state
        logcomment("Nodes present - @Filer_array");
        logcomment("Log loction - $LOGDIR");
        my @chk_state = ();
        # Check for state and call respective subroutines:
                foreach my $Node (@Nodes){
                        my $Transit_obj;
                        my $FILER_C = $Node->name();
                        $Transit_obj = NACL::Transit->new( name => $FILER_C );
                        my $filer_state = $Transit_obj->get_state('timeout' => 600);
                        $Test->nlog("$FILER_C : Filer is in $filer_state ");
                        push(@chk_state, $filer_state);
                }
                my $len = @chk_state;
                if ($len > 1){
               if ($chk_state[0] eq $chk_state[1]){
               $execution_state = $chk_state[0];
                       $Test->nlog("Execution state - $execution_state\n");
               }else{
                   $Test->nlog("States of filer is different, Boot filer in same mode");
               }
        }else{
                $execution_state = $chk_state[0];
                $Test->nlog("Execution state - $execution_state\n");
            }

        # Check filer State and change to required state
                $Test->nlog("##################################################################################");
                $Test->nlog("##");
                $Test->nlog("## Begining of PRE_TEST logs for Filer : @Filer_array");
                $Test->nlog("##");
                $Test->nlog("##################################################################################");
                $Test->nlog("Checking boot state of filer, and booting in required mode");
                my $filer_state;
                my $Transit_obj;
                my @change_states;
                my $Check_flag = 0;
				
                foreach my $Node (@Nodes){
                        my $FILER_C = $Node->name();
                        my $Transit_obj = NACL::Transit->new( name => $FILER_C );
                        my $filer_state = $Transit_obj->get_state('timeout' => 600);
                        logcomment("Filer $FILER_C is in $filer_state ");
                    if ($opts{change_state_to}){
                            if ($filer_state ne $change_to){
                            $Test->nlog("Filer - $FILER_C is in $filer_state state");
                            logcomment("Filer - $FILER_C is not in required state - $change_to, Changing to $change_to");
                                                push(@change_states, $FILER_C);
                    }
                        if ($filer_state eq $change_to){
                            $Test->nlog("Filer - $FILER_C is in $filer_state state");
                            $Test->nlog("Filer - $FILER_C is in required state - $change_to");
                        }
                                }
                }
                my @subtests;
                if (@change_states){
                    foreach my $filer_name (@change_states){
                        push(@subtests, subtest(
                                                                \&boot_filer_in_req_state, -runid,
                                                "boot_filer_in_req_state_" . "$filer_name", -bg,
                                        "--", Test => $Test,
                                                                filer_name => $filer_name,
                                                                change_state_to => $change_to,
                         )
                    );
                }
                        $Test->nlog("Subtest @subtests");
                    Subtest::wait_finish( subtest => [@subtests] );
                    my ( $fail_cnt, $fatal_cnt );
                    my @results;
                    foreach my $subtest (@subtests) {
                        @results = $subtest->rslts();
                        foreach my $result (@results) {
                            if ( $result->type() =~ /INFO/ ) {
                                $Test->nlog("Subtest boot_filer_in_req_state completed successfully");
                            } elsif ( $result->severity() >= 0 ) {
                                $Test->nlog("Subtest boot_filer_in_req_state not completed successfully");
                                if ( $result->type() =~ /FAIL/i ) {
                                    $fail_cnt++;
                                }
                                if ( $result->type() =~ /FATAL|SCRIPT|CONFIG/ ) {
                                    $fatal_cnt++;
                                }
                            } ## end elsif ($result->severity(...
                        } ## end foreach my $result (@results)
                    } ## end foreach my $subtest (@subtests)
                    if ( $fail_cnt == 0 ) {
                        $Test->nlog("FILER Booted the filer successfully in required state");
                                $Check_flag = 1;
                    }
        }
        # Check state of filer after booting
        if ($Check_flag == 1){
                foreach my $Node (@Nodes){
                        my $Transit_obj;
            my $FILER_C = $Node->name();
            $Transit_obj = NACL::Transit->new( name => $FILER_C );
            my $filer_state = $Transit_obj->get_state('timeout' => 600);
            $Test->nlog("$FILER_C : Filer is in $filer_state ");
                        if ("$filer_state" eq "$change_to") {
                                $Test->nlog("$FILER_C : Is in required test, proceeding with test");
                                $execution_state = $filer_state;
                                $Test->nlog("$FILER_C : Execution state changed to : $change_to");
                        }
                        if ("$filer_state" ne "$change_to") {
                                $Test->nlog("$FILER_C : Is not in required state");
                                logresult( "FATAL","$FILER_C is not in required state, Cannot boot in required state" );
                }
                }
        }

        # If maintenanace mode :
        if ($execution_state eq 'MAINT'){
                foreach my $Node(@Nodes){
                my $Filer = $Node->name();
                    my $host = host($Filer);
                    my $API_Object = NACL::APISet->new(
                            hostobj   => $host,
                            category  => "Node",
                            interface => "CLI",
                            set       => "Maintenance"
                            );
                $FILER_API{$Filer} = $API_Object;
                }
        }

        # Check security login, ssh option
               $Test->nlog("===================================================================================");
               $Test->nlog("==== PRE_TEST STEP 1 : Check SSH parameters and Enable SSH");
               $Test->nlog("===================================================================================");
                foreach my $Node(@Nodes){
                    my $FILER_C = $Node->name();
					logcomment("$FILER_C - Checking SSH and enabling SSH");
                    if ($execution_state eq 'CLI'){
	                    $Test->nlog("$FILER_C : Check security login, enable ssh option ");
                        $Test->nlog("$FILER_C : Filer mode is : $Filer_mode");
                        enable_ssh(Node  => $Node,
                                   Test  => $Test,
                                   Mode  => $Filer_mode,);
						logcomment("$FILER_C - End of Checking SSH and enabling SSH");
						# del_system_logs(Node  =>$Node);
						logcomment("$FILER_C : Disable all storage debug messages");
                        my $host = host($FILER_C);
						disable_debug_msg(Node => $Node);
						#start_shelflog_detector(Node=>$Node);
						start_ems_detector(Node=>$Node);
                    }
					
				}
		
		# Check kernel version	
				$Test->nlog("===================================================================================");
				$Test->nlog("==== PRE_TEST STEP 2 : Check Kernel Version");
				$Test->nlog("===================================================================================");	
				foreach my $Node(@Nodes){
					my $FILER_C = $Node->name();
					logcomment("$FILER_C - Check Version on filer");
                    if ($execution_state eq 'CLI'){
                        $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
                    } else {
                       $Api_Set_Obj = $FILER_API{$FILER_C};
                    }
	                my $ver_output = $Api_Set_Obj->execute_command('command' => 'version');
    	            logcomment("Version on $FILER_C - $ver_output");
					logcomment("$FILER_C - End of Checking Version on filer");
					
                }
					
					
        # Check for disk availibility (pre test)
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 3 : Checking for disk availability");
                $Test->nlog("===================================================================================");
                {
	                my ($max_disk_size,$disk_size);
                    my @disk_list_common;
					logcomment("Checking disk availability of FILER");
                    if ($execution_state eq 'CLI'){
	                    @disk_list_common = NACL::C::StorageDisk->find(
                        command_interface => $Nodes[0],
                        );
    	                @disk_list;
                        foreach my $disk (@disk_list_common) {
                            push( @disk_list, $disk->get_one_state_attribute('disk') );
                        }
                        my $disk_length = @disk_list;
                        if ($disk_length >0 ){
                            $Test->nlog("@Filer_array - Disk attached - @disk_list");
                        } else {
                                $Test->nlog("@Filer_array -No disk available for testing, exiting from rest of the test cases");
                                $exit_test = 1;
                                logresult( "FATAL", "@Filer_array - No disk available for testing, exiting from rest of the test cases");
                        }
                    } else {
                        my $FILER_C = $Nodes[0]->name();
                        my $Api_Set_Obj = $FILER_API{$FILER_C};
                        logcomment("Filer : $FILER_C : executing disk_list on the filer");
						my $dsk_output =  $Api_Set_Obj->execute_raw_command( 'command' => "disk_list" );
    					my $disk_list_result = {};
					    my @lines  = split( /\n/, $dsk_output );
					    my $n      = 0;
					    while ( $n <= $#lines ) {
					        last if ( $lines[$n] =~ /^-----/ );
					        $n++;
					    }
					    $n++;
					    foreach my $line ( @lines[ $n .. $#lines ] ) {
				        my (
				           $disk,     $chan, $ven,    $prodid, $rev,
				           $serialno, $hw,   $blocks, $bps,    $dq
			            )  = ( $line =~/(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/);
				        if ( ( $line =~ /\d\w\.\d\d/ ) || ( $line =~ /\d\w\.\d\d\.\d\d/ ) ) {
				            $disk_list_result->{$disk} = {
				                'DISK'       => $disk,
				                'CHAN'       => $chan,
            				    'VENDOR'     => $ven,
				                'PRODUCT_ID' => $prodid,
				                'REV'        => $rev,
				                'SERIAL'     => $serialno,
				                'HW'         => $hw,
				                'BLOCKS'     => $blocks,
				                'BPS'        => $bps,
				                'DQ'         => $dq
				            };
				        }	
						}
                        @disk_array = keys(%{$disk_list_result});
		                my $disk_length = @disk_array;
		                if ($disk_length > 0 ){
		                    $Test->nlog(" Disk attached - @disk_array");
		                } else {
			                $Test->nlog("No disk available for testing, exiting from rest of the test cases");
		                    logresult( "FATAL", "- No disk available for testing, exiting from rest of the test cases");
        			    }
                        for my $dsk (@disk_array) {
                    	    $disk_size = $disk_list_result->{$dsk}->{'BLOCKS'};
	                        $max_disk_size = $disk_size if ( $disk_size > $max_disk_size );
							$disk_capacity_total = $disk_capacity_total + $disk_size;
                        }
						$disk_capacity_total_GB = int(($disk_capacity_total/2147483648)*1000);
						logcomment("Tota Disk Capacity in GB : $disk_capacity_total_GB");
                        my $in_GB =  int(($max_disk_size/2147483648)*1000);
                        $Test->nlog("Max disk size : In Blocks is $max_disk_size i.e $in_GB GB");
                        if ( $max_disk_size <= 20971520 ) {
                            $timeout = $timeout + 1200;
                        } elsif ( $max_disk_size <= 2147483648 ) {
                            $timeout = $timeout + ( 1200 * 5 );
                        } else {
                            $timeout = $timeout + ( 1200 * 10 );
                        }
                }
				logcomment("End of Checking disk availability of FILER");
                }

        # Get filer config
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 4 : Get Filer configurations");
                $Test->nlog("===================================================================================");
		        foreach my $Node(@Nodes){
    	            my $FILER_C = $Node->name();
                    $Test->nlog("- Get filer configruation for filer $FILER_C");
					if ($execution_state eq 'CLI'){
		                $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		                $Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
                		$Api_Set_Obj->execute_command('command' => 'sysconfig -v' , 'timeout' => 600);
					} else {
						$Api_Set_Obj = $FILER_API{$FILER_C};
						$Api_Set_Obj->execute_command('command' => 'sysconfig -v' , 'timeout' => 600);
					}
                    $Test->nlog("- End of Get filer configruation for filer $FILER_C");
                }

        # Execution sysconfig -r
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 5 : Record sysconfig -r information of the filer");
                $Test->nlog("===================================================================================");
				if ($execution_state eq 'CLI'){
					my @subtests;
					foreach my $Node(@Nodes){
						my $FILER_C = $Node->name();
						push(@subtests,	subtest(\&check_recons_sickdisk, -runid, "check_recons_sickdisk_$FILER_C", -bg,"--", Node =>$Node));
					}
					Subtest::wait_finish(subtest => [@subtests]);
					status_return(subtest_ref  =>[@subtests]);
				}else{
					foreach my $Node (@Nodes){
						my $FILER_C = $Node->name();
						logcomment("$FILER_C - Executing aggr status -r");
						$Api_Set_Obj = $FILER_API{$FILER_C};
						$Api_Set_Obj->execute_command('command' => 'aggr status -r' , 'timeout' => 600);
					}
				}

        # Record link statistics for all adapters and drives
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 6 : Record link statistics for all adapters and drives");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
	                my $FILER_C = $Node->name();
                    my $Host = host($FILER_C);
					logcomment("$FILER_C - Record link statistics");
					
                    if ($test_setup ne 'FC'){
						$SAS_ADMIN_DEV_PRE->{$FILER_C} = sasadmin_dev_stats_cmode( node => $Node );
                    } else {
						$SAS_ADMIN_DEV_PRE->{$FILER_C} = fcadmin_fcal_stats( Node => $Node );
                    }
					logcomment("$FILER_C - End of Record link statistics");
                }

        # Storage show information of the filer
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 7 : Record storage show information of the filer");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
	                my $FILER_C = $Node->name();
                    logcomment("$FILER_C - Executing storage show");
                    if ($execution_state eq 'CLI'){
      	              $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
					  $Api_Set_Obj->execute_command('command' => 'storage show' , 'timeout' => 600);
                    } else {
                      $Api_Set_Obj = $FILER_API{$FILER_C};
    	 		      $Api_Set_Obj->execute_command('command' => 'storage show' , 'timeout' => 600);
                    }
					logcomment("$FILER_C - End of Executing storage show");
                }

        # Record expander map of the adapter
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 8 : Record expander map of the adapter");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
	 	           my $FILER_C = $Node->name();
				   logcomment("$FILER_C - Record expander map of the adapter");
                   my $Host = host($FILER_C);
                   if ($test_setup ne 'FC'){
        	          sasadmin_expander_map_cmode( node => $Node );
                   } else {
					  fcadmin_device_map( Node => $Node );
                   }
				   logcomment("$FILER_C - End of Record expander map of the adapter");
                }

        # Record Spare drives
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 9 : Record Spare drives attached");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
	                my $FILER_C = $Node->name();
					logcomment("$FILER_C - Recording Spare drives ");
                    if ($execution_state eq 'CLI'){
    	                $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
                        $Api_Set_Obj->execute_command('command' => 'vol status -s');
                    } else {
                        $Api_Set_Obj = $FILER_API{$FILER_C};
                        $Api_Set_Obj->execute_command('command' => 'aggr status -s');
                    }
					logcomment("$FILER_C - End of recording Spare drives ");
                }

        # Record df command to display size
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 10 : Record df command to display size");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
	                my $FILER_C = $Node->name();
					logcomment("$FILER_C - Record df command to display volume size or disk size");
                    if ($execution_state eq 'CLI'){
    	                $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
                        $Api_Set_Obj->execute_command('command' => 'df');
                    } else {
						logcomment("$FILER_C : Total capacity of Disk : $disk_capacity_total i.e In GB $disk_capacity_total_GB");
                    }
					logcomment("$FILER_C - End of recording df command to display volume size or disk size");
                }

        # Execute disk_qual t 12 for all disk
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 11 : Printing logsense data for all the disks");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
	                my $FILER_C = $Node->name();
					logcomment("$FILER_C - Print logsense data for all drives");
					$SCSI_DISK_ERRORS->{$FILER_C} = scsi_disk_errors( Node => $Node );
					logcomment("$FILER_C - End if printing logsense data for all drives");
                }

        # start media scrub
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 12 : Enable  media scrub ");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
 	 	           my $FILER_C = $Node->name();
				   logcomment("$FILER_C - Enable media Scrub ");
                   if ($execution_state eq 'CLI'){
						$Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
                        $Api_Set_Obj->execute_raw_command('command' => 'storage raid-options modify * -name raid.media_scrub.enable on');
	               } else {
						logcomment("$FILER_C : No need to enable media scrub on Maintenance mode");
        	       }
				   logcomment("$FILER_C - End of enabling media Scrub ");
        		}

        #check for failed and zeroing drives
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 13 : Check for non-zeroed disk or failed disk");
                $Test->nlog("===================================================================================");
                    if ($execution_state =~/CLI/){
						{
							my @subtests;
							foreach my $Node(@Nodes){
								my $FILER_C = $Node->name();
								push(@subtests, subtest( \&report_failed_drives, -runid,
														"report_failed_drives_" . "$FILER_C", -bg,
														"--", Node   => $Node,
														)
												);
							}
							logcomment("Subtest @subtests");
							Subtest::wait_finish( subtest => [@subtests] );
						}
						disable_fg_bg_firmware_hammer(Nodes =>[@Nodes]);
						unfail_disk_zero_spares(Nodes =>[@Nodes]);
						logcomment("End of checking for non-zeroed disk or failed disk, unfail disk");
                    } else {
						logcomment("No need to Check for non-zeroed disk or failed disk, unfail disk for Maintenance mode");
                    }
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 14 : Set log sense interval");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
                    my $FILER_C = $Node->name();
					logcomment("$FILER_C - Set log sense interval");
                    if ($execution_state eq 'CLI'){
    	                $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
	            		logcomment("$FILER_C -Set options disk.log_sense.interval for 30 minutes");
			            NACL::C::Options->option(
			                command_interface => $Node,
			                'option-name'     => 'disk.log_sense.interval',
			                'option-value'    => '30'
			            );
						logcomment("FILER - Waiting for a minute");
						sleep(60);
                    } else {
						$Api_Set_Obj = $FILER_API{$FILER_C};
						logcomment("$FILER_C : No need to Set log sense interval to 4 hrs for Maintenance mode");
                    }
					logcomment("$FILER_C - End of setting log sense interval");
                }

        # Set disk mfg flag
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 15 :Set flag disk mfg");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
	                my $FILER_C = $Node->name();
					logcomment("$FILER_C - Setting disk_mfg_test 0");
           			if ($execution_state eq 'CLI'){
		               $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
        		    } else {
		               $Api_Set_Obj = $FILER_API{$FILER_C};
        		    }
                       $Api_Set_Obj->execute_command('command' => 'setflag disk_mfg_test 0');
                       $Test->nlog("$FILER_C - Flag set");
                       $Api_Set_Obj->execute_command('command' => 'printflag disk_mfg_test');
                       sleep 5;
					logcomment("$FILER_C - End of setting disk mfg flag");
                }
	
        # Check for mini-disks. Send out Notification mail
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 16 : Check for mini-disks");
                $Test->nlog("===================================================================================");
     			my $FILER_MINI={};
		        foreach my $Node (@Nodes){
        			my $FILER_C = $Node->name();
					logcomment("$FILER_C - Check for mini-disks");
		            my $Mode = $Node->mode();
        		    my $Host = host($FILER_C);
                	my $transit_obj = NACL::Transit->new(name => $Host);
	                my $filer_state = $transit_obj->get_state('timeout' => 600);
    	            my (@mini_disks,$Api_Set_Obj);
	                if ($filer_state =~/UP|CLI/i){
                        $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset() ;
                        $Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
    	            }elsif($filer_state =~/MAINT/i){
                        my $console = Tharn::connect("$FILER_C#console");
                        # Set the properties for the Connectrec used for creating the APIset
                        $console->{prompts} = [qr/\*>/];
                        $console->{max_idle} = 600;
                        $console->{on_idle} = sub { $console->execute(""); };
                        $Api_Set_Obj = NACL::APISet->new(connection => $console,
                                                                category => "Node",
                                                                interface => "CLI",
                                                                set => "Maintenance");
                        $Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
        	        }
            	    my $res;
                	try {
                        $res = $Api_Set_Obj->mini_disk_list();
	                }catch NACL::APISet::Exceptions::FailedAndNotFoundException with{
                        logcomment("FIler : $FILER_C : mini_disk list command is not working on this particular kernel");
    	            };
        	        if(!$res){
                        return undef;
            	    }
                	my @disks_obj = @{$res->get_parsed_output()};
	                foreach (@disks_obj){
                        if($_->{type} ne "NORMAL disk") {
                                push(@mini_disks,$_->{disk});
                                $FILER_MINI->{$FILER_C}=[@mini_disks] if (scalar @mini_disks);
                        }
	                }
					logcomment("$FILER_C - End of checking for mini-disks");
    		    }
		        foreach(keys %{$FILER_MINI}){
        	        logcomment("Number of Mini_disks present on the filer $_ are ".scalar @{$FILER_MINI->{$_}}." and the drives are @{$FILER_MINI->{$_}}");
            	    # my $email_subject = "$_ : Mini_disks present on the filer";
			        # my $email_body ="Number of Mini_disks present on the filer $_ are ".scalar @{$FILER_MINI->{$_}}." and the drives are @{$FILER_MINI->{$_}}.\nLog Location : $LOGDIR\n";
			        # send_message(
            			# mail_subject => $email_subject,
			            # mail_body    => $email_body,
			            # MAIL_FROM    => $MAIL_FROM,
			            # MAIL_TO      => $MAIL_TO,
			            # EOE          => $EOE,
			            # EMAIL        => $EMAIL
			        # );
        		}


        # Check for fan speed (pre)
                $Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 17 : Check for fan speed and set to defaults");
                $Test->nlog("===================================================================================");
                foreach my $Node (@Nodes){
	                my $FILER_C = $Node->name();
                    if ($test_setup eq "SAS" ) {
    	                foreach my $Node (@Nodes) {
                                my $adapterslot;
                                my ($shelfid,$adapter_val);
                                my %adapter_hash;
                                my $flag1 = 0;
                                my $FILER_C = $Node->name();
        				        logcomment("$FILER_C - Checking for fan speed");
                        		if ($execution_state eq 'CLI'){
                                	$Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		                        } else {
        	                        $Api_Set_Obj = $FILER_API{$FILER_C};
            		            }
                                my $output = $Api_Set_Obj->execute_command('command'  => 'sasadmin expander_map');
                                my @slot_array = split( /\n\n/, $output );
                                foreach (@slot_array) {
                    	           my @shelfid;
                                   if ( $_ =~ /Expanders on channel\s+(\w+)/ ) {
                        	           $adapterslot = $1;
                                   }
                                   if ( $_ =~ /.*\s+ID\s+(\d+)/ ) {
                                       @shelfid =$_=~/.*\s+ID\s+(\d+)/g;
                                   }
                                   if ( ( $adapterslot ne "" ) && ( @shelfid ) ) {
                                       $adapter_hash{$adapterslot} = [@shelfid];
                                   }
                            	}
                                
						#Setting the fan Speeds to default values
                                my $flag1 = 0;
                                foreach my $key ( keys %adapter_hash ) {
                        	        last if ( $flag1 == 1 );
                                    my @var = @{$adapter_hash{$key}} if (defined $adapter_hash{$key});
                            	    foreach(@var){
                                	    $adapter_val = "$key.$_";
                                        my $aft = $Api_Set_Obj->execute_command('command' => "sasadmin expander_cli $adapter_val 'fan_set normal'" );
                                        if ( $aft =~ /Setting all fans to normal/ ) {
                                    	    sleep(60);
                                        	logcomment("Fan-speed has set to default value");
                                            logcomment("Checking the Fans speed again");
                                            $Api_Set_Obj->execute_command('command'  => "sasadmin expander_cli $adapter_val 'fan_set speed'");
                                            sleep 5;
                                            $flag1 = 1;
                                            last;
                                        }
                                   }
                                }
								logcomment("$FILER_C - End of checking for fan speed");
                             }#End of foreach nodes.
                        }else{
							logcomment("Test Setup is not SAS, Hence not checking fan speed");
						}
                }
				
        # Stop any error injection if running (pre-cli)
                 $Test->nlog("===================================================================================");
                 $Test->nlog("==== PRE_TEST STEP 18 : Stop any error injection if running ");
                 $Test->nlog("===================================================================================");
                 foreach my $Node (@Nodes) {
	                 my $FILER_C = $Node->name();
					 logcomment("$FILER_C - Stop any error injection");
                     if ($execution_state eq 'CLI'){
     	                $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
					 if ($test_setup ne 'FC'){
						$Api_Set_Obj->execute_command('command'  => 'sasadmin inject disable');
					 } else {
						$Api_Set_Obj->execute_command('command'  => 'fcadmin inject disable');
					 }
                     } else {
                        $Api_Set_Obj = $FILER_API{$FILER_C};
					    if ($test_setup ne 'FC'){
  						 	$Api_Set_Obj->execute_command('command'  => 'sasadmin inject disable');
					    } else {
							$Api_Set_Obj->execute_command('command'  => 'fcadmin inject disable');
						}
                     }
					logcomment("End of error injection");
                }

        
				 $Test->nlog("===================================================================================");
                 $Test->nlog("==== PRE_TEST STEP 19 : Execute get_phy_state");
                 $Test->nlog("===================================================================================");
                 foreach my $Node (@Nodes) {
                    my $FILER_C = $Node->name();
                    if ($test_setup ne 'FC'){
                        logcomment("$FILER_C - Execute sasadmin expander_phy_state");
                        $GET_PHY_STATE->{$FILER_C}= get_phy_state(Node=>$Node);
						 logcomment("$FILER_C - End of sasadmin expander_phy_state");
                    }else{
						logcomment("No checknig for FC");
                    }
                 }

				$Test->nlog("===================================================================================");
                $Test->nlog("==== PRE_TEST STEP 20 : Executing command to get scsi inquiry of each disk");
                $Test->nlog("===================================================================================");
                foreach my $Node(@Nodes){
                        my $FILER_C = $Node->name();
                        logcomment("$FILER_C - Execute scsi inquiry");
                        if ($execution_state eq 'CLI'){
                                $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
                        } else {
                                $Api_Set_Obj = $FILER_API{$FILER_C};
                        }
                        my $result = scsi_inquiry_cmode(API_OBJ=> $Api_Set_Obj,Node=> $Node);
                        if ($result == 0)
                        {
                                logcomment("scsi inquiry completed for all disks");
                        }
                }
				$Test->nlog("===================================================================================");
                 $Test->nlog("==== PRE_TEST STEP 21 : Execute storage show disk -a");
                 $Test->nlog("===================================================================================");
                 foreach my $Node (@Nodes) {
	                my $FILER_C = $Node->name();
					logcomment("$FILER_C - Execute storage show disk -a");
					$STO_DISK_SHOW->{$FILER_C}= storage_show_disk_a_data(Node=>$Node);
				 	logcomment("$FILER_C - End of Execute storage show disk -a");
                 }
              $Test->nlog("##################################################################################");
              $Test->nlog("##");
              $Test->nlog("## End of PRE_TEST logs for Filer : @Filer_array");
              $Test->nlog("##");
              $Test->nlog("##################################################################################");
#End of pre test
}

#######################################################################################################
#Subroutine Defn Begins
###
###
# Auther         - vpankaj@netapp.com
# Description    - This subroutine is used in all the test for post test process.
# Post Functions -  check state and change to required state
#                   version
#                   disk_list
#                   sysconfig -v
#                   sysconfig -r
#                   sasadmin dev_stats
#                   storage show
#                   sasadmin expander_map
#                   vol status -s
#                   df command to display size
#                   disk_qual start -t 12 -d all
#                   check for failed and zeroing drives.
#                   Check for fan speed and set to default.
#                   Stop error injection
#                   sasadmin dev_stats
# Supported Mode -  Cmode
###
#######################################################################################################

sub execute_post_test {
    my (%opts) = validate(
        @_,
        {
                        filer_mode      => { type => SCALAR },
                        node_present => { type => ARRAYREF},
                        Test            => { type => OBJECT },
                        change_state_to => { type => SCALAR, optional => 1, default => 'CLI'},
                        LOGDIR                  => {type => SCALAR, optional => 1, default => ''},
                        test_setup              => {type => SCALAR, optional => 1, default => 'SAS'},
                        BOOT_TYPE               => {type => SCALAR, optional => 1, default => 'A'},
                }
                );

        my @Nodes = @{ $opts{node_present} };
		my @Nodes = NACL::C::Node->find();
		handle_run_local_error();
        my $Filer_mode = $opts{filer_mode};
        my $Test = $opts{Test};
        my $change_to = $opts{change_state_to};
        my $TEST_CONFIG = $opts{test_config};
        my $test_setup = $opts{test_setup};
        my $exit_test = 0;
        my @Filer_array = ();
        my $execution_state ;
        my @disk_list ;
        my $node_ref;
        my @disk_array;
        my %FILER_API = ();
        my @disk_array;
        my $timeout;
        my $Api_Set_Obj;
	my $disk_capacity_total = 0;
	my $disk_capacity_total_GB = 0;
        my $LOGDIR = $opts{LOGDIR};
        my $params = NATE::ParamSet->new(global => 1);
        my $EOE                 = $params->get('EOE', default => 'default' );
        my $EMAIL               = $params->get('EMAIL',default => 'y' );
        my $MAIL_TO             = $params->get('MAIL_TO', default => 'Email to');
        my $MAIL_FROM           = $params->get('MAIL_FROM', default => 'Email from');

        if ($opts{LOGDIR}){
                $LOGDIR = $opts{LOGDIR};
        }else{
                $LOGDIR = $ENV{HOME};
        }
        my $TEST_NAME;
        opendir( DIR_LOG31, $LOGDIR );
        my @files_DIR_LOG31 = readdir(DIR_LOG31);
        foreach my $file (@files_DIR_LOG31) {
                if ( ($file =~ /(.*_NADQ02.*)\.log/) && ($file !~ /results|END_FILER_CONFIG/ )) {
                        $TEST_NAME = $1;
                }
        }
        $node_ref = \@Nodes;
        foreach my $temp_node (@Nodes){
        my $Filer = $temp_node->name();
        push (@Filer_array, $Filer);
    }

        # Check state of filer and Execute based on state
        logcomment("Nodes present - @Filer_array");
        logcomment("Log loction - $LOGDIR");
        my @chk_state = ();
        # Check for state and call respective subroutines:
                foreach my $Node (@Nodes){
                        my $Transit_obj;
                        my $FILER_C = $Node->name();
                        $Transit_obj = NACL::Transit->new( name => $FILER_C );
                        my $filer_state = $Transit_obj->get_state('timeout' => 600);
                        $Test->nlog("$FILER_C : Filer is in $filer_state ");
                        push(@chk_state, $filer_state);
                }
                my $len = @chk_state;
                if ($len > 1){
               if ($chk_state[0] eq $chk_state[1]){
               $execution_state = $chk_state[0];
                       $Test->nlog("Execution state - $execution_state\n");
               }else{
                   $Test->nlog("States of filer is different, Boot filer in same mode");
               }
        }else{
                $execution_state = $chk_state[0];
                $Test->nlog("Execution state - $execution_state\n");
            }

        # Check filer State and change to required state
                $Test->nlog("##################################################################################");
                $Test->nlog("##");
                $Test->nlog("## Begining of POST_TEST logs for Filer : @Filer_array");
                $Test->nlog("##");
                $Test->nlog("##################################################################################");
                $Test->nlog("Checking boot state of filer, and booting in required mode");
                my $filer_state;
                my $Transit_obj;
                my @change_states;
                my $Check_flag = 0;
				
                foreach my $Node (@Nodes){
                        my $FILER_C = $Node->name();
                        my $Transit_obj = NACL::Transit->new( name => $FILER_C );
                        my $filer_state = $Transit_obj->get_state('timeout' => 600);
                        logcomment("Filer $FILER_C is in $filer_state ");
                    if ($opts{change_state_to}){
                            if ($filer_state ne $change_to){
                            $Test->nlog("Filer - $FILER_C is in $filer_state state");
                            logcomment("Filer - $FILER_C is not in required state - $change_to, Changing to $change_to");
                                                push(@change_states, $FILER_C);
                    }
                        if ($filer_state eq $change_to){
                            $Test->nlog("Filer - $FILER_C is in $filer_state state");
                            $Test->nlog("Filer - $FILER_C is in required state - $change_to");
                        }
                                }
                }
                my @subtests;
                if (@change_states){
                    foreach my $filer_name (@change_states){
                        push(@subtests, subtest(
                                                                \&boot_filer_in_req_state, -runid,
                                                "boot_filer_in_req_state_" . "$filer_name", -bg,
                                        "--", Test => $Test,
                                                                filer_name => $filer_name,
                                                                change_state_to => $change_to,
                         )
                    );
                }
                        $Test->nlog("Subtest @subtests");
                    Subtest::wait_finish( subtest => [@subtests] );
                    my ( $fail_cnt, $fatal_cnt );
                    my @results;
                    foreach my $subtest (@subtests) {
                        @results = $subtest->rslts();
                        foreach my $result (@results) {
                            if ( $result->type() =~ /INFO/ ) {
                                $Test->nlog("Subtest boot_filer_in_req_state completed successfully");
                            } elsif ( $result->severity() >= 0 ) {
                                $Test->nlog("Subtest boot_filer_in_req_state not completed successfully");
                                if ( $result->type() =~ /FAIL/i ) {
                                    $fail_cnt++;
                                }
                                if ( $result->type() =~ /FATAL|SCRIPT|CONFIG/ ) {
                                    $fatal_cnt++;
                                }
                            } ## end elsif ($result->severity(...
                        } ## end foreach my $result (@results)
                    } ## end foreach my $subtest (@subtests)
                    if ( $fail_cnt == 0 ) {
                        $Test->nlog("FILER Booted the filer successfully in required state");
                                $Check_flag = 1;
                    }
        }
        # Check state of filer after booting
        if ($Check_flag == 1){
                foreach my $Node (@Nodes){
                        my $Transit_obj;
            my $FILER_C = $Node->name();
            $Transit_obj = NACL::Transit->new( name => $FILER_C );
            my $filer_state = $Transit_obj->get_state('timeout' => 600);
            $Test->nlog("$FILER_C : Filer is in $filer_state ");
                        if ("$filer_state" eq "$change_to") {
                                $Test->nlog("$FILER_C : Is in required test, proceeding with test");
                                $execution_state = $filer_state;
                                $Test->nlog("$FILER_C : Execution state changed to : $change_to");
                        }
                        if ("$filer_state" ne "$change_to") {
                                $Test->nlog("$FILER_C : Is not in required state");
                                logresult( "FATAL","$FILER_C is not in required state, Cannot boot in required state" );
                }
                }
        }

        # If maintenanace mode :
        if ($execution_state eq 'MAINT'){
                foreach my $Node(@Nodes){
                my $Filer = $Node->name();
                    my $host = host($Filer);
                    my $API_Object = NACL::APISet->new(
                            hostobj   => $host,
                            category  => "Node",
                            interface => "CLI",
                            set       => "Maintenance"
                            );
                $FILER_API{$Filer} = $API_Object;
                }
        }

        # Check security login, ssh option
		
		$Test->nlog("===================================================================================");
        $Test->nlog("==== POST_TEST STEP 1 : Check SSH connection in post test");
        $Test->nlog("===================================================================================");
        foreach my $Node(@Nodes){
	        my $FILER_C = $Node->name();
			logcomment("$FILER_C - Checking SSH parameters");
    	    if ($execution_state eq 'CLI'){
	            $Test->nlog("$FILER_C : Check security login, enable ssh option ");
                $Test->nlog("$FILER_C : Filer mode is : $Filer_mode");
                enable_ssh(Node  => $Node,
                         Test  => $Test,
                         Mode  => $Filer_mode,);
                $Test->nlog("$FILER_C : Disable all storage debug messages");
                my $host = host($FILER_C);
				disable_debug_msg(Node => $Node);
            }else{
				logcomment("Filer $FILER_C is in Maintenance mode, SSH is not used in maintenance mode");
			}
			logcomment("$FILER_C - End of Checking SSH");
		}

	# Checking Kernel version 
        $Test->nlog("===================================================================================");
        $Test->nlog("==== POST_TEST STEP 2 : Record version of Kernel used in Post test");
        $Test->nlog("===================================================================================");		
		foreach my $Node(@Nodes){
            my $FILER_C = $Node->name();
			logcomment("$FILER_C - Checking Kernel version on filers");
            if ($execution_state eq 'CLI'){
 		        $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
            } else {
                $Api_Set_Obj = $FILER_API{$FILER_C};
            }
            my $ver_output = $Api_Set_Obj->execute_command('command' => 'version');
            logcomment("Version on $FILER_C - $ver_output");
			logcomment("End of Checking kernel version");
         }

        #check for disk availibility (pre test)
		$Test->nlog("===================================================================================");
        $Test->nlog("==== POST_TEST STEP 3 : Checking for disk availability");
        $Test->nlog("===================================================================================");
        {
        my ($max_disk_size,$disk_size);
        my @disk_list_common;
		logcomment("Checking Disk Availability");
        if ($execution_state eq 'CLI'){
	        @disk_list_common = NACL::C::StorageDisk->find(
    		           command_interface => $Nodes[0],
                      );
            @disk_list;
            foreach my $disk (@disk_list_common) {
	            push( @disk_list, $disk->get_one_state_attribute('disk') );
            }
            my $disk_length = @disk_list;
            if ($disk_length >0 ){
    	        $Test->nlog("@Filer_array - Disk attached - @disk_list");
            } else {
                $Test->nlog("@Filer_array -No disk available for testing, exiting from rest of the test cases");
                $exit_test = 1;
                logresult( "FATAL", "@Filer_array - No disk available for testing, exiting from rest of the test cases");
            }
        } else {
            my $FILER_C = $Nodes[0]->name();
            my $Api_Set_Obj = $FILER_API{$FILER_C};
            logcomment("Filer : $FILER_C : executing disk_list on the filer");
            my $dsk_output =  $Api_Set_Obj->execute_raw_command( 'command' => "disk_list" );
			my $disk_list_result = {};
		    my @lines  = split( /\n/, $dsk_output );
		    my $n      = 0;
		    while ( $n <= $#lines ) {
		        last if ( $lines[$n] =~ /^-----/ );
		        $n++;
		    }
		    $n++;
		    foreach my $line ( @lines[ $n .. $#lines ] ) {
		        my (
	            $disk,     $chan, $ven,    $prodid, $rev,
	            $serialno, $hw,   $blocks, $bps,    $dq
		          )  = ( $line =~/(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/);
		        if ( ( $line =~ /\d\w\.\d\d/ ) || ( $line =~ /\d\w\.\d\d\.\d\d/ ) ) {
		            $disk_list_result->{$disk} = {
		                'DISK'       => $disk,
		                'CHAN'       => $chan,
		                'VENDOR'     => $ven,
		                'PRODUCT_ID' => $prodid,
		                'REV'        => $rev,
		                'SERIAL'     => $serialno,
		                'HW'         => $hw,
		                'BLOCKS'     => $blocks,
		                'BPS'        => $bps,
		                'DQ'         => $dq
		            };
		        }
		    }

           @disk_array = keys(%{$disk_list_result});
           my $disk_length = @disk_array;
           if ($disk_length > 0 ){
 	          $Test->nlog(" Disk attached - @disk_array");
           } else {
              $Test->nlog("No disk available for testing, exiting from rest of the test cases");
              logresult( "FATAL", "- No disk available for testing, exiting from rest of the test cases");
           }
           for my $dsk (@disk_array) {
     	      $disk_size = $disk_list_result->{$dsk}->{'BLOCKS'};
              $max_disk_size = $disk_size if ( $disk_size > $max_disk_size );
              $disk_capacity_total = $disk_capacity_total + $disk_size;
           }
		   $disk_capacity_total_GB = int(($disk_capacity_total/2147483648)*1000);
		   logcomment("Tota Disk Capacity in GB : $disk_capacity_total_GB");
           my $in_GB =  int(($max_disk_size/2147483648)*1000);
           $Test->nlog("Max disk size : In Blocks is $max_disk_size i.e $in_GB GB");
           if ( $max_disk_size <= 20971520 ) {
              $timeout = $timeout + 1200;
           } elsif ( $max_disk_size <= 2147483648 ) {
              $timeout = $timeout + ( 1200 * 5 );
           } else {
              $timeout = $timeout + ( 1200 * 10 );
           }
         }
		logcomment("End of checking Disk Availability");
       }

        # Get filer config
        $Test->nlog("===================================================================================");
        $Test->nlog("==== POST_TEST STEP 4 : Get Filer configurations");
        $Test->nlog("===================================================================================");
	    foreach my $Node(@Nodes){
    	    my $FILER_C = $Node->name();
			logcomment("Get filer configruation for filer $FILER_C");
            if ($execution_state eq 'CLI'){
	            $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
				$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
                $Api_Set_Obj->execute_command('command' => 'sysconfig -v' , 'timeout' => 600);
            } else {
                $Api_Set_Obj = $FILER_API{$FILER_C};
				$Api_Set_Obj->execute_command('command' => 'sysconfig -v' , 'timeout' => 600);
            }
			logcomment("End of Get filer configruation for filer $FILER_C");
        }

        # Execution sysconfig -r
        $Test->nlog("===================================================================================");
        $Test->nlog("==== POST_TEST STEP 5 :Record sysconfig -r information of the filer");
        $Test->nlog("===================================================================================");
		if ($execution_state eq 'CLI'){
			my @subtests;
			foreach my $Node(@Nodes){
				my $FILER_C = $Node->name();
				push(@subtests,	subtest(\&check_recons_sickdisk, -runid, "check_recons_sickdisk_$FILER_C", -bg,"--", Node =>$Node));
			}
			Subtest::wait_finish(subtest => [@subtests]);
			status_return(subtest_ref  =>[@subtests]);
		}else{
			foreach my $Node (@Nodes){
				my $FILER_C = $Node->name();
				logcomment("$FILER_C - Executing aggr status -r");
				$Api_Set_Obj = $FILER_API{$FILER_C};
				$Api_Set_Obj->execute_command('command' => 'aggr status -r' , 'timeout' => 600);
			}
		}

        # Record link statistics for all adapters and drives
         $Test->nlog("===================================================================================");
         $Test->nlog("==== POST_TEST STEP 6 : Record link statistics for all adapters and drives");
         $Test->nlog("===================================================================================");
         foreach my $Node (@Nodes){
	        my $FILER_C = $Node->name();
            my $Host = host($FILER_C);
			logcomment("$FILER_C - Record link statistics");
			if(!(defined $SAS_ADMIN_DEV_PRE->{$FILER_C})){
				logcomment("**WARNING** : $FILER_C : link statistics are not recorded properly in PRE-TEST process");
				next;
			}
            if ($test_setup ne 'FC'){
				my $after =  sasadmin_dev_stats_cmode( node => $Node );
				if(compare_sasadmin_dev_stats(initial_stats =>$SAS_ADMIN_DEV_PRE->{$FILER_C},final_stats =>$after) ==1){
					logcomment("$FILER_C : link statistics values are same when compared from PRE to POST test process");
				}else{
					logcomment("$FILER_C : link statistics values are different when compared from PRE to POST test process");
				}
            } else {
				my $after = fcadmin_fcal_stats( Node => $Node );
				if(compare_fcadmin_fcal_stats(fcadmin_fclstats_add_before =>$SAS_ADMIN_DEV_PRE->{$FILER_C},fcadmin_fclstats_add_after =>$after) ==1){
					logcomment("$FILER_C : link statistics values are same when compared from PRE to POST test process");
				}else{
					logcomment("$FILER_C : link statistics values are not same when compared from PRE to POST test process");
				}
            }
			logcomment("$FILER_C - End of recording link stats");
         }

        # Storage show information of the filer
         $Test->nlog("===================================================================================");
         $Test->nlog("==== POST_TEST STEP 7 : Record storage show information of the filer");
         $Test->nlog("===================================================================================");
         foreach my $Node (@Nodes){
             my $FILER_C = $Node->name();
             logcomment("$FILER_C - Executing storage show");
             if ($execution_state eq 'CLI'){
	             $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
				 $Api_Set_Obj->execute_command('command' => 'storage show' , 'timeout' => 600);
             } else {
                 $Api_Set_Obj = $FILER_API{$FILER_C};
			  	 $Api_Set_Obj->execute_command('command' => 'storage show' , 'timeout' => 600);
             }
			logcomment("End of $FILER_C - Executing storage show");
          }

        # Record expander map of the adapter
         $Test->nlog("===================================================================================");
         $Test->nlog("==== POST_TEST STEP 8  : Record expander map of the adapter");
         $Test->nlog("===================================================================================");
         foreach my $Node (@Nodes){
	         my $FILER_C = $Node->name();
             my $Host = host($FILER_C);
			 logcomment("$FILER_C - Record expander map of the adapter");
             if ($test_setup ne 'FC'){
      	       sasadmin_expander_map_cmode( node => $Node );
             } else {
		       fcadmin_device_map( Node => $Node );
             }
			logcomment("$FILER_C - End of recording expander map");
         }

        # Record Spare drives
          $Test->nlog("===================================================================================");
          $Test->nlog("==== POST_TEST STEP 9  : Record Spare drives attached");
          $Test->nlog("===================================================================================");
          foreach my $Node (@Nodes){
             my $FILER_C = $Node->name();
			 logcomment("Record Spare drives attached");
             if ($execution_state eq 'CLI'){
	             $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
                 $Api_Set_Obj->execute_command('command' => 'vol status -s');
             } else {
                 $Api_Set_Obj = $FILER_API{$FILER_C};
                 $Api_Set_Obj->execute_command('command' => 'aggr status -s');
             }
			logcomment("End of recording spare drives");
          }

        # Record df command to display size
           $Test->nlog("===================================================================================");
           $Test->nlog("==== POST_TEST STEP 10 : Record df command to display size");
           $Test->nlog("===================================================================================");
           foreach my $Node (@Nodes){
		       my $FILER_C = $Node->name();
			   logcomment("$FILER_C - Record df command to display size");
               if ($execution_state eq 'CLI'){
        	       $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
                   $Api_Set_Obj->execute_command('command' => 'df');
               } else {
				   logcomment("FILER_C : is in Maintenance, Hence printing disk capacity size");
			 	   logcomment("$FILER_C : Total capacity of Disk : $disk_capacity_total i.e In GB $disk_capacity_total_GB");
               }
			   logcomment("End of recording df command to display size");
           }

        # Execute disk_qual t 12 for all disk
           $Test->nlog("===================================================================================");
           $Test->nlog("==== POST_TEST STEP 11 : Printing logsense data for all the disks");
           $Test->nlog("===================================================================================");
           foreach my $Node (@Nodes){
				my $FILER_C = $Node->name();
				logcomment("$FILER_C - Print logsense data for all the disks");
				my $after = scsi_disk_errors( Node => $Node );
				if(!(defined  $SCSI_DISK_ERRORS->{$FILER_C})){
					logcomment("**WARNING** : $FILER_C : logsense data for all the disks was not executed properly in PRE-TEST process");
					next;
				}
				if(compare_scsi_disk_errors(before =>$SCSI_DISK_ERRORS->{$FILER_C},after =>$after)==1){
					logcomment("Ssci disk error values are not matching from PRE to POST test process");
				}else{
					logcomment("Ssci disk error values are matching from PRE to POST test process");
				}
           }
		   logcomment("End of Printing logsense data for all the disks");

        #check for failed and zeroing drives
           $Test->nlog("===================================================================================");
           $Test->nlog("==== POST_TEST STEP 12 : Check for non-zeroed disk or failed disk, unfail disk");
           $Test->nlog("===================================================================================");
            if ($execution_state =~/CLI/){
				disable_fg_bg_firmware_hammer(Nodes =>[@Nodes]);
				{
					my @subtests;
					foreach my $Node(@Nodes){
						my $FILER_C = $Node->name();
						push(@subtests, subtest( \&report_failed_drives, -runid,
									"report_failed_drives_" . "$FILER_C", -bg,
									"--", Node   => $Node,
									)
							);
					}
					logcomment("Subtest @subtests");
					Subtest::wait_finish( subtest => [@subtests] );
				}
				unfail_disk_zero_spares(Nodes =>[@Nodes]);
				logcomment("End of checking for non-zeroed disk or failed disk, unfail disk");
			} else {
				logcomment("No need to Check for non-zeroed disk or failed disk, unfail disk for Maintenance mode");
            }

        # Check for fan speed (pre)
              $Test->nlog("===================================================================================");
              $Test->nlog("==== POST_TEST STEP 13 : Making changes for fan speed if test setup is SAS");
              $Test->nlog("===================================================================================");
              foreach my $Node (@Nodes){
 	             my $FILER_C = $Node->name();
    	             if ($test_setup eq "SAS" ) {
        	             foreach my $Node (@Nodes) {
                                my $adapterslot;
                                my ($shelfid,$adapter_val);
                                my %adapter_hash;
                                my $flag1 = 0;
                                my $FILER_C = $Node->name();
             				   	logcomment("$FILER_C - Checking for fan speed");
                        		if ($execution_state eq 'CLI'){
                                	$Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		                        } else {
        	                        $Api_Set_Obj = $FILER_API{$FILER_C};
                        		}
                                my $output = $Api_Set_Obj->execute_command('command'  => 'sasadmin expander_map');
                                my @slot_array = split( /\n\n/, $output );
                                foreach (@slot_array) {
                                        my @shelfid;
                                        if ( $_ =~ /Expanders on channel\s+(\w+)/ ) {
                                                $adapterslot = $1;
                                        }
                                        if ( $_ =~ /.*\s+ID\s+(\d+)/ ) {
                                                @shelfid =$_=~/.*\s+ID\s+(\d+)/g;
                                        }
                                        if ( ( $adapterslot ne "" ) && ( @shelfid ) ) {
                                                $adapter_hash{$adapterslot} = [@shelfid];
                                        }
                                }
                                #Setting the fan Speeds to default values
                                my $flag1 = 0;
                                foreach my $key ( keys %adapter_hash ) {
                                        last if ( $flag1 == 1 );
                                        my @var = @{$adapter_hash{$key}} if (defined $adapter_hash{$key});
                                        foreach(@var){
                                                $adapter_val = "$key.$_";
                                                my $aft = $Api_Set_Obj->execute_command('command' => "sasadmin expander_cli $adapter_val 'fan_set normal'" );
                                                if ( $aft =~ /Setting all fans to normal/ ) {
                                                    sleep(60);
                                                    logcomment("Fan-speed has set to default value");
                                                    logcomment("Checking the Fans speed again");
                                                    $Api_Set_Obj->execute_command('command'  => "sasadmin expander_cli $adapter_val 'fan_set speed'");
                                                    sleep 5;
                                                    $flag1 = 1;
                                                    last;
                                                }
                                        }
                                }
								logcomment("End of Checking for fan speed");
                                }#End of foreach nodes.
                        }else{
							logcomment("$FILER_C - Filer is not of SASA type , Hence not checking for fan speed");
						}
                }

        # Stop any error injection if running (pre-cli)
            $Test->nlog("===================================================================================");
            $Test->nlog("==== POST_TEST STEP 14 : Stop any error injection if running ");
            $Test->nlog("===================================================================================");
            foreach my $Node (@Nodes) {
	            my $FILER_C = $Node->name();
				logcomment("$FILER_C - Stop any error injection");
                if ($execution_state eq 'CLI'){
     	           $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
				if ($test_setup ne 'FC'){
				   $Api_Set_Obj->execute_command('command'  => 'sasadmin inject disable');
				 } else {
				 	$Api_Set_Obj->execute_command('command'  => 'fcadmin inject disable');
				 } 
                } else {
                    $Api_Set_Obj = $FILER_API{$FILER_C};
					 if ($test_setup ne 'FC'){
					 $Api_Set_Obj->execute_command('command'  => 'sasadmin inject disable');
				 } else {
					 $Api_Set_Obj->execute_command('command'  => 'fcadmin inject disable');
				 }
               }
			 logcomment("End of Stopping any error injection");
            }

        # Execute sasadmin dev_stats
			$Test->nlog("===================================================================================");
            $Test->nlog("==== POST_TEST STEP 15 : Execute sasadmin get_phy_state");
            $Test->nlog("===================================================================================");
            foreach my $Node (@Nodes) {
                my $FILER_C = $Node->name();
                if ($test_setup ne 'FC'){
                    logcomment("$FILER_C - Execute sasadmin expander_phy_state");
                    my $return = get_phy_state(Node=>$Node);
                    logcomment("$FILER_C - End of Execute sasadmin get_phy_state");
					if(! (defined $GET_PHY_STATE->{$FILER_C})){
						logcomment("**WARNING** : $FILER_C : sasadmin get_phy_state command was not executed properly in PRE-TEST process");
						next;
					}
                    if(compare_phy_state(before => $GET_PHY_STATE->{$FILER_C},after=>$return,Node=>$Node)=~/true|1/){ #disk_ref=>[@drives_disk_show_a]){
                        logcomment("$FILER_C : sasadmin get_phy_state values are matching from PRE to POST test process");
                    }else{
                        logcomment("$FILER_C : sasadmin get_phy_state values and are not matching from PRE to POST test process");
                    }
                }else{
					logcomment("Not checking for FC");
                }
			}
           
	
			$Test->nlog("===================================================================================");
            $Test->nlog("==== POST_TEST STEP 16 : Executing command to get scsi inquiry of each disk");
            $Test->nlog("===================================================================================");
            foreach my $Node(@Nodes){
                    my $FILER_C = $Node->name();
                    logcomment("$FILER_C - Execute scsi inquiry");
                    if ($execution_state eq 'CLI'){
                            $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
                    } else {
                            $Api_Set_Obj = $FILER_API{$FILER_C};
                    }
                    my $result = scsi_inquiry_cmode(API_OBJ=> $Api_Set_Obj,Node=> $Node);
                    if ($result == 0)
                    {
						logcomment("scsi inquiry completed for all disks");
                    }
            }
		 $Test->nlog("===================================================================================");
            $Test->nlog("==== POST_TEST STEP 17 : Execute storage show disk -a");
            $Test->nlog("===================================================================================");
            foreach my $Node (@Nodes) {
	            my $FILER_C = $Node->name();
				logcomment("$FILER_C - Execute storage show disk -a");
				my $return = storage_show_disk_a_data(Node=>$Node);
				if(!(defined  $STO_DISK_SHOW->{$FILER_C})){
					logcomment("**WARNING** : $FILER_C : storage show disk -a command was not executed properly in PRE-TEST process");
					next;
				}
				if(compare_WWN(before => $STO_DISK_SHOW->{$FILER_C},after=>$return)){
					logcomment("$FILER_C : WWN values are matching from PRE to POST test process");
				}else{
					logcomment("$FILER_C : WWN values are not matching from PRE to POST test process");
				}
            }
			
			
			my @subtests;
			foreach my $Node(@Nodes){
				my $FILER_C = $Node->name();
				push(@subtests,	subtest(\&read_ems_logs, -runid, "read_ems_logs_$FILER_C", -bg,"--", Node =>$Node));
				#push(@subtests,	subtest(\&read_shelflog, -runid, "read_shelflog_$FILER_C", -bg,"--", Node =>$Node));
			}
			Subtest::wait_finish(subtest => [@subtests]);
			$Test->nlog("===================================================================================");
            $Test->nlog("==== POST_TEST STEP 18 : Copying the system logs to the filer");
            $Test->nlog("===================================================================================");
			foreach my $Node(@Nodes){
				my $FILER_C = $Node->name();
				my $params = NATE::ParamSet->new(global => 1);
				my $LOGDIR = $params->get('LOGDIR', default => undef);
				my ($actual_log_dir) =$LOGDIR=~/(\S+)\/HDD/;
				if(!(-d "$actual_log_dir\/SYSTEM_LOGS")){
					system("sudo mkdir $actual_log_dir\/SYSTEM_LOGS");
				}
				my $log_dir = "$actual_log_dir\/SYSTEM_LOGS\/".$parse_id."_".$FILER_C;
				get_system_logs(Node  => $Node,logdir =>$log_dir);
				logcomment("$FILER_C : System logs copied to the directory : $log_dir");
			}
			# Subtest::wait_finish(subtest => [@subtests]);
            $Test->nlog("##################################################################################");
            $Test->nlog("##");
            $Test->nlog("## End of POST_TEST logs for Filer : @Filer_array");
            $Test->nlog("##");
            $Test->nlog("##################################################################################");

#End of post test
}

#######################################################################################################
# Auther - priya3
# Description -  sasadmin_dev_stats_cmode
# Supported Mode - CMode/7Mode
######################################################################################################
sub sasadmin_dev_stats_cmode {
 my (%opts) = validate(@_,{
     node     => { type => OBJECT },
     adapter_name   => {type=>SCALAR, default=>undef, optional=>1},
  }
 );
 my $Node = $opts{node};
 my $Mode = $Node->mode();
 my $API_obj;
 my $FILER_C = $Node->name();
 my $adapter = undef ;
 my $output = "";
 if(defined($opts{adapter_name})){
  $adapter = $opts{adapter_name};
 }
	my %structure =();
	my $cmd = "sasadmin dev_stats";
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if($filer_state=~/MAINT/gi){
		my $Host = host($FILER_C);
			$API_obj = NACL::APISet->new(
				hostobj   => $Host,
				category  => "Node",
				interface => "CLI",
				set       => "Maintenance"
			);
		$output = $API_obj->execute_raw_command('command' => "$cmd");
	}elsif($filer_state=~/(CLI|UP)/gi){
		$API_obj = $Node->get_7m_or_nodescope_apiset();
		$output = $API_obj->execute_command('command' => "$cmd");
	}
	$API_obj->set_timeout( "connectrec-timeout" => 1200 );
	if($output !~ /Device stats on channel/){
	logcomment("$FILER_C : WARNING : No expected output appeared");
	return ;
	}
	$output=~s/'|,|://g;  #removing all (' and : and ,)
	my(@tot_channels,$total);
	@tot_channels=$output=~/Device stats on channel\s(\S+)/g;
	$total=@tot_channels;
	my $hba;
	my @lines = split(/\r*\n/, $output);
	foreach (@lines) {
	if($_ =~ /Device stats on channel\s(\S+)/){
	
	$hba = $1;
	}
	if($_ =~ /(^$hba\.\S+)\s+/) {
	
	my @fields = split(/\s+/, $_);
	$structure{$hba}{"$fields[0]"}{'Device'} = $fields[0];
	$structure{$hba}{"$fields[0]"}{'CmdsCmpltGood'} = $fields[1];
	$structure{$hba}{"$fields[0]"}{'CmdsCmpltError'} = $fields[2];
	$structure{$hba}{"$fields[0]"}{'FramesIn'} = $fields[3];
	$structure{$hba}{"$fields[0]"}{'FramesOut'} = $fields[4];
	$structure{$hba}{"$fields[0]"}{'VctmAbrt'} = $fields[5];
	$structure{$hba}{"$fields[0]"}{'QsceCnt'} = $fields[6];
	$structure{$hba}{"$fields[0]"}{'UdrnCnt'} = $fields[7];
	$structure{$hba}{"$fields[0]"}{'OvrnCnt'} = $fields[8];
	$structure{$hba}{"$fields[0]"}{'TrnsErrCnt'} = $fields[9];
	$structure{$hba}{"$fields[0]"}{'SCSIPtclErrCnt'} = $fields[10];
	$structure{$hba}{"$fields[0]"}{'CRCErrCnt'} = $fields[11];
	$structure{$hba}{"$fields[0]"}{'OPENErrCnt'} = $fields[12];
	$structure{$hba}{"$fields[0]"}{'InvdCnt'} = $fields[13];
	$structure{$hba}{"$fields[0]"}{'DlayCnt'} = $fields[14];
	$structure{$hba}{"$fields[0]"}{'SATAInitFailCnt'} = $fields[15];
	$structure{$hba}{"$fields[0]"}{'TO1Ct'} = $fields[16];
	$structure{$hba}{"$fields[0]"}{'TO2Ct'} = $fields[17];
	$structure{$hba}{"$fields[0]"}{'TO3Ct'} = $fields[18];
	$structure{$hba}{"$fields[0]"}{'TO4Ct'} = $fields[19];
	}
	}
	my $up_chan=0;
	my @up_channles=keys(%structure);
	$up_chan=@up_channles;
	logcomment("$FILER_C : Total number of channels are $total and the channels are @tot_channels") ;
	logcomment("$FILER_C : Total number of UP channels are $up_chan and the channels are @up_channles");
	return \%structure;
}

#######################################################################################################
## Author Arjun Lavu
## Description -  sasadmin_expander_map_cmode
## The following named arguments are accepted:
## item Node
## (Required) : Node object to execute a command.
## item adapter_name
## (Optional) : Specific channel for which the information is
## required. Default is all
## Supported Mode - CMode/7Mode[CLI/MAINT]
#######################################################################################################
sub sasadmin_expander_map_cmode {
	my (%opts) = validate(@_,
		{
			node     => { type => OBJECT },
			adapter_name   => {type=>SCALAR, default=>undef, optional=>1},
		}
	);
	my $Node = $opts{node};
	my $Mode = $Node->mode();
	my $API_obj;
	my $FILER_C = $Node->name();
	my $adapter = undef ;
	my $output = "";
	
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if(defined($opts{adapter_name})){
		$adapter = $opts{adapter_name};
	}
	my %structure =();
	my $cmd = "sasadmin expander_map $adapter";
	if($filer_state=~/MAINT/gi){
		my $Host = host($FILER_C);
		$API_obj = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance"
		);
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $API_obj->execute_raw_command('command' => "$cmd");
	}elsif($filer_state=~/(CLI|UP)/gi){
		$API_obj = $Node->get_7m_or_nodescope_apiset();
		$API_obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $API_obj->execute_command('command' => "$cmd");
	}
	
	if($output !~ /Expanders on channel/){
		logcomment("$FILER_C : WARNING : No expected output appeared");
		return ;
	}
	$output=~s/'|,|://g;  #removing all (' and : and ,)
	my(@tot_channels,$total);
	@tot_channels=$output=~/Expanders on channel\s(\S+)/g;
	$total=@tot_channels;
	my $hba;
	my @lines = split(/\r*\n/, $output);
	foreach (@lines) {
		if($_ =~ /Expanders on channel\s(\S+)/){
			$hba = $1;
		}
		if($_ =~ /^Level/) {
			my @fields = split(/\s+/, $_);
			$structure{$hba}{"$fields[3]"}{'Level'} = $fields[1];
			$structure{$hba}{"$fields[3]"}{'ID'} = $fields[5];
			$structure{$hba}{"$fields[3]"}{'SerialNumber'} = $fields[8];
			$structure{$hba}{"$fields[3]"}{'Product'} = $fields[10];
			$structure{$hba}{"$fields[3]"}{'Rev'} = $fields[12];
			$structure{$hba}{"$fields[3]"}{'Slot'} = $fields[14];
		}
	}
	my $up_chan = 0;
	my @up_channles=keys(%structure);
	$up_chan = @up_channles;
	logcomment("$FILER_C : Total number of channels are $total and the channels are @tot_channels");
	logcomment("$FILER_C : Total number of UP channels are $up_chan and the channels are @up_channles");
	return \%structure;
}


sub handle_run_local_error{
	my @temp_nodes = NACL::C::Node->find();      # Find Nodes/Filers used in the test, Based on FILER param.
	my %nodes_filer; 
	foreach my $Node (@temp_nodes) {
        my $FILER_C = $Node->name();
        $nodes_filer{$FILER_C} = [$Node];
    }
	my @Nodes= map{@{$_}}grep{(/\S/)}values(%nodes_filer);
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		my $Transit_obj = NACL::Transit->new( name => $FILER_C );
		my $filer_state;
		try{
			$filer_state = $Transit_obj->get_state('timeout' => 600);
		}catch NACL::Transit::Exceptions::Timeout with {
			logcomment("Expected: Caught a Timeout exception");
			$filer_state = $Transit_obj->get_state('timeout' => 300);
		}catch NACL::Transit::Exceptions::TransitException with {
			my $exception_object = shift;
			# logcomment("Exception is of type: " . ref ($exception_object));
			# logcomment("Error text is: " . $exception_object->text());
		};
		if($filer_state=~/USER|PASS/i){
			$Transit_obj->change_state( to => "CLI");
		}
		if($filer_state=~/CLI/i){
			#############################################################################
			my $prompt_fw ;
			my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
			my $host = Tharn::host($FILER_C);
			my $prompt_array = $host->prompt_fw();
			my $prompts = join("|",@$prompt_array);
			$prompt_fw = "($prompts)";
			logcomment("This is the prompt regex: $prompt_fw");
			my $Server = new Server(no_cli=>1);
			$Server->set_execution_server(-Server => $FILER_C);
			#
			try{
				$Server->console(cmd => "run local",
					additional_prompts_timeout => 600,
					ignore => $ignore_strings,
					additional_prompts => {
						"$FILER_C\>" => "FINAL_PROMPT",
						"run not found" => "FINAL_PROMPT",
						"::*>" => "FATAL_PROMPT",
						"::>" => "FATAL_PROMPT",
						".*Too many users logged in.*"=>"FATAL_PROMPT",
						"$prompt_fw" => "FINAL_PROMPT",
						"takeover"=>"FINAL_PROMPT",
					}
				);
				$Transit_obj->change_state( to => "CLI");
			}catch NATE::BaseException with{
				logcomment("FILER  - $FILER_C : Error while logging in dblade, Rebooting the node to rectify it");
				$Transit_obj->change_state( to => "FIRMWARE");
				sleep 60;
				$Transit_obj->change_state( to => "CLI");
				# try{
					# $Server->console(cmd => "run local",
						# additional_prompts_timeout => 600,
						# ignore => $ignore_strings,
						# additional_prompts => {
							# "$FILER_C\>" => "exit",
							# "::*>" => "FINAL_PROMPT",
							# "::>" => "FINAL_PROMPT",
							# ".*Too many users logged in.*"=>"FATAL_PROMPT",
							# "$prompt_fw" => "FINAL_PROMPT",
						# }
					# );
				# }catch NATE::BaseException with{
					# logcomment("FILER  - $FILER_C : Some other error occured on the filer");
					
				# };
			};
		}
	}
}



sub enable_firmware_console_message{
	my (%opts) = validate(
	@_,
        {
            Node => { type => OBJECT},
        }
    );
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
	logcomment("Enabling required firmware console debug messages");

        my $prompts_answers = [".*continue?"=> 'y'];
        $Api_Set_Obj->execute_raw_command('command' =>"set test",'connectrec-match_table' => $prompts_answers);
        $Api_Set_Obj->execute_raw_command('command' => "set -rows 0");
	$Api_Set_Obj->execute_raw_command('command' => "event show-suppression -node $FILER_C -is-on false");
#	$Api_Set_Obj->execute_raw_command('command' => "event show-suppression -node $FILER_C -level NO");
	$Api_Set_Obj->execute_raw_command('command' => "event config modify -suppression off -console on");
	$Api_Set_Obj->execute_raw_command('command' => "event config modify -suppression off -consoleloglevel DEBUG");
    # $Api_Set_Obj->execute_raw_command('command' => "event config modify -consoleloglevel DEBUG");
    # $Api_Set_Obj->execute_raw_command('command' => "set advance");
    # $Api_Set_Obj->execute_raw_command('command' => "event config mod -console on");
     
	logcomment("All Necessary firmware console message are enabled");
}


sub sasadmin_inject_sub {
    my (%opts) = validate(@_,{
            host => {type=>OBJECT, isa=>'Hostrec'},
            adapter_name => {type=>SCALAR,default=>undef,optional=>1},
            device_name => {type=>SCALAR,default=>undef,optional=>1},
            period => {type=>SCALAR,default=>300,optional=>1},
            command => {type=>SCALAR},
            timeout => {type=>SCALAR,default=>1200,optional=>1},
            filermode => {type=>SCALAR,default=>"normal",optional=>1 },
        }
    );
    my $output;
    my $adapter_name;
    my $a = "";
    my $b = "";
    my $mark;
    my $cmd_option;
    my $cmd1;
    my $cmd;
	my $Node;
	my $Api_Set_Obj;
	my $Host = $opts{host};
	my $FILER_C = $Host->{hostname};
	$FILER_C=~s/\"//gi;
	my @Nodes = NACL::C::Node->find();
	foreach (@Nodes){
		if($_->name()=~/^$FILER_C$/){
			$Node = $_;
			last;
		}
	}
	if(!($Node)){
		logcomment("Could not found node object ");
		logresult('FATAL',"Could not found node object ");
	}
	if($opts{filermode}=~/normal/){
		$Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
	}else{
		$Api_Set_Obj = NACL::APISet->new(
					hostobj   => $Host,
					category  => "Node",
					interface => "CLI",
					set       => "Maintenance"
					);
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
	}
	
	$cmd1 = "sasadmin inject";
    if($opts{command} =~ /^dev_reset$/){
        if(defined($opts{adapter_name})){
            $cmd = "$cmd1 dev_reset enable -t $opts{period} -r -c $opts{adapter_name}";
        }
        elsif(defined($opts{device_name})){
            $cmd = "$cmd1 dev_reset enable -t $opts{period} -d $opts{device_name}";
        }
        else{
            logresult('script', "adapter_name or device_name are the required parameters");
        }
		if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}	
        if($output =~ /Not a SAS adapter|failed|No such adapter|Usage/){
            logcomment("$output");
        }
        return 1;
    }
   elsif($opts{command} =~ /^abort$/){
        if(defined($opts{adapter_name})){
            $cmd = "$cmd1 abort enable -t $opts{period} -r -c $opts{adapter_name}";
        }
        elsif(defined($opts{device_name})){
            $cmd = "$cmd1 abort enable -t $opts{period} -d $opts{device_name}";
        }
        else{
            logresult('script', "adapter_name or device_name are the required parameters");
        }
		
		if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}	
		
		if($output =~ /Not a SAS adapter|failed|No such adapter|Usage/){
            logcomment("$output");
        }
        return 1;
    }
    elsif($opts{command} =~ /^timeout$/){
        if(defined($opts{adapter_name})){
            $cmd = "$cmd1 timeout enable -t $opts{period} -r -c $opts{adapter_name}";
        }
        elsif(defined($opts{device_name})){
            $cmd = "$cmd1 timeout enable -t $opts{period} -d $opts{device_name}";
        }
        else{
            logresult('script', "adapter_name or device_name are the required parameters");
        }
		
		if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}	
		
        if($output =~ /Not a SAS adapter|failed|No such adapter|Usage/){
            logcomment("$output");
        }
        return 1;
    }
    elsif($opts{command} =~ /^adapter_reset$/){
        if(defined($opts{adapter_name})){
            $cmd = "$cmd1 adapter_reset enable -t $opts{period}  -c $opts{adapter_name}";
        }
        else{
            logresult('script', "adapter_name is the required parameter");
        }
		
		if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}	
        if($output =~ /Not a SAS adapter|failed|No such adapter|Usage/){
            logcomment("$output");
        }
        return 1;
	}
    elsif($opts{command} =~ /^disable$/){
		$cmd = "$cmd1 disable";
		if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}
		
		if($output !~ /Disabling all error injection/){
            logcomment("$output");
        }
        return 1;
	}
    elsif($opts{command} =~ /^show$/){
		$cmd = "$cmd1 show";
		
		if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}
		
		if($output =~ /Not a SAS adapter|failed|No such adapter|Usage/){
			logcomment("$output");
        }
        return $output;
    }
    else{
        logresult('script', "Invalid command:  %opts{command}");
    }
}


##########################################################################################################
#Author- arjunl.lavu@netapp.com
##########################################################################################################
sub fcadmin_inject_sub {
   my (%opts) = validate(@_,{
            host => {type=>OBJECT},
            adapter_name => {type=>SCALAR,default=>undef,optional=>1},
            device_name => {type=>SCALAR,default=>undef,optional=>1},
            period => {type=>SCALAR,default=>300,optional=>1},
            command => {type=>SCALAR},
            timeout => {type=>SCALAR,default=>1200,optional=>1},
            filermode => {type=>SCALAR,default=>"normal",optional=>1 },
        }
    );
   my $output;
    my $adapter_name;
    my $a = "";
    my $b = "";
    my $mark;
    my $cmd_option;
    my $cmd1;
    my $cmd;
	my $Node;
	my $Api_Set_Obj;
	my $Host = $opts{host};
	my $FILER_C = $Host->{hostname};
	$FILER_C=~s/\"//gi;
	my @Nodes = NACL::C::Node->find();
	foreach (@Nodes){
		if($_->name()=~/^$FILER_C$/){
			$Node = $_;
			last;
		}
	}
	if(!($Node)){
		logcomment("Could not found node object ");
		logresult('FATAL',"Could not found node object ");
	}
	if($opts{filermode}=~/normal/){
		$Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
	}else{
		$Api_Set_Obj = NACL::APISet->new(
					hostobj   => $Host,
					category  => "Node",
					interface => "CLI",
					set       => "Maintenance"
					);
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
	}
    $cmd1 = "fcadmin inject";
    if($opts{command} =~ /^dev_reset$/){
        if(defined($opts{adapter_name})){
            $cmd = "$cmd1 dev_reset enable -t $opts{period} -r -c $opts{adapter_name}";
        }
        elsif(defined($opts{device_name})){
            $cmd = "$cmd1 dev_reset enable -t $opts{period} -d $opts{device_name}";
        }
        else{
            logresult('script', "adapter_name or device_name are the required parameters");
        }
       if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}

        if($output =~ /adapter|failed|No such adapter|Usage/){
            logcomment("$output");
        }
        return 1;
	}elsif($opts{command} =~ /^abort$/){
        if(defined($opts{adapter_name})){
            $cmd = "$cmd1 abort enable -t $opts{period} -r -c $opts{adapter_name}";
        }
        elsif(defined($opts{device_name})){
            $cmd = "$cmd1 abort enable -t $opts{period} -d $opts{device_name}";
        }
        else{
            logresult('script', "adapter_name or device_name are the required parameters");
        }
		if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}

        if($output =~ /failed|No such adapter|Usage/){
            logcomment("$output");
        }
        return 1;
    } elsif($opts{command} =~ /^timeout$/){
        if(defined($opts{adapter_name})){
            $cmd = "$cmd1 timeout enable -t $opts{period} -r -c $opts{adapter_name}";
        }
        elsif(defined($opts{device_name})){
            $cmd = "$cmd1 timeout enable -t $opts{period} -d $opts{device_name}";
        }
        else{
            logresult('script', "adapter_name or device_name are the required parameters");
        }
        if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}
        if($output =~ /failed|No such adapter|Usage/){
           logcomment("$output");
        }
        return 1;

    }elsif($opts{command} =~ /^adapter_reset$/){
        if(defined($opts{adapter_name})){
            $cmd = "$cmd1 adapter_reset enable -t $opts{period}  -c $opts{adapter_name}";
        }
        else{
            logresult('script', "adapter_name is the required parameter");
        }
		if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}
        if($output =~ /failed|No such adapter|Usage/){
             logcomment("$output");
        }
        return 1;
    }elsif($opts{command} =~ /^lip$/){
        if(defined($opts{adapter_name})){
            $cmd = "$cmd1 lip enable -t $opts{period}  -c $opts{adapter_name}";
        }
        else{
            logresult('script', "adapter_name is the required parameter");
        }
        if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}

        if($output =~ /failed|No such adapter|Usage/){
            logcomment("$output");
        }
        return 1;
    }elsif($opts{command} =~ /^disable$/){
        $cmd = "$cmd1 disable";
		if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}
        if($output =~ /failed/){
            logcomment("$output");
        }
        return 1;
    }elsif($opts{command} =~ /^show$/){
        $cmd = "$cmd1 show";
       if($opts{filermode}=~/normal/){
			$output = $Api_Set_Obj->execute_command( command => "$cmd" );
		}else{
			$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
		}
        if($output =~ /failed|No such adapter|Usage/){
             logcomment("$output");
        }
        return $output;
    }else{
        logresult('script', "Invalid command:  %opts{command}");
    }

}

#####################################################
##Disable debug messages
## Author :: Arjun Lavu
#####################################################

sub disable_debug_msg{
my (%opts) = validate(
	@_,
        {
            Node => { type => OBJECT},
        }
    );
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	my $Api_Set_Obj;
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if($filer_state=~/CLI/){
		$Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		$Api_Set_Obj->execute_command('command' => 'dbg to off');
	}else{
		my $Host = host($FILER_C);
		$Api_Set_Obj = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance",
		);
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		$Api_Set_Obj->execute_raw_command('command' => 'dbg to off');
	}
}

####################################
### Arjun Lavu
####################################

sub fcadmin_device_map {
    my (%opts) = validate(@_, {
                Node => { type=>OBJECT},
                channel_name => { type=>SCALAR, optional=>1 },
                }
            );
	my $Node = $opts{Node};
	my $FILER_C = $Node->name();
	my $Host = host($FILER_C);
	my ($output,$Api_Set_Obj);
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	my $cmd = "fcadmin device_map $opts{channel_name}";
	if($filer_state=~/CLI|UP/i){
		$Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $Api_Set_Obj->execute_command( command => "$cmd" );
	}else{
		$Api_Set_Obj = NACL::APISet->new(
					hostobj   => $Host,
					category  => "Node",
					interface => "CLI",
					set       => "Maintenance"
					);
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
	}
    if ($output =~ /fcadmin device_map: No such channel/) {
        logcomment("**WARNING** : $output");
    }

    my %HoH =();

    my @lines = split(/\r*\n/, $output);
    my ($channel, $shelf, $translated_map_flag, @translated_map, $shelf_map_flag, @shelf_map, $target_ses_flag, @target_ses_map);
    $translated_map_flag = $shelf_map_flag = $target_ses_flag = 0;
    $shelf = '';
    foreach (@lines) {
        $_ =~ s/^\s+//;
        $_ =~ s/\s+$//;
        if ($_ =~ /Cannot complete operation on channel (\w+); link is DOWN/) {
            $HoH{$1}{'State'} = "DOWN";
        }
        elsif($_ =~ /Loop Map for channel (\S+):$/) {
            my @channel = split(/\s+/,$_);
            $channel = $channel[4];
            chop($channel);
            #$channel = $1;
            $HoH{$channel}{'State'} = "UP";
        }
        elsif($_ =~ /Translated Map: Port Count (\d+)/) {
            $HoH{$channel}{'PortCount'} = $1;
            $translated_map_flag = 1;
        }
        elsif(($translated_map_flag) && ($_ !~ /Shelf mapping:/)) {
            my @fields1 = split(/\s+/, $_);
                      push(@translated_map, @fields1);
        }
        elsif($_ =~ /Shelf mapping:/) {
            $shelf_map_flag = 1;
            $HoH{$channel}{'TranslatedMap'} = [@translated_map];
            # clear map
            @translated_map = ();
            $translated_map_flag = 0;
        }
        elsif($_ =~ /Target SES devices on this loop:/) {
            $target_ses_flag = 1;
            $shelf_map_flag = 0;
        }
        elsif ($_ =~ /^Shelf (\d+):\s+(.*)/) {
            $shelf = $1;

            # Die if the shelf configuration is not valid
            if ($shelf eq "Unknown") {
                die "Configuration issue in loop: Loop $channel not properly configured";
            }

            my @fields = split(/\s+/, $2);
            if($shelf_map_flag) {
                push(@shelf_map, @fields);
                print "\nShelf Map : @shelf_map";
                $HoH{$channel}{$shelf}{'ShelfMapping'} = [@shelf_map];
                @shelf_map = ();
            }
            elsif($target_ses_flag) {
                push(@target_ses_map, @fields);
                $HoH{$channel}{$shelf}{'TargetSES'} = [@target_ses_map];
                @target_ses_map = ();
            }
        }
    }
    return \%HoH;
}

##########################################################################################################
#Author- arjunl.lavu@netapp.com
##########################################################################################################
sub fcadmin_link_stats {
    my (%opts) = validate(@_, {
                Node => { type=>OBJECT },
                channel_name => { type=>SCALAR, optional=>1 },
                }
            );
	my $Node = $opts{Node};
	my $FILER_C = $Node->name();
	my $Host = host($FILER_C);
	my ($output,$Api_Set_Obj);
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
    my $cmd = "fcadmin link_stats $opts{channel_name}";
	if($filer_state=~/CLI|UP/i){
		$Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $Api_Set_Obj->execute_command( command => "$cmd" );
	}else{
		$Api_Set_Obj = NACL::APISet->new(
					hostobj   => $Host,
					category  => "Node",
					interface => "CLI",
					set       => "Maintenance"
					);
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		$output = $Api_Set_Obj->execute_raw_command( command => "$cmd" );
	}
	
    if ($output =~ /fcadmin link_stats: No such channel/) {
       logcomment("**WARNING** : $output");
    }

    my %HoH =();

    my @lines = split(/\r*\n/, $output);
    foreach (@lines) {
        if ($_ =~ /Cannot complete operation on channel (\w+); link is DOWN/) {
            $HoH{$1}{'State'} = "DOWN";
        }
        elsif($_ =~ /(\w+)\./) {
            my @fields = split(/\s+/, $_);
            my $device_name = $fields[0];
            if($device_name =~ /(\w+)\.ha/) {
                if((!exists $HoH{$1}{'State'}) && (!defined $HoH{$1}{'State'})) {
                    $device_name = $1;
                    $HoH{$device_name}{'State'} = "UP";
                }
            }
            $HoH{$device_name}{'LinkFailureCount'} = $fields[1];
            $HoH{$device_name}{'TransportErrorCount'} = $fields[2];
            $HoH{$device_name}{'LossOfSyncCount'} = $fields[3];
            $HoH{$device_name}{'InvalidCRCCount'} = $fields[4];
            $HoH{$device_name}{'FrameInCount'} = $fields[5];
            $HoH{$device_name}{'FrameOutCount'} = $fields[6];
        }
    }
    return \%HoH;
}

########################################################################################################################################
### Arjun Lavu
## Description :: This subroutine will create required number of spares by deleting the aggregates if needed
########################################################################################################################################

sub create_spares{
        my (%opts) = validate(@_, {
                        Node => { type=>OBJECT},
                        required_spare => {type=>SCALAR},
                }
        );
        my $Node = $opts{Node};
        my $required_spares = $opts{required_spare};
        my $FILER_C = $Node->name();
        my ($err_flag,$flag_fill,%aggr_disks,$vser_aggr);
        my @spares = spare_count_cmode(Node =>$Node);
        my(@aggregates,@non_root,@delete_aggr);
        if($required_spares<= scalar @spares){
                logcomment("Already enough spare are available in the filer $FILER_C.");
                return;
        }
        my $spares_needed = $required_spares - (scalar @spares);
        logcomment("$FILER_C : Spares required are :: $spares_needed");
        try {
                my @tot_aggr = NACL::CS::StorageAggregate->fetch(
                                                command_interface => $Node,
                                                filter            => {node => $FILER_C, 'root' => 'false'}
                                        );
                foreach my $aggr (@tot_aggr) {
                        push( @aggregates, $aggr->aggregate );
                }
                logcomment("$FILER_C :: Non Root aggregates are - @aggregates");
    }catch NACL::Exceptions::NoElementsFound with {
        logcomment("$FILER_C : Non Root aggregates are not found in the filer");
                $err_flag =1;
    };

        if($err_flag){
                logcomment("No additional aggregates present in the filer : $FILER_C");
                return;
        }
        foreach my $aggr(@aggregates){
                my $disk_obj = NACL::CS::StorageAggregate->fetch(command_interface => $Node,
                                filter  => {'aggregate' => "$aggr",},
                                requested_fields => ['disklist']);
                my @disks = $disk_obj->disklist();
                logcomment("In the aggregare : $aggr total number of drives present are :: @disks");
                $aggr_disks{$aggr} = [@disks];
        }
        my $sum=0;
        foreach my $key(keys %aggr_disks){
                $sum = $sum + scalar @{$aggr_disks{$key}};
        }

        if(($sum+ (scalar @spares))<$required_spares){
                logcomment("Sum of total number of drives in the aggregates are : $sum , which are less than required spares :: $required_spares, So not deleting any aggregates");
                return;
        }

        if(scalar @aggregates == 1){
                logcomment("Only one aggregate is present in the filer");
                vserver_delete(Node =>$Node);
                aggregate_volume_delete(Node => $Node);
                return;
        }else{
                my $vserver_name = "vser_$FILER_C";
                try{
                        my $name = NACL::STask::Vserver->find(
                                command_interface => $Node,
                                filter            => { vserver => $vserver_name},
                        );
                        $vser_aggr = $name->get_one_state_attribute("aggregate");
                        logcomment("Vserver aggregate name is : $vser_aggr");
                }catch NACL::Exceptions::NoElementsFound with{
                        logcomment("No vserver found with the name $vserver_name");
                };
        }
        $sum =0;
        my %bkp_hash = %aggr_disks;
        delete $bkp_hash{$vser_aggr};
        foreach my $aggr(sort keys %bkp_hash){
                $sum = $sum + scalar @{$bkp_hash{$aggr}};
                push(@delete_aggr,$aggr);
                if($sum>=$spares_needed){
                        $flag_fill = 1;
                        last;
                }
        }

        if($flag_fill == 1){
                logcomment("Deleting the aggregates :: @delete_aggr");
                foreach my $aggr(@delete_aggr){
                        try{
                                NACL::STask::Aggregate->purge(
                                command_interface => $Node,
                                aggregate         => $aggr,
                                nacltask_verify=>  1,);
                        }catch NACL::Exceptions::NoElementsFound with {
                                logcomment("Inside catch NACL::Exceptions::NoElementsFound with");
                                logcomment("$FILER_C : WARNING : Cannot delete the aggregate $aggr ");
                        }catch NACL::APISet::Exceptions::CommandFailedException with{
                                try{
                    NACL::STask::Aggregate->purge(
                    command_interface => $Node,
                    aggregate         => $aggr,
                    nacltask_verify=>  1);
                }catch NACL::APISet::Exceptions::CommandFailedException with{
                    logcomment("$FILER_C : WARNING : Cannot delete aggregate $aggr.");
                };
                        }catch NACL::Exceptions::VserverHasVolumesOnAnotherAggregate with{
                                logcomment("$FILER_C :WARNING : Cannot delete aggregate $aggr ");
                        };
                }

        }else{
			vserver_delete(Node =>$Node);
			aggregate_volume_delete(Node => $Node);
        }
}


######################################################
## Author :  Arjun Lavu
## Description : checks for the volumes and aggregates state 
##				if they are off-line, it will try to make it on-line else it will delete them
##	Return value : no return value
#####################################################
sub check_aggr_vol_offline{
	my (%opts) = validate(@_, {
			Node => { type=>OBJECT},
		}
	);
	my $Node = $opts{Node};
	my $FILER_C = $Node->name();
	my $Transit_obj_C = NACL::Transit->new( name => $FILER_C );
	my $filer_state_C = $Transit_obj_C->get_state('timeout' => 600);
	
	if($filer_state_C!~/CLI/i){
		return;
	}
	logcomment("Checking the aggregate and volume states");
	try{
		my @aggrs = NACL::C::Aggregate->find( command_interface => $Node,
							filter => {nodes => [$FILER_C],'root' => 'false,-'});
		foreach my $aggr(@aggrs){
			my $aggregate = $aggr->get_one_state_attribute('aggregate');
			if($aggr->get_one_state_attribute('raidstatus')=~/degraded/i){
				logcomment("$FILER_C : Aggregate : $aggregate is degraded, so deleting the aggregate");
				aggregate_volume_delete(Node =>$Node,Aggr_array =>[$aggregate]);
			}elsif($aggr->get_one_state_attribute('state')=~/offline/){
				logcomment("Aggregate is offline, onlinig the aggregate $aggregate ");
				try{
					$aggr->online( 'method-timeout' => '1200');
					try{
						my @vol_obj = $aggr->get_volumes();
						foreach my $vol(@vol_obj){
							my $vol_name = $vol->get_one_state_attribute('volume');
							logcomment("Volume name $vol_name");
							my $vserver = $vol->get_one_state_attribute('vserver');
							logcomment("Vserver name $vserver");
							if($vol->get_one_state_attribute('state')=~/offline/){
								logcomment("State of volume : $vol_name is offline, trying to make it online ");
								try{
									$vol->online( 'method-timeout' => '1200');
								}catch NACL::APISet::Exceptions::CommandFailedException with {
									logcomment("Couldn't online the volume $vol_name, So deleting the volume $vol_name");
									NACL::STask::Volume->purge(
										command_interface => $Node,
										volume            => $vol_name,
										vserver           => $vserver,
									);
								};
							}
						}
					}catch NACL::APISet::Exceptions::CommandFailedException with {
						logcomment("Couldn't online the aggregate, So deleting the aggregate :: $aggregate");
						aggregate_volume_delete(Node =>$Node,Aggr_array =>[$aggregate]);
					};
				}catch NACL::APISet::Exceptions::CommandFailedException with {
					logcomment("No volumes found in the aggregate - $aggregate");
					aggregate_volume_delete(Node =>$Node,Aggr_array =>[$aggregate]);
				};
			}elsif($aggr->get_one_state_attribute('state')=~/online/){
				try{
					my @vol_obj = $aggr->get_volumes();
					foreach my $vol(@vol_obj){
						my $vol_name = $vol->get_one_state_attribute('volume');
						logcomment("Volume name $vol_name");
						my $vserver = $vol->get_one_state_attribute('vserver');
						logcomment("Vserver name $vserver");
						if($vol->get_one_state_attribute('state')=~/offline/){
							logcomment("State of volume : $vol_name is offline, trying to make it online ");
							try{
								$vol->online( 'method-timeout' => '1200');
							}catch NACL::APISet::Exceptions::CommandFailedException with {
								logcomment("Couldn't online the volume $vol_name, So deleting the volume $vol_name");
								NACL::STask::Volume->purge(
									command_interface => $Node,
									volume            => $vol_name,
									vserver           => $vserver,
								);
							};
						}
					}
				}catch NATE::BaseException with {
					logcomment("No volumes found in the aggregate :: $aggregate");
					aggregate_volume_delete(Node =>$Node,Aggr_array =>[$aggregate]);
				};
			}elsif($aggr->get_one_state_attribute('state')!~/online/){
				logcomment("Aggregate is neither offline nor online, So deleting the aggregate $aggregate");
				aggregate_volume_delete(Node =>$Node,Aggr_array =>[$aggregate]);
			}
		}
		
	}catch NACL::Exceptions::NoElementsFound with {
		logcomment("$FILER_C : Non root aggregates are not found");
		# $AGGR_CNT->{$FILER_C} = 0;
	};
	sleep 30;
	try{
		my @agg_names;
		my @aggrs = NACL::C::Aggregate->find( command_interface => $Node,
						filter => {nodes => [$FILER_C]});
		foreach my $aggr(@aggrs){
			push(@agg_names,$aggr->get_one_state_attribute('aggregate'));
		}
		if(@agg_names){
			logcomment("Total number of aggregates present in the filer : $FILER_C : are ".scalar @agg_names." and the aggregates are @agg_names");
			$AGGR_CNT->{$FILER_C} = scalar @agg_names;
		}
	}catch NACL::Exceptions::NoElementsFound with {
		$AGGR_CNT->{$FILER_C} = 0;
		logcomment("$FILER_C :: No non root aggregates found");
	};	
}

###########################################################################
## Check for failed drives and unfail, after that zero spares
###########################################################################
sub unfail_disk_zero_spares{
	my (%opts) = validate(@_, {
			Nodes => { type=>ARRAYREF},
		}
	);
	my @Nodes = @{$opts{Nodes}};
	my $filer_c = $Nodes[0]->name();
	my $Transit_obj_C = NACL::Transit->new( name => $filer_c );
	my $filer_state_C = $Transit_obj_C->get_state('timeout' => 600);
	if($filer_state_C!~/CLI/i){
		return;
	}
	my @subtest;
	foreach my $node(@Nodes){
		my $FILER_C = $node->name();
		push(@subtest, subtest(
                        \&spare_count_cmode, -runid,
                        "spare_count_cmode_" . "$FILER_C", -bg,
                        "--", Node   => $node,
					)
		);
	}
	Subtest::wait_finish( subtest => [@subtest] );
}


###########################################################################
### Disable firmware foreground background hammer
###########################################################################

sub disable_fg_bg_firmware_hammer{
	my (%opts) = validate(@_, {
			Nodes => { type=>ARRAYREF},
		}
	);
	my @Nodes = @{$opts{Nodes}};
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		my $Transit_obj = NACL::Transit->new( name => $FILER_C );
		my $filer_state= $Transit_obj->get_state('timeout' => 600);
		if($filer_state!~/CLI/){
			logcomment("filer is not in file-system");
			next;
		}
		##disabling background firmwares
        NACL::C::Options->option(
            command_interface => $Node,
            'option-name'     => 'raid.background_disk_fw_update.enable',
            'option-value'    => 'off'
        );
		my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		$Api_Set_Obj->set_timeout("connectrec-timeout"=>3600);
		##disabling foreground firmwares
		try {
			my $prompts= ['Are you sure you want to' => 'y'];
			$Api_Set_Obj->execute_command('command' => "disk_fw_update -S",'connectrec-match_table' => $prompts);
			sleep(60);
			logcomment("Firmware Qualification download stopped ");
		}catch NACL::APISet::Exceptions::ResponseException with {
			logcomment("Couldn't stop firmware foreground.");
		};
		##hammer stopping
		$Api_Set_Obj->hammer_abort();
		sleep 20;
		$Api_Set_Obj->hammer_abort();
	}	
}

sub get_config_status{
	my (%opts) = validate(@_, {
			Nodes => { type=>ARRAYREF},
		}
	);
	my @Nodes = @{$opts{Nodes}};
	my (%filer_details,$Api_Set_Obj,$output);
	foreach my $Node(@Nodes){
		my $FILER_C = $Node->name();
		my $Host = host($FILER_C);
		my $Transit_obj = NACL::Transit->new( name => $FILER_C );
		my $filer_state = $Transit_obj->get_state('timeout' => 600);
		logcomment("Filer : $FILER_C is in $filer_state state");
		if($filer_state=~/PASS/i){
			$Transit_obj->change_state( to => "CLI");
		}
		if ($filer_state =~/UP|CLI/i) {
			$Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
			$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
			$output = $Api_Set_Obj->execute_command('command' => 'sysconfig -v');
		}elsif ($filer_state =~/MAINT/i){
			$Api_Set_Obj = NACL::APISet->new(
							hostobj   => $Host,
							category  => "Node",
							interface => "CLI",
							set       => "Maintenance"
						);
			$Api_Set_Obj->set_timeout("connectrec-timeout" => 1200 );
			$output =$Api_Set_Obj->execute_raw_command('command' => 'sysconfig -v');
		}
		if($output=~/System\s*ID\s*:\s*\S+\s*\((\S+)\)/){
			$filer_details{$FILER_C}{system_name} = $1;
			logcomment("Filer Name : $1");
		}
		if($output=~/System\s*ID\s*:\s*(\S+)/){
			$filer_details{$FILER_C}{system_id} = $1;
			logcomment("Model-id :$1");
		}	
		
		if($output=~/partner\s*ID\s*:\s*(\S+)/){
			$filer_details{$FILER_C}{partne_id} = $1;
			logcomment("Partner-id :  $1");
		}
		if($output=~/partner\s*ID\s*:\s*\S+\s*\((\S+)\)/){
			$filer_details{$FILER_C}{partner_name} = $1;
			logcomment("Partner filer name :  $1");
		}
		if($output=~/System\s*Serial\s*Number\s*:\s*(\S+)/){
			$filer_details{$FILER_C}{System_Serial_Number} = $1;
			logcomment("System Serial number : $1");
		}
		if($output=~/System\s*Serial\s*Number\s*:\s*\S+\s*\((\S+)\)/){
			$filer_details{$FILER_C}{System_Serial_Number_ID} = $1;
		}
		if($filer_details{$FILER_C}{system_name} ne $filer_details{$FILER_C}{System_Serial_Number_ID}){
			logcomment("**WARNING** : Could not find filer name ".$filer_details{$FILER_C}{system_name}." in System serial number");
		}
		my $filer_name = $Host->{'hostname'};
		logcomment("filer name from tharnhost $filer_name");
		$filer_name=~s/\"//gi;
		if($filer_details{$FILER_C}{'system_name'}!~/^$filer_name$/){
			logcomment("**FATAL** : Filer name in the configuration file is $filer_name , But the filer name found in sysconfig -v is :".$filer_details{$FILER_C}{system_name}. " which are different");
			logcomment("Please check/correct the filer IP's and re-run the test again");
			logresult('FATAL','Filer name in the configuration file is $filer_name , But the filer name found in sysconfig -v : '. $filer_details{$FILER_C}{system_name}.' are different');
		}
	}
	my($fail_1,$fail_2);
	if($filer_details{$Nodes[0]->name}{system_id} ne $filer_details{$Nodes[1]->name}{partne_id}){
		logcomment("**WARNING** : Filer name ".$Nodes[0]->name." is not same as filer's ".$Nodes[1]->name." partner id" );
		$fail_1 = 1;
	}
	if($filer_details{$Nodes[1]->name}{system_id} ne $filer_details{$Nodes[0]->name}{partne_id}){
		logcomment("**WARNING** : Filer name ".$Nodes[1]->name." is not same as filer's ".$Nodes[0]->name." partner id" );
		$fail_2 =1;
	}
	if(($fail_1)&&($fail_2)){
		logcomment("**FATAL** : Filers are not connected to each other, Please re-run the test with the correct configuration");
		logresult('FATAL','Filers are not connected to each other, Please re-run the test with the correct configuration');
	}
	HA_config(API_Obj => $Api_Set_Obj);
}

sub WaitSickDiskcopy {
    my (%opts) = validate(
        @_,
        {
            Node         => { type => OBJECT },
            failed_data    => { type => SCALAR , default => undef, optional => 1 },
        }
    );
    my $Node         = $opts{Node};
    my $failed_data  = $opts{failed_data} if(defined $opts{failed_data});
    my $timeout      = 288000;
    my $drcompleted  = 0;
    my $curtime      = time;
    my $endtime      = $curtime + $timeout;
    my $FILER_C        = $Node->name();
    my $API_obj = $Node->get_7m_or_nodescope_apiset();
	my @copying_disks;
    if (!$failed_data) {
        my $count;
        my $after = $API_obj->execute_command( "command" => "sysconfig -r" );
        foreach my $line ( split( /\n/, $after ) ) {
            if (( $line =~ /-> copy\s+(\S+)\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\(copy\s+(\S+%)\s+completed\)/ )||( $line =~ /copy in progress/ )) {
			push(@copying_disks,$2)if(defined $2);
                $count++;
            }
        }
		if($count){
			my $mail_subject = "INFO : $parse_id : disks are copying ";
			$mail_subject = "INFO : $parse_id : disks are copying in check_filer_setup, killing the test"if($parse_id=~/check_filer/i);
			
			my $mail_body = "#################################################################################################
## 
## Disk copy is under progress on FILER : $FILER_C.
## 
## User can stop execution of test by killing <process_id> to stop execution.
## sudo kill -9 $$
## 
#################################################################################################";
				my %mail_params = (HTML    => $mail_body,
							Text    => $mail_body,
							From    => $MAIL_FROM,
							To      => $MAIL_TO,
							Subject => $mail_subject,);
		
							$mail_params{HTML} = "<HTML><pre>$mail_params{Text}<\\HTML>";
							my $mail = HTML::Mail->new(%mail_params);
							$mail->send()or logcomment("CONFIG : trouble sending mail");
			if($parse_id=~/check_filer/i){
				logcomment("**FATAL** : $FILER_C : Disk copying found in check_filer_setup, so killing the test process");
				logresult('FATAL',"$FILER_C : Disk copying found in check_filer_setup, So killing the test process");
			}	
		}
        $failed_data = $count;
    }
	
	logcomment("$FILER_C : Number of drives found re-constructing are : $failed_data")if($failed_data);
	sleep 60;
    while (($curtime < $endtime)&&($drcompleted < $failed_data)) {
		my $dsk_cpy_flag = 0;
        my $after = $API_obj->execute_command( "command" => "sysconfig -r" );
        foreach my $line ( split( /\n/, $after ) ) {
            if (( $line =~ /-> copy\s+(\S+)\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\S+\(copy\s+(\S+%)\s+completed\)/ )||( $line =~ /copy in progress/ )) {
                if ( defined($2) ) {
                    logcomment("$2 percent of Disk copying has completd on disk $1 ");
                }
				$dsk_cpy_flag = 1;
            }
        }
        
        if ( $dsk_cpy_flag == 0 ) {
            logcomment("FILER : $FILER_C : Sick Disk copy completed as per the output of sysconfig -r command");
            return 1;
        }else{
			sleep(600);
		}
        $curtime = time;
    } ## end while (($drcompleted < $numfaildr...

}

## himangin@netapp.com
## return 1 - PASS(all recontruction complete)
sub WaitReconstruct {
    my (%opts) = validate(
        @_,
        {
            Node         => { type => OBJECT },
            failed_parity  => { type => SCALAR, default => undef, optional => 1 },
            MIXED_CONFIG => { type => SCALAR, default => "0", optional => 1 },
        }
    );
    my $Node         = $opts{Node};
    my $failed_parity  = $opts{failed_parity} if(defined $opts{failed_parity});
    my $MIXED_CONFIG = $opts{MIXED_CONFIG};
    my $timeout      = 288000;
    my $drcompleted  = 0;
    my $curtime      = time;
    my $endtime      = $curtime + $timeout;
    my $FILER_C      = $Node->name();
    my $Api_Set_Obj  = $Node->get_7m_or_nodescope_apiset();
	my @copying_disks;
    if (!$failed_parity) {
        my $count;
        my $after = $Api_Set_Obj->execute_command( 'command' => "sysconfig -r" );
        foreach my $line ( split( /\n/, $after ) ) {
            if ( ( $line =~ /reconstruction\s(.*)/ )||( $line =~ /\s*RAID group\s+(\S+)\s*\(reconstruction\s+(\S+%)\s(.*)/ ) || ( $line =~ /.*\(prefail\,\scopy\sin\sprogress/ ) ) {
                $count++;
            }
        }
		if($count){
			my $mail_subject = "INFO : $parse_id : disk re-construction is going on ";
			$mail_subject = "INFO : $parse_id : disk re-construction is going on in check_filer_setup ,so killing the test"if($parse_id=~/check_filer/i);
			
			my $mail_body = "#################################################################################################
## 
## Disk copy is under progress on FILER : $FILER_C, NDATE will wait for completion.
## 
## 
## User can stop execution of test by killing <process_id> to stop execution.
## sudo kill -9 $$
## 
#################################################################################################";
				my %mail_params = (HTML    => $mail_body,
							Text    => $mail_body,
							From    => $MAIL_FROM,
							To      => $MAIL_TO,
							Subject => $mail_subject,);
		
							$mail_params{HTML} = "<HTML><pre>$mail_params{Text}<\\HTML>";
							my $mail = HTML::Mail->new(%mail_params);
							$mail->send()or logcomment("CONFIG : trouble sending mail");
			if($parse_id=~/check_filer/i){
				logcomment("**FATAL** : $FILER_C : Disk re-construction found in check_filer_setup, So killing the test process");
				logresult('FATAL',"$FILER_C : Disk re-construction found in check_filer_setup, So killing the test process");
			}	
		}
        $failed_parity = $count;
    }
	logcomment("$FILER_C : Number of drives found re-constructing are : $failed_parity")if($failed_parity);
	sleep 60;
    while (($curtime < $endtime)&&($drcompleted < $failed_parity)) {
        #Only for SAS/BSAS configuration, while reconstruction is underway, issue statit -b, wait for 5 minutes and issue statit -e for each reconstruction.
        if ( $MIXED_CONFIG == 1 ) {
            logcomment("Issue statit -b ,wait for 5 minutes and issue statit -e for each reconstruction.");
            my $statit_b_output = $Api_Set_Obj->execute_raw_command( 'command' => "statit -b" );
            sleep(300);
            my $statit_e_output = $Api_Set_Obj->execute_raw_command( 'command' => "statit -e" );
            sleep(300);

        }
		my $recons_flag = 1;
        my $after = $Api_Set_Obj->execute_command( 'command' => "sysconfig -r" );
        foreach my $line ( split( /\n/, $after ) ) {
            if ( ( $line =~ /\s*RAID group\s+(\S+)\s*\(reconstruction\s+(\S+%)\s(.*)/ ) || ( $line =~ /.*\(prefail\,\scopy\sin\sprogress/ ) ||( $line =~ /reconstruction\s(.*)/ )) {
                if ( defined($2) ) {
                    logcomment("FILER - $FILER_C : $2 percent of reconstruction is completed on RAID group $1 ");
                }
				$recons_flag = 0;
            }
        }
        logcomment("The number of drives found reconstructing are $failed_parity");
        #Executing sysconfig -r command to check if reconstruction is still in progress
        if ( $recons_flag == 1 ) {
            logcomment("FILER : $FILER_C : Reconstruction completed as per the output of sysconfig -r command");
            return 1;
        }else{
			sleep 600;
		}
        $curtime = time;
    } ##     
} ## end sub WaitReconstruct


sub check_recons_sickdisk {
	my (%opts) = validate(
        @_,
        {
            Node         => { type => OBJECT },
		}	
		);
        my $Node  = $opts{Node};
        my $return = WaitSickDiskcopy(Node => $Node);
        my $result = WaitReconstruct(Node => $Node);
        if (($return = 1)&&($result = 1)) {
			# logcomment("Reconstruction or disk copying completed successfully. Please carry on with the scrub process");
                return 1;
        }else{
			logcomment("Reconstruction or sick disk copying is not complete");
                return 0;
        }
}


sub check_path_ha{
	my (%opts) = validate(
		@_,
		{
			Node => { type => OBJECT },
		}	
	);
	my $Node  = $opts{Node};
	my $FILER_C = $Node->name();
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	my $return = sysconfig_v_data(node=>$Node);
	logcomment("$FILER_C : Model No    : ".$return->{model});
	logcomment("$FILER_C : System Path : ".$return->{path});
	if(($return->{model}!~/FAS2/)&&($return->{path}=~/single/i)){
		logcomment("**WARNING** : $FILER_C is a single-path system");
	}
	if($filer_state=~/CLI/){
		my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
		$Api_Set_Obj->set_timeout( "connectrec-timeout" => 1200 );
		my $prompts_answers = ["Do you want to continue"=> 'y'];
		my $return = $Api_Set_Obj->execute_raw_command('command' => 'cluster ha show');
		if($return=~/false/i){
			logcomment("**WARNING** : HA is not configured, Setting the HA to true");
			$Api_Set_Obj->execute_raw_command('command' => 'cluster ha modify -configured true','connectrec-match_table' => $prompts_answers);
		}
	}
}

##############################
## himangin@netapp.com
## check for stsb or acron dongles
sub get_filer_check {
        my (%opts) = validate(
                @_,
                {
                        Node => { type => OBJECT },
                }
        );
        my $Node  = $opts{Node};
        my $FILER_C = $Node->name();
   my $Api_set_object = $Node->get_7m_or_nodescope_apiset;
   my $output = $Api_set_object->execute_command( 'command' => "help" );
   my $var = "";
     foreach my $line ( split( /\n/, $output ) ) {
        if ($line =~ /stsb/i){
            logcomment("STSB command found");
            $var = 'stsb';
                        return $var;
        }elsif ($line =~ /acron/i){
            logcomment("Acron command found");
            $var = 'acron';
                        return $var;
        }
    }
}

#######################################################################################################
# Author - priya3@netapp.com
# Description - power cycle count and phy change count for Cmode/7mode
# Usage - Mandatory paramanter - Node
# Supported Mode - CMode/7mode (CLI/UP)
# Return - hash ref
#######################################################################################################
sub get_phy_state{
	my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT},
        }
    );
    my $Node=$opts{Node};
    my $Api_Set_Obj = $Node->get_7m_or_nodescope_apiset();
	my $output = $Api_Set_Obj->execute_command('command' => "sasadmin expander_phy_state" ,'timeout' => 600 );
	my $power_struct = {};
	my $shlfid ="";
	my %convert = ('0'=>'00','1' =>'01','2'=>'02','3'=>'03','4'=>'04','5'=>'05','6'=>'06','7'=>'07','8'=>'08','9'=>'09');
	
    foreach my $outp ( split( /\r*\n/, $output ) ) {
		$outp =~ s/^\s+|\s+$//g;
		my $bay;
		my $phy;
        if ($outp =~ /Expander phy state on\s+(\S+)\s+/){
            $shlfid = $1;
            if ( $shlfid =~ /(\S+)\.(\S+)/ )  {
				my $first  = $1;
				my $second = $2;
				if($2=~/^\d$/){
					$shlfid = $first.".".$convert{$second};
				}else{
					$shlfid = $first.".".$second;
				}
				#$power_struct->{$shlfid}->{Shelfid} = $shlfid;
            }
        } elsif ($outp =~/^(\d+)\/(\d+)\s+\S+\s+\S+\s+\S+\s+(\d+)\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s+\d+\s+(\d+)/) {
            $phy = $1;
			$bay = $2;
            $power_struct->{$shlfid}->{$bay}->{'Power cycle count'} = $3;
            $power_struct->{$shlfid}->{$bay}->{'Phy change count'} = $4;
        } else {
			next;
        }
	}
	return ($power_struct);
}

##############################################################
## Arjun Lavu
##############################################################
sub report_failed_drives {
	my (%opts) = validate(
        @_,
        {
            Node   => { type => OBJECT },
        }
    );
    my $Node    =	$opts{Node};
	my $FILER_C = $Node->name();
	my ($failed,$failed_u)=(0,0);
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	return if($filer_state!~/CLI/);
 	my @broken;
	try{
		my %hash = (filter => {'container-type' => "broken",'owner' => $FILER_C});
		my @broken_obj = NACL::C::Disk->find(
						command_interface => $Node,
						%hash,
					);
		foreach my $state_obj (@broken_obj){
			my $free_disk = $state_obj->disk();
			if ($free_disk =~ /(\S+)\:(\S+)/){
				$free_disk = $2;
			}
			push( @broken,$free_disk);
		}

	}catch NACL::Exceptions::NoElementsFound with{
		logcomment("$FILER_C : No failed disks found for the filer");
		$failed =1;
	};
	
	{
		my @broken_disk_U;
		try{
			my %hash = (filter => {'container-type' => "broken",'owner' => "-"});
			my @broken_obj = NACL::C::Disk->find(
								command_interface => $Node,
								%hash,
								allow_empty => 1,
							);
			foreach my $state_obj (@broken_obj){
				my $free_disk = $state_obj->disk();
				if ($free_disk =~ /(\S+)\:(\S+)/){
					$free_disk = $2;
				}
				push( @broken_disk_U,$free_disk);
			}
		}catch NACL::Exceptions::NoElementsFound with{
			logcomment("$FILER_C : No unknowun broken disks found for the filer");
			$failed_u = 1;
		};
		push(@broken,@broken_disk_U) if(scalar @broken_disk_U);
	}
	
	
	return if(($failed)&&($failed_u));
=head
	foreach my $boken (@broken){
		
		try{
			NACL::C::StorageDisk->unfail( command_interface => $Node,
													disk => $boken,
													spare => "true",
													'method-timeout'  => 1200);
			sleep 30;
		}catch NACL::APISet::Exceptions::CommandFailedException with {
			try{
				NACL::C::StorageDisk->unfail( command_interface => $Node,
                                                disk => $boken,
												'method-timeout'  => 1200);
				sleep 20;							
			}catch NACL::APISet::Exceptions::CommandFailedException with {
				# logcomment("**WARNING** : $FILER_C : Couldn't unfail the disk $boken");
			};
		}catch NATE::BaseException with {
			logcomment("Unfailing the drive is interupted, may be because of timeout issue, So trying again to unafail after 5 minutes");
			sleep 300;
			try{
				NACL::C::StorageDisk->unfail( command_interface => $Node,
													disk => $boken,
													spare => "true",
													'method-timeout'  => 1200);
			}catch NATE::BaseException with {
				logcomment("**WARNING** : Unfailing the drive $boken is not successfull");
			};
		};												
	}
	sleep 120;
	
	@broken=();
	logcomment("$FILER_C : Checking again for the failed drvies");
	try{
		my %hash = (filter => {'container-type' => "broken",'owner' => $FILER_C});
		my @broken_obj = NACL::C::Disk->find(
						command_interface => $Node,
						%hash,
					);
		foreach my $state_obj (@broken_obj){
			my $free_disk = $state_obj->disk();
			if ($free_disk =~ /(\S+)\:(\S+)/){
				$free_disk = $2;
			}
			push( @broken,$free_disk);
		}
		
		
	}catch NACL::Exceptions::NoElementsFound with{
		# logcomment("$FILER_C :: No failed disks found in the filer");
	};
	{
		my @broken_disk_U;
		try{
			my %hash = (filter => {'container-type' => "broken",'owner' => "-"});
			my @broken_obj = NACL::C::Disk->find(
								command_interface => $Node,
								%hash,
								allow_empty => 1,
							);
			foreach my $state_obj (@broken_obj){
				my $free_disk = $state_obj->disk();
				if ($free_disk =~ /(\S+)\:(\S+)/){
					$free_disk = $2;
				}
				push( @broken_disk_U,$free_disk);
			}
		}catch NACL::Exceptions::NoElementsFound with{
			# logcomment("$FILER_C : No unknowun broken disks found for the filer");
			$failed_u = 1;
		};
		push(@broken,@broken_disk_U) if(scalar @broken_disk_U);
	}
=cut	
	if(@broken){
		logcomment("**FATAL** : $FILER_C : Number of FAILED disks are ".scalar @broken." and the disks are @broken");
		my $mail_subject = "INFO : FAILED drives are present in the filer $FILER_C";
		my $mail_body = "#################################################################################################
## 
## FAILED drives are present in the filer $FILER_C
##
## Number of failed drives are ".scalar @broken." and the drives are @broken"."
##
## Stopping the test suite execution : $STEST_FILE 
## 
#################################################################################################";
		my %mail_params = (HTML    => $mail_body,
			Text    => $mail_body,
			From    => $MAIL_FROM,
			To      => $MAIL_TO,
			Subject => $mail_subject,);
		logresult('FATAL',"FAILED drives are present in the filer $FILER_C, so killing the test suite : $STEST_FILE");
		$mail_params{HTML} = "<HTML><pre>$mail_params{Text}<\\HTML>";
		my $mail = HTML::Mail->new(%mail_params);
		$mail->send()or logcomment("CONFIG : trouble sending mail");
	}
}
######################################################
## Author :  Arjun Lavu
## Description : Prints the test dependent values
######################################################
sub print_test_variables{
	my $Home = $ENV{HOME};
	my $mini_disk_present;
	$/=undef;
	open(FH,"$Home/NDATE/TEST_LISTS/$STEST_FILE");
	my $test_suite_file = <FH>;
	$/="\n";
	close(FH);
	my $params = NATE::ParamSet->new(global => 1);
	my $LOGDIR = $params->get('LOGDIR', default => undef);
	my $actual_log_dir;
	if($LOGDIR=~/\/HDD/){
		($actual_log_dir) =$LOGDIR=~/(\S+)\/HDD/;
	}else{
		$actual_log_dir = $LOGDIR;
	}
	opendir(READDIR, "$actual_log_dir");
	my @thefiles = readdir(READDIR);
	# logcomment("Total number of files present are : @thefiles");
	foreach my $file (@thefiles){
		if($file=~/check_filer_setup(.*?)\.log/){
			$/=undef;
			open(FH1,"$actual_log_dir\/$file")||logcomment("Cannot open file $actual_log_dir\/$file");
			my $data = <FH1>;
			$/="\n";
			if($data=~/is\s+configured\s+as\s+a\s+\S+\s+minidisk/igs){
				$mini_disk_present=1;
			}
			last;
		}
	}
	close(FH1);
	if($parse_id=~/_Hmr_Scrub/){
		my ($priority) = $test_suite_file=~/SCRUB_PRIORITY_LEVEL\s*\=\s*(\S+)/;
		logcomment("SCRUB PRIORITY LEVEL IS : $priority");
	}elsif($parse_id=~/Disk_FW_DL_Dev_Rst/){
		my ($RESETVALUE) = $test_suite_file=~/RESETVALUE\s*\=\s*(\S+)/;
		logcomment("DEVICE RESET VALUE IS : $RESETVALUE");
	}elsif($parse_id=~/Hmr_Adp_Rst/){
		my ($RESETVALUE) = $test_suite_file=~/RESETVALUE\s*\=\s*(\S+)/;
		logcomment("DEVICE RESET VALUE IS : $RESETVALUE");
	}
	if($parse_id=~/check_filer/){
		my %modes = (1=>'FILE_SYSTEM',2=>'MAINTENANCE','F'=>'FILE_SYSTEM','M'=>'MAINTENANCE');
		if($test_suite_file=~/Filer_mode\s*\=\s*(\S+)/i){
			my $filer_mode = $1;
			logcomment("REQUIRED FILER MODE IS : ".$modes{uc($filer_mode)});
		}
		if($BOOT_MODE!~/1|5/){
			logcomment("USER SELECTED BOOT_MODE IS : $BOOT_MODE");
		}
	}else{
		my $str;
		my %wait_time=('1'=>'10%','2'=>'50%','3'=>'100%','4'=>'95%');
		if($wait_time{$TEST_WAIT_TIME}){
			$str = "TEST WAIT-TIME IS : ".$wait_time{$TEST_WAIT_TIME};
		}else{
			$str ="TEST WAIT-TIME IS : 100%\n";
		}
		if($mini_disk_present){
			$str = $str."\n"."MINI DISKS ARE PRESENT IN THE FILER-SETUP";
		}else{
			$str = $str."\n"."MINI DISKS ARE NOT PRESENT IN THE FILER-SETUP";
		}
		logcomment("$str");
	}
}

##############################################################################################################################
### Arjun Lavu
## description: subroutine will handle unknown prompts during logging-in the filer for the first time
##############################################################################################################################
sub handle_prompts{
    my (%opts) = validate(
        @_,
        {
            Node => { type => OBJECT },
        }
    );
    my $Node  = $opts{Node};
    my $FILER_C = $Node->name();
    my $filer_con  = connect("$FILER_C#console");
    my $Transit_obj = NACL::Transit->new( name => $FILER_C );
    my $filer_state;
    try{
        $filer_state = $Transit_obj->get_state('timeout' => 600);
    }catch NACL::Transit::Exceptions::Timeout with {
        logcomment("Could not get the filer prompt with in the timeout, so attempting Ctrl_C on the console of the filer $FILER_C");
        say( $filer_con, "\cC","::>|::\*>|\*>",-noprompt,-timeout, 300, -ok  );
    };
	if($filer_state=~/TAKEN_OVER_WAITING/){
		my $current;
		my $partner;
		my %nodes_filer;
		my @temp_nodes = NACL::C::Node->find();      # Find Nodes/Filers used in the test, Based on FILER param.
		foreach my $Node (@temp_nodes) {
			my $FILER_C = $Node->name();
			$nodes_filer{$FILER_C} = $Node;
		}
		@temp_nodes = values(%nodes_filer);   
		foreach my $Node (@temp_nodes) {
			my $FILER = $Node->name();
			if($FILER=~/^$FILER_C$/){
				$current = $Node;
			}else{
				$partner = $Node;
			}
		}
		giveback_takeover( Node =>$current,Partner=> $partner);
	}
    try{
        $filer_state = $Transit_obj->get_state('timeout' => 300);
        if($filer_state!~/CLI|MAINT|FIRMWARE|HALTED|BOOT_MENU|CFE_BANNER|LOADER_BANNERFIRMWARE/) {
            NACL::Transit::Exceptions::Timeout->throw( "throwing exception " );
        }
    }catch NACL::Transit::Exceptions::Timeout with {
        logcomment("FILER - $FILER_C state is ::: $filer_state");
        try{
            logcomment("Again trying to get the prompts");
            my $Server = new Server(no_cli=>1);
            my $host = Tharn::host($FILER_C);
            my $passwd = $host->{'default_password'};
            my $prompt_array = $host->prompt_fw();
            my $prompts = join("|",@$prompt_array);
            my $prompt_fw = "($prompts)";
            my @filer_working=$Server->servers();
            $Server->set_execution_server(-Server => $FILER_C);
            my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
            $Server->console(cmd=>"\cC",
                    additional_prompts_timeout => 600,
                    ignore => $ignore_strings,
                    additional_prompts => {
                        "$prompt_fw" => "FINAL_PROMPT",
                        "::>"       => "FINAL_PROMPT",
                        ".*>.*"       => "FINAL_PROMPT",
                        ".*Enter it again.*"=>"$passwd",
                        ".*Password.*"=>"$passwd",
                        ".*Enter a new password.*"=>"$passwd",
                        ".*New password.*"=>"$passwd",
                        ".*Continue with boot.*" =>  "yes",
						".*login.*"=>"admin",
                        ".*Selection (1-8)?.*"=>'5',
                    }
                );
            }catch NATE::BaseException with{
                logcomment("$FILER_C : Could not get the filer prompt");
            };
    };
}

######################################################
## Author :  aditis@netapp.com
## Description : checks for scsi inquiry on each disk
##
###################################################

sub scsi_inquiry_cmode
{
    my (%opts) = validate(
        @_,
        {
            API_OBJ =>{ type => OBJECT},
            Node =>{ type => OBJECT}
        }
    );
    my $Node = $opts{Node};
    my $API_OBJ = $opts{API_OBJ};
    my $FILER_C = $Node->name();
    my @disk_list = list_of_disk( Node => $Node );
    my @dsk_arr;
    foreach my $disk (@disk_list) {
        $disk=~s/(^\s+)|(\s+$)//ig;
        next if ($disk !~ /\S/);
        push (@dsk_arr,$disk);
    }
    my @disk_array = grep {(($_ !~ /P\d+$/) && ($_ =~ /\S/))}@dsk_arr;

#    my @disk_array = grep {!/P\d+$/}@disk_list;
#    my @disk_array = get_disks_list(Node => $Node);
    my $disk_length = @disk_array;
    my $test_result = 0;
    logcomment("Disks used for scsi inquiry are $disk_length and disks are : @disk_array");
    foreach my $dsk (@disk_array)
    {
        if ($disk_length > 0)
        {
            my $output = $API_OBJ->execute_command('command' => "scsi inquiry $dsk");
            $API_OBJ->set_timeout( "connectrec-timeout" => '600' );
            my $after = $API_OBJ->execute_command('command' => "");
            my $output = $after.$output;
            if ($output =~ /scsi inquiry: device\s*\S+ not found/) {
                 logcomment("**WARNING** : $FILER_C : Scsi inquiry command failed on $dsk");
            }
            else {
            my $flag = 0;
            my $flag1 = 0;
            my $prod_id;
	    foreach my $line(split(/\n/,$output))
            {
                if ($line =~ /t10_vendor_id:\s*\"(\S+)\s*/){
                        if ($1 =~ /NETAPP/)
                        {
                                logcomment("Vendor ID of disk $dsk is NETAPP");
                                $test_result = 0;
                        }
                        else
                        {
                                logcomment("**WARNING** : $FILER_C : Vendor ID of disk $dsk is $1");
                        }
                }
                if ($line =~ /product_id:\s*(\S+)\s*(\S+)/) {
                        $prod_id = $1.$2;
                        logcomment("Product ID of disk $dsk is $prod_id");
                        $flag1 = 1;
                }
                if ($line =~ /revision:\s*(\S+)/) {
                        if ((my $revision = $1) =~ /NA|NQ|NT|NE|NX\d\d$/)
                        {
                                logcomment("Firmware Revision of disk $dsk is $revision");
                                $test_result = 0;
                        }
                        else
                        {
                                logcomment("**WARNING** : $FILER_C : Firmware Revision $revision for disk $dsk is not starting with any of the NA|NQ|NT|NE|NX");
                        }
                }
#                if (($line =~ /vendor\s*unique\s*\"(\w+)\s*/) || ($line =~ /vendor\s*unique\s*\"\s*(\w+)\s*/))
		if ($line =~ /vendor\s*unique\s*\"\s*(.*)\"/gs)
                {
                    logcomment("Vendor unique of disk $dsk is $1");
                    $flag = 1;
                    $test_result = 0;
                }
            }
	     if ($flag1 != 1)
            {
               logcomment("**WARNING** : $FILER_C : Product ID is not present for disk $dsk");
            }
            if ($flag != 1)
            {
               logcomment("**WARNING** : $FILER_C : vendor unique is not present for disk $dsk");
            }
        }
        }
        else
        {
            $test_result = 1;
            logcomment("**FATAL**:$FILER_C:No disk available for testing, exiting from rest of the test case");

        }
    }
    return $test_result;
}

##############################################################
## Author : himangin@netapp.com
## Subroutine handles CMODE giveback and takeover states of the nodes making them up
## String "pass" is returned if both the nodes are found up else "fail"
##############################################################
sub giveback_takeover {
    my (%opts) = validate(
            @_,
            {
                    Node    =>      { type => OBJECT },
                    Partner =>      { type => OBJECT }
            }
    );
    my $Node  = $opts{Node};
    my $Partner = $opts{Partner};
    my ($flag1, $flag2);
    my $pass = "pass";
    my $fail = "fail";
    logcomment("Checking if the nodes are in giveback and takeover");
    my @Nodes;
    push (@Nodes, $Node, $Partner);
    my ($takeoverA, $givebackA, $takeoverB, $givebackB);
    my $Server = new Server(no_cli=>1);
    ##### Checking if the filer is in  loader or maint state
    foreach my $Node (@Nodes) {
        my $FILER_C = $Node->name();
		my $Host = host($FILER_C);
        my $Home = $ENV{HOME};
		my $ignore_strings = ["MADIMM\\d+->","DIMM\\d+->","^T>"];
		my $prompt_array = $Host->prompt_fw();
		my $prompts = join("|",@$prompt_array);
		my $prompt_fw = "($prompts)";
		my $filer_info = `cat $Home/NDATE/FILER_INFO/$FILER_C`;
		my $passwd;
		($passwd) = $filer_info=~/default_password\s*=\s*(\S+)\s*/ig;
		# logcomment("password is $passwd");
	
		my $transit_obj = NACL::Transit->new(name => $Host);
		my $filer_state = $transit_obj->get_state('timeout' => 600);
		if ($filer_state =~ /MAINT/i){
				logcomment("Node is found in $filer_state state, changing it to cli state");
				$transit_obj->change_state( to => "FIRMWARE");
		}
		$filer_state = $transit_obj->get_state('timeout' => 600);
		if ($filer_state =~ /FIRMWARE/i){
			logcomment("Node is found in $filer_state state, trying to change the state to CLI");
            try{
                    $filer_state = $transit_obj->change_state( to => "CLI");
            }catch NACL::Transit::Exceptions::Timeout with {
                    logcomment("Expected: Caught a Timeout exception");
                    $filer_state = $transit_obj->get_state('timeout' => 300);
             }catch NACL::Transit::Exceptions::TransitException with {
                    my $exception_object = shift;
                    #logcomment("Exception is of type: " . ref ($exception_object));
                    #logcomment("Error text is: " . $exception_object->text());
                    logcomment("Filer state could not be changed to CLI");
            };
			sleep 10;
			my $filer_state = $transit_obj->get_state('timeout' => 600);
                        if ($filer_state =~ /USERNAME|PASSWORD|FIRMWARE/i){
                                logcomment("Filer state could not be changed");
				return $fail; 
                        }
			if ($filer_state =~ /CLI/i){
					logcomment("Node $FILER_C is Up and running");
			} elsif ($filer_state =~/TAKEN_OVER_WAITING/) {
					logcomment("Node $FILER_C is in $filer_state state");
			}
		}
    }
    my $FILER_A = $Node->name();
    my $FILER_B = $Partner->name();
    my $HostA = host($FILER_A);
    my $transit_obj = NACL::Transit->new(name => $HostA);
    my $filer_state_A = $transit_obj->get_state('timeout' => 600);
    if($filer_state_A =~/(UP|CLI)/i){
		logcomment("Node $FILER_A is Up and running");
        $takeoverA = 1;
    } elsif ($filer_state_A =~/TAKEN_OVER_WAITING/) {
		logcomment("Node $FILER_A is in $filer_state_A state");
		$givebackA =1;
    } else {
		logcomment("Node $FILER_A is in $filer_state_A state");
    }
    my $HostB = host($FILER_B);
    my $transit_obj = NACL::Transit->new(name => $HostB);
    my $filer_state_B = $transit_obj->get_state('timeout' => 600);
    if($filer_state_B =~/(UP|CLI)/i){
            logcomment("Partner node $FILER_B is Up and running");
            $takeoverB = 1;
    } elsif ($filer_state_B =~/TAKEN_OVER_WAITING/) {
            logcomment("Partner node $FILER_B is in $filer_state_B state");
            $givebackB =1;
    } else {
            logcomment("Patner node $FILER_B is in $filer_state_B state");
    }
    if (($takeoverA)&&($givebackB)){
            logcomment("Execute storage failover on node $FILER_A");
            $Server->set_execution_server(-Server => $FILER_A);
            $Server->console(cmd => "storage failover giveback -ofnode $FILER_B");
            sleep 600;
    } elsif (($givebackA)&&($takeoverB)){
            logcomment("Execute storage failover on partner $FILER_B");
            $Server->set_execution_server(-Server => $FILER_B);
            $Server->console(cmd => "storage failover giveback -ofnode $FILER_A");
            sleep 600;
    }
    my $transit_obj = NACL::Transit->new(name => $HostA);
    my $filer_state_A = $transit_obj->get_state('timeout' => 600);
    if($filer_state_A =~/CLI|USERNAME|PASSWORD/i){
            $transit_obj->change_state( to => "CLI");
            my $filer_state_A = $transit_obj->get_state('timeout' => 600);
            if($filer_state_A =~/(UP|CLI)/i){
                    logcomment("Node $FILER_A is Up and running");
                    $flag1 = 1;
            } else {
                    logcomment("Node $FILER_A is in $filer_state_A state");
            }
    } else {
		logcomment("Node $FILER_A is in $filer_state_A state");
    }
    my $transit_obj = NACL::Transit->new(name => $HostB);
    my $filer_state_B = $transit_obj->get_state('timeout' => 600);
    if($filer_state_B =~/CLI|USERNAME|PASSWORD/i){
        $transit_obj->change_state( to => "CLI");
        my $filer_state_B = $transit_obj->get_state('timeout' => 600);
        if($filer_state_B =~/(UP|CLI)/i){
                logcomment("Partner node $FILER_B is Up and running");
                $flag2 = 1;
        } else {
                logcomment("Partner node $FILER_B is in $filer_state_B state");
        }
    } else {
            logcomment("Partner node $FILER_B is in $filer_state_B state");
    }
    if (($flag1)&&($flag2)){
            return $pass;
    } else {
            return $fail;
    }
}
##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub sasadmin_expander_cli_phydump {
    my (%opts) = validate(
        @_,
        {
            Node    => { type => OBJECT, default => undef, optional => 1 },
        }
    );
	my $Node = $opts{Node};
	my $output;
	my $FINAL={};
	my $FILER_C =$Node->name();
	my $return = sasadmin_expander_map_cmode(node=>$Node);
	my @channels = keys %{$return};
	#LINE:
	foreach my $key (@channels){
		my @WWN = keys %{$return->{$key}};
		foreach my $WWN(@WWN){
			my $ID = $return->{$key}->{$WWN}->{'ID'};
			if($ID){
				$output = sasadmin_expander_cli(Node=>$Node,command=>'phydump',shelf_id=>$ID,adapter_name=>$key);
				if($output!=1){
					$output=~s/(.*)(-----+)(.*)/$3/s;
					foreach my $line(split("\n",$output)){
						if($line=~/(\S+)\s*\|(.*)\|(.*)$/){
							$FINAL->{$key.$ID}->{$1} = $3;
						}
					}
				}
			}
		}
	}
	#logcomment("Dumping ".Dumper($FINAL));
	return $FINAL;
}

##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub sasadmin_expander_cli {
    my (%opts) = validate(
        @_,
        {
            Node    => { type => OBJECT, default => undef, optional => 1 },
            timeout => { type => SCALAR,  default => "300", optional => 1 },
            command  => { type => SCALAR },
            shelf_id => { type => SCALAR },
            adapter_name => { type => SCALAR },
            retry        => { type => SCALAR, default => 5, optional => 1 },
        }
    );
    my $output;
    my $adapter_name = $opts{adapter_name};
    my $command      = $opts{command};
    my $shelfid = $opts{shelf_id};
    my $retry;
    my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	my $Host= host($FILER_C);
	my $cmd = "sasadmin expander_cli $adapter_name\.$shelfid \'$command\' ";
	my $transit_obj = NACL::Transit->new(name => $FILER_C);
    my $filer_state = $transit_obj->get_state('timeout' => 600);
	my $api_set_obj;
	if($filer_state=~/CLI/){
		$api_set_obj = $Node->get_7m_or_nodescope_apiset();
		$api_set_obj->set_timeout( 'connectrec-timeout' => 1800 );
	}elsif($filer_state=~/MAINT/){
		$api_set_obj = NACL::APISet->new(
			hostobj   => $Host,
			category  => "Node",
			interface => "CLI",
			set       => "Maintenance"
        );
	}else{
		logresult('FATAL',"Filer : $FILER_C : is not in required state i,e $filer_state");
	}
	CLI_LABEL:;
	
	$output = $api_set_obj->execute_command( 'command' => $cmd );
    # print "response dump is" . Dumper $output;
    if ( $output =~ /Enclosure Services Unavailable/ ) {
        if ( $retry <= $opts{retry} ) {
            logcomment("Inband CLI command failed because Enclosure services are Unavaiable. Retry: $retry Retry after 20 secs" );
            sleep 20;
            $retry++;
            goto CLI_LABEL;
        }
        else {
            logcomment("**WARNING** : Inband cli command failed with enclosure services unavaiable even after $opts{retry} retries with 20 secs interval");
			return 1;
		}
    }
    if ( $output =~ /DSA DB lock/ ) {
        if ( $retry <= $opts{retry} ) {
            logcomment("Inband CLI command failed because DSA DB lock: UNLOCKED; LOCKs held. Retry: $retry Retry after 20 secs" );
            sleep 20;
            $retry++;
            goto CLI_LABEL;
        }
        else {
            logcomment("**WARNING** :Inband cli command failed with DSA DB lock even after $opts{retry} retries with 20 secs interval");
			return 1;
        }
    }
    if ( ( $output =~ /expander_cli: failed/ ) && ( $command !~ /watchdog_tp|reboot/ ) ){
        logcomment("**WARNING** : Command failed :: $output");
		return 1;
    }
    if ( $output =~ /resource busy/ && ( $retry == 15 ) ) {
		logcomment("**WARNING** : Command failed even after trying for 15 times :: $output");
		return 1;
    }
    return $output;
}
##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub compare_phy_state{
	my (%opts) = validate(
			@_,
			{
				before =>{ type => HASHREF},
				after =>{ type => HASHREF},
				disk_ref =>{ type => ARRAYREF,default => undef, optional => 1 },
				Node=>{type => OBJECT, default => undef, optional => 1 },
				compare=>{typr =>SCALAR,default => 'n', optional => 1 },
				
			}
		);
	my $before = $opts{before};
	my $after = $opts{after};
	my @disks;
	my %disk_has;
	my $FILER_C;
	if(($parse_id=~/PwrCyc/i)&&($opts{compare}=~/^n$/i)){
		logcomment("Power Cycle test is selected, hence Phy change count/Power cycle count values will not be compared in POST steps");
		return 'true';
	}
	if(defined $opts{disk_ref}){
		grep{$disk_has{$_}=1}@{$opts{disk_ref}};
	}elsif(defined $opts{Node}){
		$FILER_C  = $opts{Node}->name();
		my $API_Object = $opts{Node}->get_7m_or_nodescope_apiset();
		grep{$disk_has{$_}=1}@{disk_show_drive_maint(API_Obj => $API_Object,Filer => $FILER_C)->{'driveA'}}; 
	}
	my $flag='true';
	my @keys_after = keys %{$opts{after}};
	foreach my $key(@keys_after){
		my @keys_inside = keys %{$after->{$key}};
		foreach my $key1(@keys_inside){
			my $disk_inside = $key.'.'.$key1;
			if(exists $disk_has{$disk_inside}){
				if($opts{compare}=~/^Y$/i){
                                        my (@pass_drive, @fail_drive);
                                        logcomment("For disk : $disk_inside\n");
                                        my $phy_diff = ($after->{$key}->{$key1}->{'Phy change count'}) - ($before->{$key}->{$key1}->{'Phy change count'});
                                        my $pwr_diff = ($after->{$key}->{$key1}->{'Power cycle count'}) - ($before->{$key}->{$key1}->{'Power cycle count'});
                                        my $value = int($phy_diff/2) + ($before->{$key}->{$key1}->{'Power cycle count'});
                                        if (($value == ($after->{$key}->{$key1}->{'Power cycle count'})) || ($value == (($after->{$key}->{$key1}->{'Power cycle count'}) + 255))) {
                                                push( @pass_drive, $disk_inside );
                                        	logcomment("Phy change value BEFORE: ".$before->{$key}->{$key1}->{'Phy change count'}." Phy change value AFTER: ".$after->{$key}->{$key1}->{'Phy change count'}." Phy change value DELTA: $phy_diff");
                                        	logcomment("Power cycle count BEFORE: ".$before->{$key}->{$key1}->{'Power cycle count'}." Power cycle count AFTER: ".$after->{$key}->{$key1}->{'Power cycle count'}." Power cycle count DELTA: ".int($phy_diff/2));
					} else {
                                                push( @fail_drive, $disk_inside );
						logcomment("Phy change value BEFORE: ".$before->{$key}->{$key1}->{'Phy change count'}." Phy change value AFTER: ".$after->{$key}->{$key1}->{'Phy change count'}." Phy change value DELTA: $phy_diff");
						my $delta = ($after->{$key}->{$key1}->{'Power cycle count'}) - ($before->{$key}->{$key1}->{'Power cycle count'});
						if ($delta < 0) {
							$delta = 255 + $delta;
						}
						logcomment("Power cycle count BEFORE: ".$before->{$key}->{$key1}->{'Power cycle count'}." Power cycle count AFTER: ".$after->{$key}->{$key1}->{'Power cycle count'}." Power cycle count DELTA: $delta (expected value is ".int($phy_diff/2).")"); 
                                        }

                                    if (@fail_drive) {
                                                @fail_drive = unique(@fail_drive);
                                                logcomment("**WARINING** : Comparison failed for drive : @fail_drive");
                                                $flag="fail";
                                        }
				}else{
					if($after->{$key}->{$key1}->{'Power cycle count'}!=$before->{$key}->{$key1}->{'Power cycle count'}){
						logcomment("**WARNING** : $FILER_C : Power cycle count values of the drive $disk_inside are not matching, Value of Power cycle count BEFORE is ".$before->{$key}->{$key1}->{'Power cycle count'}." and Value of Power cycle count AFTER is ".$after->{$key}->{$key1}->{'Power cycle count'});
						$flag="fail";
					}
					if($after->{$key}->{$key1}->{'Phy change count'}!=$before->{$key}->{$key1}->{'Phy change count'}){
						logcomment("**WARNING** : $FILER_C :  Phy change count values of the drive $disk_inside are not matching, Value of Phy change count BEFORE is ".$before->{$key}->{$key1}->{'Phy change count'}." and Value of Phy change count AFTER is ".$after->{$key}->{$key1}->{'Phy change count'});
						$flag="fail";
					}
				}
			}
		}
	}
	return $flag;
}
##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub compare_sasadmin_expander_cli_phydump{
	my (%opts) = validate(
		@_,
		{
			before =>{ type => HASHREF},
			after =>{ type => HASHREF},
		}
	);
	my $before = $opts{before};
	my $after = $opts{after};	
#	logcomment("Dum3".Dumper($before));
#	logcomment("Dum4".Dumper($after));
	my $flag=0;
	foreach my $key(keys %{$after}){
		my @adapter = split("",$key);
		logcomment("Comparing the values of ".$adapter[0].$adapter[1].".".$adapter[2]." from PRE to POST test process");
		foreach my $key1(keys %{$after->{$key}}){
			if($after->{$key}->{$key1}!=$before->{$key}->{$key1}){
				logcomment("**WARNING** : Values are not matching for the PHY : $key : in PRE ".$before->{$key}->{$key1}." in POST ".$after->{$key}->{$key1});
				$flag=1;
			}
			# logcomment("$after->{$key}->{$key1}  hhdhd $before->{$key}->{$key1}");
		}
	}
	return $flag;
}

##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub read_shelflog{
	my (%opts) = validate(
		@_,
		{
			Node =>{ type => HASHREF},
		}
	);
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	my $params = NATE::ParamSet->new(global => 1);
	my $LOGDIR = $params->get('LOGDIR', default => undef);
	my ($actual_log_dir) =$LOGDIR=~/(\S+)\/HDD/;
	end_shelflog_detector(Node=>$Node);
	$/=undef;
	my $logfile = "$LOGDIR/"."read_shelflog_$FILER_C"."\.log";
	open(FH,"$logfile")|| return logcomment("**WARNING** : $FILER_C : cannot open the file $logfile");
	my $DATA = <FH>;
	my @copy;
	foreach (split("\n",$DATA)){
		if($_=~/STAF_handle|END OF TEST/g){
			push(@copy,$_);
		}
	}
	# if($DATA=~/(.*)(Ending shelflog_iom_master.*)(\d+\s+\d+\s+END OF TEST.*)/s){
		# $data = $1.$3;
	# }
	$/="\n";
	close FH;
	if(!(-d "$actual_log_dir\/SYSTEM_LOGS")){
		system("sudo mkdir $actual_log_dir\/SYSTEM_LOGS");
	}
	my $file_create = "$actual_log_dir\/SYSTEM_LOGS\/".$parse_id."_".$FILER_C."_IOM\.log";
	system("sudo touch $file_create");
	system("sudo chmod 666 $file_create");
	# system("sudo cp -rf $logfile $file_create");
	$DATA=~s/X\;X/ /gs;
	open(FH1,">>$file_create")||return logcomment("**WARNING** : $FILER_C : cannot create the file $file_create");
	print FH1 $DATA;
	close FH1;
	push(@copy,"\n=========================================================================================\n");
	push(@copy,"\n\t\t\tshelflog_iom_master log data is copied to file $file_create\n");
	push(@copy,"=========================================================================================\n");
	system("sudo chmod 666 $logfile");
	open(FH,">$logfile")|| return logcomment("**WARNING** : $FILER_C : cannot create the file $logfile");
	print FH "@copy";
	close FH;
}


##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################

sub read_ems_logs{
	my (%opts) = validate(
		@_,
		{
			Node =>{ type => HASHREF},
		}
	);
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	my $params = NATE::ParamSet->new(global => 1);
	my $LOGDIR = $params->get('LOGDIR', default => undef);
	my ($actual_log_dir) =$LOGDIR=~/(\S+)\/HDD/;
	end_ems_detector(Node=>$Node);
	$/=undef;
	my $logfile = "$LOGDIR/"."read_ems_logs_$FILER_C"."\.log";
	open(FH,"$logfile")|| return logcomment("WARNING : $FILER_C : cannot open the file $logfile");
	my $DATA = <FH>;
	my @copy;
	foreach (split("\n",$DATA)){
		if($_=~/STAF_handle|END OF TEST/g){
			push(@copy,$_);
		}
	}
	$/="\n";
	close FH;
	my $dir = "$actual_log_dir\/SYSTEM_LOGS\/".$parse_id."_"."$FILER_C";
	if(!(-d "$dir")){
		system("sudo mkdir $dir");
	}
	my $file_create = "$dir\/".$parse_id."_".$FILER_C."_EMS\.log";
	system("sudo touch $file_create");
	system("sudo chmod 666 $file_create");	
	# system("sudo cp -rf $logfile $file_create");
	open(FH1,">>$file_create")||return logcomment("WARNING : $FILER_C :: cannot create the file $file_create");
	$DATA=~s/X\;X/ /gs;
	print FH1 $DATA;
	close FH1;
	push(@copy,"\n=========================================================================================\n");
	push(@copy,"\n\t\t\tEMS log data is copied to file $file_create\n");
	push(@copy,"=========================================================================================\n");
	system("chmod 666 $logfile");
	open(FH,">$logfile")|| return logcomment("WARNING : $FILER_C ::: cannot create the file $logfile");
	print FH "@copy";
	close FH;

}

##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub start_shelflog_detector{
my (%opts) = validate(
		@_,
		{
			Node =>{ type => OBJECT},
		}
	);
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	
	my $Log_file='/mroot/etc/log/shelflog/shelflog_iom_master';
	$SHELFLOG_DETECTOR->{$FILER_C} = NACL::MTask::SystemLogDetector->new(
		command_interface => $Node,
		set_log_file      => [$Log_file],
		nacltask_timeout  => 432000,
	);	
	$SHELFLOG_DETECTOR->{$FILER_C}->start();
	logcomment("$FILER_C : Reading shelflog_iom_master log started");
}


##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub end_shelflog_detector{
my (%opts) = validate(
		@_,
		{
			Node =>{ type => OBJECT},
		}
	);
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	logcomment("$FILER_C : Ending shelflog_iom_master log reading");
	my ($var) = $SHELFLOG_DETECTOR->{$FILER_C}->get_logs();
}

##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub start_ems_detector{
	my (%opts) = validate(
		@_,
		{
			Node =>{ type => OBJECT},
		}
	);
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	$EMS_DETECTOR->{$FILER_C} = NACL::MTask::EventLogDetector->new(
						command_interface => $Node,
						check_for_any_presence =>	['dfu.firmwareDownloading', 'dfu.fwDownloaded' ],
					);
	$EMS_DETECTOR->{$FILER_C}->start();
	my $event_start_time = $EMS_DETECTOR->{$FILER_C}->event_begin_time();	
	logcomment("$FILER_C : Reading EMS log started, Start time is :: $event_start_time");
}


##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub end_ems_detector{
	my (%opts) = validate(
		@_,
		{
			Node =>{ type => OBJECT},
		}
	);
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	if(defined $EMS_DETECTOR->{$FILER_C}){
		try{
			my $event_end_time = $EMS_DETECTOR->{$FILER_C}->event_end_time();
			# logcomment("$FILER_C : Ending EMS log reading, end time is : $event_end_time");
			$EMS_DETECTOR->{$FILER_C}->stop( 'check' => 1 );
		}catch NACL::Exceptions::EventCheckFailure with{
			logcomment("EMS LOGS READ");
		};	
	}else{
		logcomment("**WARNING** : $FILER_C : Event detector object has not created in PRE_TEST process");
	}
}


##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub drive_names_minus_adapter{
	my (%opts) = validate(
		@_,
		{
			primary =>{ type => ARRAYREF},
			secondary =>{ type => ARRAYREF},
		}
	);
	my @primary = @{$opts{primary}};
	my @secondary = @{$opts{secondary}};
	my @return;
	my %filter;
	foreach my $disk (@primary){
		$disk=~s/^\s*|\s*$//gi;
		(my $bkp=$disk)=~s/^(\S+?)\.//;
		$filter{$bkp}=$disk;
	}
	foreach my $key(keys %filter){
		$key=~s/^\s+|\s+$//i;
		foreach my $dsk(@secondary){
			$dsk=~s/^\s+|\s+$//i;
			if($dsk=~/$key$/){
				push(@return,$filter{$key}) if($filter{$key}=~/\S/);
			}
		}
	}
	# logcomment("Common drives @return");
	return @return;
}


##############################################################
## Author : arjun.lavu@netapp.comapre
##############################################################
sub compare_WWN{
	my (%opts) = validate(
		@_,
		{
			before =>{ type => HASHREF},
			after =>{ type => HASHREF},
		}
	);
	my $before = $opts{before};
	my $after = $opts{after};	
	my $before_dup={};
	my $after_dup ={};
	foreach my $dsk(keys %{$after}){
		(my $dsk_dup = $dsk)=~s/^(\S+?)\.//;
		$after_dup->{$dsk_dup} = $after->{$dsk};
	}
	foreach my $dsk(keys %{$before}){
		(my $dsk_dup = $dsk)=~s/^(\S+?)\.//;
		$before_dup->{$dsk_dup} = $before->{$dsk};
	}
	my $flag=1;
	# my @drives = keys(%{$after});
	foreach my $disk(keys %{$after}){
		my $ref = ref($after->{$disk});
		next if($ref!~/HAS/i);
		(my $dsk_dup = $disk)=~s/^(\S+?)\.//;
        if($after_dup->{$dsk_dup}->{'WWN'} ne $before_dup->{$dsk_dup}->{'WWN'}){
			logcomment("**WARNING** : WWN values are not matching for the disk - $disk, Before :: $before->{$disk}->{'WWN'}, After :: $after->{$disk}->{'WWN'} ");
			$flag=0;
		}
	}
	return $flag;
}


##############################################################
## Author : arjun.lavu@netapp.comapre
## Description :: Set the filer time as server time
##############################################################
sub set_filer_time{
	my (%opts) = validate(
		@_,
		{
			Node =>{ type => OBJECT},
		}
	);
	logcomment("Setting the filer time");
	my $Node=$opts{Node};
	my $FILER_C = $Node->name();
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
    my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if($filer_state=~/CLI|UP/i){
		my $mon =`date +%m`;
		my $day = `date +%d`;
		my $year= `date +%Y`;
		my $date =`date`;
		my $time;
		chomp($mon,$day,$year);
		$date=~s/^\s+//g;
		if($date=~/^\S+\s+\S+\s+\S+\s+(\S+)/){
			$time = $1;
		}
		NACL::C::ClusterDate->modify(
					command_interface => $Node,
					date => "$mon/$day/$year $time"
		);
	}
}


##############################################################
## Author : arjun.lavu@netapp
##############################################################
sub get_valid_drives_for_firm{
	my (%opts) = validate(
		@_,
		{
			Node =>{ type => OBJECT},
			drives =>{type => ARRAYREF}
		}
	);
	my $Node=$opts{Node};
	my @drive_list = @{$opts{drives}};
	my $FILER_C = $Node->name();
	my $API_OBJ = $Node->get_7m_or_nodescope_apiset();
	my $disk_tot = disk_show_drive_maint(API_Obj =>$API_OBJ,Filer=>$FILER_C);
	my @drives = @{$disk_tot->{'driveA'}};
	my(@actual_drives,%actual_filter,%drives_filter,@disk_list,@return );
	foreach my $dsk(@drive_list){
		( my $fil_dsk = $dsk ) =~s/(\w+\.)//;
		$drives_filter{$fil_dsk} = $dsk;
	}
	foreach my $dsk(@drives){
		( my $fil_dsk = $dsk ) =~s/(\w+\.)//;
		$actual_filter{$fil_dsk} = $dsk;
	}
	my @actual_drives_tmp = grep {/\S/}intersection([sort keys %drives_filter],[sort keys %actual_filter]);
	foreach(@actual_drives_tmp){
		push(@actual_drives,$actual_filter{$_})if(($_=~/\S/)&&($_!~/P\d+$/));
	}
	
	try {
		my @aggrs = NACL::C::Aggregate->find( command_interface => $Node,
						filter => {nodes => [$FILER_C],'root' => 'false'});
		foreach my $aggr(@aggrs){
			my $aggregate = $aggr->get_one_state_attribute('aggregate');
			logcomment("$FILER_C : Aggr name :: $aggregate");
			if($aggr->get_one_state_attribute('raidstatus')=~/degraded|reconstruct|offline/i){
				my $disk_obj = NACL::CS::StorageAggregate->fetch(command_interface => $Node,
                            filter  => {'aggregate' => "$aggregate",},
                            requested_fields => ['disklist']);
				my @disks = $disk_obj->disklist();
				logcomment("Degraded aggregate : $aggregate : disks : @disks");
				my $disk_hashref = NACL::C::StorageDisk->get_nodescope_diskname(
						command_interface => $Node,
						disks => \@disks,
				);
				# logcomment("dumoing ".Dumper($disk_hashref));
				@disk_list = values %{$disk_hashref};
				logcomment("**WARNING** : $FILER_C : Degraded aggregate : $aggregate : drives(dblade) :: @disk_list , So ignoring from firmware validation");
			}
		}
    }catch NACL::Exceptions::NoElementsFound with {
        logcomment("$FILER_C : Non Root aggregates are not found in the filer");
    };
	my $API_obj = $Node->get_7m_or_nodescope_apiset();
	my $out = $API_obj->execute_command( 'command' => "aggr status -s");
	my (@zeroing);
	if($out =~/zeroing|not zeroed/i){
		my $n      = 0;
        my @lines  = split( /\n/, $out );
        while ( $n <= $#lines ) {
            last if ( $lines[$n] =~ /^-----/ );
            $n++;
        }
        $n++;
        foreach my $var ( @lines[ $n .. $#lines ] ) {
			$var=~s/^\s+|\s+$//gi;
			if($var=~/spare\s*(\S+).*(not zeroed|zeroing)/){
				push(@zeroing,$1);
			}
		}
	}	
	if(@zeroing){
		logcomment("**WARNING** : Total number of zeroing/not zeroed drives are ".scalar @zeroing." and the drives are @zeroing, So ignoring these drives from firmware download validation");
	}
	push(@disk_list,@zeroing)if(@zeroing);

	my @common;
	@common = intersection([sort @actual_drives],[sort @disk_list]);
	my @return = array_diff([sort @actual_drives],[sort @common]);
	@return = grep{/\S/}@return;
	if(@return){
		logcomment("$FILER_C : Drives on which firmware download needs to be validated are : ".scalar @return." and the drives are @return");
	}else{
		logcomment("$FILER_C : No relevent drives are available to validate firmware update");
	}	
	return @return;
}



##############################################################
## Author : arjun.lavu@netapp
##############################################################
sub compare_scsi_disk_errors{
	my (%opts) = validate(
		@_,
		{
			before =>{ type => HASHREF},
			after =>{ type => HASHREF},
		}
	);
	my $before = $opts{before};
	my $after = $opts{after};	
	my $before_dup={};
	my $after_dup={};
	my $fail=0;
	my %filter=('Number of glist entries'=>1,'Soft errors on read bit error rate'=>1,'Soft errors on write bit error rate'=>1,
				'Soft error instantaneous rate'=>1,'Hard errors on read bit error rate'=>1,'Hard errors on write bit error rate'=>1,
				'Hard error instantaneous rate'=>1,'Soft errors on read since boot'=>1,'Soft errors on write since boot'=>1,
				'Hard errors on read since boot'=>1, 'Hard errors on write since boot'=>1);
	foreach my $disk (keys(%{$before})){
		(my $disk_bkp=$disk)=~s/^(\S+?)\.//;
		$before_dup->{$disk_bkp} = $before->{$disk};
	}
	foreach my $disk (keys(%{$after})){
		(my $disk_bkp=$disk)=~s/^(\S+?)\.//;
		$after_dup->{$disk_bkp} = $after->{$disk};
	}
	
	foreach my $dsk(keys(%{$after})){	## can be replaced  with disk show -a output
		(my $disk_bkp=$dsk)=~s/^(\S+?)\.//;
		my @keys = keys (%{$after->{$dsk}});
		foreach my $val(@keys){
			next if(!(exists $filter{$val}));
			if($val=~/Hard errors on read in last 128 hours|Hard errors on write in last 128 hours/ig){
				if($after_dup->{$disk_bkp}->{$val}>$before_dup->{$disk_bkp}->{$val}){
					logcomment("**WARNING** : $dsk : For the disk the values of \[$val\] are not matching");
					logcomment("The values of \[$val\] are ---->before ($before_dup->{$disk_bkp}->{$val}) and after ($after_dup->{$disk_bkp}->{$val}) <----");
					$fail = 1;
				}
				next;
			}
			if($parse_id=~/PwrCyc/i){
				if($val=~/Soft errors on read since boot|Soft errors on write since boot|Hard errors on read since boot|Hard errors on write since boot/ig){
					if($after_dup->{$disk_bkp}->{$val}>$before_dup->{$disk_bkp}->{$val}){
						logcomment("**WARNING** : $dsk : For the disk the values of \[$val\] are not matching");
						logcomment("The values of \[$val\] are ---->before ($before_dup->{$disk_bkp}->{$val}) and after ($after_dup->{$disk_bkp}->{$val}) <----");
						$fail = 1;
					}
				}else{
					if($after_dup->{$disk_bkp}->{$val}!= $before_dup->{$disk_bkp}->{$val}){
						logcomment("**WARNING** : $dsk : For the disk the values of \[$val\] are not matching");
						logcomment("The values of \[$val\] are ---->before ($before_dup->{$disk_bkp}->{$val}) and after ($after_dup->{$disk_bkp}->{$val}) <----");
						$fail = 1;
					}
				}
			}else{
				if($after_dup->{$disk_bkp}->{$val}!= $before_dup->{$disk_bkp}->{$val}){
						logcomment("**WARNING** : $dsk : For the disk the values of \[$val\] are not matching");
						logcomment("The values of \[$val\] are ---->before ($before_dup->{$disk_bkp}->{$val}) and after ($after_dup->{$disk_bkp}->{$val}) <----");
						$fail = 1;
				}
			}
		}	
	}
	return $fail;
}



###############################################################################
## Author : arjun.lavu@netapp
## Description :: fail the test if the filer drive format is not in FS compatible
###############################################################################
sub fail_if_diff_drive_foramt{
my (%opts) = validate(
		@_,
		{
			Node =>{ type => OBJECT},
		}
	);
	my $Node = $opts{Node};
	my $FILER_C = $Node->name();
	my @drive_not_supported;
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
	my $filer_state = $Transit_obj->get_state('timeout' => 600);
	logcomment("$FILER_C :: filer state is : $filer_state");
	return undef if($filer_state!~/CLI/i);
	my @disk_obj = NACL::C::Disk->find(
									command_interface => $Node,
								);
	foreach my $state_obj (@disk_obj){
		my $free_disk = $state_obj->disk();
		if ($free_disk =~ /(\S+)\:(\S+)/){
			push( @drive_not_supported,$2);
		}
	}
	if(scalar @drive_not_supported){
		logcomment("**FATAL** : $FILER_C : Total number of drives which are not in FS format are ".scalar @drive_not_supported." and the drives are  @drive_not_supported, \nPlease remove the unsupported drives from the system and try again");
		return 'fail';
	}
}

###############################################################################
## Author : arjun.lavu@netapp
## Description :: Copy the system logs of the filer to server specified path
###############################################################################
sub get_system_logs {
	my (%opts) = validate(
        @_,
        {
			Node  => { type => OBJECT },
			logdir => { type => SCALAR},

        }
    );
    my $Node = $opts{Node};
	my $FILER_C = $Node->name();
	my $log_dir = $opts{logdir};
	my $API_obj= $Node->get_7m_or_nodescope_apiset();
	my $API_Object;
	my $flag=0;
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
    my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if($filer_state!~/CLI/i){
		logcomment("**WARNING** : $FILER_C : filer is not in file-system mode, So Cannot copy system files");
	}
	logcomment("Getting the system logs of the filer :: $FILER_C");
	# my $sudo = "/usr/bin/sudo";
    my $Client = NACL::C::Client->find();
	my $scp;
	try {
	    $scp = NACL::MTask::SCP->new(
        			target_command_interface => $Node,
			        source_command_interface => $Client,
			    	);
    } catch NATE::BaseException with {
		$flag =1;
        logcomment("**WARNING** : $FILER_C : Could not create SCP object, Please check the connections");
    };
	if($flag){
		return;
	}
	logcomment("system log dir - $log_dir");
	if ( -d "$log_dir" ) {
	    logcomment(" Directory System_Log is created successfully");
    }else{
		system("sudo mkdir $log_dir");
		if (!( -d "$log_dir" )) {
			logcomment("**WARNING** : Cannot create directory :: $log_dir");
			return;
		}
	}
	system("sudo chmod 777 $log_dir");
	logcomment("List all files in etc");
	my $local_api = $Node->get_7m_or_nodescope_apiset();
    my $response = $local_api->ls( paths => "/etc/log/" );
	try {
		my $Filer_apiset = $Node->apiset(
								category  => 'Node',
								interface => 'CLI',
								set       => "Systemshell"
							);
		my @filer_logfile_names = ('/mroot/etc/log/adapter_dump*', '/mroot/etc/log/ems*','/mroot/etc/log/messages*','/mroot/etc/log/shelflog/shelflog*','/mroot/etc/shm_med_err*');
		foreach my $log_path(@filer_logfile_names){
			my $File_on_filer = $Filer_apiset->execute_raw_command(command =>"ls $log_path");
			# logcomment("output is $File_on_filer");
			if($File_on_filer=~/No match|No such/i){
				logcomment("WARNING : $FILER_C : No $log_path files found on the filer");
				next;
			}
			my @files = $File_on_filer=~/(\S+)/sg;
			# logcomment("files to transfer : @files");
			foreach my $file (@files){
				chomp($file);
				try {
					$scp->copy_from_target_to_source('files_to_copy'  => [$file],
												set_directory_on_source => "$log_dir",
												);
				} catch NATE::BaseException with {
					logcomment("**WARNING** : $FILER_C : Could not copy file :$file");
				};
			}
		}
	} catch  NACL::APISet::Exceptions::ConnectionFailedException with {
        logcomment("**WARNING** : $FILER_C : Cannot connect to filer using system shell");
    };
}

###############################################################################
## Author : arjun.lavu@netapp
## Description :: Delete the system logs from the filer
###############################################################################
sub del_system_logs{
	my (%opts) = validate(
        @_,
        {
			Node  => { type => OBJECT },
        }
    );
    my $Node = $opts{Node};
	my $FILER_C = $Node->name();
	my $flag=0;
	my $Transit_obj = NACL::Transit->new( name => $FILER_C );
    my $filer_state = $Transit_obj->get_state('timeout' => 600);
	if($filer_state!~/CLI/i){
		logcomment("**WARNING** : $FILER_C : filer is not in file-system mode, So Cannot copy system files");
	}
    my $Client = NACL::C::Client->find();
	logcomment("List all files in etc");
	my $local_api = $Node->get_7m_or_nodescope_apiset();
    my $response = $local_api->ls( paths => "/etc/log/" );
	try {
		my $Filer_apiset = $Node->apiset(
								category  => 'Node',
								interface => 'CLI',
								set       => "Systemshell"
							);
		my @filer_logfile_names = ('/mroot/etc/log/adapter_dump*', '/mroot/etc/log/ems*','/mroot/etc/log/messages*','/mroot/etc/log/shelflog/shelflog*','/mroot/etc/shm_med_err*');
		foreach my $log_path(@filer_logfile_names){
			logcomment("$FILER_C : deleting the log file $log_path");
			my $File_on_filer = $Filer_apiset->execute_raw_command(command =>"ls $log_path");
			if($File_on_filer=~/No match|No such/i){
				logcomment("**WARNING** :: $FILER_C : No $log_path files found on the filer");
				next;
			}else{
				$Filer_apiset->execute_raw_command(command =>"rm -rf $log_path");
			}
		}
	} catch  NACL::APISet::Exceptions::ConnectionFailedException with {
        logcomment("**WARNING** : $FILER_C :: Cannot connect to filer using system shell");
    };

}

1;
